# np-ui-lib
Native Angular UI Components and Design Framework

<p align="center">
  <img width="250px" height="250px" src="https://raw.githubusercontent.com/np-ui-lib/np-ui-lib/master/src/assets/images/logo-img.png">
</p>

<p align="center">
  <img src="https://raw.githubusercontent.com/np-ui-lib/np-ui-lib/master/src/assets/images/angular.svg">
  <img src="https://raw.githubusercontent.com/np-ui-lib/np-ui-lib/master/src/assets/images/typescript.svg">
  <img src="https://raw.githubusercontent.com/np-ui-lib/np-ui-lib/master/src/assets/images/npm.svg">
  <img src="https://raw.githubusercontent.com/np-ui-lib/np-ui-lib/master/src/assets/images/license.svg">
  <img src="https://raw.githubusercontent.com/np-ui-lib/np-ui-lib/master/src/assets/images/contributions.svg">
</p>

### [Click here for full documentation](https://np-ui-lib.github.io)
### [Click here for source code](https://github.com/np-ui-lib/np-ui-lib)
### [Release Notes](https://github.com/np-ui-lib/np-ui-lib/tree/master/projects/np-ui-lib/CHANGELOG.md)
### [NPM package manager](https://www.npmjs.com/package/np-ui-lib)
### NPM Command to add package to application
```
npm i np-ui-lib --save
```

### List of components:
|            1            |       2       |      3      |               4           |        5        |           6         |
|-------------------------|---------------|-------------|---------------------------|-----------------|---------------------|
| Input Text              | Textarea      | Date Picker | Time Picker               | Color Picker    | Switch              |
| Dropdown                | Auto Complete | Tags        | Number Box                | File Upload     | Slider              |
| Checkbox                | Radio Button  | Rich Text   | Menubar                   | Panel Menubar   | Breadcrumb          |
| Toolbar                 | Data Grid     | Paginator   | Calendar                  | Timeline        | Alert               |
| Notification            | Tooltip       | Popover     | Panel                     | Accordion       | Tabs                |
| Steps                   | Card          | Progress    | Loader                    | BlockUi         | Carousel            |
| Modal                   | Dialog        | Tree View   | List                      | Virtual Scroll  | Sidepanel           |
| Masking                 | Defer         | i18N        | Themes and Framework CSS  | Grid Layout     | Padding and Margin  |
| Button and Button Group | Badges        | Form        |                           |                 |                     |

### Modules to be pre-installed
```javascript
"@angular/common": "^15.0.0",
"@angular/core": "^15.0.0",
"@angular/cdk": "^15.0.0",
"@angular/forms": "^15.0.0",
"@angular/router": "^15.0.0",
"rxjs": "~7.5.0",
```

### Import below css to your application, or add in styles section in angular.json
```css
@import "~@angular/cdk/overlay-prebuilt.css";
@import "np-ui-lib/styles/default-theme.scss";
```

## License
This project is licensed under the MIT License.
