import { EventEmitter, OnDestroy } from "@angular/core";
import { TemplateRef, ViewContainerRef, ElementRef, AfterViewInit, AfterContentInit } from "@angular/core";
import { ControlValueAccessor } from "@angular/forms";
import { Overlay, OverlayPositionBuilder } from "@angular/cdk/overlay";
import { BehaviorSubject, Subscription } from "rxjs";
import * as i0 from "@angular/core";
export declare class NpAutoCompleteComponent implements ControlValueAccessor, AfterViewInit, AfterContentInit, OnDestroy {
    overlay: Overlay;
    private viewContainerRef;
    private overlayPositionBuilder;
    private elementRef;
    private static controlCount;
    searchResult: BehaviorSubject<any[]>;
    forceToSelect: boolean;
    valueKey: string;
    itemTemplate: TemplateRef<any>;
    searchDelay: number;
    maxResultLimit: number;
    minSearchCharLimit: number;
    orderBy: string;
    orderDir: string;
    placeholder: string;
    readOnly: boolean;
    autoFocus: boolean;
    tabIndex: number;
    styleClass: string;
    inputId: string;
    onSearch: EventEmitter<any>;
    onChange: EventEmitter<any>;
    onFocus: EventEmitter<any>;
    onBlur: EventEmitter<any>;
    templatePortalContent: TemplateRef<any>;
    inputViewChild: ElementRef;
    searchKeyword: string;
    innerValue: any;
    isDisabled: boolean;
    subscription: Subscription;
    options: any[];
    searchTimeout: any;
    isLoading: boolean;
    focused: boolean;
    isOpen: boolean;
    private templatePortal;
    private overlayRef;
    private onChangeCallback;
    private onTouchedCallback;
    constructor(overlay: Overlay, viewContainerRef: ViewContainerRef, overlayPositionBuilder: OverlayPositionBuilder, elementRef: ElementRef);
    ngAfterContentInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    get value(): any;
    set value(v: any);
    writeValue(v: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState?(isDisabled: boolean): void;
    focus(): void;
    _getDisplayValue(): void;
    _close(): void;
    _onInput($event: any): void;
    _onInputChange($event: any): void;
    _selectValue(val: any): void;
    _onKeydown(event: KeyboardEvent): void;
    _trackBy(index: number): number;
    _onBlur($event: any): void;
    _onFocus($event: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NpAutoCompleteComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NpAutoCompleteComponent, "np-auto-complete", never, { "searchResult": "searchResult"; "forceToSelect": "forceToSelect"; "valueKey": "valueKey"; "itemTemplate": "itemTemplate"; "searchDelay": "searchDelay"; "maxResultLimit": "maxResultLimit"; "minSearchCharLimit": "minSearchCharLimit"; "orderBy": "orderBy"; "orderDir": "orderDir"; "placeholder": "placeholder"; "readOnly": "readOnly"; "autoFocus": "autoFocus"; "tabIndex": "tabIndex"; "styleClass": "styleClass"; "inputId": "inputId"; }, { "onSearch": "onSearch"; "onChange": "onChange"; "onFocus": "onFocus"; "onBlur": "onBlur"; }, never, never, false, never>;
}
