import { EventEmitter } from "@angular/core";
import { TemplateRef, ViewContainerRef, ElementRef, AfterViewInit, AfterContentInit } from "@angular/core";
import { ControlValueAccessor } from "@angular/forms";
import { Overlay, OverlayPositionBuilder } from "@angular/cdk/overlay";
import * as i0 from "@angular/core";
export declare class NpColorPickerComponent implements ControlValueAccessor, AfterViewInit, AfterContentInit {
    overlay: Overlay;
    private viewContainerRef;
    private overlayPositionBuilder;
    private elementRef;
    private static controlCount;
    format: string;
    colors: string[];
    defaultOpen: boolean;
    readOnly: boolean;
    autoFocus: boolean;
    tabIndex: number;
    styleClass: string;
    inputId: string;
    onChange: EventEmitter<any>;
    onFocus: EventEmitter<any>;
    onBlur: EventEmitter<any>;
    templatePortalContent: TemplateRef<any>;
    inputViewChild: ElementRef;
    constructor(overlay: Overlay, viewContainerRef: ViewContainerRef, overlayPositionBuilder: OverlayPositionBuilder, elementRef: ElementRef);
    isOpen: boolean;
    stripColor: string;
    currentCursorColor: string;
    xColorCursor: string;
    yColorCursor: string;
    innerValue: string;
    isDisabled: boolean;
    currentHex: string;
    currentR: number;
    currentG: number;
    currentB: number;
    focused: boolean;
    private templatePortal;
    private overlayRef;
    private onChangeCallback;
    private onTouchedCallback;
    ngAfterContentInit(): void;
    ngAfterViewInit(): void;
    get value(): string;
    set value(v: string);
    writeValue(v: string): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState?(isDisabled: boolean): void;
    focus(): void;
    _toggleColorPicker(): void;
    _open(): void;
    _close(): void;
    _updateStripCanvas(): void;
    _updateBlockCanvas(): void;
    _clickStripeColor(e: any): void;
    _clickBlockColor(e: any): void;
    _rgbToHex(r: any, g: any, b: any): string;
    _convertNumberToHex(num: any): string;
    _hexToRgb(hex: string): any;
    _onClickColorBlock(color: string): void;
    _clear(): void;
    _getColorFromClickevent(e: any, clickedElement: string): any;
    _onKeydown(event: KeyboardEvent): void;
    _onChangeHex(event: any): void;
    _onChangeR(event: any): void;
    _onChangeG(event: any): void;
    _onChangeB(event: any): void;
    _setCurrentValues(val: string): void;
    _onBlur($event: any): void;
    _onFocus($event: any): void;
    _onMouseLeaveStrip(): void;
    _onMouseLeaveBlock(): void;
    _onMouseOverStrip(e: any): void;
    _onMouseOverBlock(e: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NpColorPickerComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NpColorPickerComponent, "np-color-picker", never, { "format": "format"; "colors": "colors"; "defaultOpen": "defaultOpen"; "readOnly": "readOnly"; "autoFocus": "autoFocus"; "tabIndex": "tabIndex"; "styleClass": "styleClass"; "inputId": "inputId"; }, { "onChange": "onChange"; "onFocus": "onFocus"; "onBlur": "onBlur"; }, never, never, false, never>;
}
