import { CdkDragDrop } from "@angular/cdk/drag-drop";
import { EventEmitter, OnDestroy, OnInit, TemplateRef } from "@angular/core";
import { ViewContainerRef, ElementRef, AfterContentInit, AfterViewInit } from "@angular/core";
import { BehaviorSubject, Subscription } from "rxjs";
import { Overlay, OverlayPositionBuilder } from "@angular/cdk/overlay";
import { Column } from "./models/column.model";
import { DataTypes, FilterTypes, SortDirections } from "./models/constants";
import { DataSource } from "./models/data-source.model";
import { LoadOptions } from "./models/load-options.model";
import { State } from "./models/state.model";
import { NpFileService } from "./services/np-file.service";
import { NpFilterService } from "./services/np-filter.service";
import { NpODataService } from "./services/np-odata.service";
import { NpGridUtilityService } from "./services/np-grid-utility.service";
import { NpPaginatorComponent } from "../np-paginator/np-paginator.component";
import { NpTranslationsService } from "../np-translations/np-translations.service";
import { NpDialogService } from "../np-dialog/np-dialog.service";
import * as i0 from "@angular/core";
export declare class NpDataGridComponent implements OnInit, AfterContentInit, AfterViewInit, OnDestroy {
    private filterService;
    private utilityService;
    private oDataService;
    private fileService;
    overlay: Overlay;
    private viewContainerRef;
    private overlayPositionBuilder;
    private dialogService;
    private translationsService;
    private elementRef;
    private static controlCount;
    inputId: string;
    columns: Column[];
    dataSource: BehaviorSubject<DataSource>;
    height: number;
    width: number;
    multiColumnSortEnable: boolean;
    masterDetailTemplate: TemplateRef<any>;
    singleRowExpand: boolean;
    expandRowOnClick: boolean;
    singleRowSelectEnable: boolean;
    multiRowSelectEnable: boolean;
    selectRowOnClick: boolean;
    key: string;
    showColumnChooser: boolean;
    title: string;
    enableStateStoring: boolean;
    isReadOnlyStates: boolean;
    noDataMessage: string;
    showFilters: boolean;
    dateFormat: string;
    showSummary: boolean;
    summaryTemplate: TemplateRef<any>;
    allowColumnResize: boolean;
    allowColumnReorder: boolean;
    isServerOperations: boolean;
    isODataOperations: boolean;
    odataVersion: 1 | 2 | 3 | 4;
    allowExport: boolean;
    isServerExport: boolean;
    showToolBar: boolean;
    pageSize: number;
    styleClass: string;
    onInit: EventEmitter<any>;
    onAfterInit: EventEmitter<any>;
    onLoadData: EventEmitter<LoadOptions>;
    onSelect: EventEmitter<any>;
    onDeselect: EventEmitter<any>;
    onRowClick: EventEmitter<any>;
    onStatesUpdate: EventEmitter<any>;
    onServerExport: EventEmitter<LoadOptions>;
    columnChooserTemplate: TemplateRef<any>;
    gridPaginator: NpPaginatorComponent;
    gridColumns: Column[];
    dataSourceClone: DataSource;
    subscription: Subscription;
    currentViewData: any[];
    totalRow: number;
    filtersList: any[];
    sortColumnList: any[];
    filterColumnList: any[];
    isFilterAvailable: boolean;
    enableMasterDetail: boolean;
    openRowKeys: any[];
    selectedRowKeys: any[];
    isAllSelected: boolean;
    keyColumnName: string;
    dataTypes: typeof DataTypes;
    sortDirections: typeof SortDirections;
    isOpenColumnChooser: boolean;
    visibleColumns: any[];
    stateList: State[];
    currentStateName: string;
    summaryData: any;
    searchColumnsKeyword: string;
    isDataSourceInit: boolean;
    _colSpanForDetailRow: number;
    private columnChooserTemplatePortal;
    private columnChooserOverlayRef;
    constructor(filterService: NpFilterService, utilityService: NpGridUtilityService, oDataService: NpODataService, fileService: NpFileService, overlay: Overlay, viewContainerRef: ViewContainerRef, overlayPositionBuilder: OverlayPositionBuilder, dialogService: NpDialogService, translationsService: NpTranslationsService, elementRef: ElementRef);
    ngOnInit(): void;
    ngAfterContentInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    getSelectedRowKeys(): any[];
    selectRowByKey(key: any): void;
    deselectRowByKey(key: any): void;
    reset(): void;
    selectAll(): void;
    deselectAll(): void;
    hideColumnByIndex(idx: number): void;
    showColumnByIndex(idx: number): void;
    hideColumnByDataField(dataField: string): void;
    showColumnByDataField(dataField: string): void;
    goToPage(pageNumber: number): void;
    sortByColumn(dataField: string, direction: SortDirections): void;
    filterByColumn(dataField: string, keyword: string, type: FilterTypes): void;
    getTotalRows(): number;
    getCurrentPageNumber(): number;
    getPageSize(): number;
    getTotalPages(): number;
    closeAllChild(): void;
    getFilterColumns(): any[];
    getSortColumns(): any[];
    getColumns(): Column[];
    setColumns(columns: Column[]): void;
    loadStateByName(stateName: string): void;
    getCurrentStateName(): string;
    removeAllSorting(): void;
    removeAllFilters(): void;
    getAllState(): State[];
    setAllState(states: State[]): void;
    refresh(): void;
    _subscribeDataSource(): void;
    _onPageChange(options: any): void;
    _setColumns(): void;
    _setVisibleColumns(): void;
    _onCellClick($event: any, column: Column, data: any): void;
    _onSort(column: Column): void;
    _sortDataSource(): void;
    _removeAllSorting(): void;
    _removeSortingFromColumn(column: Column): void;
    _resetDataSource(): void;
    _onFilter(column: Column, isForceFilter?: boolean): void;
    _filterDataSource(): void;
    _removeAllFilters(): void;
    _onClickExpandRow(data: any): void;
    _expandRow(keyValue: any): void;
    _onClickCollapseRow(data: any): void;
    _collapseRow(keyValue: any): void;
    _onClickSelectAll(checked: boolean): void;
    _deselectAll(): void;
    _selectAll(): void;
    _onClickSelectRow(checked: boolean, data: any): void;
    _selectRow(keyValue: any, checked: boolean): void;
    _isSelected(data: any): boolean;
    _isOpenDetailRow(data: any): boolean;
    _rowClick(event: any, data: any): void;
    _onColumnChoosing(checked: boolean, col: Column): void;
    _openColumnChooser(): void;
    _closeColumnChooser(): void;
    _dropColumn(event: CdkDragDrop<string[]>): void;
    _saveState(): void;
    _openDialogAddNewState(): void;
    _addState(stateName: string): void;
    _deleteState(): void;
    _loadState(): void;
    _cloneColumns(cols: Column[]): Column[];
    _onRefresh(): void;
    _onResetColumns(): void;
    _resizeColumn($event: any, column: Column): void;
    _exportToFile(): void;
    _showAllColumns(): void;
    _clearColumnSearch(): void;
    _allowRowSelection(): boolean;
    _trackBy(index: number): number;
    _isAnyRowSelected(): boolean;
    _onClickCheckbox($event: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NpDataGridComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NpDataGridComponent, "np-data-grid", never, { "inputId": "inputId"; "columns": "columns"; "dataSource": "dataSource"; "height": "height"; "width": "width"; "multiColumnSortEnable": "multiColumnSortEnable"; "masterDetailTemplate": "masterDetailTemplate"; "singleRowExpand": "singleRowExpand"; "expandRowOnClick": "expandRowOnClick"; "singleRowSelectEnable": "singleRowSelectEnable"; "multiRowSelectEnable": "multiRowSelectEnable"; "selectRowOnClick": "selectRowOnClick"; "key": "key"; "showColumnChooser": "showColumnChooser"; "title": "title"; "enableStateStoring": "enableStateStoring"; "isReadOnlyStates": "isReadOnlyStates"; "noDataMessage": "noDataMessage"; "showFilters": "showFilters"; "dateFormat": "dateFormat"; "showSummary": "showSummary"; "summaryTemplate": "summaryTemplate"; "allowColumnResize": "allowColumnResize"; "allowColumnReorder": "allowColumnReorder"; "isServerOperations": "isServerOperations"; "isODataOperations": "isODataOperations"; "odataVersion": "odataVersion"; "allowExport": "allowExport"; "isServerExport": "isServerExport"; "showToolBar": "showToolBar"; "pageSize": "pageSize"; "styleClass": "styleClass"; }, { "onInit": "onInit"; "onAfterInit": "onAfterInit"; "onLoadData": "onLoadData"; "onSelect": "onSelect"; "onDeselect": "onDeselect"; "onRowClick": "onRowClick"; "onStatesUpdate": "onStatesUpdate"; "onServerExport": "onServerExport"; }, never, never, false, never>;
}
