import { EventEmitter } from "@angular/core";
import { TemplateRef, ViewContainerRef, ElementRef, AfterViewInit, AfterContentInit } from "@angular/core";
import { ControlValueAccessor } from "@angular/forms";
import { Overlay, OverlayPositionBuilder } from "@angular/cdk/overlay";
import { NpUtilityService } from "../np-utility/np-utility.service";
import * as i0 from "@angular/core";
export declare class NpDatePickerComponent implements ControlValueAccessor, AfterViewInit, AfterContentInit {
    overlay: Overlay;
    private viewContainerRef;
    private overlayPositionBuilder;
    private elementRef;
    private utility;
    private static controlCount;
    minDate: Date;
    maxDate: Date;
    format: string;
    defaultOpen: boolean;
    showTodayButton: boolean;
    disableWeekDays: string[];
    disableDates: Date[];
    dateLabels: any[];
    dateClass: any;
    isStartMonthWithMonday: boolean;
    placeholder: string;
    readOnly: boolean;
    autoFocus: boolean;
    tabIndex: number;
    styleClass: string;
    inputId: string;
    onChange: EventEmitter<any>;
    onFocus: EventEmitter<any>;
    onBlur: EventEmitter<any>;
    templatePortalContent: TemplateRef<any>;
    inputViewChild: ElementRef;
    weekDays: string[];
    monthsList: any[];
    months: any[];
    years: number[];
    currentMonthWeeks: any;
    currentMonth: number;
    currentYear: number;
    today: Date;
    isOpen: boolean;
    innerValue: Date;
    isDisabled: boolean;
    originalWeekDays: string[];
    focused: boolean;
    private templatePortal;
    private overlayRef;
    private onChangeCallback;
    private onTouchedCallback;
    constructor(overlay: Overlay, viewContainerRef: ViewContainerRef, overlayPositionBuilder: OverlayPositionBuilder, elementRef: ElementRef, utility: NpUtilityService);
    ngAfterContentInit(): void;
    ngAfterViewInit(): void;
    get value(): Date;
    set value(v: Date);
    writeValue(v: Date): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState?(isDisabled: boolean): void;
    focus(): void;
    _resetVariables(): void;
    _calculateDays(): void;
    _getCurrentMonthData(): any[];
    _daysInCurrentMonth(): number;
    _prevMonth(): void;
    _nextMonth(): void;
    _selectDate(date: Date): void;
    _selectMonth($event: any): void;
    _changeYear($event: any): void;
    _toggleDatePicker(): void;
    _open(): void;
    _close(): void;
    _setToday(): void;
    _clear(): void;
    _getTooltip(currentDate: Date): void;
    _checkIsWeekDayDisabled(index: number): boolean;
    _checkIsFullDateDisabled(date: Date): boolean;
    _setSelectedDate(date: Date): void;
    _onKeydown(event: KeyboardEvent): void;
    _onInputChange($event: any): void;
    _compareDate(dateA: Date, dateB: Date): boolean;
    _onBlur($event: any): void;
    _onFocus($event: any): void;
    _getDateClass(item: any): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<NpDatePickerComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NpDatePickerComponent, "np-date-picker", never, { "minDate": "minDate"; "maxDate": "maxDate"; "format": "format"; "defaultOpen": "defaultOpen"; "showTodayButton": "showTodayButton"; "disableWeekDays": "disableWeekDays"; "disableDates": "disableDates"; "dateLabels": "dateLabels"; "dateClass": "dateClass"; "isStartMonthWithMonday": "isStartMonthWithMonday"; "placeholder": "placeholder"; "readOnly": "readOnly"; "autoFocus": "autoFocus"; "tabIndex": "tabIndex"; "styleClass": "styleClass"; "inputId": "inputId"; }, { "onChange": "onChange"; "onFocus": "onFocus"; "onBlur": "onBlur"; }, never, never, false, never>;
}
