import { ElementRef, EventEmitter } from "@angular/core";
import { ControlValueAccessor, Validator } from "@angular/forms";
import { NpPopoverDirective } from "../np-popover/np-popover.directive";
import * as i0 from "@angular/core";
export declare class NpRichTextComponent implements ControlValueAccessor, Validator {
    private el;
    private static controlCount;
    minLength: number;
    maxLength: number;
    config: string[];
    fonts: string[];
    height: number;
    readOnly: boolean;
    autoFocus: boolean;
    tabIndex: number;
    styleClass: string;
    inputId: string;
    onChange: EventEmitter<any>;
    onFocus: EventEmitter<any>;
    onBlur: EventEmitter<any>;
    inputViewChild: ElementRef;
    createLinkPopover: NpPopoverDirective;
    foreColorPopover: NpPopoverDirective;
    backColorPopover: NpPopoverDirective;
    innerValue: string;
    isDisabled: boolean;
    focused: boolean;
    isBold: boolean;
    isItalic: boolean;
    isUnderline: boolean;
    isBlockquote: boolean;
    isStrikethrough: boolean;
    currentFormat: string;
    currentFont: string;
    currentfontsize: string;
    linkUrl: string;
    currentSelectionRange: Range;
    foreColor: string;
    backColor: string;
    private onChangeCallback;
    private onTouchedCallback;
    constructor(el: ElementRef);
    get value(): string;
    set value(v: string);
    writeValue(v: string): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState?(isDisabled: boolean): void;
    validate(): any;
    focus(): void;
    _onInputChange(event: any): void;
    _onBlur($event: any): void;
    _onFocus($event: any): void;
    _formatDoc(sCmd: string, sValue: any): void;
    _formatBlock(sCmd: string, sValue: any): void;
    _showForeColorOverlay(): void;
    _changeForeColor(color: any): void;
    _showBackColorOverlay(): void;
    _changeBackColor(color: any): void;
    _onCloseOverlays(): void;
    _showCreateLink(): void;
    _createLink(): void;
    _closeCreateLinkOverlay(): void;
    _changeRGBToHex(val: any): string;
    _rgbToHex(r: any, g: any, b: any): string;
    _convertNumberToHex(num: any): string;
    _isAllowed(permission: string): boolean;
    static ɵfac: i0.ɵɵFactoryDeclaration<NpRichTextComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NpRichTextComponent, "np-rich-text", never, { "minLength": "minLength"; "maxLength": "maxLength"; "config": "config"; "fonts": "fonts"; "height": "height"; "readOnly": "readOnly"; "autoFocus": "autoFocus"; "tabIndex": "tabIndex"; "styleClass": "styleClass"; "inputId": "inputId"; }, { "onChange": "onChange"; "onFocus": "onFocus"; "onBlur": "onBlur"; }, never, never, false, never>;
}
