import { EventEmitter, OnDestroy } from "@angular/core";
import { TemplateRef, ViewContainerRef, ElementRef, AfterViewInit, AfterContentInit } from "@angular/core";
import { ControlValueAccessor } from "@angular/forms";
import { Overlay, OverlayPositionBuilder } from "@angular/cdk/overlay";
import { BehaviorSubject, Subscription } from "rxjs";
import { NpUtilityService } from "../np-utility/np-utility.service";
import * as i0 from "@angular/core";
export declare class NpTagsComponent implements ControlValueAccessor, AfterViewInit, AfterContentInit, OnDestroy {
    overlay: Overlay;
    private viewContainerRef;
    private overlayPositionBuilder;
    private elementRef;
    private utility;
    private static controlCount;
    displayKey: string;
    valueKey: string;
    searchResult: BehaviorSubject<any[]>;
    isServerSide: boolean;
    forceToSelect: boolean;
    itemTemplate: TemplateRef<any>;
    searchDelay: number;
    maxResultLimit: number;
    minSearchCharLimit: number;
    maxSelectLimit: number;
    orderBy: string;
    orderDir: string;
    placeholder: string;
    readOnly: boolean;
    autoFocus: boolean;
    tabIndex: number;
    styleClass: string;
    inputId: string;
    onChange: EventEmitter<any>;
    onSearch: EventEmitter<any>;
    onCreateNewTag: EventEmitter<any>;
    onFocus: EventEmitter<any>;
    onBlur: EventEmitter<any>;
    templatePortalContent: TemplateRef<any>;
    inputViewChild: ElementRef;
    selected: any[];
    subscription: Subscription;
    options: any[];
    displayValue: string;
    searchTimeout: any;
    isLoading: boolean;
    innerValue: any[];
    isDisabled: boolean;
    focused: boolean;
    private templatePortal;
    private overlayRef;
    private onChangeCallback;
    private onTouchedCallback;
    constructor(overlay: Overlay, viewContainerRef: ViewContainerRef, overlayPositionBuilder: OverlayPositionBuilder, elementRef: ElementRef, utility: NpUtilityService);
    ngAfterContentInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    get value(): any[];
    set value(v: any[]);
    writeValue(v: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState?(isDisabled: boolean): void;
    focus(): void;
    _close(): void;
    _onInput($event: any): void;
    _selectValue(val: any): void;
    _open(): void;
    _createNewTag(): void;
    _getValueFromTag(val: any): void;
    _removeTag(tag: any): void;
    _isSelected(tag: any): boolean;
    _onKeydown(event: KeyboardEvent): void;
    _trackBy(index: number): number;
    _getDisplayValue(): string;
    _onBlur($event: any): void;
    _onFocus($event: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NpTagsComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NpTagsComponent, "np-tags", never, { "displayKey": "displayKey"; "valueKey": "valueKey"; "searchResult": "searchResult"; "isServerSide": "isServerSide"; "forceToSelect": "forceToSelect"; "itemTemplate": "itemTemplate"; "searchDelay": "searchDelay"; "maxResultLimit": "maxResultLimit"; "minSearchCharLimit": "minSearchCharLimit"; "maxSelectLimit": "maxSelectLimit"; "orderBy": "orderBy"; "orderDir": "orderDir"; "placeholder": "placeholder"; "readOnly": "readOnly"; "autoFocus": "autoFocus"; "tabIndex": "tabIndex"; "styleClass": "styleClass"; "inputId": "inputId"; }, { "onChange": "onChange"; "onSearch": "onSearch"; "onCreateNewTag": "onCreateNewTag"; "onFocus": "onFocus"; "onBlur": "onBlur"; }, never, never, false, never>;
}
