import { EventEmitter } from "@angular/core";
import { TemplateRef, ViewContainerRef, ElementRef, AfterViewInit, AfterContentInit } from "@angular/core";
import { ControlValueAccessor } from "@angular/forms";
import { Overlay, OverlayPositionBuilder } from "@angular/cdk/overlay";
import * as i0 from "@angular/core";
export declare class NpTimePickerComponent implements ControlValueAccessor, AfterViewInit, AfterContentInit {
    overlay: Overlay;
    private viewContainerRef;
    private overlayPositionBuilder;
    private elementRef;
    private static controlCount;
    defaultOpen: boolean;
    is24Hours: boolean;
    showNowButton: boolean;
    hideSeconds: boolean;
    placeholder: string;
    readOnly: boolean;
    autoFocus: boolean;
    tabIndex: number;
    styleClass: string;
    inputId: string;
    onChange: EventEmitter<any>;
    onFocus: EventEmitter<any>;
    onBlur: EventEmitter<any>;
    templatePortalContent: TemplateRef<any>;
    inputViewChild: ElementRef;
    hours: number[];
    minutes: number[];
    seconds: number[];
    isOpen: boolean;
    selectedHour: number;
    selectedMinute: number;
    selectedSecond: number;
    selectedAMPM: string;
    pattern: any;
    innerValue: string;
    isDisabled: boolean;
    focused: boolean;
    private templatePortal;
    private overlayRef;
    private onChangeCallback;
    private onTouchedCallback;
    constructor(overlay: Overlay, viewContainerRef: ViewContainerRef, overlayPositionBuilder: OverlayPositionBuilder, elementRef: ElementRef);
    ngAfterViewInit(): void;
    get value(): string;
    set value(v: string);
    writeValue(v: string): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState?(isDisabled: boolean): void;
    ngAfterContentInit(): void;
    get24hrsTimeFormat(): string;
    get12hrsTimeFormat(): string;
    focus(): void;
    _minusHour(): void;
    _minusMinute(): void;
    _minusSecond(): void;
    _addHour(): void;
    _addMinute(): void;
    _addSecond(): void;
    _changeTime($event: any, arg: string): void;
    _setValue(): void;
    _getHours(): string;
    _getMinutes(): string;
    _getSeconds(): string;
    private timeConvert12to24;
    private timeConvert24to12;
    _toggleTimePicker(): void;
    _open(): void;
    _close(): void;
    _extractValues(): void;
    _selectNowTime(): void;
    _clear(): void;
    _clearSelectedValue(): void;
    _changeAMPM(): void;
    _onKeydown(event: KeyboardEvent): void;
    _onInputChange($event: any): void;
    _onBlur($event: any): void;
    _onFocus($event: any): void;
    _getRegEx(): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<NpTimePickerComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NpTimePickerComponent, "np-time-picker", never, { "defaultOpen": "defaultOpen"; "is24Hours": "is24Hours"; "showNowButton": "showNowButton"; "hideSeconds": "hideSeconds"; "placeholder": "placeholder"; "readOnly": "readOnly"; "autoFocus": "autoFocus"; "tabIndex": "tabIndex"; "styleClass": "styleClass"; "inputId": "inputId"; }, { "onChange": "onChange"; "onFocus": "onFocus"; "onBlur": "onBlur"; }, never, never, false, never>;
}
