import * as i0 from '@angular/core';
import { Directive, Input, NgModule, Injectable, Pipe, EventEmitter, forwardRef, Component, ViewEncapsulation, ChangeDetectionStrategy, Output, ViewChild, Injector, TemplateRef, ContentChild, HostListener, ContentChildren, Inject, Optional } from '@angular/core';
import * as i3 from '@angular/forms';
import { NG_VALUE_ACCESSOR, FormsModule, NgControl, NG_VALIDATORS } from '@angular/forms';
import * as i2 from '@angular/cdk/portal';
import { TemplatePortal, PortalModule, ComponentPortal } from '@angular/cdk/portal';
import * as i1 from '@angular/cdk/overlay';
import { OverlayModule, OverlayConfig } from '@angular/cdk/overlay';
import * as i1$1 from '@angular/common';
import { CommonModule } from '@angular/common';
import { BehaviorSubject, Subject } from 'rxjs';
import * as i10 from '@angular/cdk/drag-drop';
import { moveItemInArray, DragDropModule } from '@angular/cdk/drag-drop';
import * as i1$2 from '@angular/router';
import { RouterModule } from '@angular/router';
import * as i2$1 from '@angular/cdk/scrolling';
import { CdkVirtualScrollViewport, ScrollingModule } from '@angular/cdk/scrolling';
import { CdkStepper, CdkStep, STEPPER_GLOBAL_OPTIONS, CdkStepperNext, CdkStepperPrevious, CdkStepperModule } from '@angular/cdk/stepper';

const TopBottomOverlayPositions = [
    {
        originX: "start",
        originY: "bottom",
        overlayX: "start",
        overlayY: "top",
    },
    {
        originX: "start",
        originY: "top",
        overlayX: "start",
        overlayY: "bottom",
    },
];

class NpAutofocusDirective {
    constructor(el) {
        this.el = el;
    }
    set autofocus(value) {
        if (value) {
            setTimeout(() => {
                this.el.nativeElement.focus();
            }, 100);
        }
    }
}
NpAutofocusDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpAutofocusDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
NpAutofocusDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.0.1", type: NpAutofocusDirective, selector: "[npAutofocus]", inputs: { autofocus: ["npAutofocus", "autofocus"] }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpAutofocusDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: "[npAutofocus]",
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { autofocus: [{
                type: Input,
                args: ["npAutofocus"]
            }] } });
class NpAutofocusModule {
}
NpAutofocusModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpAutofocusModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpAutofocusModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpAutofocusModule, declarations: [NpAutofocusDirective], exports: [NpAutofocusDirective] });
NpAutofocusModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpAutofocusModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpAutofocusModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpAutofocusDirective],
                    exports: [NpAutofocusDirective],
                }]
        }] });

class NpTranslationsService {
    constructor() {
        this._setDefaultTranslations();
        this.onTranslationsChange = new BehaviorSubject(null);
    }
    setTranslations(translations) {
        if (!translations) {
            this._setDefaultTranslations();
        }
        else {
            this._translations = translations;
        }
        this.onTranslationsChange.next(null);
    }
    ;
    translate(key) {
        return this._translations[key] || key;
    }
    _setDefaultTranslations() {
        this._translations = {
            'Su': 'Su',
            'Mo': 'Mo',
            'Tu': 'Tu',
            'We': 'We',
            'Th': 'Th',
            'Fr': 'Fr',
            'Sa': 'Sa',
            'Sunday': 'Sunday',
            'Monday': 'Monday',
            'Tuesday': 'Tuesday',
            'Wednesday': 'Wednesday',
            'Thursday': 'Thursday',
            'Friday': 'Friday',
            'Saturday': 'Saturday',
            'January': 'January',
            'February': 'February',
            'March': 'March',
            'April': 'April',
            'May': 'May',
            'June': 'June',
            'July': 'July',
            'August': 'August',
            'September': 'September',
            'October': 'October',
            'November': 'November',
            'December': 'December',
            'Today': 'Today',
            'Ok': 'Ok',
            'Clear': 'Clear',
            'Cancel': 'Cancel',
            'No_Result_Found': 'No result found',
            'Select': 'Select...',
            'Search': 'Search...',
            'Reset': 'Reset',
            'True': 'True',
            'False': 'False',
            'No_Data_Found': 'No data found',
            'Search_Columns': 'Search columns...',
            'Saved_Successfully': 'Saved successfully',
            'Add_New_State': 'Add new state',
            'Deleted_Successfully': 'Deleted successfully',
            'State_Name_Already_Exists': 'State name already exists',
            'Alert': 'Alert',
            'Confirm': 'Confirm',
            'Prompt': 'Prompt',
            'Choose_Files': 'Choose files',
            'Choose_File': 'Choose file',
            'Items_Per_Page': 'Items per page',
            'Now': 'Now',
            '>': '>',
            '<': '<',
            '>=': '>=',
            '<=': '<=',
            '=': '=',
            '!=': '!=',
            'abc': 'abc',
            'abc*': 'abc*',
            '*abc': '*abc',
            '*abc*': '*abc*',
            'Enter_The_URL_For_Link': 'Enter the URL for link',
            'Formatting': 'Formatting',
            'Font': 'Font',
            'Font_Size': 'Font size'
        };
    }
}
NpTranslationsService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTranslationsService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
NpTranslationsService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTranslationsService, providedIn: "root" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTranslationsService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: "root",
                }]
        }], ctorParameters: function () { return []; } });

class NpTranslatePipe {
    constructor(translationService, _ref) {
        this.translationService = translationService;
        this._ref = _ref;
        this.value = "";
    }
    transform(key) {
        this.subscription = this.translationService.onTranslationsChange.subscribe(() => {
            this.value = this.translationService.translate(key);
            this._ref.markForCheck();
        });
        return this.value;
    }
    ngOnDestroy() {
        if (this.subscription) {
            this.subscription.unsubscribe();
        }
    }
}
NpTranslatePipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTranslatePipe, deps: [{ token: NpTranslationsService }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Pipe });
NpTranslatePipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpTranslatePipe, name: "npTranslate", pure: false });
NpTranslatePipe.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTranslatePipe });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTranslatePipe, decorators: [{
            type: Injectable
        }, {
            type: Pipe,
            args: [{
                    name: "npTranslate",
                    pure: false,
                }]
        }], ctorParameters: function () { return [{ type: NpTranslationsService }, { type: i0.ChangeDetectorRef }]; } });

class NpColorPickerComponent {
    constructor(overlay, viewContainerRef, overlayPositionBuilder, elementRef) {
        this.overlay = overlay;
        this.viewContainerRef = viewContainerRef;
        this.overlayPositionBuilder = overlayPositionBuilder;
        this.elementRef = elementRef;
        /* forma can be 'hex' or 'rgb' */
        this.format = "hex";
        this.inputId = `np-color-picker_${NpColorPickerComponent.controlCount++}`;
        this.onChange = new EventEmitter();
        this.onFocus = new EventEmitter();
        this.onBlur = new EventEmitter();
        this.isOpen = false;
        this.isDisabled = false;
        this.currentHex = "";
        this.focused = false;
        this.onChangeCallback = () => { };
        this.onTouchedCallback = () => { };
    }
    ngAfterContentInit() {
        if (!this.colors) {
            if (this.format === "hex") {
                this.colors = [
                    "#FF0000",
                    "#FF7F00",
                    "#FFFF00",
                    "#7FFF00",
                    "#00FF00",
                    "#00FF7F",
                    "#00FFFF",
                    "#007FFF",
                    "#0000FF",
                    "#7F00FF",
                    "#FF00FF",
                    "#FF007F",
                    "#f44336",
                    "#e91e63",
                    "#9c27b0",
                    "#673ab7",
                    "#3f51b5",
                    "#2196f3",
                    "#03a9f4",
                    "#00bcd4",
                    "#009688",
                    "#4caf50",
                    "#8bc34a",
                    "#cddc39",
                    "#ffeb3b",
                    "#ffc107",
                    "#ff9800",
                    "#ff5722",
                    "#795548",
                    "#9e9e9e",
                    "#607d8b",
                    "#000000",
                ];
            }
            else {
                this.colors = [
                    "rgb(255,0,0)",
                    "rgb(255,127,0)",
                    "rgb(255,255,0)",
                    "rgb(127,255,0)",
                    "rgb(0,255,0)",
                    "rgb(0,255,127)",
                    "rgb(0,255,255)",
                    "rgb(0,127,255)",
                    "rgb(0,0,255)",
                    "rgb(127,0,255)",
                    "rgb(255,0,255)",
                    "rgb(255,0,127)",
                    "rgb(244,67,54)",
                    "rgb(244,67,54)",
                    "rgb(156,39,176)",
                    "rgb(103,58,183)",
                    "rgb(63,81,181)",
                    "rgb(33,150,243)",
                    "rgb(3,169,244)",
                    "rgb(0,188,212)",
                    "rgb(0,150,136)",
                    "rgb(76,175,80)",
                    "rgb(139,195,74)",
                    "rgb(205,220,57)",
                    "rgb(255,235,59)",
                    "rgb(255,193,7)",
                    "rgb(255,152,0)",
                    "rgb(255,87,34)",
                    "rgb(121,85,72)",
                    "rgb(158,158,158)",
                    "rgb(96,125,139)",
                    "rgb(0,0,0)",
                ];
            }
        }
    }
    ngAfterViewInit() {
        const positionStrategy = this.overlayPositionBuilder
            .flexibleConnectedTo(this.elementRef)
            .withPositions(TopBottomOverlayPositions);
        this.overlayRef = this.overlay.create({
            positionStrategy,
            hasBackdrop: true,
            backdropClass: "np-color-picker-backdrop",
            scrollStrategy: this.overlay.scrollStrategies.reposition(),
            panelClass: this.styleClass,
        });
        this.templatePortal = new TemplatePortal(this.templatePortalContent, this.viewContainerRef);
        this.overlayRef.backdropClick().subscribe(() => this._close());
        if (this.defaultOpen) {
            setTimeout(() => {
                this._updateStripCanvas();
                this._updateBlockCanvas();
            }, 10);
        }
    }
    get value() {
        return this.innerValue ? this.innerValue : null;
    }
    set value(v) {
        if (v !== this.innerValue) {
            this.innerValue = v;
            this.stripColor = v;
            this._setCurrentValues(v);
            this.onChangeCallback(v);
            this.onChange.emit(v);
        }
    }
    writeValue(v) {
        if (v !== this.innerValue) {
            this.innerValue = v;
            this.stripColor = v;
            this._setCurrentValues(v);
        }
    }
    registerOnChange(fn) {
        this.onChangeCallback = fn;
    }
    registerOnTouched(fn) {
        this.onTouchedCallback = fn;
    }
    setDisabledState(isDisabled) {
        this.isDisabled = isDisabled;
    }
    focus() {
        this.inputViewChild.nativeElement.focus();
    }
    _toggleColorPicker() {
        if (this.isOpen) {
            this._close();
        }
        else {
            this._open();
        }
    }
    _open() {
        if (this.defaultOpen === true || this.isDisabled || this.readOnly) {
            return;
        }
        this.isOpen = true;
        this.stripColor = this.value;
        if (!this.overlayRef.hasAttached()) {
            this.overlayRef.attach(this.templatePortal);
        }
        setTimeout(() => {
            this._updateStripCanvas();
            this._updateBlockCanvas();
        }, 10);
    }
    _close() {
        if (this.defaultOpen) {
            return;
        }
        this.isOpen = false;
        this.overlayRef.detach();
        this.inputViewChild.nativeElement.focus();
    }
    _updateStripCanvas() {
        let strip;
        if (this.defaultOpen) {
            strip = this.elementRef.nativeElement.querySelector(".np-color-picker-strip");
        }
        else {
            strip = this.overlayRef.overlayElement.querySelector(".np-color-picker-strip");
        }
        const ctx2 = strip.getContext("2d");
        ctx2.rect(0, 0, 25, 170);
        const grd1 = ctx2.createLinearGradient(0, 0, 0, 170);
        grd1.addColorStop(0, "rgba(255, 0, 0, 1)");
        grd1.addColorStop(0.17, "rgba(255, 255, 0, 1)");
        grd1.addColorStop(0.34, "rgba(0, 255, 0, 1)");
        grd1.addColorStop(0.51, "rgba(0, 255, 255, 1)");
        grd1.addColorStop(0.68, "rgba(0, 0, 255, 1)");
        grd1.addColorStop(0.85, "rgba(255, 0, 255, 1)");
        grd1.addColorStop(1, "rgba(255, 0, 0, 1)");
        ctx2.fillStyle = grd1;
        ctx2.fill();
    }
    _updateBlockCanvas() {
        let block;
        if (this.defaultOpen) {
            block = this.elementRef.nativeElement.querySelector(".np-color-picker-block");
        }
        else {
            block = this.overlayRef.overlayElement.querySelector(".np-color-picker-block");
        }
        const ctx1 = block.getContext("2d");
        ctx1.fillStyle = this.stripColor
            ? this.stripColor
            : this.value
                ? this.value
                : "rgb(255,0,0)";
        ctx1.fillRect(0, 0, 170, 170);
        const grdWhite = ctx1.createLinearGradient(0, 0, 170, 0);
        grdWhite.addColorStop(0, "rgba(255,255,255,1)");
        grdWhite.addColorStop(1, "rgba(255,255,255,0)");
        ctx1.fillStyle = grdWhite;
        ctx1.fillRect(0, 0, 170, 170);
        const grdBlack = ctx1.createLinearGradient(0, 0, 0, 170);
        grdBlack.addColorStop(0, "rgba(0,0,0,0)");
        grdBlack.addColorStop(1, "rgba(0,0,0,1)");
        ctx1.fillStyle = grdBlack;
        ctx1.fillRect(0, 0, 170, 170);
    }
    _clickStripeColor(e) {
        const imageData = this._getColorFromClickevent(e, ".np-color-picker-strip");
        this.stripColor =
            this.format === "rgb"
                ? `rgb(${imageData[0]},${imageData[1]},${imageData[2]})`
                : this._rgbToHex(imageData[0], imageData[1], imageData[2]);
        this._updateBlockCanvas();
    }
    _clickBlockColor(e) {
        const imageData = this._getColorFromClickevent(e, ".np-color-picker-block");
        this.value =
            this.format === "rgb"
                ? `rgb(${imageData[0]},${imageData[1]},${imageData[2]})`
                : this._rgbToHex(imageData[0], imageData[1], imageData[2]);
    }
    _rgbToHex(r, g, b) {
        const red = this._convertNumberToHex(r);
        const green = this._convertNumberToHex(g);
        const blue = this._convertNumberToHex(b);
        return `#${red}${green}${blue}`;
    }
    _convertNumberToHex(num) {
        let hex = Number(num).toString(16);
        if (hex.length < 2) {
            hex = `0${hex}`;
        }
        return hex;
    }
    _hexToRgb(hex) {
        if (!hex) {
            return null;
        }
        const r = parseInt(hex.substring(1, 3), 16);
        const g = parseInt(hex.substring(3, 5), 16);
        const b = parseInt(hex.substring(5, 7), 16);
        return { r, g, b };
    }
    _onClickColorBlock(color) {
        this.value = color;
        this.stripColor = this.value;
        this._updateBlockCanvas();
    }
    _clear() {
        if (this.isDisabled || this.readOnly) {
            return;
        }
        this.value = null;
        this._close();
    }
    _getColorFromClickevent(e, clickedElement) {
        let strip;
        if (this.defaultOpen) {
            strip = this.elementRef.nativeElement.querySelector(clickedElement);
        }
        else {
            strip = this.overlayRef.overlayElement.querySelector(clickedElement);
        }
        const ctx2 = strip.getContext("2d");
        const x = e.offsetX;
        const y = e.offsetY;
        return ctx2.getImageData(x, y, 1, 1).data;
    }
    _onKeydown(event) {
        if (event.key === "Tab" || event.key === "Escape") {
            this._close();
        }
        if (event.key === "ArrowDown") {
            this._open();
            event.preventDefault();
        }
    }
    _onChangeHex(event) {
        let val = event.target.value;
        if (val && val.charAt(0) !== "#") {
            val = `#${event.target.value}`;
        }
        if (this.format === "hex") {
            this.value = val;
        }
        else {
            const rgb = this._hexToRgb(val);
            this.value = `rgb(${rgb.r},${rgb.g},${rgb.b})`;
        }
        this._updateBlockCanvas();
    }
    _onChangeR(event) {
        if (this.format === "hex") {
            this.value = this._rgbToHex(event.target.value, this.currentG, this.currentB);
        }
        else {
            this.value = `rgb(${event.target.value},${this.currentG},${this.currentB})`;
        }
        this._updateBlockCanvas();
    }
    _onChangeG(event) {
        if (this.format === "hex") {
            this.value = this._rgbToHex(this.currentR, event.target.value, this.currentB);
        }
        else {
            this.value = `rgb(${this.currentR},${event.target.value},${this.currentB})`;
        }
        this._updateBlockCanvas();
    }
    _onChangeB(event) {
        if (this.format === "hex") {
            this.value = this._rgbToHex(this.currentR, this.currentG, event.target.value);
        }
        else {
            this.value = `rgb(${this.currentR},${this.currentG},${event.target.value})`;
        }
        this._updateBlockCanvas();
    }
    _setCurrentValues(val) {
        if (!val) {
            this.currentHex = "";
            this.currentR = null;
            this.currentG = null;
            this.currentB = null;
            return;
        }
        if (this.format === "hex") {
            this.currentHex = val;
            const rgb = this._hexToRgb(val);
            if (rgb) {
                this.currentR = rgb.r;
                this.currentG = rgb.g;
                this.currentB = rgb.b;
            }
        }
        else {
            const rgb = val
                .replace("rgb", "")
                .replace("(", "")
                .replace(")", "")
                .replace(" ", "");
            const rgbAray = rgb.split(",");
            this.currentR = Number(rgbAray[0]);
            this.currentG = Number(rgbAray[1]);
            this.currentB = Number(rgbAray[2]);
            this.currentHex = this._rgbToHex(this.currentR, this.currentG, this.currentB);
        }
    }
    _onBlur($event) {
        this.focused = false;
        this.onTouchedCallback();
        this.onBlur.emit($event);
    }
    _onFocus($event) {
        this.focused = true;
        this.onFocus.emit($event);
    }
    _onMouseLeaveStrip() {
        this.currentCursorColor = undefined;
    }
    _onMouseLeaveBlock() {
        this.currentCursorColor = undefined;
    }
    _onMouseOverStrip(e) {
        this.xColorCursor = `${e.pageX}px`;
        this.yColorCursor = `${e.pageY}px`;
        const imageData = this._getColorFromClickevent(e, ".np-color-picker-strip");
        this.currentCursorColor =
            this.format === "rgb"
                ? `rgb(${imageData[0]},${imageData[1]},${imageData[2]})`
                : this._rgbToHex(imageData[0], imageData[1], imageData[2]);
    }
    _onMouseOverBlock(e) {
        this.xColorCursor = `${e.pageX}px`;
        this.yColorCursor = `${e.pageY}px`;
        const imageData = this._getColorFromClickevent(e, ".np-color-picker-block");
        this.currentCursorColor =
            this.format === "rgb"
                ? `rgb(${imageData[0]},${imageData[1]},${imageData[2]})`
                : this._rgbToHex(imageData[0], imageData[1], imageData[2]);
    }
}
NpColorPickerComponent.controlCount = 1;
NpColorPickerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpColorPickerComponent, deps: [{ token: i1.Overlay }, { token: i0.ViewContainerRef }, { token: i1.OverlayPositionBuilder }, { token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component });
NpColorPickerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpColorPickerComponent, selector: "np-color-picker", inputs: { format: "format", colors: "colors", defaultOpen: "defaultOpen", readOnly: "readOnly", autoFocus: "autoFocus", tabIndex: "tabIndex", styleClass: "styleClass", inputId: "inputId" }, outputs: { onChange: "onChange", onFocus: "onFocus", onBlur: "onBlur" }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => NpColorPickerComponent),
            multi: true,
        },
    ], viewQueries: [{ propertyName: "templatePortalContent", first: true, predicate: ["templatePortalContent"], descendants: true }, { propertyName: "inputViewChild", first: true, predicate: ["control"], descendants: true }], ngImport: i0, template: "<div [ngClass]=\"{\r\n    'np-color-picker': true,\r\n    'np-disabled': isDisabled,\r\n    'np-readonly': readOnly\r\n  }\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-color-picker-input-group\" *ngIf=\"!defaultOpen; else templatePortalContent\"\r\n    [ngClass]=\"{ 'np-focused': focused }\">\r\n    <input class=\"np-color-picker-input\" #control [disabled]=\"isDisabled\" [npAutofocus]=\"autoFocus\"\r\n      [attr.tabindex]=\"tabIndex\" [readonly]=\"readOnly\" [value]=\"value\" (keydown)=\"_onKeydown($event)\"\r\n      (blur)=\"_onBlur($event)\" (focus)=\"_onFocus($event)\" />\r\n    <div class=\"np-input-color-block\" (click)=\"_toggleColorPicker()\" [ngStyle]=\"{ 'background-color': innerValue }\">\r\n    </div>\r\n    <button class=\"np-btn-icon np-toggle-overlay\" type=\"button\" tabindex=\"-1\" (click)=\"_toggleColorPicker()\">\r\n      <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n        <path\r\n          d=\"M20.71 5.63l-2.34-2.34c-.39-.39-1.02-.39-1.41 0l-3.12 3.12-1.93-1.91-1.41 1.41 1.42 1.42L3 16.25V21h4.75l8.92-8.92 1.42 1.42 1.41-1.41-1.92-1.92 3.12-3.12c.4-.4.4-1.03.01-1.42zM6.92 19L5 17.08l8.06-8.06 1.92 1.92L6.92 19z\">\r\n        </path>\r\n      </svg>\r\n    </button>\r\n  </div>\r\n</div>\r\n<ng-template #templatePortalContent>\r\n  <div class=\"np-color-picker-overlay\" [ngClass]=\"{ 'np-overlay-open': defaultOpen }\">\r\n    <div class=\"np-color-picker-header\">\r\n      <div class=\"np-hex-inputs\">\r\n        <label>HEX</label><input class=\"np-color-hex-input\" type=\"text\" [value]=\"currentHex\"\r\n          (change)=\"_onChangeHex($event)\" />\r\n        <div class=\"np-selected-color-block\" [ngStyle]=\"{ 'background-color': innerValue }\"></div>\r\n        <div class=\"np-current-color-block\" [ngStyle]=\"{ 'background-color': currentCursorColor }\"></div>\r\n      </div>\r\n      <div class=\"np-rgb-inputs\">\r\n        <label>R</label><input class=\"np-color-r-input\" type=\"number\" min=\"0\" max=\"255\" [value]=\"currentR\"\r\n          (change)=\"_onChangeR($event)\" />\r\n        <label>G</label><input class=\"np-color-g-input\" type=\"number\" min=\"0\" max=\"255\" [value]=\"currentG\"\r\n          (change)=\"_onChangeG($event)\" />\r\n        <label>B</label><input class=\"np-color-b-input\" type=\"number\" min=\"0\" max=\"255\" [value]=\"currentB\"\r\n          (change)=\"_onChangeB($event)\" />\r\n      </div>\r\n    </div>\r\n    <div class=\"np-color-canvases\">\r\n      <canvas class=\"np-color-picker-block\" width=\"170\" height=\"170\" (click)=\"_clickBlockColor($event)\"\r\n        (mousemove)=\"_onMouseOverBlock($event)\" (mouseleave)=\"_onMouseLeaveBlock()\"></canvas>\r\n      <canvas class=\"np-color-picker-strip\" width=\"25\" height=\"170\" (click)=\"_clickStripeColor($event)\"\r\n        (mousemove)=\"_onMouseOverStrip($event)\" (mouseleave)=\"_onMouseLeaveStrip()\"></canvas>\r\n    </div>\r\n    <div class=\"np-color-blocks\" *ngIf=\"colors && colors.length > 0\">\r\n      <div class=\"np-color-block\" *ngFor=\"let color of colors\" [style.background-color]=\"color\"\r\n        (click)=\"_onClickColorBlock(color)\"></div>\r\n    </div>\r\n    <div class=\"np-color-picker-footer\">\r\n      <button class=\"np-btn np-btn-primary np-ok\" type=\"button\" *ngIf=\"!defaultOpen\" tabindex=\"-1\" (click)=\"_close()\">\r\n        {{ \"Ok\" | npTranslate }}\r\n      </button>\r\n      <button class=\"np-btn np-btn-danger np-clear\" type=\"button\" tabindex=\"-1\" (click)=\"_clear()\">\r\n        {{ \"Clear\" | npTranslate }}\r\n      </button>\r\n    </div>\r\n  </div>\r\n</ng-template>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$1.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "directive", type: NpAutofocusDirective, selector: "[npAutofocus]", inputs: ["npAutofocus"] }, { kind: "pipe", type: NpTranslatePipe, name: "npTranslate" }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpColorPickerComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-color-picker", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => NpColorPickerComponent),
                            multi: true,
                        },
                    ], template: "<div [ngClass]=\"{\r\n    'np-color-picker': true,\r\n    'np-disabled': isDisabled,\r\n    'np-readonly': readOnly\r\n  }\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-color-picker-input-group\" *ngIf=\"!defaultOpen; else templatePortalContent\"\r\n    [ngClass]=\"{ 'np-focused': focused }\">\r\n    <input class=\"np-color-picker-input\" #control [disabled]=\"isDisabled\" [npAutofocus]=\"autoFocus\"\r\n      [attr.tabindex]=\"tabIndex\" [readonly]=\"readOnly\" [value]=\"value\" (keydown)=\"_onKeydown($event)\"\r\n      (blur)=\"_onBlur($event)\" (focus)=\"_onFocus($event)\" />\r\n    <div class=\"np-input-color-block\" (click)=\"_toggleColorPicker()\" [ngStyle]=\"{ 'background-color': innerValue }\">\r\n    </div>\r\n    <button class=\"np-btn-icon np-toggle-overlay\" type=\"button\" tabindex=\"-1\" (click)=\"_toggleColorPicker()\">\r\n      <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n        <path\r\n          d=\"M20.71 5.63l-2.34-2.34c-.39-.39-1.02-.39-1.41 0l-3.12 3.12-1.93-1.91-1.41 1.41 1.42 1.42L3 16.25V21h4.75l8.92-8.92 1.42 1.42 1.41-1.41-1.92-1.92 3.12-3.12c.4-.4.4-1.03.01-1.42zM6.92 19L5 17.08l8.06-8.06 1.92 1.92L6.92 19z\">\r\n        </path>\r\n      </svg>\r\n    </button>\r\n  </div>\r\n</div>\r\n<ng-template #templatePortalContent>\r\n  <div class=\"np-color-picker-overlay\" [ngClass]=\"{ 'np-overlay-open': defaultOpen }\">\r\n    <div class=\"np-color-picker-header\">\r\n      <div class=\"np-hex-inputs\">\r\n        <label>HEX</label><input class=\"np-color-hex-input\" type=\"text\" [value]=\"currentHex\"\r\n          (change)=\"_onChangeHex($event)\" />\r\n        <div class=\"np-selected-color-block\" [ngStyle]=\"{ 'background-color': innerValue }\"></div>\r\n        <div class=\"np-current-color-block\" [ngStyle]=\"{ 'background-color': currentCursorColor }\"></div>\r\n      </div>\r\n      <div class=\"np-rgb-inputs\">\r\n        <label>R</label><input class=\"np-color-r-input\" type=\"number\" min=\"0\" max=\"255\" [value]=\"currentR\"\r\n          (change)=\"_onChangeR($event)\" />\r\n        <label>G</label><input class=\"np-color-g-input\" type=\"number\" min=\"0\" max=\"255\" [value]=\"currentG\"\r\n          (change)=\"_onChangeG($event)\" />\r\n        <label>B</label><input class=\"np-color-b-input\" type=\"number\" min=\"0\" max=\"255\" [value]=\"currentB\"\r\n          (change)=\"_onChangeB($event)\" />\r\n      </div>\r\n    </div>\r\n    <div class=\"np-color-canvases\">\r\n      <canvas class=\"np-color-picker-block\" width=\"170\" height=\"170\" (click)=\"_clickBlockColor($event)\"\r\n        (mousemove)=\"_onMouseOverBlock($event)\" (mouseleave)=\"_onMouseLeaveBlock()\"></canvas>\r\n      <canvas class=\"np-color-picker-strip\" width=\"25\" height=\"170\" (click)=\"_clickStripeColor($event)\"\r\n        (mousemove)=\"_onMouseOverStrip($event)\" (mouseleave)=\"_onMouseLeaveStrip()\"></canvas>\r\n    </div>\r\n    <div class=\"np-color-blocks\" *ngIf=\"colors && colors.length > 0\">\r\n      <div class=\"np-color-block\" *ngFor=\"let color of colors\" [style.background-color]=\"color\"\r\n        (click)=\"_onClickColorBlock(color)\"></div>\r\n    </div>\r\n    <div class=\"np-color-picker-footer\">\r\n      <button class=\"np-btn np-btn-primary np-ok\" type=\"button\" *ngIf=\"!defaultOpen\" tabindex=\"-1\" (click)=\"_close()\">\r\n        {{ \"Ok\" | npTranslate }}\r\n      </button>\r\n      <button class=\"np-btn np-btn-danger np-clear\" type=\"button\" tabindex=\"-1\" (click)=\"_clear()\">\r\n        {{ \"Clear\" | npTranslate }}\r\n      </button>\r\n    </div>\r\n  </div>\r\n</ng-template>" }]
        }], ctorParameters: function () { return [{ type: i1.Overlay }, { type: i0.ViewContainerRef }, { type: i1.OverlayPositionBuilder }, { type: i0.ElementRef }]; }, propDecorators: { format: [{
                type: Input
            }], colors: [{
                type: Input
            }], defaultOpen: [{
                type: Input
            }], readOnly: [{
                type: Input
            }], autoFocus: [{
                type: Input
            }], tabIndex: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], inputId: [{
                type: Input
            }], onChange: [{
                type: Output
            }], onFocus: [{
                type: Output
            }], onBlur: [{
                type: Output
            }], templatePortalContent: [{
                type: ViewChild,
                args: ["templatePortalContent"]
            }], inputViewChild: [{
                type: ViewChild,
                args: ["control"]
            }] } });

class NpTranslationsModule {
}
NpTranslationsModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTranslationsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpTranslationsModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpTranslationsModule, declarations: [NpTranslatePipe], exports: [NpTranslatePipe] });
NpTranslationsModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTranslationsModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTranslationsModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpTranslatePipe],
                    exports: [NpTranslatePipe],
                }]
        }] });

class NpColorPickerModule {
}
NpColorPickerModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpColorPickerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpColorPickerModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpColorPickerModule, declarations: [NpColorPickerComponent], imports: [CommonModule,
        OverlayModule,
        PortalModule,
        NpAutofocusModule,
        NpTranslationsModule], exports: [NpColorPickerComponent] });
NpColorPickerModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpColorPickerModule, imports: [CommonModule,
        OverlayModule,
        PortalModule,
        NpAutofocusModule,
        NpTranslationsModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpColorPickerModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpColorPickerComponent],
                    imports: [
                        CommonModule,
                        OverlayModule,
                        PortalModule,
                        NpAutofocusModule,
                        NpTranslationsModule,
                    ],
                    exports: [NpColorPickerComponent],
                }]
        }] });

var FilterTypes;
(function (FilterTypes) {
    FilterTypes["StartsWith"] = "startswith";
    FilterTypes["EndsWith"] = "endswith";
    FilterTypes["Contains"] = "contains";
    FilterTypes["GreaterThan"] = "gt";
    FilterTypes["GreaterThanOrEquals"] = "ge";
    FilterTypes["LessThan"] = "lt";
    FilterTypes["LessThanOrEquals"] = "le";
    FilterTypes["Equals"] = "eq";
    FilterTypes["NotEquals"] = "ne";
    FilterTypes["Reset"] = "Reset";
})(FilterTypes || (FilterTypes = {}));
var DataTypes;
(function (DataTypes) {
    DataTypes["Number"] = "number";
    DataTypes["String"] = "string";
    DataTypes["Date"] = "date";
    DataTypes["Boolean"] = "boolean";
})(DataTypes || (DataTypes = {}));
var SortDirections;
(function (SortDirections) {
    SortDirections["Ascending"] = "asc";
    SortDirections["Descending"] = "desc";
})(SortDirections || (SortDirections = {}));
const Filters = [
    {
        name: FilterTypes.Equals,
        text: "abc",
        forDataType: DataTypes.String,
    },
    {
        name: FilterTypes.StartsWith,
        text: "abc*",
        forDataType: DataTypes.String,
    },
    {
        name: FilterTypes.EndsWith,
        text: "*abc",
        forDataType: DataTypes.String,
    },
    {
        name: FilterTypes.Contains,
        text: "*abc*",
        forDataType: DataTypes.String,
    },
    {
        name: FilterTypes.GreaterThan,
        text: ">",
        forDataType: DataTypes.Number,
    },
    {
        name: FilterTypes.LessThan,
        text: "<",
        forDataType: DataTypes.Number,
    },
    {
        name: FilterTypes.GreaterThanOrEquals,
        text: ">=",
        forDataType: DataTypes.Number,
    },
    {
        name: FilterTypes.LessThanOrEquals,
        text: "<=",
        forDataType: DataTypes.Number,
    },
    {
        name: FilterTypes.Equals,
        text: "=",
        forDataType: DataTypes.Number,
    },
    {
        name: FilterTypes.Equals,
        text: "=",
        forDataType: DataTypes.Boolean,
    },
    {
        name: FilterTypes.GreaterThan,
        text: ">",
        forDataType: DataTypes.Date,
    },
    {
        name: FilterTypes.LessThan,
        text: "<",
        forDataType: DataTypes.Date,
    },
    {
        name: FilterTypes.GreaterThanOrEquals,
        text: ">=",
        forDataType: DataTypes.Date,
    },
    {
        name: FilterTypes.LessThanOrEquals,
        text: "<=",
        forDataType: DataTypes.Date,
    },
    {
        name: FilterTypes.Equals,
        text: "=",
        forDataType: DataTypes.Date,
    },
    {
        name: FilterTypes.NotEquals,
        text: "!=",
        forDataType: DataTypes.Number,
    },
    {
        name: FilterTypes.NotEquals,
        text: "!=",
        forDataType: DataTypes.Date,
    },
    {
        name: FilterTypes.NotEquals,
        text: "!=",
        forDataType: DataTypes.Boolean,
    },
];

class Column {
    constructor(item) {
        this.dataField = item.dataField;
        this.dataType = item.dataType ? item.dataType : DataTypes.String;
        this.visible = item.visible;
        this.width = item.width;
        this.caption = item.caption ? item.caption : item.dataField;
        this.sortDirection = item.sortDirection;
        this.filterValue = item.filterValue;
        this.filterOperator = item.filterOperator;
        this.sortEnable = item.sortEnable;
        this.filterEnable = item.filterEnable;
        this.cellTemplate = item.cellTemplate;
        this.onCellClick = item.onCellClick;
        this.styleClass = item.styleClass;
        this.rightAlignText = item.rightAlignText;
        this.trueFilterText = item.trueFilterText;
        this.falseFilterText = item.falseFilterText;
    }
}

class DataSource {
    constructor(data, total, summary, isAllPages) {
        this.data = data;
        this.total = total;
        this.summary = summary;
        this.isAllPages = isAllPages ? isAllPages : false;
    }
}

class LoadOptions {
}

class State {
    constructor(name, columns) {
        this.name = name;
        this.columns = columns;
    }
}

class NpDialogConfig {
    constructor(item) {
        this.type = item.type || "alert";
        this.hasBackDrop = item.hasBackDrop === false ? false : true;
        this.backDropClass = item.backDropClass;
        this.inputId = item.inputId;
        this.styleClass = item.styleClass;
    }
}

class NpGridUtilityService {
    custFilter(arr, fun) {
        return arr.filter(fun);
    }
    custFind(arr, fun) {
        return arr.find(fun);
    }
    custSort(arr, ele, order) {
        if (order === SortDirections.Ascending) {
            return arr
                .concat()
                .sort((a, b) => (a[ele] > b[ele] ? 1 : b[ele] > a[ele] ? -1 : 0));
        }
        else {
            return arr
                .concat()
                .sort((a, b) => (a[ele] < b[ele] ? 1 : b[ele] < a[ele] ? -1 : 0));
        }
    }
}
NpGridUtilityService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpGridUtilityService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
NpGridUtilityService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpGridUtilityService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpGridUtilityService, decorators: [{
            type: Injectable
        }] });

class NpFilterService {
    constructor(utility) {
        this.utility = utility;
    }
    filterData(filterColumns, data) {
        for (const element of filterColumns) {
            if (element.filterOperator === FilterTypes.StartsWith) {
                const filterVal = element.filterValue.toLowerCase();
                data = this.utility.custFilter(data, (a) => {
                    if (!a[element.dataField]) {
                        return false;
                    }
                    return a[element.dataField].toLowerCase().startsWith(filterVal, 0);
                });
            }
            else if (element.filterOperator === FilterTypes.EndsWith) {
                const filterVal = element.filterValue.toLowerCase();
                data = this.utility.custFilter(data, (a) => {
                    if (!a[element.dataField]) {
                        return false;
                    }
                    return a[element.dataField].toLowerCase().endsWith(filterVal);
                });
            }
            else if (element.filterOperator === FilterTypes.Contains) {
                const filterVal = element.filterValue.toLowerCase();
                data = this.utility.custFilter(data, (a) => {
                    if (!a[element.dataField]) {
                        return false;
                    }
                    return a[element.dataField].toLowerCase().indexOf(filterVal) !== -1;
                });
            }
            else if (element.filterOperator === FilterTypes.GreaterThan) {
                if (element.dataType === DataTypes.Number) {
                    const filterVal = Number(element.filterValue);
                    data = this.utility.custFilter(data, (a) => {
                        if (!a[element.dataField]) {
                            return false;
                        }
                        return Number(a[element.dataField]) > filterVal;
                    });
                }
                else if (element.dataType === DataTypes.Date) {
                    const filterVal = new Date(element.filterValue).setHours(0, 0, 0, 0);
                    data = this.utility.custFilter(data, (a) => {
                        if (!a[element.dataField]) {
                            return false;
                        }
                        return (new Date(a[element.dataField]).setHours(0, 0, 0, 0) > filterVal);
                    });
                }
            }
            else if (element.filterOperator === FilterTypes.GreaterThanOrEquals) {
                if (element.dataType === DataTypes.Number) {
                    const filterVal = Number(element.filterValue);
                    data = this.utility.custFilter(data, (a) => {
                        if (!a[element.dataField]) {
                            return false;
                        }
                        return Number(a[element.dataField]) >= filterVal;
                    });
                }
                else if (element.dataType === DataTypes.Date) {
                    const filterVal = new Date(element.filterValue).setHours(0, 0, 0, 0);
                    data = this.utility.custFilter(data, (a) => {
                        if (!a[element.dataField]) {
                            return false;
                        }
                        return (new Date(a[element.dataField]).setHours(0, 0, 0, 0) >= filterVal);
                    });
                }
            }
            else if (element.filterOperator === FilterTypes.LessThan) {
                if (element.dataType === DataTypes.Number) {
                    const filterVal = Number(element.filterValue);
                    data = this.utility.custFilter(data, (a) => {
                        if (!a[element.dataField]) {
                            return false;
                        }
                        return Number(a[element.dataField]) < filterVal;
                    });
                }
                else if (element.dataType === DataTypes.Date) {
                    const filterVal = new Date(element.filterValue).setHours(0, 0, 0, 0);
                    data = this.utility.custFilter(data, (a) => {
                        if (!a[element.dataField]) {
                            return false;
                        }
                        return (new Date(a[element.dataField]).setHours(0, 0, 0, 0) < filterVal);
                    });
                }
            }
            else if (element.filterOperator === FilterTypes.LessThanOrEquals) {
                if (element.dataType === DataTypes.Number) {
                    const filterVal = Number(element.filterValue);
                    data = this.utility.custFilter(data, (a) => {
                        if (!a[element.dataField]) {
                            return false;
                        }
                        return Number(a[element.dataField]) <= filterVal;
                    });
                }
                else if (element.dataType === DataTypes.Date) {
                    const filterVal = new Date(element.filterValue).setHours(0, 0, 0, 0);
                    data = this.utility.custFilter(data, (a) => {
                        if (!a[element.dataField]) {
                            return false;
                        }
                        return (new Date(a[element.dataField]).setHours(0, 0, 0, 0) <= filterVal);
                    });
                }
            }
            else if (element.filterOperator === FilterTypes.Equals) {
                if (element.dataType === DataTypes.Boolean) {
                    if (element.filterValue === "true") {
                        data = this.utility.custFilter(data, (a) => {
                            return a[element.dataField] === true;
                        });
                    }
                    else {
                        data = this.utility.custFilter(data, (a) => {
                            return a[element.dataField] === false;
                        });
                    }
                }
                else if (element.dataType === DataTypes.Number) {
                    const filterVal = Number(element.filterValue);
                    data = this.utility.custFilter(data, (a) => {
                        if (!a[element.dataField]) {
                            return false;
                        }
                        return Number(a[element.dataField]) === filterVal;
                    });
                }
                else if (element.dataType === DataTypes.Date) {
                    const filterVal = new Date(element.filterValue).setHours(0, 0, 0, 0);
                    data = this.utility.custFilter(data, (a) => {
                        if (!a[element.dataField]) {
                            return false;
                        }
                        return (new Date(a[element.dataField]).setHours(0, 0, 0, 0) === filterVal);
                    });
                }
                else if (element.dataType === DataTypes.String) {
                    const filterVal = element.filterValue.toLowerCase();
                    data = this.utility.custFilter(data, (a) => {
                        if (!a[element.dataField]) {
                            return false;
                        }
                        return a[element.dataField].toLowerCase() === filterVal;
                    });
                }
            }
            else if (element.filterOperator === FilterTypes.NotEquals) {
                if (element.dataType === DataTypes.Boolean) {
                    if (element.filterValue === "true") {
                        data = this.utility.custFilter(data, (a) => {
                            return a[element.dataField] !== true;
                        });
                    }
                    else {
                        data = this.utility.custFilter(data, (a) => {
                            return a[element.dataField] !== false;
                        });
                    }
                }
                else if (element.dataType === DataTypes.Number) {
                    const filterVal = Number(element.filterValue);
                    data = this.utility.custFilter(data, (a) => {
                        if (!a[element.dataField]) {
                            return false;
                        }
                        return Number(a[element.dataField]) !== filterVal;
                    });
                }
                else if (element.dataType === DataTypes.Date) {
                    const filterVal = new Date(element.filterValue).setHours(0, 0, 0, 0);
                    data = this.utility.custFilter(data, (a) => {
                        if (!a[element.dataField]) {
                            return false;
                        }
                        return (new Date(a[element.dataField]).setHours(0, 0, 0, 0) !== filterVal);
                    });
                }
            }
        }
        return data;
    }
}
NpFilterService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpFilterService, deps: [{ token: NpGridUtilityService }], target: i0.ɵɵFactoryTarget.Injectable });
NpFilterService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpFilterService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpFilterService, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: NpGridUtilityService }]; } });

class NpODataService {
    buildQuery(filterColumns, sortColumns, top, skip, getTotalRecords = true, odataVersion = 4) {
        const queryTmpArray = [];
        // filter
        if (filterColumns) {
            if (filterColumns && filterColumns.length === 1) {
                if (filterColumns[0].dataType === DataTypes.String) {
                    if (filterColumns[0].filterOperator === FilterTypes.Equals) {
                        queryTmpArray.push(`$filter=(${filterColumns[0].dataField} eq '${filterColumns[0].filterValue}')`);
                    }
                    else {
                        queryTmpArray.push(`$filter=(${filterColumns[0].filterOperator}(${filterColumns[0].dataField},'${filterColumns[0].filterValue}'))`);
                    }
                }
                else {
                    queryTmpArray.push(`$filter=(${filterColumns[0].dataField} ${filterColumns[0].filterOperator} ${filterColumns[0].filterValue})`);
                }
            }
            if (filterColumns && filterColumns.length > 1) {
                const filterQueue = [];
                for (const element of filterColumns) {
                    if (element.dataType === DataTypes.String) {
                        if (element.filterOperator === FilterTypes.Equals) {
                            filterQueue.push(`${element.dataField} eq '${element.filterValue}'`);
                        }
                        else {
                            filterQueue.push(`${element.filterOperator}(${element.dataField} ,'${element.filterValue}')`);
                        }
                    }
                    else {
                        filterQueue.push(`${element.dataField} ${element.filterOperator} ${element.filterValue}`);
                    }
                }
                if (filterQueue.length > 1) {
                    queryTmpArray.push(`$filter=(${filterQueue.join(" and ")})`);
                }
            }
        }
        // sorting
        if (sortColumns) {
            const sortQueue = [];
            for (const element of sortColumns) {
                sortQueue.push(`${element.dataField} ${element.sortDirection}`);
            }
            if (sortQueue.length > 0) {
                queryTmpArray.push(`$orderby=${sortQueue.join(", ")}`);
            }
        }
        // top
        if (top > 0) {
            queryTmpArray.push(`$top=${top}`);
        }
        // skip
        if (skip > 0) {
            queryTmpArray.push(`$skip=${skip}`);
        }
        // inlinecount
        if (getTotalRecords) {
            if (odataVersion == 4) {
                queryTmpArray.push(`$count=true`);
            }
            else {
                queryTmpArray.push(`$inlinecount=allpages`);
            }
        }
        else {
            if (odataVersion == 4) {
                queryTmpArray.push(`$count=false`);
            }
            else {
                queryTmpArray.push(`$inlinecount=none`);
            }
        }
        return queryTmpArray.join("&");
    }
}
NpODataService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpODataService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
NpODataService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpODataService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpODataService, decorators: [{
            type: Injectable
        }] });

class NpFileService {
    constructor(datePipe) {
        this.datePipe = datePipe;
    }
    downloadCSVFile(data, columns, dateFormat, fileName) {
        const CSVData = this.createCSVData(data, columns, dateFormat);
        return this.downloadFile(CSVData, this.normalizeFileName(fileName, "csv"));
    }
    downloadFile(content, fileName) {
        const dataURI = this.generateDataURI(content);
        const anchor = document.createElement("a");
        anchor.href = dataURI;
        anchor.download = fileName;
        anchor.setAttribute("style", "visibility:hidden");
        document.body.appendChild(anchor);
        anchor.click();
        document.body.removeChild(anchor);
    }
    generateDataURI(content) {
        return "data:text/csv;charset=utf-8,\uFEFF" + encodeURIComponent(content);
    }
    createCSVData(data, columnList, dateFormat) {
        const headersLabels = [];
        for (const element of columnList) {
            if (element.dataField === undefined) {
                continue;
            }
            headersLabels.push(element.caption);
        }
        const head = headersLabels.join(",") + "\r\n";
        const rows = [];
        for (const element of data) {
            const cols = [];
            for (const column of columnList) {
                if (element[column.dataField] !== undefined &&
                    element[column.dataField] !== null) {
                    if (column.dataType === DataTypes.Date) {
                        cols.push(this.datePipe.transform(element[column.dataField], dateFormat));
                    }
                    else {
                        cols.push(`"${element[column.dataField].toString().replace(/\"/g, '""')}"`);
                    }
                }
                else {
                    cols.push("");
                }
            }
            rows.push(cols.join(","));
        }
        return head + rows.join("\r\n");
    }
    normalizeFileName(fileName, extension) {
        if (fileName === undefined || fileName === null || fileName.length === 0) {
            fileName = "download";
        }
        const suffix = "." + extension;
        const extensionPattern = new RegExp(`(\\${extension})?$`);
        return fileName.replace(/\s+/, "_").replace(extensionPattern, suffix);
    }
}
NpFileService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpFileService, deps: [{ token: i1$1.DatePipe }], target: i0.ɵɵFactoryTarget.Injectable });
NpFileService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpFileService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpFileService, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: i1$1.DatePipe }]; } });

class NpDialogRef {
    constructor(overlay, content, config, data) {
        this.overlay = overlay;
        this.content = content;
        this.config = config;
        this.data = data;
        this.onClose = new Subject();
    }
    close(data) {
        this._close(data);
    }
    _close(data) {
        this.overlay.dispose();
        this.onClose.next(data);
        this.onClose.complete();
    }
}

class NpDialogContainerComponent {
    constructor(dialogRef, translationService) {
        this.dialogRef = dialogRef;
        this.translationService = translationService;
        this.inputId = `np-dialog_${NpDialogContainerComponent.controlCount++}`;
    }
    ngOnInit() {
        this.type = this.dialogRef.config.type
            ? this.dialogRef.config.type
            : "alert";
        this.title = this.translationService.translate(this.type === "alert"
            ? "Alert"
            : this.type === "confirm"
                ? "Confirm"
                : "Prompt");
        this.message = this.dialogRef.content;
        if (typeof this.message === "string") {
            this.contentType = "string";
        }
        else {
            this.contentType = "template";
            this.context = {
                data: this.dialogRef.data,
            };
        }
        if (this.dialogRef.config.inputId) {
            this.inputId = this.dialogRef.config.inputId;
        }
        if (this.dialogRef.config.styleClass) {
            this.styleClass = this.dialogRef.config.styleClass;
        }
    }
    onOk() {
        if (this.type === "prompt") {
            this.dialogRef.close(this.value ? this.value : "");
        }
        else if (this.type === "confirm") {
            this.dialogRef.close(true);
        }
        else {
            this.dialogRef.close(undefined);
        }
    }
    onCancel() {
        if (this.type === "prompt") {
            this.dialogRef.close(null);
        }
        else if (this.type === "confirm") {
            this.dialogRef.close(false);
        }
        else {
            this.dialogRef.close(undefined);
        }
    }
}
NpDialogContainerComponent.controlCount = 1;
NpDialogContainerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpDialogContainerComponent, deps: [{ token: NpDialogRef }, { token: NpTranslationsService }], target: i0.ɵɵFactoryTarget.Component });
NpDialogContainerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpDialogContainerComponent, selector: "np-dialog", ngImport: i0, template: "<div role=\"alertdialog\" [ngClass]=\"'np-dialog'\" [class]=\"styleClass\" [attr.id]=\"inputId\"\r\n  [attr.aria-modal]=\"dialogRef.config.hasBackDrop ? 'true' : null\" [attr.aria-labelledby]=\"inputId + '_title'\">\r\n  <div class=\"np-dialog-header\" [innerHTML]=\"title\" [id]=\"inputId + '_title'\"></div>\r\n  <div class=\"np-dialog-body\">\r\n    <ng-container [ngSwitch]=\"contentType\">\r\n      <ng-container *ngSwitchCase=\"'string'\">\r\n        <div [innerHTML]=\"message\"></div>\r\n      </ng-container>\r\n      <ng-container *ngSwitchCase=\"'template'\">\r\n        <ng-container *ngTemplateOutlet=\"message; context: context\"></ng-container>\r\n      </ng-container>\r\n    </ng-container>\r\n    <input class=\"np-form-control np-dialog-input\" type=\"text\" *ngIf=\"type === 'prompt'\" [(ngModel)]=\"value\"\r\n      [npAutofocus]=\"true\" />\r\n  </div>\r\n  <div class=\"np-dialog-footer\">\r\n    <div class=\"np-btn-group\">\r\n      <button class=\"np-btn np-btn-primary np-dialog-ok\" (click)=\"onOk()\">\r\n        {{ \"Ok\" | npTranslate }}\r\n      </button>\r\n      <button class=\"np-btn np-btn-danger np-dialog-cancel\" *ngIf=\"type !== 'alert'\" (click)=\"onCancel()\">\r\n        {{ \"Cancel\" | npTranslate }}\r\n      </button>\r\n    </div>\r\n  </div>\r\n</div>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i1$1.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { kind: "directive", type: i1$1.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { kind: "directive", type: i3.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i3.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "directive", type: NpAutofocusDirective, selector: "[npAutofocus]", inputs: ["npAutofocus"] }, { kind: "pipe", type: NpTranslatePipe, name: "npTranslate" }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpDialogContainerComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-dialog", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, template: "<div role=\"alertdialog\" [ngClass]=\"'np-dialog'\" [class]=\"styleClass\" [attr.id]=\"inputId\"\r\n  [attr.aria-modal]=\"dialogRef.config.hasBackDrop ? 'true' : null\" [attr.aria-labelledby]=\"inputId + '_title'\">\r\n  <div class=\"np-dialog-header\" [innerHTML]=\"title\" [id]=\"inputId + '_title'\"></div>\r\n  <div class=\"np-dialog-body\">\r\n    <ng-container [ngSwitch]=\"contentType\">\r\n      <ng-container *ngSwitchCase=\"'string'\">\r\n        <div [innerHTML]=\"message\"></div>\r\n      </ng-container>\r\n      <ng-container *ngSwitchCase=\"'template'\">\r\n        <ng-container *ngTemplateOutlet=\"message; context: context\"></ng-container>\r\n      </ng-container>\r\n    </ng-container>\r\n    <input class=\"np-form-control np-dialog-input\" type=\"text\" *ngIf=\"type === 'prompt'\" [(ngModel)]=\"value\"\r\n      [npAutofocus]=\"true\" />\r\n  </div>\r\n  <div class=\"np-dialog-footer\">\r\n    <div class=\"np-btn-group\">\r\n      <button class=\"np-btn np-btn-primary np-dialog-ok\" (click)=\"onOk()\">\r\n        {{ \"Ok\" | npTranslate }}\r\n      </button>\r\n      <button class=\"np-btn np-btn-danger np-dialog-cancel\" *ngIf=\"type !== 'alert'\" (click)=\"onCancel()\">\r\n        {{ \"Cancel\" | npTranslate }}\r\n      </button>\r\n    </div>\r\n  </div>\r\n</div>" }]
        }], ctorParameters: function () { return [{ type: NpDialogRef }, { type: NpTranslationsService }]; } });

class NpDialogService {
    constructor(overlay, injector, overlayPositionBuilder) {
        this.overlay = overlay;
        this.injector = injector;
        this.overlayPositionBuilder = overlayPositionBuilder;
    }
    open(content, config, data) {
        const positionStrategy = this.overlayPositionBuilder
            .global()
            .centerHorizontally()
            .centerVertically();
        if (!config) {
            config = new NpDialogConfig({});
        }
        const overlayConfig = new OverlayConfig({
            positionStrategy,
            hasBackdrop: config.hasBackDrop,
            backdropClass: config.backDropClass || "np-dialog-backdrop",
            scrollStrategy: this.overlay.scrollStrategies.block(),
            panelClass: "np-dialog-overlay",
        });
        const overlayRef = this.overlay.create(overlayConfig);
        const myOverlayRef = new NpDialogRef(overlayRef, content, config, data);
        const injector = Injector.create({
            parent: this.injector,
            providers: [{ provide: NpDialogRef, useValue: myOverlayRef }],
        });
        overlayRef.attach(new ComponentPortal(NpDialogContainerComponent, null, injector));
        return myOverlayRef;
    }
}
NpDialogService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpDialogService, deps: [{ token: i1.Overlay }, { token: i0.Injector }, { token: i1.OverlayPositionBuilder }], target: i0.ɵɵFactoryTarget.Injectable });
NpDialogService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpDialogService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpDialogService, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: i1.Overlay }, { type: i0.Injector }, { type: i1.OverlayPositionBuilder }]; } });

class NpUtilityService {
    isEqual(x, y) {
        if (x === y) {
            return true;
        }
        if (!(x instanceof Object) || !(y instanceof Object)) {
            return false;
        }
        if (x.constructor !== y.constructor) {
            return false;
        }
        for (const p in x) {
            if (!x.hasOwnProperty(p)) {
                continue;
            }
            if (!y.hasOwnProperty(p)) {
                return false;
            }
            if (x[p] === y[p]) {
                continue;
            }
            if (typeof x[p] !== "object") {
                return false;
            }
            if (!this.isEqual(x[p], y[p])) {
                return false;
            }
        }
        for (const p in y) {
            if (y.hasOwnProperty(p) && !x.hasOwnProperty(p)) {
                return false;
            }
        }
        return true;
    }
    ReverseFormatDate(value, formatDate) {
        if (value.length === 0) {
            return null;
        }
        const formatTmp = formatDate.replace(/[a-z]/gi, "");
        const formatArray = formatTmp.split("");
        let day;
        let month;
        let year;
        const pattern = formatDate.split(formatArray[0]);
        if (value) {
            for (let i = 0; i < pattern.length; i++) {
                switch (pattern[i]) {
                    case "d":
                    case "dd": {
                        day = value.substr(formatDate.indexOf("d"), value.length - formatDate.length + pattern[i].length);
                        break;
                    }
                    case "M":
                    case "MM": {
                        month =
                            Number(value.substr(formatDate.indexOf("M"), value.length - formatDate.length + pattern[i].length)) - 1;
                        break;
                    }
                    case "MMM":
                    case "MMMM": {
                        const m = value.substr(formatDate.indexOf("M"), value.length - formatDate.length + pattern[i].length);
                        month = this.getMonth(m.toLowerCase());
                        break;
                    }
                    case "y":
                    case "yy":
                    case "yyyy": {
                        year = value.substr(formatDate.indexOf("y"), value.length - formatDate.length + pattern[i].length);
                        break;
                    }
                }
            }
        }
        const result = new Date(year, month, day);
        if (result.toString() === "Invalid Date") {
            return "Invalid Date";
        }
        return result;
    }
    getMonth(month) {
        let result = 0;
        switch (month) {
            case "january":
            case "jan":
                result = 0;
                break;
            case "february":
            case "feb":
                result = 1;
                break;
            case "march":
            case "mar":
                result = 2;
                break;
            case "april":
            case "apr":
                result = 3;
                break;
            case "may":
                result = 4;
                break;
            case "june":
            case "jun":
                result = 5;
                break;
            case "july":
            case "jul":
                result = 6;
                break;
            case "august":
            case "aug":
                result = 7;
                break;
            case "september":
            case "sep":
                result = 8;
                break;
            case "october":
            case "oct":
                result = 9;
                break;
            case "november":
            case "nov":
                result = 10;
                break;
            case "december":
            case "dec":
                result = 11;
                break;
        }
        return result;
    }
    getPosition(placement) {
        let result;
        switch (placement) {
            case "left": {
                result = [
                    {
                        originX: "start",
                        originY: "center",
                        overlayX: "end",
                        overlayY: "center",
                        offsetX: -5,
                    },
                ];
                break;
            }
            case "right": {
                result = [
                    {
                        originX: "end",
                        originY: "center",
                        overlayX: "start",
                        overlayY: "center",
                        offsetX: 5,
                    },
                ];
                break;
            }
            case "top": {
                result = [
                    {
                        originX: "center",
                        originY: "top",
                        overlayX: "center",
                        overlayY: "bottom",
                        offsetY: -5,
                    },
                ];
                break;
            }
            case "bottom": {
                result = [
                    {
                        originX: "center",
                        originY: "bottom",
                        overlayX: "center",
                        overlayY: "top",
                        offsetY: 5,
                    },
                ];
                break;
            }
            default: {
                result = [
                    {
                        originX: "center",
                        originY: "bottom",
                        overlayX: "center",
                        overlayY: "top",
                        offsetY: 5,
                    },
                    {
                        originX: "center",
                        originY: "top",
                        overlayX: "center",
                        overlayY: "bottom",
                        offsetY: -5,
                    },
                    {
                        originX: "start",
                        originY: "center",
                        overlayX: "end",
                        overlayY: "center",
                        offsetX: -5,
                    },
                    {
                        originX: "end",
                        originY: "center",
                        overlayX: "start",
                        overlayY: "center",
                        offsetX: 5,
                    },
                ];
            }
        }
        return result;
    }
}
NpUtilityService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpUtilityService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
NpUtilityService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpUtilityService, providedIn: "root" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpUtilityService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: "root",
                }]
        }] });

class NpTooltipComponent {
    constructor() {
        this.inputId = `np-tooltip_${NpTooltipComponent.controlCount++}`;
    }
    ngOnInit() {
        if (this.tooltip instanceof TemplateRef) {
            this.isTemplate = true;
        }
    }
}
NpTooltipComponent.controlCount = 1;
NpTooltipComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTooltipComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NpTooltipComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpTooltipComponent, selector: "ng-component", inputs: { tooltip: "tooltip", context: "context", width: "width", styleClass: "styleClass", inputId: "inputId" }, ngImport: i0, template: "<div [ngClass]=\"'np-tooltip'\" [class]=\"styleClass\" [attr.id]=\"inputId\" [style.width.px]=\"width\">\r\n  <ng-container *ngIf=\"!isTemplate\">\r\n    <div [innerHTML]=\"tooltip\"></div>\r\n  </ng-container>\r\n  <ng-template *ngIf=\"isTemplate\" [ngTemplateOutlet]=\"tooltip\" [ngTemplateOutletContext]=\"context\">\r\n  </ng-template>\r\n</div>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTooltipComponent, decorators: [{
            type: Component,
            args: [{ encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, template: "<div [ngClass]=\"'np-tooltip'\" [class]=\"styleClass\" [attr.id]=\"inputId\" [style.width.px]=\"width\">\r\n  <ng-container *ngIf=\"!isTemplate\">\r\n    <div [innerHTML]=\"tooltip\"></div>\r\n  </ng-container>\r\n  <ng-template *ngIf=\"isTemplate\" [ngTemplateOutlet]=\"tooltip\" [ngTemplateOutletContext]=\"context\">\r\n  </ng-template>\r\n</div>" }]
        }], propDecorators: { tooltip: [{
                type: Input
            }], context: [{
                type: Input
            }], width: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], inputId: [{
                type: Input
            }] } });

class NpTooltipDirective {
    constructor(overlay, overlayPositionBuilder, elementRef, utility) {
        this.overlay = overlay;
        this.overlayPositionBuilder = overlayPositionBuilder;
        this.elementRef = elementRef;
        this.utility = utility;
        this.tooltipOnFocus = false;
        this.mouseEnterListener = () => { };
        this.mouseLeaveListener = () => { };
        this.focusListener = () => { };
        this.blurListener = () => { };
    }
    ngAfterViewInit() {
        this.elementRef.nativeElement.className = `${this.elementRef.nativeElement.className} np-tooltip-target`.trim();
        const position = this.utility.getPosition(this.placement);
        const positionStrategy = this.overlayPositionBuilder
            .flexibleConnectedTo(this.elementRef)
            .withPositions(position);
        this.overlayRef = this.overlay.create({
            positionStrategy,
            scrollStrategy: this.overlay.scrollStrategies.reposition(),
        });
        if (this.tooltipOnFocus) {
            this.focusListener = this._show.bind(this);
            this.blurListener = this._hide.bind(this);
            this.elementRef.nativeElement.addEventListener("focus", this.focusListener);
            this.elementRef.nativeElement.addEventListener("blur", this.blurListener);
        }
        else {
            this.mouseEnterListener = this._show.bind(this);
            this.mouseLeaveListener = this._hide.bind(this);
            this.elementRef.nativeElement.addEventListener("mouseover", this.mouseEnterListener);
            this.elementRef.nativeElement.addEventListener("mouseout", this.mouseLeaveListener);
        }
    }
    ngOnDestroy() {
        if (this.overlayRef.hasAttached()) {
            this.overlayRef.detach();
        }
    }
    _show() {
        const tooltipPortal = new ComponentPortal(NpTooltipComponent);
        const tooltipRef = this.overlayRef.attach(tooltipPortal);
        tooltipRef.instance.tooltip = this.text;
        tooltipRef.instance.context = this.context;
        tooltipRef.instance.width = this.width;
        tooltipRef.instance.styleClass = this.styleClass;
    }
    _hide() {
        if (this.overlayRef.hasAttached()) {
            this.overlayRef.detach();
        }
    }
}
NpTooltipDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTooltipDirective, deps: [{ token: i1.Overlay }, { token: i1.OverlayPositionBuilder }, { token: i0.ElementRef }, { token: NpUtilityService }], target: i0.ɵɵFactoryTarget.Directive });
NpTooltipDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.0.1", type: NpTooltipDirective, selector: "[npTooltip]", inputs: { text: ["npTooltip", "text"], placement: "placement", context: "context", width: "width", styleClass: "styleClass", tooltipOnFocus: "tooltipOnFocus" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTooltipDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: "[npTooltip]",
                }]
        }], ctorParameters: function () { return [{ type: i1.Overlay }, { type: i1.OverlayPositionBuilder }, { type: i0.ElementRef }, { type: NpUtilityService }]; }, propDecorators: { text: [{
                type: Input,
                args: ["npTooltip"]
            }], placement: [{
                type: Input
            }], context: [{
                type: Input
            }], width: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], tooltipOnFocus: [{
                type: Input
            }] } });

class NpDatePickerComponent {
    constructor(overlay, viewContainerRef, overlayPositionBuilder, elementRef, utility) {
        this.overlay = overlay;
        this.viewContainerRef = viewContainerRef;
        this.overlayPositionBuilder = overlayPositionBuilder;
        this.elementRef = elementRef;
        this.utility = utility;
        this.format = "dd/MM/yyyy";
        this.defaultOpen = false;
        this.showTodayButton = false;
        this.disableWeekDays = [];
        this.disableDates = [];
        this.dateLabels = [];
        this.isStartMonthWithMonday = false;
        this.placeholder = "";
        this.inputId = `np-date-picker_${NpDatePickerComponent.controlCount++}`;
        this.onChange = new EventEmitter();
        this.onFocus = new EventEmitter();
        this.onBlur = new EventEmitter();
        this.years = [];
        this.isOpen = false;
        this.isDisabled = false;
        this.originalWeekDays = ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"];
        this.focused = false;
        this.onChangeCallback = () => { };
        this.onTouchedCallback = () => { };
        this.monthsList = [
            { key: 0, value: "January" },
            { key: 1, value: "February" },
            { key: 2, value: "March" },
            { key: 3, value: "April" },
            { key: 4, value: "May" },
            { key: 5, value: "June" },
            { key: 6, value: "July" },
            { key: 7, value: "August" },
            { key: 8, value: "September" },
            { key: 9, value: "October" },
            { key: 10, value: "November" },
            { key: 11, value: "December" },
        ];
        this.today = new Date();
        this.today.setHours(0, 0, 0, 0);
    }
    ngAfterContentInit() {
        if (this.isStartMonthWithMonday) {
            this.weekDays = ["Mo", "Tu", "We", "Th", "Fr", "Sa", "Su"];
        }
        else {
            this.weekDays = ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"];
        }
        if (this.defaultOpen) {
            this._resetVariables();
        }
    }
    ngAfterViewInit() {
        const positionStrategy = this.overlayPositionBuilder
            .flexibleConnectedTo(this.elementRef)
            .withPositions(TopBottomOverlayPositions);
        this.overlayRef = this.overlay.create({
            positionStrategy,
            hasBackdrop: true,
            backdropClass: "np-date-picker-backdrop",
            scrollStrategy: this.overlay.scrollStrategies.reposition(),
            panelClass: this.styleClass,
        });
        this.templatePortal = new TemplatePortal(this.templatePortalContent, this.viewContainerRef);
        this.overlayRef.backdropClick().subscribe(() => this._close());
    }
    get value() {
        return this.innerValue ? this.innerValue : null;
    }
    set value(v) {
        if (v !== this.innerValue) {
            this.innerValue = v;
            this.onChangeCallback(v);
            this.onChange.emit(v);
        }
    }
    writeValue(v) {
        if (v !== this.innerValue) {
            this.innerValue = v;
            if (this._checkIsFullDateDisabled(v)) {
                this.value = null;
            }
        }
    }
    registerOnChange(fn) {
        this.onChangeCallback = fn;
    }
    registerOnTouched(fn) {
        this.onTouchedCallback = fn;
    }
    setDisabledState(isDisabled) {
        this.isDisabled = isDisabled;
    }
    focus() {
        this.inputViewChild.nativeElement.focus();
    }
    _resetVariables() {
        if (this.value) {
            if (this.minDate && this.minDate > this.value) {
                this.value = null;
            }
            if (this.maxDate && this.maxDate < this.value) {
                this.value = null;
            }
        }
        let currentDate = this.value && this.value.toString() !== "Invalid Date"
            ? this.value
            : this.today;
        if (this.minDate && currentDate < this.minDate) {
            currentDate = this.minDate;
        }
        if (this.maxDate && currentDate > this.maxDate) {
            currentDate = this.maxDate;
        }
        this.currentMonth = currentDate.getMonth();
        this.currentYear = currentDate.getFullYear();
        this._calculateDays();
    }
    _calculateDays() {
        const weeks = [];
        weeks[0] = [];
        const daysInMonth = this._getCurrentMonthData();
        const firstWeekDayOfMonth = new Date(this.currentYear, this.currentMonth, 1).getDay();
        // push extra values up to week days match to start date if month
        for (let index = 0; index < firstWeekDayOfMonth; index++) {
            weeks[0].push({ disabled: true });
        }
        if (this.isStartMonthWithMonday) {
            // if start with monday then
            if (firstWeekDayOfMonth === 0) {
                weeks[0].push({ disabled: true }, { disabled: true }, { disabled: true }, { disabled: true }, { disabled: true }, { disabled: true });
            }
            else {
                weeks[0].pop();
            }
        }
        let j = 0;
        // push all dates in month
        daysInMonth.forEach((element) => {
            if (weeks[j].length === 7) {
                j++;
                weeks[j] = [];
            }
            weeks[j].push(element);
        });
        this.currentMonthWeeks = weeks;
    }
    _getCurrentMonthData() {
        const data = [];
        const totalDaysInMonth = this._daysInCurrentMonth();
        for (let i = 1; i <= totalDaysInMonth; i++) {
            const date = new Date(this.currentYear, this.currentMonth, i);
            data.push({
                date,
                day: i,
                disabled: this._checkIsFullDateDisabled(date),
                today: this._compareDate(this.today, date),
                selected: this._compareDate(this.value, date),
                toolTip: this._getTooltip(date),
            });
        }
        return data;
    }
    _daysInCurrentMonth() {
        let days = 0;
        switch (this.currentMonth) {
            case 0: // Jan
            case 2: // Mar
            case 4: // May
            case 6: // Jul
            case 7: // Aug
            case 9: // Oct
            case 11: // Dec
                days = 31;
                break;
            case 3: // Apr
            case 5: // Jun
            case 8: // Sept
            case 10: // Nov
                days = 30;
                break;
            case 1: // Feb
                days = this.currentYear % 4 === 0 ? 29 : 28;
                break;
        }
        return days;
    }
    _prevMonth() {
        if (this.currentMonth === 0) {
            this.currentMonth = 11;
            this.currentYear = this.currentYear - 1;
        }
        else {
            this.currentMonth = this.currentMonth - 1;
        }
        this._calculateDays();
    }
    _nextMonth() {
        if (this.currentMonth === 11) {
            this.currentMonth = 0;
            this.currentYear = this.currentYear + 1;
        }
        else {
            this.currentMonth = this.currentMonth + 1;
        }
        this._calculateDays();
    }
    _selectDate(date) {
        if (date === null ||
            this._checkIsFullDateDisabled(date) ||
            this.isDisabled ||
            this.readOnly) {
            return;
        }
        this._setSelectedDate(date);
        this._close();
    }
    _selectMonth($event) {
        this.currentMonth = Number($event.target.value);
        this._calculateDays();
    }
    _changeYear($event) {
        this.currentYear = Number($event.target.value.trim());
        this._calculateDays();
    }
    _toggleDatePicker() {
        if (this.isOpen) {
            this._close();
        }
        else {
            this._open();
        }
    }
    _open() {
        if (this.defaultOpen === true || this.isDisabled || this.readOnly) {
            return;
        }
        this.isOpen = true;
        this._resetVariables();
        if (!this.overlayRef.hasAttached()) {
            this.overlayRef.attach(this.templatePortal);
        }
    }
    _close() {
        if (this.defaultOpen) {
            return;
        }
        this.isOpen = false;
        this.overlayRef.detach();
        this.inputViewChild.nativeElement.focus();
    }
    _setToday() {
        if (this._checkIsFullDateDisabled(this.today)) {
            return;
        }
        this._setSelectedDate(this.today);
        this._calculateDays();
        this._close();
    }
    _clear() {
        if (this.isDisabled || this.readOnly) {
            return;
        }
        this._setSelectedDate(null);
        this._calculateDays();
        this._close();
    }
    _getTooltip(currentDate) {
        if (currentDate && this.dateLabels && this.dateLabels.length > 0) {
            const dateLabel = this.dateLabels.find((item) => this._compareDate(item.date, currentDate));
            return dateLabel ? dateLabel.label : null;
        }
        return null;
    }
    _checkIsWeekDayDisabled(index) {
        const day = this.originalWeekDays[index];
        return this.disableWeekDays.indexOf(day) > -1;
    }
    _checkIsFullDateDisabled(date) {
        if (date === undefined || date === null) {
            return false;
        }
        if (this.minDate && date < this.minDate) {
            return true;
        }
        if (this.maxDate && date > this.maxDate) {
            return true;
        }
        if (this._checkIsWeekDayDisabled(date.getDay())) {
            return true;
        }
        return (this.disableDates.findIndex((item) => this._compareDate(item, date))) > -1;
    }
    _setSelectedDate(date) {
        if (date) {
            date.setHours(0, 0, 0, 0);
        }
        if (this._checkIsFullDateDisabled(date)) {
            return;
        }
        this.value = date;
        this._resetVariables();
    }
    _onKeydown(event) {
        if (event.key === "Tab" || event.key === "Escape") {
            this._close();
        }
        if (event.key === "ArrowDown") {
            this._open();
            event.preventDefault();
        }
    }
    _onInputChange($event) {
        const date = this.utility.ReverseFormatDate($event.target.value.trim(), this.format);
        if (date === "Invalid Date") {
            $event.target.value = "";
            this.value = null;
            return;
        }
        if (this._checkIsFullDateDisabled(date)) {
            this.value = null;
            return;
        }
        this.value = date;
        this._resetVariables();
    }
    _compareDate(dateA, dateB) {
        if (!dateA || !dateB) {
            return false;
        }
        if (dateA.getFullYear() === dateB.getFullYear() &&
            dateA.getMonth() === dateB.getMonth() &&
            dateA.getDate() === dateB.getDate()) {
            return true;
        }
        return false;
    }
    _onBlur($event) {
        this.focused = false;
        this.onTouchedCallback();
        this.onBlur.emit($event);
    }
    _onFocus($event) {
        this.focused = true;
        this.onFocus.emit($event);
    }
    _getDateClass(item) {
        if (this.dateClass) {
            return (`np-date-picker-day np-day-${item.day} ` + this.dateClass(item.date)).trim();
        }
        return `np-date-picker-day np-day-${item.day}`;
    }
}
NpDatePickerComponent.controlCount = 1;
NpDatePickerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpDatePickerComponent, deps: [{ token: i1.Overlay }, { token: i0.ViewContainerRef }, { token: i1.OverlayPositionBuilder }, { token: i0.ElementRef }, { token: NpUtilityService }], target: i0.ɵɵFactoryTarget.Component });
NpDatePickerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpDatePickerComponent, selector: "np-date-picker", inputs: { minDate: "minDate", maxDate: "maxDate", format: "format", defaultOpen: "defaultOpen", showTodayButton: "showTodayButton", disableWeekDays: "disableWeekDays", disableDates: "disableDates", dateLabels: "dateLabels", dateClass: "dateClass", isStartMonthWithMonday: "isStartMonthWithMonday", placeholder: "placeholder", readOnly: "readOnly", autoFocus: "autoFocus", tabIndex: "tabIndex", styleClass: "styleClass", inputId: "inputId" }, outputs: { onChange: "onChange", onFocus: "onFocus", onBlur: "onBlur" }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => NpDatePickerComponent),
            multi: true,
        },
    ], viewQueries: [{ propertyName: "templatePortalContent", first: true, predicate: ["templatePortalContent"], descendants: true }, { propertyName: "inputViewChild", first: true, predicate: ["control"], descendants: true }], ngImport: i0, template: "<div [ngClass]=\"{\r\n    'np-date-picker': true,\r\n    'np-disabled': isDisabled,\r\n    'np-readonly': readOnly\r\n  }\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-input-group\" *ngIf=\"!defaultOpen; else templatePortalContent\" [ngClass]=\"{ 'np-focused': focused }\">\r\n    <input class=\"np-form-control\" type=\"text\" #control [value]=\"value | date: format\" [placeholder]=\"placeholder\"\r\n      [disabled]=\"isDisabled\" [npAutofocus]=\"autoFocus\" [attr.tabindex]=\"tabIndex\" [readonly]=\"readOnly\"\r\n      (click)=\"_open()\" (keydown)=\"_onKeydown($event)\" (change)=\"_onInputChange($event)\" (blur)=\"_onBlur($event)\"\r\n      (focus)=\"_onFocus($event)\" />\r\n    <div class=\"np-input-group-append\">\r\n      <button class=\"np-btn-icon np-toggle-overlay\" type=\"button\" tabindex=\"-1\" (click)=\"_toggleDatePicker()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path\r\n            d=\"M9 11H7v2h2v-2zm4 0h-2v2h2v-2zm4 0h-2v2h2v-2zm2-7h-1V2h-2v2H8V2H6v2H5c-1.11 0-1.99.9-1.99 2L3 20c0 1.1.89 2 2 2h14c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm0 16H5V9h14v11z\">\r\n          </path>\r\n          <path fill=\"none\" d=\"M0 0h24v24H0z\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n  </div>\r\n</div>\r\n<ng-template #templatePortalContent>\r\n  <div class=\"np-date-picker-overlay\" [ngClass]=\"{ 'np-overlay-open': defaultOpen }\">\r\n    <div class=\"np-date-picker-header\">\r\n      <button class=\"np-btn-icon\" type=\"button\" tabindex=\"-1\" (click)=\"_prevMonth()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M15.41 16.59L10.83 12l4.58-4.59L14 6l-6 6 6 6 1.41-1.41z\"></path>\r\n          <path fill=\"none\" d=\"M0 0h24v24H0V0z\"></path>\r\n        </svg>\r\n      </button>\r\n      <input class=\"np-form-control np-date-picker-years\" type=\"number\" tabindex=\"-1\" [value]=\"currentYear\"\r\n        (change)=\"_changeYear($event)\" required />\r\n      <select class=\"np-form-control np-date-picker-months\" tabindex=\"-1\" (change)=\"_selectMonth($event)\">\r\n        <option *ngFor=\"let month of monthsList\" [value]=\"month.key\" [text]=\"month.value | npTranslate\"\r\n          [selected]=\"month.key === currentMonth\"></option>\r\n      </select>\r\n      <button class=\"np-btn-icon\" type=\"button\" tabindex=\"-1\" (click)=\"_nextMonth()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M8.59 16.59L13.17 12 8.59 7.41 10 6l6 6-6 6-1.41-1.41z\"></path>\r\n          <path fill=\"none\" d=\"M0 0h24v24H0V0z\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n    <div class=\"np-date-picker-weekdays\">\r\n      <ng-container *ngFor=\"let weekDay of weekDays\">\r\n        <div class=\"np-date-picker-weekday\">{{ weekDay | npTranslate }}</div>\r\n      </ng-container>\r\n    </div>\r\n    <div class=\"np-date-picker-days\">\r\n      <div *ngFor=\"let week of currentMonthWeeks\">\r\n        <ng-container *ngFor=\"let item of week\">\r\n          <div *ngIf=\"!item.day\" class=\"np-date-picker-day\"></div>\r\n          <div *ngIf=\"item.day\" [class]=\"_getDateClass(item)\" (click)=\"_selectDate(item.date)\" [ngClass]=\"{\r\n              'np-date-picker-today': item.today,\r\n              'np-disabled': item.disabled,\r\n              'np-date-picker-selected': item.selected\r\n            }\">\r\n            <div *ngIf=\"item.toolTip; else dayTemplate\" [npTooltip]=\"item.toolTip\" [innerHTML]=\"item.day\"></div>\r\n            <ng-template #dayTemplate>\r\n              <div [innerHTML]=\"item.day\"></div>\r\n            </ng-template>\r\n          </div>\r\n        </ng-container>\r\n      </div>\r\n    </div>\r\n    <div class=\"np-date-picker-footer\">\r\n      <button class=\"np-btn np-btn-primary np-ok\" type=\"button\" *ngIf=\"!defaultOpen\" tabindex=\"-1\" (click)=\"_close()\">\r\n        {{ \"Ok\" | npTranslate }}\r\n      </button>\r\n      <button class=\"np-btn np-btn-primary np-today\" type=\"button\" *ngIf=\"showTodayButton\" tabindex=\"-1\"\r\n        (click)=\"_setToday()\">\r\n        {{ \"Today\" | npTranslate }}\r\n      </button>\r\n      <button class=\"np-btn np-btn-danger np-clear\" type=\"button\" tabindex=\"-1\" (click)=\"_clear()\">\r\n        {{ \"Clear\" | npTranslate }}\r\n      </button>\r\n    </div>\r\n  </div>\r\n</ng-template>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: NpTooltipDirective, selector: "[npTooltip]", inputs: ["npTooltip", "placement", "context", "width", "styleClass", "tooltipOnFocus"] }, { kind: "directive", type: NpAutofocusDirective, selector: "[npAutofocus]", inputs: ["npAutofocus"] }, { kind: "pipe", type: i1$1.DatePipe, name: "date" }, { kind: "pipe", type: NpTranslatePipe, name: "npTranslate" }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpDatePickerComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-date-picker", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => NpDatePickerComponent),
                            multi: true,
                        },
                    ], template: "<div [ngClass]=\"{\r\n    'np-date-picker': true,\r\n    'np-disabled': isDisabled,\r\n    'np-readonly': readOnly\r\n  }\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-input-group\" *ngIf=\"!defaultOpen; else templatePortalContent\" [ngClass]=\"{ 'np-focused': focused }\">\r\n    <input class=\"np-form-control\" type=\"text\" #control [value]=\"value | date: format\" [placeholder]=\"placeholder\"\r\n      [disabled]=\"isDisabled\" [npAutofocus]=\"autoFocus\" [attr.tabindex]=\"tabIndex\" [readonly]=\"readOnly\"\r\n      (click)=\"_open()\" (keydown)=\"_onKeydown($event)\" (change)=\"_onInputChange($event)\" (blur)=\"_onBlur($event)\"\r\n      (focus)=\"_onFocus($event)\" />\r\n    <div class=\"np-input-group-append\">\r\n      <button class=\"np-btn-icon np-toggle-overlay\" type=\"button\" tabindex=\"-1\" (click)=\"_toggleDatePicker()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path\r\n            d=\"M9 11H7v2h2v-2zm4 0h-2v2h2v-2zm4 0h-2v2h2v-2zm2-7h-1V2h-2v2H8V2H6v2H5c-1.11 0-1.99.9-1.99 2L3 20c0 1.1.89 2 2 2h14c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm0 16H5V9h14v11z\">\r\n          </path>\r\n          <path fill=\"none\" d=\"M0 0h24v24H0z\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n  </div>\r\n</div>\r\n<ng-template #templatePortalContent>\r\n  <div class=\"np-date-picker-overlay\" [ngClass]=\"{ 'np-overlay-open': defaultOpen }\">\r\n    <div class=\"np-date-picker-header\">\r\n      <button class=\"np-btn-icon\" type=\"button\" tabindex=\"-1\" (click)=\"_prevMonth()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M15.41 16.59L10.83 12l4.58-4.59L14 6l-6 6 6 6 1.41-1.41z\"></path>\r\n          <path fill=\"none\" d=\"M0 0h24v24H0V0z\"></path>\r\n        </svg>\r\n      </button>\r\n      <input class=\"np-form-control np-date-picker-years\" type=\"number\" tabindex=\"-1\" [value]=\"currentYear\"\r\n        (change)=\"_changeYear($event)\" required />\r\n      <select class=\"np-form-control np-date-picker-months\" tabindex=\"-1\" (change)=\"_selectMonth($event)\">\r\n        <option *ngFor=\"let month of monthsList\" [value]=\"month.key\" [text]=\"month.value | npTranslate\"\r\n          [selected]=\"month.key === currentMonth\"></option>\r\n      </select>\r\n      <button class=\"np-btn-icon\" type=\"button\" tabindex=\"-1\" (click)=\"_nextMonth()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M8.59 16.59L13.17 12 8.59 7.41 10 6l6 6-6 6-1.41-1.41z\"></path>\r\n          <path fill=\"none\" d=\"M0 0h24v24H0V0z\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n    <div class=\"np-date-picker-weekdays\">\r\n      <ng-container *ngFor=\"let weekDay of weekDays\">\r\n        <div class=\"np-date-picker-weekday\">{{ weekDay | npTranslate }}</div>\r\n      </ng-container>\r\n    </div>\r\n    <div class=\"np-date-picker-days\">\r\n      <div *ngFor=\"let week of currentMonthWeeks\">\r\n        <ng-container *ngFor=\"let item of week\">\r\n          <div *ngIf=\"!item.day\" class=\"np-date-picker-day\"></div>\r\n          <div *ngIf=\"item.day\" [class]=\"_getDateClass(item)\" (click)=\"_selectDate(item.date)\" [ngClass]=\"{\r\n              'np-date-picker-today': item.today,\r\n              'np-disabled': item.disabled,\r\n              'np-date-picker-selected': item.selected\r\n            }\">\r\n            <div *ngIf=\"item.toolTip; else dayTemplate\" [npTooltip]=\"item.toolTip\" [innerHTML]=\"item.day\"></div>\r\n            <ng-template #dayTemplate>\r\n              <div [innerHTML]=\"item.day\"></div>\r\n            </ng-template>\r\n          </div>\r\n        </ng-container>\r\n      </div>\r\n    </div>\r\n    <div class=\"np-date-picker-footer\">\r\n      <button class=\"np-btn np-btn-primary np-ok\" type=\"button\" *ngIf=\"!defaultOpen\" tabindex=\"-1\" (click)=\"_close()\">\r\n        {{ \"Ok\" | npTranslate }}\r\n      </button>\r\n      <button class=\"np-btn np-btn-primary np-today\" type=\"button\" *ngIf=\"showTodayButton\" tabindex=\"-1\"\r\n        (click)=\"_setToday()\">\r\n        {{ \"Today\" | npTranslate }}\r\n      </button>\r\n      <button class=\"np-btn np-btn-danger np-clear\" type=\"button\" tabindex=\"-1\" (click)=\"_clear()\">\r\n        {{ \"Clear\" | npTranslate }}\r\n      </button>\r\n    </div>\r\n  </div>\r\n</ng-template>" }]
        }], ctorParameters: function () { return [{ type: i1.Overlay }, { type: i0.ViewContainerRef }, { type: i1.OverlayPositionBuilder }, { type: i0.ElementRef }, { type: NpUtilityService }]; }, propDecorators: { minDate: [{
                type: Input
            }], maxDate: [{
                type: Input
            }], format: [{
                type: Input
            }], defaultOpen: [{
                type: Input
            }], showTodayButton: [{
                type: Input
            }], disableWeekDays: [{
                type: Input
            }], disableDates: [{
                type: Input
            }], dateLabels: [{
                type: Input
            }], dateClass: [{
                type: Input
            }], isStartMonthWithMonday: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], readOnly: [{
                type: Input
            }], autoFocus: [{
                type: Input
            }], tabIndex: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], inputId: [{
                type: Input
            }], onChange: [{
                type: Output
            }], onFocus: [{
                type: Output
            }], onBlur: [{
                type: Output
            }], templatePortalContent: [{
                type: ViewChild,
                args: ["templatePortalContent"]
            }], inputViewChild: [{
                type: ViewChild,
                args: ["control"]
            }] } });

class NpPaginatorComponent {
    constructor() {
        this.showPageSize = true;
        this.showTotal = true;
        this.inputId = `np-paginator-box_${NpPaginatorComponent.controlCount++}`;
        this.onPageChange = new EventEmitter();
        this.onPageSizeChange = new EventEmitter();
        this.onRefresh = new EventEmitter();
        this.initialized = false;
    }
    ngOnChanges(changes) {
        if (changes && changes["totalItems"]) {
            this.totalPages = this._calculateTotalPages();
            this._setStartEndIndex();
            if (this.currentPage > this.totalPages) {
                this._applyChanges();
            }
            return;
        }
        if (changes && (changes["currentPage"] || changes["pageSize"])) {
            this._applyChanges();
        }
    }
    ngOnInit() {
        if (!this.pageSize) {
            this.pageSize = 10;
        }
        if (!this.totalItems) {
            this.totalItems = 0;
        }
        if (!this.currentPage) {
            this.currentPage = 1;
        }
        this.initialized = true;
        this._applyChanges();
    }
    loadPage(page) {
        this._loadPage(page);
    }
    refresh() {
        this.onRefresh.emit();
        this.onPageChange.emit({
            currentPage: this.currentPage,
            pageSize: this.pageSize,
        });
    }
    _onCurrentPageChange(event) {
        this._loadPage(Number(event.target.value));
    }
    _onItemPerPageChange(event) {
        this.onPageSizeChange.emit(event.target.value);
        this.pageSize = Number(event.target.value);
        this._loadPage(1);
    }
    _loadPage(page) {
        this.currentPage = page;
        this._applyChanges();
    }
    _applyChanges() {
        if (this.initialized) {
            this.totalPages = this._calculateTotalPages();
        }
        if (this.currentPage > 0 && this.pageSize > 0 && this.totalPages > 0) {
            if (this.currentPage < 1) {
                this.currentPage = 1;
            }
            if (this.currentPage > this.totalPages) {
                this.currentPage = this.totalPages;
            }
            this.onPageChange.emit({
                currentPage: this.currentPage,
                pageSize: this.pageSize,
            });
            this._setStartEndIndex();
        }
    }
    _calculateTotalPages() {
        const result = this.pageSize < 1 ? 1 : Math.ceil(this.totalItems / this.pageSize);
        return Math.max(result || 0, 1);
    }
    _setStartEndIndex() {
        if (this.totalItems === 0) {
            this.startIndex = -1;
            this.endIndex = -1;
            return;
        }
        this.startIndex = (this.currentPage - 1) * this.pageSize;
        this.endIndex = Math.min(this.startIndex + this.pageSize - 1, this.totalItems - 1);
    }
}
NpPaginatorComponent.controlCount = 1;
NpPaginatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpPaginatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NpPaginatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpPaginatorComponent, selector: "np-paginator", inputs: { pageSize: "pageSize", totalItems: "totalItems", currentPage: "currentPage", showPageSize: "showPageSize", showTotal: "showTotal", styleClass: "styleClass", inputId: "inputId" }, outputs: { onPageChange: "onPageChange", onPageSizeChange: "onPageSizeChange", onRefresh: "onRefresh" }, usesOnChanges: true, ngImport: i0, template: "<div [ngClass]=\"'np-toolbar np-paginator'\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-toolbar-item\">\r\n    <button class=\"np-btn-icon np-paginator-first\" type=\"button\" [ngClass]=\"{ 'np-disabled': currentPage === 1 }\"\r\n      (click)=\"_loadPage(1)\">\r\n      <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n        <path d=\"M18.41 16.59L13.82 12l4.59-4.59L17 6l-6 6 6 6zM6 6h2v12H6z\"></path>\r\n      </svg>\r\n    </button>\r\n  </div>\r\n  <div class=\"np-toolbar-item\">\r\n    <button class=\"np-btn-icon np-paginator-prev\" type=\"button\" [ngClass]=\"{ 'np-disabled': currentPage === 1 }\"\r\n      (click)=\"_loadPage(currentPage - 1)\">\r\n      <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n        <path d=\"M15.41 7.41L14 6l-6 6 6 6 1.41-1.41L10.83 12z\"></path>\r\n      </svg>\r\n    </button>\r\n  </div>\r\n  <div class=\"np-toolbar-item\">\r\n    <input class=\"np-form-control np-paginator-current-page\" type=\"number\" [value]=\"currentPage\" [min]=\"1\"\r\n      [max]=\"totalPages\" (change)=\"_onCurrentPageChange($event)\" />\r\n  </div>\r\n  <div class=\"np-toolbar-item\">/ {{ totalPages }}</div>\r\n  <div class=\"np-toolbar-item\">\r\n    <button class=\"np-btn-icon np-paginator-next\" type=\"button\"\r\n      [ngClass]=\"{ 'np-disabled': currentPage === totalPages }\" (click)=\"_loadPage(currentPage + 1)\">\r\n      <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n        <path d=\"M10 6L8.59 7.41 13.17 12l-4.58 4.59L10 18l6-6z\"></path>\r\n      </svg>\r\n    </button>\r\n  </div>\r\n  <div class=\"np-toolbar-item\">\r\n    <button class=\"np-btn-icon np-paginator-last\" type=\"button\"\r\n      [ngClass]=\"{ 'np-disabled': currentPage === totalPages }\" (click)=\"_loadPage(totalPages)\">\r\n      <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n        <path d=\"M5.59 7.41L10.18 12l-4.59 4.59L7 18l6-6-6-6zM16 6h2v12h-2z\"></path>\r\n      </svg>\r\n    </button>\r\n  </div>\r\n  <div class=\"np-toolbar-spacer\"></div>\r\n  <div class=\"np-toolbar-item\" *ngIf=\"showPageSize\">\r\n    {{ \"Items_Per_Page\" | npTranslate }}\r\n  </div>\r\n  <div class=\"np-toolbar-item\" *ngIf=\"showPageSize\">\r\n    <input class=\"np-form-control np-paginator-page-size\" type=\"number\" [value]=\"pageSize\" [min]=\"1\" [max]=\"100\"\r\n      (change)=\"_onItemPerPageChange($event)\" />\r\n  </div>\r\n  <div class=\"np-toolbar-item\" *ngIf=\"showTotal\">\r\n    {{ startIndex + 1 }}-{{ endIndex + 1 }} / {{ totalItems }}\r\n  </div>\r\n  <div class=\"np-toolbar-item\">\r\n    <button class=\"np-btn-icon np-paginator-refresh\" type=\"button\" (click)=\"refresh()\">\r\n      <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n        <path\r\n          d=\"M17.65 6.35C16.2 4.9 14.21 4 12 4c-4.42 0-7.99 3.58-7.99 8s3.57 8 7.99 8c3.73 0 6.84-2.55 7.73-6h-2.08c-.82 2.33-3.04 4-5.65 4-3.31 0-6-2.69-6-6s2.69-6 6-6c1.66 0 3.14.69 4.22 1.78L13 11h7V4l-2.35 2.35z\">\r\n        </path>\r\n        <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n      </svg>\r\n    </button>\r\n  </div>\r\n</div>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "pipe", type: NpTranslatePipe, name: "npTranslate" }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpPaginatorComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-paginator", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, template: "<div [ngClass]=\"'np-toolbar np-paginator'\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-toolbar-item\">\r\n    <button class=\"np-btn-icon np-paginator-first\" type=\"button\" [ngClass]=\"{ 'np-disabled': currentPage === 1 }\"\r\n      (click)=\"_loadPage(1)\">\r\n      <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n        <path d=\"M18.41 16.59L13.82 12l4.59-4.59L17 6l-6 6 6 6zM6 6h2v12H6z\"></path>\r\n      </svg>\r\n    </button>\r\n  </div>\r\n  <div class=\"np-toolbar-item\">\r\n    <button class=\"np-btn-icon np-paginator-prev\" type=\"button\" [ngClass]=\"{ 'np-disabled': currentPage === 1 }\"\r\n      (click)=\"_loadPage(currentPage - 1)\">\r\n      <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n        <path d=\"M15.41 7.41L14 6l-6 6 6 6 1.41-1.41L10.83 12z\"></path>\r\n      </svg>\r\n    </button>\r\n  </div>\r\n  <div class=\"np-toolbar-item\">\r\n    <input class=\"np-form-control np-paginator-current-page\" type=\"number\" [value]=\"currentPage\" [min]=\"1\"\r\n      [max]=\"totalPages\" (change)=\"_onCurrentPageChange($event)\" />\r\n  </div>\r\n  <div class=\"np-toolbar-item\">/ {{ totalPages }}</div>\r\n  <div class=\"np-toolbar-item\">\r\n    <button class=\"np-btn-icon np-paginator-next\" type=\"button\"\r\n      [ngClass]=\"{ 'np-disabled': currentPage === totalPages }\" (click)=\"_loadPage(currentPage + 1)\">\r\n      <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n        <path d=\"M10 6L8.59 7.41 13.17 12l-4.58 4.59L10 18l6-6z\"></path>\r\n      </svg>\r\n    </button>\r\n  </div>\r\n  <div class=\"np-toolbar-item\">\r\n    <button class=\"np-btn-icon np-paginator-last\" type=\"button\"\r\n      [ngClass]=\"{ 'np-disabled': currentPage === totalPages }\" (click)=\"_loadPage(totalPages)\">\r\n      <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n        <path d=\"M5.59 7.41L10.18 12l-4.59 4.59L7 18l6-6-6-6zM16 6h2v12h-2z\"></path>\r\n      </svg>\r\n    </button>\r\n  </div>\r\n  <div class=\"np-toolbar-spacer\"></div>\r\n  <div class=\"np-toolbar-item\" *ngIf=\"showPageSize\">\r\n    {{ \"Items_Per_Page\" | npTranslate }}\r\n  </div>\r\n  <div class=\"np-toolbar-item\" *ngIf=\"showPageSize\">\r\n    <input class=\"np-form-control np-paginator-page-size\" type=\"number\" [value]=\"pageSize\" [min]=\"1\" [max]=\"100\"\r\n      (change)=\"_onItemPerPageChange($event)\" />\r\n  </div>\r\n  <div class=\"np-toolbar-item\" *ngIf=\"showTotal\">\r\n    {{ startIndex + 1 }}-{{ endIndex + 1 }} / {{ totalItems }}\r\n  </div>\r\n  <div class=\"np-toolbar-item\">\r\n    <button class=\"np-btn-icon np-paginator-refresh\" type=\"button\" (click)=\"refresh()\">\r\n      <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n        <path\r\n          d=\"M17.65 6.35C16.2 4.9 14.21 4 12 4c-4.42 0-7.99 3.58-7.99 8s3.57 8 7.99 8c3.73 0 6.84-2.55 7.73-6h-2.08c-.82 2.33-3.04 4-5.65 4-3.31 0-6-2.69-6-6s2.69-6 6-6c1.66 0 3.14.69 4.22 1.78L13 11h7V4l-2.35 2.35z\">\r\n        </path>\r\n        <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n      </svg>\r\n    </button>\r\n  </div>\r\n</div>" }]
        }], propDecorators: { pageSize: [{
                type: Input
            }], totalItems: [{
                type: Input
            }], currentPage: [{
                type: Input
            }], showPageSize: [{
                type: Input
            }], showTotal: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], inputId: [{
                type: Input
            }], onPageChange: [{
                type: Output
            }], onPageSizeChange: [{
                type: Output
            }], onRefresh: [{
                type: Output
            }] } });

class NpCheckboxComponent {
    constructor() {
        this.inputId = `np-checkbox_${NpCheckboxComponent.controlCount++}`;
        this.onChange = new EventEmitter();
        this.onFocus = new EventEmitter();
        this.onBlur = new EventEmitter();
        this.isDisabled = false;
        this.focused = false;
        this.onChangeCallback = () => { };
        this.onTouchedCallback = () => { };
    }
    get value() {
        return this.innerValue ? this.innerValue : null;
    }
    set value(v) {
        if (v !== this.innerValue) {
            this.innerValue = v;
            this.indeterminate = false;
            this.onChangeCallback(v);
            this.onChange.emit(v);
        }
    }
    writeValue(v) {
        if (v !== this.innerValue) {
            this.innerValue = v;
        }
    }
    registerOnChange(fn) {
        this.onChangeCallback = fn;
    }
    registerOnTouched(fn) {
        this.onTouchedCallback = fn;
    }
    setDisabledState(isDisabled) {
        this.isDisabled = isDisabled;
    }
    focus() {
        this.inputViewChild.nativeElement.focus();
    }
    _onBlur($event) {
        this.focused = false;
        this.onTouchedCallback();
        this.onBlur.emit($event);
    }
    _onFocus($event) {
        this.focused = true;
        this.onFocus.emit($event);
    }
    _onChange(event) {
        this.value = event.target.checked;
    }
    _onKeyDown(event) {
        if (event.key === "Space" && (this.readOnly || this.isDisabled)) {
            event.preventDefault();
        }
    }
    _getInputId() {
        return this.inputId + "_input";
    }
}
NpCheckboxComponent.controlCount = 1;
NpCheckboxComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpCheckboxComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NpCheckboxComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpCheckboxComponent, selector: "np-checkbox", inputs: { label: "label", indeterminate: "indeterminate", readOnly: "readOnly", autoFocus: "autoFocus", tabIndex: "tabIndex", styleClass: "styleClass", inputId: "inputId" }, outputs: { onChange: "onChange", onFocus: "onFocus", onBlur: "onBlur" }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => NpCheckboxComponent),
            multi: true,
        },
    ], viewQueries: [{ propertyName: "inputViewChild", first: true, predicate: ["control"], descendants: true }], ngImport: i0, template: "<div [ngClass]=\"{\r\n    'np-checkbox': true,\r\n    'np-disabled': isDisabled,\r\n    'np-readonly': readOnly\r\n  }\" role=\"checkbox\" [attr.aria-checked]=\"indeterminate ? 'mixed' : innerValue\" [class]=\"styleClass\"\r\n  [attr.id]=\"inputId\">\r\n  <label class=\"np-checkbox-label\" [attr.for]=\"_getInputId()\">\r\n    <input class=\"np-checkbox-input\" type=\"checkbox\" #control [attr.id]=\"_getInputId()\" [checked]=\"innerValue\"\r\n      [disabled]=\"isDisabled\" [readonly]=\"readOnly\" [attr.tabindex]=\"tabIndex\" [npAutofocus]=\"autoFocus\"\r\n      (change)=\"_onChange($event)\" [indeterminate]=\"indeterminate\" (blur)=\"_onBlur($event)\" (focus)=\"_onFocus($event)\"\r\n      (keydown)=\"_onKeyDown($event)\" />\r\n    <span class=\"np-checkbox-checkmark\" [ngClass]=\"{ 'np-focused': focused }\">\r\n      <svg class=\"np-checkbox-icon\" *ngIf=\"innerValue\" viewBox=\"0 0 24 24\">\r\n        <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        <path d=\"M9 16.2L4.8 12l-1.4 1.4L9 19 21 7l-1.4-1.4L9 16.2z\"></path>\r\n      </svg>\r\n      <svg class=\"np-checkbox-icon\" *ngIf=\"indeterminate\" viewBox=\"0 0 24 24\">\r\n        <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        <path d=\"M19 13H5v-2h14v2z\"></path>\r\n      </svg>\r\n    </span>\r\n    <span class=\"np-checkbox-text\" *ngIf=\"label\" [innerHTML]=\"label\"></span>\r\n  </label>\r\n</div>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: NpAutofocusDirective, selector: "[npAutofocus]", inputs: ["npAutofocus"] }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpCheckboxComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-checkbox", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => NpCheckboxComponent),
                            multi: true,
                        },
                    ], template: "<div [ngClass]=\"{\r\n    'np-checkbox': true,\r\n    'np-disabled': isDisabled,\r\n    'np-readonly': readOnly\r\n  }\" role=\"checkbox\" [attr.aria-checked]=\"indeterminate ? 'mixed' : innerValue\" [class]=\"styleClass\"\r\n  [attr.id]=\"inputId\">\r\n  <label class=\"np-checkbox-label\" [attr.for]=\"_getInputId()\">\r\n    <input class=\"np-checkbox-input\" type=\"checkbox\" #control [attr.id]=\"_getInputId()\" [checked]=\"innerValue\"\r\n      [disabled]=\"isDisabled\" [readonly]=\"readOnly\" [attr.tabindex]=\"tabIndex\" [npAutofocus]=\"autoFocus\"\r\n      (change)=\"_onChange($event)\" [indeterminate]=\"indeterminate\" (blur)=\"_onBlur($event)\" (focus)=\"_onFocus($event)\"\r\n      (keydown)=\"_onKeyDown($event)\" />\r\n    <span class=\"np-checkbox-checkmark\" [ngClass]=\"{ 'np-focused': focused }\">\r\n      <svg class=\"np-checkbox-icon\" *ngIf=\"innerValue\" viewBox=\"0 0 24 24\">\r\n        <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        <path d=\"M9 16.2L4.8 12l-1.4 1.4L9 19 21 7l-1.4-1.4L9 16.2z\"></path>\r\n      </svg>\r\n      <svg class=\"np-checkbox-icon\" *ngIf=\"indeterminate\" viewBox=\"0 0 24 24\">\r\n        <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        <path d=\"M19 13H5v-2h14v2z\"></path>\r\n      </svg>\r\n    </span>\r\n    <span class=\"np-checkbox-text\" *ngIf=\"label\" [innerHTML]=\"label\"></span>\r\n  </label>\r\n</div>" }]
        }], propDecorators: { label: [{
                type: Input
            }], indeterminate: [{
                type: Input
            }], readOnly: [{
                type: Input
            }], autoFocus: [{
                type: Input
            }], tabIndex: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], inputId: [{
                type: Input
            }], onChange: [{
                type: Output
            }], onFocus: [{
                type: Output
            }], onBlur: [{
                type: Output
            }], inputViewChild: [{
                type: ViewChild,
                args: ["control"]
            }] } });

class NpFilterTypesPipe {
    transform(filterList, args) {
        return filterList.filter((filterType) => filterType.forDataType === args);
    }
}
NpFilterTypesPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpFilterTypesPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
NpFilterTypesPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpFilterTypesPipe, name: "filterTypesPipe" });
NpFilterTypesPipe.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpFilterTypesPipe });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpFilterTypesPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: "filterTypesPipe",
                }]
        }, {
            type: Injectable
        }] });

class NpSearchColumnsPipe {
    transform(filterList, args) {
        if (args) {
            const result = filterList.filter((column) => {
                return (column.caption && column.caption.toLowerCase().startsWith(args, 0));
            });
            return result;
        }
        return filterList;
    }
}
NpSearchColumnsPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpSearchColumnsPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
NpSearchColumnsPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpSearchColumnsPipe, name: "searchColumnsPipe" });
NpSearchColumnsPipe.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpSearchColumnsPipe });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpSearchColumnsPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: "searchColumnsPipe",
                }]
        }, {
            type: Injectable
        }] });

class NpDataGridComponent {
    constructor(filterService, utilityService, oDataService, fileService, overlay, viewContainerRef, overlayPositionBuilder, dialogService, translationsService, elementRef) {
        this.filterService = filterService;
        this.utilityService = utilityService;
        this.oDataService = oDataService;
        this.fileService = fileService;
        this.overlay = overlay;
        this.viewContainerRef = viewContainerRef;
        this.overlayPositionBuilder = overlayPositionBuilder;
        this.dialogService = dialogService;
        this.translationsService = translationsService;
        this.elementRef = elementRef;
        this.inputId = `np-data-grid_${NpDataGridComponent.controlCount++}`;
        this.singleRowExpand = false;
        this.expandRowOnClick = false;
        this.singleRowSelectEnable = false;
        this.multiRowSelectEnable = false;
        this.selectRowOnClick = false;
        this.title = "";
        this.isReadOnlyStates = false;
        this.showFilters = true;
        this.dateFormat = "dd/MM/yyyy";
        this.showSummary = false;
        this.allowColumnResize = false;
        this.allowColumnReorder = false;
        this.isServerOperations = false;
        this.isODataOperations = false;
        this.odataVersion = 4;
        this.allowExport = false;
        this.isServerExport = false;
        this.showToolBar = false;
        this.pageSize = 10;
        this.onInit = new EventEmitter();
        this.onAfterInit = new EventEmitter();
        this.onLoadData = new EventEmitter();
        this.onSelect = new EventEmitter();
        this.onDeselect = new EventEmitter();
        this.onRowClick = new EventEmitter();
        this.onStatesUpdate = new EventEmitter();
        this.onServerExport = new EventEmitter();
        this.totalRow = 0;
        this.enableMasterDetail = false;
        this.openRowKeys = [];
        this.selectedRowKeys = [];
        this.dataTypes = DataTypes;
        this.sortDirections = SortDirections;
        this.isOpenColumnChooser = false;
        this.visibleColumns = [];
        this.isDataSourceInit = false;
        this._colSpanForDetailRow = 0;
        this.sortColumnList = [];
        this.filtersList = Filters;
        this.filterColumnList = [];
        this.stateList = [];
        this.currentStateName = "";
        this.isFilterAvailable = false;
        this.showFilters = true;
    }
    ngOnInit() {
        this.onInit.emit();
    }
    ngAfterContentInit() {
        if (this.masterDetailTemplate) {
            this.enableMasterDetail = true;
        }
        this._setColumns();
        if (this.key) {
            this.keyColumnName = this.key;
        }
        else {
            this.keyColumnName = this.gridColumns[0].dataField;
        }
        this._subscribeDataSource();
    }
    ngAfterViewInit() {
        const positionStrategy = this.overlayPositionBuilder
            .flexibleConnectedTo(this.elementRef.nativeElement.querySelector("#btn-column-chooser"))
            .withPositions(TopBottomOverlayPositions);
        this.columnChooserOverlayRef = this.overlay.create({
            positionStrategy,
            hasBackdrop: true,
            backdropClass: "np-grid-backdrop",
            scrollStrategy: this.overlay.scrollStrategies.reposition(),
        });
        this.columnChooserTemplatePortal = new TemplatePortal(this.columnChooserTemplate, this.viewContainerRef);
        this.columnChooserOverlayRef
            .backdropClick()
            .subscribe(() => this._closeColumnChooser());
        this.onAfterInit.emit();
    }
    ngOnDestroy() {
        if (this.subscription) {
            this.subscription.unsubscribe();
        }
    }
    getSelectedRowKeys() {
        return this.selectedRowKeys;
    }
    selectRowByKey(key) {
        if (this.selectedRowKeys.indexOf(key) === -1) {
            this.selectedRowKeys.push(key);
        }
    }
    deselectRowByKey(key) {
        const idx = this.selectedRowKeys.indexOf(key);
        if (idx >= 0) {
            this.selectedRowKeys.splice(idx, 1);
        }
    }
    reset() {
        this._setColumns();
        this.filterColumnList = [];
        this.sortColumnList = [];
        this.selectedRowKeys = [];
        this.openRowKeys = [];
        this.isAllSelected = false;
        this.isOpenColumnChooser = false;
        this.currentStateName = "";
        this._closeColumnChooser();
        if (this.isServerOperations) {
            this.gridPaginator.loadPage(1);
        }
        else {
            this._resetDataSource();
            this.gridPaginator.loadPage(1);
        }
    }
    selectAll() {
        this._selectAll();
    }
    deselectAll() {
        this._deselectAll();
    }
    hideColumnByIndex(idx) {
        this.gridColumns[idx].visible = false;
        this._setVisibleColumns();
    }
    showColumnByIndex(idx) {
        this.gridColumns[idx].visible = true;
        this._setVisibleColumns();
    }
    hideColumnByDataField(dataField) {
        for (const element of this.gridColumns) {
            if (element.dataField === dataField) {
                element.visible = false;
            }
        }
        this._setVisibleColumns();
    }
    showColumnByDataField(dataField) {
        for (const element of this.gridColumns) {
            if (element.dataField === dataField) {
                element.visible = true;
            }
        }
        this._setVisibleColumns();
    }
    goToPage(pageNumber) {
        this.gridPaginator.loadPage(pageNumber);
    }
    sortByColumn(dataField, direction) {
        const sortColumn = this.utilityService.custFind(this.gridColumns, (element) => {
            return element.dataField === dataField;
        });
        sortColumn.sortDirection = direction;
        this._onSort(sortColumn);
    }
    filterByColumn(dataField, keyword, type) {
        const filterColumn = this.utilityService.custFind(this.gridColumns, (element) => {
            return element.dataField === dataField;
        });
        filterColumn.filterString = keyword;
        filterColumn.filterType = type;
        this._onFilter(filterColumn, true);
    }
    getTotalRows() {
        return this.totalRow;
    }
    getCurrentPageNumber() {
        return this.gridPaginator.currentPage;
    }
    getPageSize() {
        return this.pageSize;
    }
    getTotalPages() {
        return this.gridPaginator.totalPages;
    }
    closeAllChild() {
        this.openRowKeys = [];
    }
    getFilterColumns() {
        return this.filterColumnList;
    }
    getSortColumns() {
        return this.sortColumnList;
    }
    getColumns() {
        return this._cloneColumns(this.gridColumns);
    }
    setColumns(columns) {
        this.gridColumns = this._cloneColumns(columns);
        const currentFilterColumnList = [];
        for (const element of this.gridColumns) {
            if (element.filterOperator &&
                element.filterValue &&
                element.filterValue.toString().length > 0) {
                currentFilterColumnList.push({
                    dataField: element.dataField,
                    filterOperator: element.filterOperator,
                    filterValue: element.filterValue,
                    dataType: element.dataType,
                });
            }
        }
        this.filterColumnList = currentFilterColumnList;
        const currentSortColumnList = [];
        for (const element of this.gridColumns) {
            if (element.sortEnable && element.sortDirection) {
                currentSortColumnList.push({
                    dataField: element.dataField,
                    sortDirection: element.sortDirection,
                });
            }
        }
        this.sortColumnList = currentSortColumnList;
        if (!this.isServerOperations) {
            this._filterDataSource();
            this._sortDataSource();
        }
        this.gridPaginator.loadPage(1);
        this._setVisibleColumns();
        this.selectedRowKeys = [];
        this.openRowKeys = [];
    }
    loadStateByName(stateName) {
        const state = this.stateList.filter((element) => element.name === stateName);
        if (state && state.length > 0) {
            this.currentStateName = stateName;
            this.setColumns(state[0].columns);
        }
        else {
            throw new Error("Data grid State not found");
        }
    }
    getCurrentStateName() {
        return this.currentStateName;
    }
    removeAllSorting() {
        this._removeAllSorting();
        this.gridPaginator.loadPage(1);
    }
    removeAllFilters() {
        this._removeAllFilters();
        this.gridPaginator.loadPage(1);
    }
    getAllState() {
        return this.stateList;
    }
    setAllState(states) {
        this.stateList = states;
    }
    refresh() {
        this._onRefresh();
    }
    _subscribeDataSource() {
        this.subscription = this.dataSource.subscribe((ds) => {
            if (ds === undefined || ds === null) {
                return;
            }
            if (this.isServerOperations) {
                // to export to csv, this change has all data
                if (ds.isAllPages) {
                    this.fileService.downloadCSVFile(ds.data, this.visibleColumns, this.dateFormat);
                    return;
                }
                this.currentViewData = ds.data;
                this.summaryData = ds.summary;
                this.totalRow = ds.total;
                if (this.isAllSelected) {
                    for (const element of this.currentViewData) {
                        if (this.selectedRowKeys.indexOf(element[this.keyColumnName]) === -1) {
                            this.selectedRowKeys.push(element[this.keyColumnName]);
                        }
                    }
                }
            }
            else {
                this.dataSourceClone = new DataSource(ds.data, ds.data.length, ds.summary);
                this.totalRow = ds.data.length;
                this.summaryData = ds.summary;
                this.isDataSourceInit = true;
                this.gridPaginator.refresh();
            }
        });
    }
    _onPageChange(options) {
        if (this.isServerOperations) {
            const loadOpt = new LoadOptions();
            if (this.isODataOperations) {
                const top = options.pageSize;
                const skip = (options.currentPage - 1) * options.pageSize;
                loadOpt.odataQuery = this.oDataService.buildQuery(this.filterColumnList, this.sortColumnList, top, skip, true, this.odataVersion);
                loadOpt.pageNumber = 0;
                loadOpt.pageSize = 0;
                loadOpt.sortColumns = [];
                loadOpt.filterColumns = [];
                loadOpt.isAllPages = false;
            }
            else {
                loadOpt.pageNumber = options.currentPage;
                loadOpt.pageSize = options.pageSize;
                loadOpt.sortColumns = this.sortColumnList;
                loadOpt.filterColumns = this.filterColumnList;
                loadOpt.isAllPages = false;
                loadOpt.odataQuery = "";
            }
            this.onLoadData.emit(loadOpt);
        }
        else {
            if (!this.isDataSourceInit) {
                return;
            }
            const start = (options.currentPage - 1) * options.pageSize;
            const end = Math.min(start + options.pageSize - 1, this.totalRow - 1);
            this.currentViewData = this.dataSourceClone.data.slice(start, end + 1);
        }
    }
    _setColumns() {
        const result = [];
        for (const element of this.columns) {
            result.push(new Column(element));
        }
        this.gridColumns = result;
        this._setVisibleColumns();
    }
    _setVisibleColumns() {
        this.visibleColumns = this.utilityService.custFilter(this.gridColumns, (element) => element.visible === true);
        this.isFilterAvailable =
            this.utilityService.custFilter(this.visibleColumns, (element) => element.filterEnable === true).length > 0;
        this._colSpanForDetailRow =
            this.visibleColumns.length + (this._allowRowSelection() ? 1 : 0) + 1;
    }
    _onCellClick($event, column, data) {
        if (column.onCellClick !== undefined) {
            column.onCellClick($event, column, data);
        }
    }
    // on first click ascending, on second click descending and on third click remove sorting
    _onSort(column) {
        if (!column.sortEnable) {
            return;
        }
        // if sort direction is descending then remove sorting from column
        if (column.sortDirection === SortDirections.Descending) {
            this._removeSortingFromColumn(column);
            return;
        }
        const sortOrder = column.sortDirection === SortDirections.Ascending
            ? SortDirections.Descending
            : SortDirections.Ascending;
        if (!this.multiColumnSortEnable) {
            this._removeAllSorting();
        }
        column.sortDirection = sortOrder;
        if (this.multiColumnSortEnable) {
            const list = [];
            for (const element of this.sortColumnList) {
                if (element.dataField !== column.dataField) {
                    list.push(element);
                }
            }
            this.sortColumnList = list;
        }
        this.sortColumnList.push({
            dataField: column.dataField,
            sortDirection: column.sortDirection,
        });
        this.selectedRowKeys = [];
        this.isAllSelected = false;
        this.openRowKeys = [];
        if (!this.isServerOperations) {
            this._sortDataSource();
        }
        this.gridPaginator.loadPage(1);
    }
    _sortDataSource() {
        let data = this.dataSourceClone.data;
        for (const element of this.sortColumnList) {
            data = this.utilityService.custSort(data, element.dataField, element.sortDirection);
        }
        this.dataSourceClone.data = data;
    }
    _removeAllSorting() {
        for (const element of this.gridColumns) {
            element.sortDirection = null;
        }
        this.sortColumnList = [];
    }
    _removeSortingFromColumn(column) {
        column.sortDirection = null;
        const list = [];
        for (const element of this.sortColumnList) {
            if (element.dataField !== column.dataField) {
                list.push(element);
            }
        }
        this.sortColumnList = list;
        if (!this.isServerOperations) {
            this._resetDataSource();
            this._filterDataSource();
            for (const element of this.sortColumnList) {
                this.dataSourceClone.data = this.utilityService.custSort(this.dataSourceClone.data, element.dataField, element.sortDirection);
            }
        }
        this.gridPaginator.loadPage(1);
    }
    _resetDataSource() {
        this.dataSourceClone.data = this.dataSource.getValue().data;
        this.totalRow = this.dataSourceClone.data.length;
    }
    _onFilter(column, isForceFilter = false) {
        if (column.filterOperator && column.filterOperator === FilterTypes.Reset) {
            column.filterOperator = undefined;
            column.filterValue = undefined;
            isForceFilter = true;
        }
        if (!isForceFilter &&
            (column.filterValue === undefined ||
                column.filterValue === null ||
                column.filterValue.length === 0 ||
                column.filterOperator === undefined ||
                column.filterOperator === null)) {
            return;
        }
        const currentFilterList = [];
        for (const element of this.gridColumns) {
            if (element.filterOperator === undefined ||
                element.filterOperator === null ||
                element.filterValue === undefined ||
                element.filterValue === null ||
                element.filterValue.toString().length === 0) {
                continue;
            }
            else {
                currentFilterList.push({
                    dataField: element.dataField,
                    filterOperator: element.filterOperator,
                    filterValue: element.filterValue,
                    dataType: element.dataType,
                });
            }
        }
        this.filterColumnList = currentFilterList;
        this.selectedRowKeys = [];
        this.isAllSelected = false;
        this.openRowKeys = [];
        if (!this.isServerOperations) {
            this._filterDataSource();
            this._sortDataSource();
        }
        this.gridPaginator.loadPage(1);
    }
    _filterDataSource() {
        const data = this.filterService.filterData(this.filterColumnList, this.dataSource.getValue().data);
        this.dataSourceClone.data = data;
        this.totalRow = data.length;
    }
    _removeAllFilters() {
        for (const element of this.gridColumns) {
            element.filterOperator = null;
            element.filterValue = null;
        }
        this.filterColumnList = [];
    }
    _onClickExpandRow(data) {
        if (this.expandRowOnClick === true) {
            return;
        }
        const keyValue = data[this.keyColumnName];
        this._expandRow(keyValue);
    }
    _expandRow(keyValue) {
        if (this.singleRowExpand === true) {
            this.openRowKeys = [keyValue];
        }
        else {
            this.openRowKeys.push(keyValue);
        }
    }
    _onClickCollapseRow(data) {
        if (this.expandRowOnClick === true) {
            return;
        }
        const keyValue = data[this.keyColumnName];
        this._collapseRow(keyValue);
    }
    _collapseRow(keyValue) {
        const idx = this.openRowKeys.indexOf(keyValue);
        this.openRowKeys.splice(idx, 1);
    }
    _onClickSelectAll(checked) {
        if (this.singleRowSelectEnable) {
            return;
        }
        if (checked) {
            this._selectAll();
        }
        else {
            this._deselectAll();
        }
    }
    _deselectAll() {
        const selectedRows = this.selectedRowKeys;
        this.selectedRowKeys = [];
        this.isAllSelected = false;
        if (this.onDeselect !== undefined) {
            const event = { data: selectedRows };
            this.onDeselect.emit(event);
        }
    }
    _selectAll() {
        const key = this.keyColumnName;
        const selectedKeys = [];
        if (this.isServerOperations) {
            for (const element of this.currentViewData) {
                selectedKeys.push(element[key]);
            }
        }
        else {
            for (const element of this.dataSourceClone.data) {
                selectedKeys.push(element[key]);
            }
        }
        this.selectedRowKeys = selectedKeys;
        this.isAllSelected = true;
        if (this.onSelect !== undefined) {
            const event = { data: selectedKeys };
            this.onSelect.emit(event);
        }
    }
    _onClickSelectRow(checked, data) {
        if (this.selectRowOnClick === true) {
            return;
        }
        const keyValue = data[this.keyColumnName];
        this._selectRow(keyValue, checked);
    }
    _selectRow(keyValue, checked) {
        if (this.singleRowSelectEnable) {
            this.selectedRowKeys = [];
            if (checked) {
                this.selectedRowKeys.push(keyValue);
            }
        }
        else {
            if (checked) {
                this.selectedRowKeys.push(keyValue);
            }
            else {
                const idx = this.selectedRowKeys.indexOf(keyValue);
                this.selectedRowKeys.splice(idx, 1);
            }
        }
        if (checked) {
            if (this.onSelect !== undefined) {
                this.onSelect.emit(keyValue);
            }
        }
        else {
            this.isAllSelected = false;
            if (this.onDeselect !== undefined) {
                this.onDeselect.emit(keyValue);
            }
        }
    }
    _isSelected(data) {
        const keyValue = data[this.keyColumnName];
        return this.selectedRowKeys.indexOf(keyValue) > -1;
    }
    _isOpenDetailRow(data) {
        if (!this.enableMasterDetail) {
            return false;
        }
        const keyValue = data[this.keyColumnName];
        return this.openRowKeys.indexOf(keyValue) > -1;
    }
    _rowClick(event, data) {
        if (this.masterDetailTemplate && this.expandRowOnClick) {
            if (this._isOpenDetailRow(data)) {
                this._collapseRow(data[this.keyColumnName]);
            }
            else {
                this._expandRow(data[this.keyColumnName]);
            }
        }
        if ((this.singleRowSelectEnable || this.multiRowSelectEnable) &&
            this.selectRowOnClick) {
            if (this._isSelected(data)) {
                this._selectRow(data[this.keyColumnName], false);
            }
            else {
                this._selectRow(data[this.keyColumnName], true);
            }
        }
        if (this.onRowClick) {
            event.data = data;
            this.onRowClick.emit(event);
        }
    }
    _onColumnChoosing(checked, col) {
        col.visible = checked;
        this._setVisibleColumns();
    }
    _openColumnChooser() {
        if (!this.columnChooserOverlayRef.hasAttached()) {
            this.columnChooserOverlayRef.attach(this.columnChooserTemplatePortal);
        }
    }
    _closeColumnChooser() {
        this.columnChooserOverlayRef.detach();
    }
    _dropColumn(event) {
        moveItemInArray(this.gridColumns, event.previousIndex, event.currentIndex);
        this._setVisibleColumns();
    }
    _saveState() {
        const columns = this._cloneColumns(this.gridColumns);
        const currentStateName = this.currentStateName;
        let editedState;
        for (const element of this.stateList) {
            if (element.name === currentStateName) {
                element.columns = columns;
                editedState = element;
                this.dialogService.open(this.translationsService.translate("Saved_Successfully"), new NpDialogConfig({ type: "alert" }), null);
            }
        }
        if (this.onStatesUpdate) {
            this.onStatesUpdate.emit({ action: "edit", state: editedState });
        }
    }
    _openDialogAddNewState() {
        const promptAddNewState = this.dialogService.open(this.translationsService.translate("Add_New_State"), new NpDialogConfig({ type: "prompt" }), null);
        promptAddNewState.onClose.subscribe((data) => {
            if (data != undefined && data != null && data.trim().length > 0) {
                this._addState(data);
            }
        });
    }
    _addState(stateName) {
        const name = stateName.trim();
        const state = this.stateList.filter((element) => element.name === name);
        if (state && state.length > 0) {
            this.dialogService.open(this.translationsService.translate("State_Name_Already_Exists"), new NpDialogConfig({ type: "alert" }), null);
            return;
        }
        const columns = this._cloneColumns(this.gridColumns);
        const newState = new State(name, columns);
        this.stateList.push(newState);
        this.currentStateName = name;
        if (this.onStatesUpdate) {
            this.onStatesUpdate.emit({ action: "add", state: newState });
        }
    }
    _deleteState() {
        const currentStateName = this.currentStateName;
        const list = [];
        let deletedState;
        for (const element of this.stateList) {
            if (element.name !== currentStateName) {
                list.push(element);
            }
            else {
                deletedState = element;
            }
        }
        this.stateList = list;
        if (this.stateList.length > 0) {
            this.currentStateName = this.stateList[0].name;
        }
        else {
            this.currentStateName = "";
        }
        this._loadState();
        if (this.onStatesUpdate) {
            this.onStatesUpdate.emit({ action: "delete", state: deletedState });
        }
        this.dialogService.open(this.translationsService.translate("Deleted_Successfully"), new NpDialogConfig({ type: "alert" }), null);
    }
    _loadState() {
        const currentStateName = this.currentStateName;
        if (currentStateName === "") {
            this.reset();
            return;
        }
        this.loadStateByName(currentStateName);
    }
    _cloneColumns(cols) {
        const result = [];
        for (const element of cols) {
            result.push(new Column(element));
        }
        return result;
    }
    _onRefresh() {
        this.gridPaginator.refresh();
    }
    _onResetColumns() {
        this.reset();
    }
    _resizeColumn($event, column) {
        let currentWidth = column.width;
        if (isNaN(currentWidth)) {
            currentWidth =
                $event.source.element.nativeElement.parentElement.offsetWidth;
        }
        column.width = (isNaN(currentWidth) ? 0 : currentWidth) + $event.distance.x;
        $event.source.reset();
    }
    _exportToFile() {
        const loadOpt = new LoadOptions();
        if (this.isServerExport) {
            if (this.isODataOperations) {
                loadOpt.odataQuery = this.oDataService.buildQuery(this.filterColumnList, this.sortColumnList, 0, 0, false, this.odataVersion);
                loadOpt.isAllPages = true;
            }
            else {
                loadOpt.pageNumber = 1;
                loadOpt.pageSize = this.totalRow;
                loadOpt.sortColumns = this.sortColumnList;
                loadOpt.filterColumns = this.filterColumnList;
                loadOpt.isAllPages = true;
            }
            this.onServerExport.emit(loadOpt);
            return;
        }
        if (this.isServerOperations) {
            if (this.isODataOperations) {
                loadOpt.odataQuery = this.oDataService.buildQuery(this.filterColumnList, this.sortColumnList, 0, 0, true, this.odataVersion);
                loadOpt.isAllPages = true;
            }
            else {
                loadOpt.pageNumber = 1;
                loadOpt.pageSize = this.totalRow;
                loadOpt.sortColumns = this.sortColumnList;
                loadOpt.filterColumns = this.filterColumnList;
                loadOpt.isAllPages = true;
            }
            this.onLoadData.emit(loadOpt);
        }
        else {
            this.fileService.downloadCSVFile(this.dataSourceClone.data, this.visibleColumns, this.dateFormat);
        }
    }
    _showAllColumns() {
        this.gridColumns.forEach((element) => {
            element.visible = true;
        });
        this._setVisibleColumns();
    }
    _clearColumnSearch() {
        this.searchColumnsKeyword = null;
    }
    _allowRowSelection() {
        return this.singleRowSelectEnable || this.multiRowSelectEnable;
    }
    _trackBy(index) {
        return index;
    }
    _isAnyRowSelected() {
        return (!this.isAllSelected &&
            this.selectedRowKeys &&
            this.selectedRowKeys.length > 0);
    }
    _onClickCheckbox($event) {
        if (this.selectRowOnClick) {
            $event.preventDefault();
        }
    }
}
NpDataGridComponent.controlCount = 1;
NpDataGridComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpDataGridComponent, deps: [{ token: NpFilterService }, { token: NpGridUtilityService }, { token: NpODataService }, { token: NpFileService }, { token: i1.Overlay }, { token: i0.ViewContainerRef }, { token: i1.OverlayPositionBuilder }, { token: NpDialogService }, { token: NpTranslationsService }, { token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component });
NpDataGridComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpDataGridComponent, selector: "np-data-grid", inputs: { inputId: "inputId", columns: "columns", dataSource: "dataSource", height: "height", width: "width", multiColumnSortEnable: "multiColumnSortEnable", masterDetailTemplate: "masterDetailTemplate", singleRowExpand: "singleRowExpand", expandRowOnClick: "expandRowOnClick", singleRowSelectEnable: "singleRowSelectEnable", multiRowSelectEnable: "multiRowSelectEnable", selectRowOnClick: "selectRowOnClick", key: "key", showColumnChooser: "showColumnChooser", title: "title", enableStateStoring: "enableStateStoring", isReadOnlyStates: "isReadOnlyStates", noDataMessage: "noDataMessage", showFilters: "showFilters", dateFormat: "dateFormat", showSummary: "showSummary", summaryTemplate: "summaryTemplate", allowColumnResize: "allowColumnResize", allowColumnReorder: "allowColumnReorder", isServerOperations: "isServerOperations", isODataOperations: "isODataOperations", odataVersion: "odataVersion", allowExport: "allowExport", isServerExport: "isServerExport", showToolBar: "showToolBar", pageSize: "pageSize", styleClass: "styleClass" }, outputs: { onInit: "onInit", onAfterInit: "onAfterInit", onLoadData: "onLoadData", onSelect: "onSelect", onDeselect: "onDeselect", onRowClick: "onRowClick", onStatesUpdate: "onStatesUpdate", onServerExport: "onServerExport" }, viewQueries: [{ propertyName: "columnChooserTemplate", first: true, predicate: ["columnChooserTemplate"], descendants: true }, { propertyName: "gridPaginator", first: true, predicate: ["gridPaginator"], descendants: true }], ngImport: i0, template: "<div [ngClass]=\"'np-grid'\" [style.max-height.px]=\"height\" [style.max-width.px]=\"width\" [class]=\"styleClass\"\r\n  [attr.id]=\"inputId\">\r\n  <div class=\"np-grid-title\" *ngIf=\"title\" [innerHTML]=\"title\"></div>\r\n  <div class=\"np-toolbar np-grid-toolbar\" *ngIf=\"showToolBar\">\r\n    <div class=\"np-toolbar-item\" *ngIf=\"showColumnChooser\">\r\n      <button class=\"np-btn-icon np-column-chooser-btn\" id=\"btn-column-chooser\" type=\"button\"\r\n        (click)=\"_openColumnChooser()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M4 5v13h17V5H4zm10 2v9h-3V7h3zM6 7h3v9H6V7zm13 9h-3V7h3v9z\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n    <div class=\"np-toolbar-item\" *ngIf=\"isFilterAvailable\">\r\n      <button class=\"np-btn-icon np-toggle-filter-btn\" type=\"button\" (click)=\"showFilters = !showFilters\">\r\n        <svg class=\"np-icon\" *ngIf=\"!showFilters\" viewBox=\"0 0 24 24\">\r\n          <path\r\n            d=\"M15,19.88C15.04,20.18 14.94,20.5 14.71,20.71C14.32,21.1 13.69,21.1 13.3,20.71L9.29,16.7C9.06,16.47 8.96,16.16 9,15.87V10.75L4.21,4.62C3.87,4.19 3.95,3.56 4.38,3.22C4.57,3.08 4.78,3 5,3V3H19V3C19.22,3 19.43,3.08 19.62,3.22C20.05,3.56 20.13,4.19 19.79,4.62L15,10.75V19.88M7.04,5L11,10.06V15.58L13,17.58V10.05L16.96,5H7.04Z\">\r\n          </path>\r\n        </svg>\r\n        <svg class=\"np-icon\" *ngIf=\"showFilters\" viewBox=\"0 0 24 24\">\r\n          <path\r\n            d=\"M14.73,20.83L17.58,18L14.73,15.17L16.15,13.76L19,16.57L21.8,13.76L23.22,15.17L20.41,18L23.22,20.83L21.8,22.24L19,19.4L16.15,22.24L14.73,20.83M13,19.88C13.04,20.18 12.94,20.5 12.71,20.71C12.32,21.1 11.69,21.1 11.3,20.71L7.29,16.7C7.06,16.47 6.96,16.16 7,15.87V10.75L2.21,4.62C1.87,4.19 1.95,3.56 2.38,3.22C2.57,3.08 2.78,3 3,3V3H17V3C17.22,3 17.43,3.08 17.62,3.22C18.05,3.56 18.13,4.19 17.79,4.62L13,10.75V19.88M5.04,5L9,10.06V15.58L11,17.58V10.05L14.96,5H5.04Z\">\r\n          </path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n    <div class=\"np-toolbar-item\" *ngIf=\"allowExport\">\r\n      <button class=\"np-btn-icon np-grid-export-btn\" type=\"button\" (click)=\"_exportToFile()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M14 2H6c-1.1 0-1.99.9-1.99 2L4 20c0 1.1.89 2 1.99 2H18c1.1 0 2-.9 2-2V8l-6-6zM6 20V4h7v5h5v11H6z\">\r\n          </path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n    <div class=\"np-toolbar-spacer\"></div>\r\n    <ng-container *ngIf=\"enableStateStoring\">\r\n      <div class=\"np-toolbar-item\">\r\n        <select class=\"np-form-control np-grid-states\" [(ngModel)]=\"currentStateName\" (change)=\"_loadState()\">\r\n          <option value>{{ \"Select\" | npTranslate }}</option>\r\n          <option *ngFor=\"let state of stateList; trackBy: _trackBy\" [text]=\"state.name\" [value]=\"state.name\"></option>\r\n        </select>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"currentStateName.length > 0 && !isReadOnlyStates\">\r\n        <button class=\"np-btn-icon np-grid-state-save\" type=\"button\" (click)=\"_saveState()\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path\r\n              d=\"M17 3H5c-1.11 0-2 .9-2 2v14c0 1.1.89 2 2 2h14c1.1 0 2-.9 2-2V7l-4-4zm2 16H5V5h11.17L19 7.83V19zm-7-7c-1.66 0-3 1.34-3 3s1.34 3 3 3 3-1.34 3-3-1.34-3-3-3zM6 6h9v4H6z\">\r\n            </path>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"currentStateName.length > 0 && !isReadOnlyStates\">\r\n        <button class=\"np-btn-icon np-grid-state-delete\" type=\"button\" (click)=\"_deleteState()\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path\r\n              d=\"M14.12 10.47L12 12.59l-2.13-2.12-1.41 1.41L10.59 14l-2.12 2.12 1.41 1.41L12 15.41l2.12 2.12 1.41-1.41L13.41 14l2.12-2.12zM15.5 4l-1-1h-5l-1 1H5v2h14V4zM6 19c0 1.1.9 2 2 2h8c1.1 0 2-.9 2-2V7H6v12zM8 9h8v10H8V9z\">\r\n            </path>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-item\">\r\n        <button class=\"np-btn-icon np-grid-state-add\" type=\"button\" *ngIf=\"!isReadOnlyStates\"\r\n          (click)=\"_openDialogAddNewState()\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path\r\n              d=\"M19 3H5c-1.11 0-2 .9-2 2v14c0 1.1.89 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm0 16H5V5h14v14zm-8-2h2v-4h4v-2h-4V7h-2v4H7v2h4z\">\r\n            </path>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n    </ng-container>\r\n  </div>\r\n  <div class=\"np-grid-container\">\r\n    <div class=\"np-grid-thead\">\r\n      <table role=\"grid\">\r\n        <colgroup>\r\n          <col *ngIf=\"enableMasterDetail\" class=\"np-grid-col-width\" />\r\n          <col *ngIf=\"_allowRowSelection()\" class=\"np-grid-col-width\" />\r\n          <col *ngFor=\"let column of visibleColumns; trackBy: _trackBy\" [style.width.px]=\"column.width\" />\r\n        </colgroup>\r\n        <thead>\r\n          <tr class=\"np-row-header\">\r\n            <th *ngIf=\"enableMasterDetail\"></th>\r\n            <th *ngIf=\"_allowRowSelection()\" class=\"no-padding\">\r\n              <np-checkbox *ngIf=\"multiRowSelectEnable\" [(ngModel)]=\"isAllSelected\"\r\n                [indeterminate]=\"_isAnyRowSelected()\" (onChange)=\"_onClickSelectAll($event)\">\r\n              </np-checkbox>\r\n            </th>\r\n            <th *ngFor=\"\r\n                let column of visibleColumns;\r\n                let k = index;\r\n                trackBy: _trackBy\r\n              \">\r\n              <span [innerHTML]=\"column.caption\" (click)=\"_onSort(column)\"\r\n                [ngClass]=\"{ 'np-grid-sorting-header': column.sortEnable }\">\r\n              </span>\r\n              <ng-container *ngIf=\"column.sortEnable\">\r\n                <button type=\"button\" [ngClass]=\"{\r\n                    'np-sort-ascending':\r\n                      column.sortDirection === sortDirections.Ascending,\r\n                    'np-sort-descending':\r\n                      column.sortDirection === sortDirections.Descending,\r\n                    'np-sort-toggle': !column.sortDirection\r\n                  }\" (click)=\"_onSort(column)\">\r\n                  <svg class=\"np-icon\" *ngIf=\"column.sortDirection === sortDirections.Ascending\" viewBox=\"0 0 24 24\">\r\n                    <path d=\"M20 12l-1.41-1.41L13 16.17V4h-2v12.17l-5.58-5.59L4 12l8 8 8-8z\"></path>\r\n                  </svg>\r\n                  <svg class=\"np-icon\" *ngIf=\"column.sortDirection === sortDirections.Descending\" viewBox=\"0 0 24 24\">\r\n                    <path d=\"M4 12l1.41 1.41L11 7.83V20h2V7.83l5.58 5.59L20 12l-8-8-8 8z\"></path>\r\n                  </svg>\r\n                  <svg class=\"np-icon\" *ngIf=\"!column.sortDirection\" viewBox=\"0 0 24 24\">\r\n                    <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n                    <path d=\"M9 3L5 6.99h3V14h2V6.99h3L9 3zm7 14.01V10h-2v7.01h-3L15 21l4-3.99h-3z\"></path>\r\n                  </svg>\r\n                </button>\r\n              </ng-container>\r\n              <div class=\"np-grid-resize-handle\" *ngIf=\"allowColumnResize\" cdkDrag cdkDragLockAxis=\"x\"\r\n                (cdkDragEnded)=\"_resizeColumn($event, column)\"></div>\r\n            </th>\r\n          </tr>\r\n          <tr class=\"np-row-filter\" *ngIf=\"isFilterAvailable && showFilters\">\r\n            <th *ngIf=\"enableMasterDetail\"></th>\r\n            <th *ngIf=\"_allowRowSelection()\"></th>\r\n            <th *ngFor=\"\r\n                let column of visibleColumns;\r\n                let l = index;\r\n                trackBy: _trackBy\r\n              \">\r\n              <ng-container *ngIf=\"column.filterEnable\">\r\n                <select class=\"np-form-control np-grid-filter-type\" [(ngModel)]=\"column.filterOperator\"\r\n                  (change)=\"_onFilter(column, false)\">\r\n                  <option [value]=\"undefined\" disabled hidden>\r\n                    {{ \"Select\" | npTranslate }}\r\n                  </option>\r\n                  <option *ngFor=\"\r\n                      let fOperator of filtersList\r\n                        | filterTypesPipe: column.dataType;\r\n                      trackBy: _trackBy\r\n                    \" [text]=\"fOperator.text | npTranslate\" [value]=\"fOperator.name\"></option>\r\n                  <option value=\"Reset\" [disabled]=\"column.filterOperator === undefined\">\r\n                    {{ \"Reset\" | npTranslate }}\r\n                  </option>\r\n                </select>\r\n                <input class=\"np-form-control np-grid-filter-val\" type=\"text\"\r\n                  *ngIf=\"column.dataType === dataTypes.String\" [(ngModel)]=\"column.filterValue\"\r\n                  (change)=\"_onFilter(column, false)\" [placeholder]=\"'Search' | npTranslate\" />\r\n                <input class=\"np-form-control np-grid-filter-val\" type=\"number\"\r\n                  *ngIf=\"column.dataType === dataTypes.Number\" [(ngModel)]=\"column.filterValue\"\r\n                  (change)=\"_onFilter(column, false)\" [placeholder]=\"'Search' | npTranslate\" />\r\n                <np-date-picker *ngIf=\"column.dataType === dataTypes.Date\" [format]=\"dateFormat\"\r\n                  [styleClass]=\"'np-grid-filter-val'\" [(ngModel)]=\"column.filterValue\"\r\n                  (onChange)=\"_onFilter(column, false)\" [placeholder]=\"dateFormat\">\r\n                </np-date-picker>\r\n                <select class=\"np-form-control np-grid-filter-val\" *ngIf=\"column.dataType === dataTypes.Boolean\"\r\n                  [(ngModel)]=\"column.filterValue\" (change)=\"_onFilter(column, false)\">\r\n                  <option [value]=\"undefined\" disabled hidden>\r\n                    {{ \"Select\" | npTranslate }}\r\n                  </option>\r\n                  <option [value]=\"true\">\r\n                    {{\r\n                    column.trueFilterText\r\n                    ? column.trueFilterText\r\n                    : (\"True\" | npTranslate)\r\n                    }}\r\n                  </option>\r\n                  <option [value]=\"false\">\r\n                    {{\r\n                    column.falseFilterText\r\n                    ? column.falseFilterText\r\n                    : (\"False\" | npTranslate)\r\n                    }}\r\n                  </option>\r\n                </select>\r\n              </ng-container>\r\n            </th>\r\n          </tr>\r\n        </thead>\r\n      </table>\r\n    </div>\r\n    <div class=\"np-grid-tbody\">\r\n      <table role=\"grid\">\r\n        <colgroup>\r\n          <col *ngIf=\"enableMasterDetail\" class=\"np-grid-col-width\" />\r\n          <col *ngIf=\"_allowRowSelection()\" class=\"np-grid-col-width\" />\r\n          <col *ngFor=\"let column of visibleColumns\" [style.width.px]=\"column.width\" />\r\n        </colgroup>\r\n        <tbody>\r\n          <ng-container *ngFor=\"\r\n              let data of currentViewData;\r\n              let i = index;\r\n              trackBy: _trackBy\r\n            \">\r\n            <tr id=\"row_{{ i }}\" [ngClass]=\"{\r\n                'np-grid-selected': _isSelected(data),\r\n                'np-row-master': enableMasterDetail\r\n              }\" (click)=\"_rowClick($event, data)\">\r\n              <td *ngIf=\"enableMasterDetail\" class=\"no-padding\">\r\n                <button *ngIf=\"!_isOpenDetailRow(data); else collapseRowButton\" class=\"np-detail-row-expand\"\r\n                  type=\"button\" (click)=\"_onClickExpandRow(data)\">\r\n                  <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n                    <path d=\"M19 13h-6v6h-2v-6H5v-2h6V5h2v6h6v2z\"></path>\r\n                    <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n                  </svg>\r\n                </button>\r\n                <ng-template #collapseRowButton>\r\n                  <button class=\"np-detail-row-collapse\" type=\"button\" (click)=\"_onClickCollapseRow(data)\">\r\n                    <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n                      <path d=\"M19 13H5v-2h14v2z\"></path>\r\n                      <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n                    </svg>\r\n                  </button>\r\n                </ng-template>\r\n              </td>\r\n              <td *ngIf=\"_allowRowSelection()\" class=\"no-padding\">\r\n                <np-checkbox [ngModel]=\"_isSelected(data)\" (onChange)=\"_onClickSelectRow($event, data)\"\r\n                  (click)=\"_onClickCheckbox($event)\">\r\n                </np-checkbox>\r\n              </td>\r\n              <td *ngFor=\"\r\n                  let column of visibleColumns;\r\n                  let j = index;\r\n                  trackBy: _trackBy\r\n                \" [class]=\"column.styleClass\" [ngClass]=\"{ 'np-text-right': column.rightAlignText }\"\r\n                (click)=\"_onCellClick($event, column, data)\">\r\n                <ng-container *ngIf=\"!column.cellTemplate; else customTemplate\">\r\n                  <ng-container *ngIf=\"\r\n                      column.dataType !== dataTypes.Date;\r\n                      else dateTemplate\r\n                    \">\r\n                    {{ data[column.dataField] }}\r\n                  </ng-container>\r\n                  <ng-template #dateTemplate>\r\n                    {{ data[column.dataField] | date: dateFormat }}\r\n                  </ng-template>\r\n                </ng-container>\r\n                <ng-template #customTemplate [ngTemplateOutlet]=\"column.cellTemplate\"\r\n                  [ngTemplateOutletContext]=\"{ row: data }\">\r\n                </ng-template>\r\n              </td>\r\n            </tr>\r\n            <tr *ngIf=\"enableMasterDetail && _isOpenDetailRow(data)\" class=\"np-row-detail\" id=\"row_{{ i }}_detail\">\r\n              <td [attr.colspan]=\"_colSpanForDetailRow\">\r\n                <ng-container *ngTemplateOutlet=\"\r\n                    masterDetailTemplate;\r\n                    context: { row: data }\r\n                  \">\r\n                </ng-container>\r\n              </td>\r\n            </tr>\r\n          </ng-container>\r\n        </tbody>\r\n      </table>\r\n    </div>\r\n    <div class=\"np-grid-no-data\" *ngIf=\"currentViewData && currentViewData.length === 0\">\r\n      {{ noDataMessage || (\"No_Data_Found\" | npTranslate) }}\r\n    </div>\r\n    <div class=\"np-grid-summary\" *ngIf=\"showSummary\">\r\n      <ng-container *ngTemplateOutlet=\"summaryTemplate; context: { summary: summaryData }\">\r\n      </ng-container>\r\n    </div>\r\n  </div>\r\n  <np-paginator #gridPaginator [pageSize]=\"pageSize\" [totalItems]=\"totalRow\" [styleClass]=\"'np-grid-pagination'\"\r\n    (onPageChange)=\"_onPageChange($event)\">\r\n  </np-paginator>\r\n</div>\r\n<ng-template #columnChooserTemplate>\r\n  <div class=\"np-column-chooser np-border\">\r\n    <div class=\"np-btn-group np-float-right\">\r\n      <button class=\"np-btn-icon np-grid-show-all\" type=\"button\" (click)=\"_showAllColumns()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n          <path\r\n            d=\"M12 4.5C7 4.5 2.73 7.61 1 12c1.73 4.39 6 7.5 11 7.5s9.27-3.11 11-7.5c-1.73-4.39-6-7.5-11-7.5zM12 17c-2.76 0-5-2.24-5-5s2.24-5 5-5 5 2.24 5 5-2.24 5-5 5zm0-8c-1.66 0-3 1.34-3 3s1.34 3 3 3 3-1.34 3-3-1.34-3-3-3z\">\r\n          </path>\r\n        </svg>\r\n      </button>\r\n      <button class=\"np-btn-icon np-grid-reset\" type=\"button\" (click)=\"_onResetColumns()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path\r\n            d=\"M12 6v3l4-4-4-4v3c-4.42 0-8 3.58-8 8 0 1.57.46 3.03 1.24 4.26L6.7 14.8c-.45-.83-.7-1.79-.7-2.8 0-3.31 2.69-6 6-6zm6.76 1.74L17.3 9.2c.44.84.7 1.79.7 2.8 0 3.31-2.69 6-6 6v-3l-4 4 4 4v-3c4.42 0 8-3.58 8-8 0-1.57-.46-3.03-1.24-4.26z\">\r\n          </path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n      <button class=\"np-btn-icon np-grid-close\" type=\"button\" (click)=\"_closeColumnChooser()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path\r\n            d=\"M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z\">\r\n          </path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n    <div class=\"np-grid-search\">\r\n      <input class=\"np-form-control np-grid-search-input\" type=\"text\" [placeholder]=\"'Search_Columns' | npTranslate\"\r\n        [(ngModel)]=\"searchColumnsKeyword\" />\r\n      <button class=\"np-btn-icon np-float-right np-grid-clear\" type=\"button\" (click)=\"_clearColumnSearch()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path\r\n            d=\"M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z\">\r\n          </path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n    <div class=\"np-grid-columns\" cdkDropList [cdkDropListDisabled]=\"!allowColumnReorder\"\r\n      (cdkDropListDropped)=\"_dropColumn($event)\">\r\n      <div class=\"np-grid-columns-item\" *ngFor=\"\r\n          let column of gridColumns | searchColumnsPipe: searchColumnsKeyword;\r\n          trackBy: _trackBy\r\n        \" cdkDrag cdkDragLockAxis=\"y\" cdkDragBoundary=\".np-grid-columns\">\r\n        <np-checkbox [(ngModel)]=\"column.visible\" [label]=\"column.caption\"\r\n          (onChange)=\"_onColumnChoosing($event, column)\">\r\n        </np-checkbox>\r\n        <div class=\"np-grid-drag-handle\" cdkDragHandle *ngIf=\"allowColumnReorder\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path\r\n              d=\"M10 9h4V6h3l-5-5-5 5h3v3zm-1 1H6V7l-5 5 5 5v-3h3v-4zm14 2l-5-5v3h-3v4h3v3l5-5zm-9 3h-4v3H7l5 5 5-5h-3v-3z\">\r\n            </path>\r\n          </svg>\r\n        </div>\r\n        <div class=\"np-grid-drag-placeholder\" *cdkDragPlaceholder></div>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</ng-template>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i3.NgSelectOption, selector: "option", inputs: ["ngValue", "value"] }, { kind: "directive", type: i3.ɵNgSelectMultipleOption, selector: "option", inputs: ["ngValue", "value"] }, { kind: "directive", type: i3.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i3.NumberValueAccessor, selector: "input[type=number][formControlName],input[type=number][formControl],input[type=number][ngModel]" }, { kind: "directive", type: i3.SelectControlValueAccessor, selector: "select:not([multiple])[formControlName],select:not([multiple])[formControl],select:not([multiple])[ngModel]", inputs: ["compareWith"] }, { kind: "directive", type: i3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i3.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "directive", type: i10.CdkDropList, selector: "[cdkDropList], cdk-drop-list", inputs: ["cdkDropListConnectedTo", "cdkDropListData", "cdkDropListOrientation", "id", "cdkDropListLockAxis", "cdkDropListDisabled", "cdkDropListSortingDisabled", "cdkDropListEnterPredicate", "cdkDropListSortPredicate", "cdkDropListAutoScrollDisabled", "cdkDropListAutoScrollStep"], outputs: ["cdkDropListDropped", "cdkDropListEntered", "cdkDropListExited", "cdkDropListSorted"], exportAs: ["cdkDropList"] }, { kind: "directive", type: i10.CdkDrag, selector: "[cdkDrag]", inputs: ["cdkDragData", "cdkDragLockAxis", "cdkDragRootElement", "cdkDragBoundary", "cdkDragStartDelay", "cdkDragFreeDragPosition", "cdkDragDisabled", "cdkDragConstrainPosition", "cdkDragPreviewClass", "cdkDragPreviewContainer"], outputs: ["cdkDragStarted", "cdkDragReleased", "cdkDragEnded", "cdkDragEntered", "cdkDragExited", "cdkDragDropped", "cdkDragMoved"], exportAs: ["cdkDrag"] }, { kind: "directive", type: i10.CdkDragHandle, selector: "[cdkDragHandle]", inputs: ["cdkDragHandleDisabled"] }, { kind: "directive", type: i10.CdkDragPlaceholder, selector: "ng-template[cdkDragPlaceholder]", inputs: ["data"] }, { kind: "component", type: NpDatePickerComponent, selector: "np-date-picker", inputs: ["minDate", "maxDate", "format", "defaultOpen", "showTodayButton", "disableWeekDays", "disableDates", "dateLabels", "dateClass", "isStartMonthWithMonday", "placeholder", "readOnly", "autoFocus", "tabIndex", "styleClass", "inputId"], outputs: ["onChange", "onFocus", "onBlur"] }, { kind: "component", type: NpPaginatorComponent, selector: "np-paginator", inputs: ["pageSize", "totalItems", "currentPage", "showPageSize", "showTotal", "styleClass", "inputId"], outputs: ["onPageChange", "onPageSizeChange", "onRefresh"] }, { kind: "component", type: NpCheckboxComponent, selector: "np-checkbox", inputs: ["label", "indeterminate", "readOnly", "autoFocus", "tabIndex", "styleClass", "inputId"], outputs: ["onChange", "onFocus", "onBlur"] }, { kind: "pipe", type: i1$1.DatePipe, name: "date" }, { kind: "pipe", type: NpTranslatePipe, name: "npTranslate" }, { kind: "pipe", type: NpFilterTypesPipe, name: "filterTypesPipe" }, { kind: "pipe", type: NpSearchColumnsPipe, name: "searchColumnsPipe" }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpDataGridComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-data-grid", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, template: "<div [ngClass]=\"'np-grid'\" [style.max-height.px]=\"height\" [style.max-width.px]=\"width\" [class]=\"styleClass\"\r\n  [attr.id]=\"inputId\">\r\n  <div class=\"np-grid-title\" *ngIf=\"title\" [innerHTML]=\"title\"></div>\r\n  <div class=\"np-toolbar np-grid-toolbar\" *ngIf=\"showToolBar\">\r\n    <div class=\"np-toolbar-item\" *ngIf=\"showColumnChooser\">\r\n      <button class=\"np-btn-icon np-column-chooser-btn\" id=\"btn-column-chooser\" type=\"button\"\r\n        (click)=\"_openColumnChooser()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M4 5v13h17V5H4zm10 2v9h-3V7h3zM6 7h3v9H6V7zm13 9h-3V7h3v9z\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n    <div class=\"np-toolbar-item\" *ngIf=\"isFilterAvailable\">\r\n      <button class=\"np-btn-icon np-toggle-filter-btn\" type=\"button\" (click)=\"showFilters = !showFilters\">\r\n        <svg class=\"np-icon\" *ngIf=\"!showFilters\" viewBox=\"0 0 24 24\">\r\n          <path\r\n            d=\"M15,19.88C15.04,20.18 14.94,20.5 14.71,20.71C14.32,21.1 13.69,21.1 13.3,20.71L9.29,16.7C9.06,16.47 8.96,16.16 9,15.87V10.75L4.21,4.62C3.87,4.19 3.95,3.56 4.38,3.22C4.57,3.08 4.78,3 5,3V3H19V3C19.22,3 19.43,3.08 19.62,3.22C20.05,3.56 20.13,4.19 19.79,4.62L15,10.75V19.88M7.04,5L11,10.06V15.58L13,17.58V10.05L16.96,5H7.04Z\">\r\n          </path>\r\n        </svg>\r\n        <svg class=\"np-icon\" *ngIf=\"showFilters\" viewBox=\"0 0 24 24\">\r\n          <path\r\n            d=\"M14.73,20.83L17.58,18L14.73,15.17L16.15,13.76L19,16.57L21.8,13.76L23.22,15.17L20.41,18L23.22,20.83L21.8,22.24L19,19.4L16.15,22.24L14.73,20.83M13,19.88C13.04,20.18 12.94,20.5 12.71,20.71C12.32,21.1 11.69,21.1 11.3,20.71L7.29,16.7C7.06,16.47 6.96,16.16 7,15.87V10.75L2.21,4.62C1.87,4.19 1.95,3.56 2.38,3.22C2.57,3.08 2.78,3 3,3V3H17V3C17.22,3 17.43,3.08 17.62,3.22C18.05,3.56 18.13,4.19 17.79,4.62L13,10.75V19.88M5.04,5L9,10.06V15.58L11,17.58V10.05L14.96,5H5.04Z\">\r\n          </path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n    <div class=\"np-toolbar-item\" *ngIf=\"allowExport\">\r\n      <button class=\"np-btn-icon np-grid-export-btn\" type=\"button\" (click)=\"_exportToFile()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M14 2H6c-1.1 0-1.99.9-1.99 2L4 20c0 1.1.89 2 1.99 2H18c1.1 0 2-.9 2-2V8l-6-6zM6 20V4h7v5h5v11H6z\">\r\n          </path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n    <div class=\"np-toolbar-spacer\"></div>\r\n    <ng-container *ngIf=\"enableStateStoring\">\r\n      <div class=\"np-toolbar-item\">\r\n        <select class=\"np-form-control np-grid-states\" [(ngModel)]=\"currentStateName\" (change)=\"_loadState()\">\r\n          <option value>{{ \"Select\" | npTranslate }}</option>\r\n          <option *ngFor=\"let state of stateList; trackBy: _trackBy\" [text]=\"state.name\" [value]=\"state.name\"></option>\r\n        </select>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"currentStateName.length > 0 && !isReadOnlyStates\">\r\n        <button class=\"np-btn-icon np-grid-state-save\" type=\"button\" (click)=\"_saveState()\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path\r\n              d=\"M17 3H5c-1.11 0-2 .9-2 2v14c0 1.1.89 2 2 2h14c1.1 0 2-.9 2-2V7l-4-4zm2 16H5V5h11.17L19 7.83V19zm-7-7c-1.66 0-3 1.34-3 3s1.34 3 3 3 3-1.34 3-3-1.34-3-3-3zM6 6h9v4H6z\">\r\n            </path>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"currentStateName.length > 0 && !isReadOnlyStates\">\r\n        <button class=\"np-btn-icon np-grid-state-delete\" type=\"button\" (click)=\"_deleteState()\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path\r\n              d=\"M14.12 10.47L12 12.59l-2.13-2.12-1.41 1.41L10.59 14l-2.12 2.12 1.41 1.41L12 15.41l2.12 2.12 1.41-1.41L13.41 14l2.12-2.12zM15.5 4l-1-1h-5l-1 1H5v2h14V4zM6 19c0 1.1.9 2 2 2h8c1.1 0 2-.9 2-2V7H6v12zM8 9h8v10H8V9z\">\r\n            </path>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-item\">\r\n        <button class=\"np-btn-icon np-grid-state-add\" type=\"button\" *ngIf=\"!isReadOnlyStates\"\r\n          (click)=\"_openDialogAddNewState()\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path\r\n              d=\"M19 3H5c-1.11 0-2 .9-2 2v14c0 1.1.89 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm0 16H5V5h14v14zm-8-2h2v-4h4v-2h-4V7h-2v4H7v2h4z\">\r\n            </path>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n    </ng-container>\r\n  </div>\r\n  <div class=\"np-grid-container\">\r\n    <div class=\"np-grid-thead\">\r\n      <table role=\"grid\">\r\n        <colgroup>\r\n          <col *ngIf=\"enableMasterDetail\" class=\"np-grid-col-width\" />\r\n          <col *ngIf=\"_allowRowSelection()\" class=\"np-grid-col-width\" />\r\n          <col *ngFor=\"let column of visibleColumns; trackBy: _trackBy\" [style.width.px]=\"column.width\" />\r\n        </colgroup>\r\n        <thead>\r\n          <tr class=\"np-row-header\">\r\n            <th *ngIf=\"enableMasterDetail\"></th>\r\n            <th *ngIf=\"_allowRowSelection()\" class=\"no-padding\">\r\n              <np-checkbox *ngIf=\"multiRowSelectEnable\" [(ngModel)]=\"isAllSelected\"\r\n                [indeterminate]=\"_isAnyRowSelected()\" (onChange)=\"_onClickSelectAll($event)\">\r\n              </np-checkbox>\r\n            </th>\r\n            <th *ngFor=\"\r\n                let column of visibleColumns;\r\n                let k = index;\r\n                trackBy: _trackBy\r\n              \">\r\n              <span [innerHTML]=\"column.caption\" (click)=\"_onSort(column)\"\r\n                [ngClass]=\"{ 'np-grid-sorting-header': column.sortEnable }\">\r\n              </span>\r\n              <ng-container *ngIf=\"column.sortEnable\">\r\n                <button type=\"button\" [ngClass]=\"{\r\n                    'np-sort-ascending':\r\n                      column.sortDirection === sortDirections.Ascending,\r\n                    'np-sort-descending':\r\n                      column.sortDirection === sortDirections.Descending,\r\n                    'np-sort-toggle': !column.sortDirection\r\n                  }\" (click)=\"_onSort(column)\">\r\n                  <svg class=\"np-icon\" *ngIf=\"column.sortDirection === sortDirections.Ascending\" viewBox=\"0 0 24 24\">\r\n                    <path d=\"M20 12l-1.41-1.41L13 16.17V4h-2v12.17l-5.58-5.59L4 12l8 8 8-8z\"></path>\r\n                  </svg>\r\n                  <svg class=\"np-icon\" *ngIf=\"column.sortDirection === sortDirections.Descending\" viewBox=\"0 0 24 24\">\r\n                    <path d=\"M4 12l1.41 1.41L11 7.83V20h2V7.83l5.58 5.59L20 12l-8-8-8 8z\"></path>\r\n                  </svg>\r\n                  <svg class=\"np-icon\" *ngIf=\"!column.sortDirection\" viewBox=\"0 0 24 24\">\r\n                    <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n                    <path d=\"M9 3L5 6.99h3V14h2V6.99h3L9 3zm7 14.01V10h-2v7.01h-3L15 21l4-3.99h-3z\"></path>\r\n                  </svg>\r\n                </button>\r\n              </ng-container>\r\n              <div class=\"np-grid-resize-handle\" *ngIf=\"allowColumnResize\" cdkDrag cdkDragLockAxis=\"x\"\r\n                (cdkDragEnded)=\"_resizeColumn($event, column)\"></div>\r\n            </th>\r\n          </tr>\r\n          <tr class=\"np-row-filter\" *ngIf=\"isFilterAvailable && showFilters\">\r\n            <th *ngIf=\"enableMasterDetail\"></th>\r\n            <th *ngIf=\"_allowRowSelection()\"></th>\r\n            <th *ngFor=\"\r\n                let column of visibleColumns;\r\n                let l = index;\r\n                trackBy: _trackBy\r\n              \">\r\n              <ng-container *ngIf=\"column.filterEnable\">\r\n                <select class=\"np-form-control np-grid-filter-type\" [(ngModel)]=\"column.filterOperator\"\r\n                  (change)=\"_onFilter(column, false)\">\r\n                  <option [value]=\"undefined\" disabled hidden>\r\n                    {{ \"Select\" | npTranslate }}\r\n                  </option>\r\n                  <option *ngFor=\"\r\n                      let fOperator of filtersList\r\n                        | filterTypesPipe: column.dataType;\r\n                      trackBy: _trackBy\r\n                    \" [text]=\"fOperator.text | npTranslate\" [value]=\"fOperator.name\"></option>\r\n                  <option value=\"Reset\" [disabled]=\"column.filterOperator === undefined\">\r\n                    {{ \"Reset\" | npTranslate }}\r\n                  </option>\r\n                </select>\r\n                <input class=\"np-form-control np-grid-filter-val\" type=\"text\"\r\n                  *ngIf=\"column.dataType === dataTypes.String\" [(ngModel)]=\"column.filterValue\"\r\n                  (change)=\"_onFilter(column, false)\" [placeholder]=\"'Search' | npTranslate\" />\r\n                <input class=\"np-form-control np-grid-filter-val\" type=\"number\"\r\n                  *ngIf=\"column.dataType === dataTypes.Number\" [(ngModel)]=\"column.filterValue\"\r\n                  (change)=\"_onFilter(column, false)\" [placeholder]=\"'Search' | npTranslate\" />\r\n                <np-date-picker *ngIf=\"column.dataType === dataTypes.Date\" [format]=\"dateFormat\"\r\n                  [styleClass]=\"'np-grid-filter-val'\" [(ngModel)]=\"column.filterValue\"\r\n                  (onChange)=\"_onFilter(column, false)\" [placeholder]=\"dateFormat\">\r\n                </np-date-picker>\r\n                <select class=\"np-form-control np-grid-filter-val\" *ngIf=\"column.dataType === dataTypes.Boolean\"\r\n                  [(ngModel)]=\"column.filterValue\" (change)=\"_onFilter(column, false)\">\r\n                  <option [value]=\"undefined\" disabled hidden>\r\n                    {{ \"Select\" | npTranslate }}\r\n                  </option>\r\n                  <option [value]=\"true\">\r\n                    {{\r\n                    column.trueFilterText\r\n                    ? column.trueFilterText\r\n                    : (\"True\" | npTranslate)\r\n                    }}\r\n                  </option>\r\n                  <option [value]=\"false\">\r\n                    {{\r\n                    column.falseFilterText\r\n                    ? column.falseFilterText\r\n                    : (\"False\" | npTranslate)\r\n                    }}\r\n                  </option>\r\n                </select>\r\n              </ng-container>\r\n            </th>\r\n          </tr>\r\n        </thead>\r\n      </table>\r\n    </div>\r\n    <div class=\"np-grid-tbody\">\r\n      <table role=\"grid\">\r\n        <colgroup>\r\n          <col *ngIf=\"enableMasterDetail\" class=\"np-grid-col-width\" />\r\n          <col *ngIf=\"_allowRowSelection()\" class=\"np-grid-col-width\" />\r\n          <col *ngFor=\"let column of visibleColumns\" [style.width.px]=\"column.width\" />\r\n        </colgroup>\r\n        <tbody>\r\n          <ng-container *ngFor=\"\r\n              let data of currentViewData;\r\n              let i = index;\r\n              trackBy: _trackBy\r\n            \">\r\n            <tr id=\"row_{{ i }}\" [ngClass]=\"{\r\n                'np-grid-selected': _isSelected(data),\r\n                'np-row-master': enableMasterDetail\r\n              }\" (click)=\"_rowClick($event, data)\">\r\n              <td *ngIf=\"enableMasterDetail\" class=\"no-padding\">\r\n                <button *ngIf=\"!_isOpenDetailRow(data); else collapseRowButton\" class=\"np-detail-row-expand\"\r\n                  type=\"button\" (click)=\"_onClickExpandRow(data)\">\r\n                  <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n                    <path d=\"M19 13h-6v6h-2v-6H5v-2h6V5h2v6h6v2z\"></path>\r\n                    <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n                  </svg>\r\n                </button>\r\n                <ng-template #collapseRowButton>\r\n                  <button class=\"np-detail-row-collapse\" type=\"button\" (click)=\"_onClickCollapseRow(data)\">\r\n                    <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n                      <path d=\"M19 13H5v-2h14v2z\"></path>\r\n                      <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n                    </svg>\r\n                  </button>\r\n                </ng-template>\r\n              </td>\r\n              <td *ngIf=\"_allowRowSelection()\" class=\"no-padding\">\r\n                <np-checkbox [ngModel]=\"_isSelected(data)\" (onChange)=\"_onClickSelectRow($event, data)\"\r\n                  (click)=\"_onClickCheckbox($event)\">\r\n                </np-checkbox>\r\n              </td>\r\n              <td *ngFor=\"\r\n                  let column of visibleColumns;\r\n                  let j = index;\r\n                  trackBy: _trackBy\r\n                \" [class]=\"column.styleClass\" [ngClass]=\"{ 'np-text-right': column.rightAlignText }\"\r\n                (click)=\"_onCellClick($event, column, data)\">\r\n                <ng-container *ngIf=\"!column.cellTemplate; else customTemplate\">\r\n                  <ng-container *ngIf=\"\r\n                      column.dataType !== dataTypes.Date;\r\n                      else dateTemplate\r\n                    \">\r\n                    {{ data[column.dataField] }}\r\n                  </ng-container>\r\n                  <ng-template #dateTemplate>\r\n                    {{ data[column.dataField] | date: dateFormat }}\r\n                  </ng-template>\r\n                </ng-container>\r\n                <ng-template #customTemplate [ngTemplateOutlet]=\"column.cellTemplate\"\r\n                  [ngTemplateOutletContext]=\"{ row: data }\">\r\n                </ng-template>\r\n              </td>\r\n            </tr>\r\n            <tr *ngIf=\"enableMasterDetail && _isOpenDetailRow(data)\" class=\"np-row-detail\" id=\"row_{{ i }}_detail\">\r\n              <td [attr.colspan]=\"_colSpanForDetailRow\">\r\n                <ng-container *ngTemplateOutlet=\"\r\n                    masterDetailTemplate;\r\n                    context: { row: data }\r\n                  \">\r\n                </ng-container>\r\n              </td>\r\n            </tr>\r\n          </ng-container>\r\n        </tbody>\r\n      </table>\r\n    </div>\r\n    <div class=\"np-grid-no-data\" *ngIf=\"currentViewData && currentViewData.length === 0\">\r\n      {{ noDataMessage || (\"No_Data_Found\" | npTranslate) }}\r\n    </div>\r\n    <div class=\"np-grid-summary\" *ngIf=\"showSummary\">\r\n      <ng-container *ngTemplateOutlet=\"summaryTemplate; context: { summary: summaryData }\">\r\n      </ng-container>\r\n    </div>\r\n  </div>\r\n  <np-paginator #gridPaginator [pageSize]=\"pageSize\" [totalItems]=\"totalRow\" [styleClass]=\"'np-grid-pagination'\"\r\n    (onPageChange)=\"_onPageChange($event)\">\r\n  </np-paginator>\r\n</div>\r\n<ng-template #columnChooserTemplate>\r\n  <div class=\"np-column-chooser np-border\">\r\n    <div class=\"np-btn-group np-float-right\">\r\n      <button class=\"np-btn-icon np-grid-show-all\" type=\"button\" (click)=\"_showAllColumns()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n          <path\r\n            d=\"M12 4.5C7 4.5 2.73 7.61 1 12c1.73 4.39 6 7.5 11 7.5s9.27-3.11 11-7.5c-1.73-4.39-6-7.5-11-7.5zM12 17c-2.76 0-5-2.24-5-5s2.24-5 5-5 5 2.24 5 5-2.24 5-5 5zm0-8c-1.66 0-3 1.34-3 3s1.34 3 3 3 3-1.34 3-3-1.34-3-3-3z\">\r\n          </path>\r\n        </svg>\r\n      </button>\r\n      <button class=\"np-btn-icon np-grid-reset\" type=\"button\" (click)=\"_onResetColumns()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path\r\n            d=\"M12 6v3l4-4-4-4v3c-4.42 0-8 3.58-8 8 0 1.57.46 3.03 1.24 4.26L6.7 14.8c-.45-.83-.7-1.79-.7-2.8 0-3.31 2.69-6 6-6zm6.76 1.74L17.3 9.2c.44.84.7 1.79.7 2.8 0 3.31-2.69 6-6 6v-3l-4 4 4 4v-3c4.42 0 8-3.58 8-8 0-1.57-.46-3.03-1.24-4.26z\">\r\n          </path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n      <button class=\"np-btn-icon np-grid-close\" type=\"button\" (click)=\"_closeColumnChooser()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path\r\n            d=\"M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z\">\r\n          </path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n    <div class=\"np-grid-search\">\r\n      <input class=\"np-form-control np-grid-search-input\" type=\"text\" [placeholder]=\"'Search_Columns' | npTranslate\"\r\n        [(ngModel)]=\"searchColumnsKeyword\" />\r\n      <button class=\"np-btn-icon np-float-right np-grid-clear\" type=\"button\" (click)=\"_clearColumnSearch()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path\r\n            d=\"M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z\">\r\n          </path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n    <div class=\"np-grid-columns\" cdkDropList [cdkDropListDisabled]=\"!allowColumnReorder\"\r\n      (cdkDropListDropped)=\"_dropColumn($event)\">\r\n      <div class=\"np-grid-columns-item\" *ngFor=\"\r\n          let column of gridColumns | searchColumnsPipe: searchColumnsKeyword;\r\n          trackBy: _trackBy\r\n        \" cdkDrag cdkDragLockAxis=\"y\" cdkDragBoundary=\".np-grid-columns\">\r\n        <np-checkbox [(ngModel)]=\"column.visible\" [label]=\"column.caption\"\r\n          (onChange)=\"_onColumnChoosing($event, column)\">\r\n        </np-checkbox>\r\n        <div class=\"np-grid-drag-handle\" cdkDragHandle *ngIf=\"allowColumnReorder\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path\r\n              d=\"M10 9h4V6h3l-5-5-5 5h3v3zm-1 1H6V7l-5 5 5 5v-3h3v-4zm14 2l-5-5v3h-3v4h3v3l5-5zm-9 3h-4v3H7l5 5 5-5h-3v-3z\">\r\n            </path>\r\n          </svg>\r\n        </div>\r\n        <div class=\"np-grid-drag-placeholder\" *cdkDragPlaceholder></div>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</ng-template>" }]
        }], ctorParameters: function () { return [{ type: NpFilterService }, { type: NpGridUtilityService }, { type: NpODataService }, { type: NpFileService }, { type: i1.Overlay }, { type: i0.ViewContainerRef }, { type: i1.OverlayPositionBuilder }, { type: NpDialogService }, { type: NpTranslationsService }, { type: i0.ElementRef }]; }, propDecorators: { inputId: [{
                type: Input
            }], columns: [{
                type: Input
            }], dataSource: [{
                type: Input
            }], height: [{
                type: Input
            }], width: [{
                type: Input
            }], multiColumnSortEnable: [{
                type: Input
            }], masterDetailTemplate: [{
                type: Input
            }], singleRowExpand: [{
                type: Input
            }], expandRowOnClick: [{
                type: Input
            }], singleRowSelectEnable: [{
                type: Input
            }], multiRowSelectEnable: [{
                type: Input
            }], selectRowOnClick: [{
                type: Input
            }], key: [{
                type: Input
            }], showColumnChooser: [{
                type: Input
            }], title: [{
                type: Input
            }], enableStateStoring: [{
                type: Input
            }], isReadOnlyStates: [{
                type: Input
            }], noDataMessage: [{
                type: Input
            }], showFilters: [{
                type: Input
            }], dateFormat: [{
                type: Input
            }], showSummary: [{
                type: Input
            }], summaryTemplate: [{
                type: Input
            }], allowColumnResize: [{
                type: Input
            }], allowColumnReorder: [{
                type: Input
            }], isServerOperations: [{
                type: Input
            }], isODataOperations: [{
                type: Input
            }], odataVersion: [{
                type: Input
            }], allowExport: [{
                type: Input
            }], isServerExport: [{
                type: Input
            }], showToolBar: [{
                type: Input
            }], pageSize: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], onInit: [{
                type: Output
            }], onAfterInit: [{
                type: Output
            }], onLoadData: [{
                type: Output
            }], onSelect: [{
                type: Output
            }], onDeselect: [{
                type: Output
            }], onRowClick: [{
                type: Output
            }], onStatesUpdate: [{
                type: Output
            }], onServerExport: [{
                type: Output
            }], columnChooserTemplate: [{
                type: ViewChild,
                args: ["columnChooserTemplate"]
            }], gridPaginator: [{
                type: ViewChild,
                args: ["gridPaginator"]
            }] } });

class NpTooltipModule {
}
NpTooltipModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTooltipModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpTooltipModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpTooltipModule, declarations: [NpTooltipComponent, NpTooltipDirective], imports: [CommonModule, OverlayModule], exports: [NpTooltipDirective] });
NpTooltipModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTooltipModule, imports: [CommonModule, OverlayModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTooltipModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpTooltipComponent, NpTooltipDirective],
                    imports: [CommonModule, OverlayModule],
                    exports: [NpTooltipDirective]
                }]
        }] });

class NpDatePickerModule {
}
NpDatePickerModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpDatePickerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpDatePickerModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpDatePickerModule, declarations: [NpDatePickerComponent], imports: [CommonModule,
        OverlayModule,
        PortalModule,
        NpTooltipModule,
        NpAutofocusModule,
        NpTranslationsModule], exports: [NpDatePickerComponent] });
NpDatePickerModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpDatePickerModule, imports: [CommonModule,
        OverlayModule,
        PortalModule,
        NpTooltipModule,
        NpAutofocusModule,
        NpTranslationsModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpDatePickerModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpDatePickerComponent],
                    imports: [
                        CommonModule,
                        OverlayModule,
                        PortalModule,
                        NpTooltipModule,
                        NpAutofocusModule,
                        NpTranslationsModule,
                    ],
                    exports: [NpDatePickerComponent],
                }]
        }] });

class NpDialogModule {
}
NpDialogModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpDialogModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpDialogModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpDialogModule, declarations: [NpDialogContainerComponent], imports: [CommonModule,
        FormsModule,
        OverlayModule,
        PortalModule,
        NpTranslationsModule,
        NpAutofocusModule], exports: [NpDialogContainerComponent] });
NpDialogModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpDialogModule, providers: [NpDialogService], imports: [CommonModule,
        FormsModule,
        OverlayModule,
        PortalModule,
        NpTranslationsModule,
        NpAutofocusModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpDialogModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpDialogContainerComponent],
                    imports: [
                        CommonModule,
                        FormsModule,
                        OverlayModule,
                        PortalModule,
                        NpTranslationsModule,
                        NpAutofocusModule,
                    ],
                    exports: [NpDialogContainerComponent],
                    providers: [NpDialogService]
                }]
        }] });

class NpPaginatorModule {
}
NpPaginatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpPaginatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpPaginatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpPaginatorModule, declarations: [NpPaginatorComponent], imports: [CommonModule, NpTranslationsModule], exports: [NpPaginatorComponent] });
NpPaginatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpPaginatorModule, imports: [CommonModule, NpTranslationsModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpPaginatorModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpPaginatorComponent],
                    imports: [CommonModule, NpTranslationsModule],
                    exports: [NpPaginatorComponent],
                }]
        }] });

class NpCheckboxGroupComponent {
    constructor() {
        // Orientation can be 'horizontal' or 'vertical'
        this.orientation = "horizontal";
        this.inputId = `np-checkbox-group_${NpCheckboxGroupComponent.controlCount++}`;
    }
}
NpCheckboxGroupComponent.controlCount = 1;
NpCheckboxGroupComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpCheckboxGroupComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NpCheckboxGroupComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpCheckboxGroupComponent, selector: "np-checkbox-group", inputs: { orientation: "orientation", inputId: "inputId" }, ngImport: i0, template: "<div class=\"np-checkbox-group\" role=\"group\" [ngClass]=\"{ 'np-checkbox-group-vertical': orientation === 'vertical' }\"\r\n  [attr.id]=\"inputId\">\r\n  <ng-content></ng-content>\r\n</div>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpCheckboxGroupComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-checkbox-group", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, template: "<div class=\"np-checkbox-group\" role=\"group\" [ngClass]=\"{ 'np-checkbox-group-vertical': orientation === 'vertical' }\"\r\n  [attr.id]=\"inputId\">\r\n  <ng-content></ng-content>\r\n</div>" }]
        }], propDecorators: { orientation: [{
                type: Input
            }], inputId: [{
                type: Input
            }] } });

class NpCheckboxModule {
}
NpCheckboxModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpCheckboxModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpCheckboxModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpCheckboxModule, declarations: [NpCheckboxComponent, NpCheckboxGroupComponent], imports: [CommonModule, NpAutofocusModule], exports: [NpCheckboxComponent, NpCheckboxGroupComponent] });
NpCheckboxModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpCheckboxModule, imports: [CommonModule, NpAutofocusModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpCheckboxModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpCheckboxComponent, NpCheckboxGroupComponent],
                    imports: [CommonModule, NpAutofocusModule],
                    exports: [NpCheckboxComponent, NpCheckboxGroupComponent],
                }]
        }] });

class NpDataGridModule {
}
NpDataGridModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpDataGridModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpDataGridModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpDataGridModule, declarations: [NpDataGridComponent, NpFilterTypesPipe, NpSearchColumnsPipe], imports: [CommonModule,
        FormsModule,
        DragDropModule,
        OverlayModule,
        PortalModule,
        NpDatePickerModule,
        NpDialogModule,
        NpPaginatorModule,
        NpCheckboxModule,
        NpTranslationsModule], exports: [NpDataGridComponent] });
NpDataGridModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpDataGridModule, providers: [
        NpFilterService,
        NpGridUtilityService,
        NpODataService,
        NpFileService,
    ], imports: [CommonModule,
        FormsModule,
        DragDropModule,
        OverlayModule,
        PortalModule,
        NpDatePickerModule,
        NpDialogModule,
        NpPaginatorModule,
        NpCheckboxModule,
        NpTranslationsModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpDataGridModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpDataGridComponent, NpFilterTypesPipe, NpSearchColumnsPipe],
                    imports: [
                        CommonModule,
                        FormsModule,
                        DragDropModule,
                        OverlayModule,
                        PortalModule,
                        NpDatePickerModule,
                        NpDialogModule,
                        NpPaginatorModule,
                        NpCheckboxModule,
                        NpTranslationsModule,
                    ],
                    exports: [NpDataGridComponent],
                    providers: [
                        NpFilterService,
                        NpGridUtilityService,
                        NpODataService,
                        NpFileService,
                    ],
                }]
        }] });

class NpTimePickerComponent {
    constructor(overlay, viewContainerRef, overlayPositionBuilder, elementRef) {
        this.overlay = overlay;
        this.viewContainerRef = viewContainerRef;
        this.overlayPositionBuilder = overlayPositionBuilder;
        this.elementRef = elementRef;
        this.defaultOpen = false;
        this.is24Hours = false;
        this.showNowButton = false;
        this.hideSeconds = false;
        this.placeholder = "";
        this.inputId = `np-time-picker_${NpTimePickerComponent.controlCount++}`;
        this.onChange = new EventEmitter();
        this.onFocus = new EventEmitter();
        this.onBlur = new EventEmitter();
        this.hours = [];
        this.minutes = [];
        this.seconds = [];
        this.isOpen = false;
        this.selectedAMPM = "AM";
        this.isDisabled = false;
        this.focused = false;
        this.onChangeCallback = () => { };
        this.onTouchedCallback = () => { };
    }
    ngAfterViewInit() {
        const positionStrategy = this.overlayPositionBuilder
            .flexibleConnectedTo(this.elementRef)
            .withPositions(TopBottomOverlayPositions);
        this.overlayRef = this.overlay.create({
            positionStrategy,
            hasBackdrop: true,
            backdropClass: "np-time-picker-backdrop",
            scrollStrategy: this.overlay.scrollStrategies.reposition(),
            panelClass: this.styleClass,
        });
        this.templatePortal = new TemplatePortal(this.templatePortalContent, this.viewContainerRef);
        this.overlayRef.backdropClick().subscribe(() => this._close());
    }
    get value() {
        return this.innerValue ? this.innerValue : null;
    }
    set value(v) {
        if (v !== this.innerValue) {
            this.innerValue = v;
            this.onChangeCallback(v);
            this.onChange.emit(v);
        }
    }
    writeValue(v) {
        if (v !== this.innerValue) {
            this.innerValue = v;
            this._extractValues();
        }
    }
    registerOnChange(fn) {
        this.onChangeCallback = fn;
    }
    registerOnTouched(fn) {
        this.onTouchedCallback = fn;
    }
    setDisabledState(isDisabled) {
        this.isDisabled = isDisabled;
    }
    ngAfterContentInit() {
        this.hours = [];
        const hoursList = [];
        this.pattern = new RegExp(this._getRegEx());
        if (this.is24Hours) {
            for (let i = 0; i < 24; i++) {
                hoursList.push(i);
            }
        }
        else {
            for (let i = 0; i < 12; i++) {
                hoursList.push(i);
            }
        }
        this.hours = hoursList;
        const minuteAndSeconds = [];
        for (let i = 0; i < 60; i++) {
            minuteAndSeconds.push(i);
        }
        this.minutes = minuteAndSeconds;
        this.seconds = minuteAndSeconds;
    }
    get24hrsTimeFormat() {
        if (this.is24Hours) {
            return this.value;
        }
        return this.timeConvert12to24(this.value);
    }
    get12hrsTimeFormat() {
        if (this.is24Hours) {
            return this.timeConvert24to12(this.value);
        }
        return this.value;
    }
    focus() {
        this.inputViewChild.nativeElement.focus();
    }
    _minusHour() {
        this.selectedHour =
            this.selectedHour === null || this.selectedHour === 0
                ? this.is24Hours
                    ? 23
                    : 11
                : this.selectedHour - 1;
        this._setValue();
    }
    _minusMinute() {
        this.selectedMinute =
            this.selectedMinute === null || this.selectedMinute === 0
                ? 59
                : this.selectedMinute - 1;
        if (this.selectedMinute === 59) {
            this.selectedHour =
                this.selectedHour === null || this.selectedHour === 0
                    ? this.is24Hours
                        ? 23
                        : 11
                    : this.selectedHour - 1;
        }
        this._setValue();
    }
    _minusSecond() {
        this.selectedSecond =
            this.selectedSecond === null || this.selectedSecond === 0
                ? 59
                : this.selectedSecond - 1;
        if (this.selectedSecond === 59) {
            this.selectedMinute =
                this.selectedMinute === null || this.selectedMinute === 0
                    ? 59
                    : this.selectedMinute - 1;
            if (this.selectedMinute === 59) {
                this.selectedHour =
                    this.selectedHour === null || this.selectedHour === 0
                        ? this.is24Hours
                            ? 23
                            : 11
                        : this.selectedHour - 1;
            }
        }
        this._setValue();
    }
    _addHour() {
        if (this.selectedHour > (this.is24Hours ? 23 : 11)) {
            this.selectedHour = this.is24Hours ? 23 : 11;
        }
        this.selectedHour =
            this.selectedHour === null ||
                this.selectedHour === (this.is24Hours ? 23 : 11)
                ? 0
                : this.selectedHour + 1;
        this._setValue();
    }
    _addMinute() {
        if (this.selectedMinute > 59) {
            this.selectedMinute = 59;
        }
        this.selectedMinute =
            this.selectedMinute === null || this.selectedMinute === 59
                ? 0
                : this.selectedMinute + 1;
        if (this.selectedMinute === 0) {
            this.selectedHour =
                this.selectedHour === null ||
                    this.selectedHour === (this.is24Hours ? 23 : 11)
                    ? 0
                    : this.selectedHour + 1;
        }
        this._setValue();
    }
    _addSecond() {
        if (this.selectedSecond > 59) {
            this.selectedSecond = 59;
        }
        this.selectedSecond =
            this.selectedSecond === null || this.selectedSecond === 59
                ? 0
                : this.selectedSecond + 1;
        if (this.selectedSecond === 0) {
            this.selectedMinute =
                this.selectedMinute === null || this.selectedMinute === 59
                    ? 0
                    : this.selectedMinute + 1;
            if (this.selectedMinute === 0) {
                this.selectedHour =
                    this.selectedHour === null ||
                        this.selectedHour === (this.is24Hours ? 23 : 11)
                        ? 0
                        : this.selectedHour + 1;
            }
        }
        this._setValue();
    }
    _changeTime($event, arg) {
        if (arg === "hour") {
            this.selectedHour = Number($event.target.value);
        }
        else if (arg === "minute") {
            this.selectedMinute = Number($event.target.value);
        }
        else if (arg === "second") {
            this.selectedSecond = Number($event.target.value);
        }
        else if (arg === "AMPM") {
            this.selectedAMPM = $event.target.value;
        }
        this._setValue();
    }
    _setValue() {
        if (this.is24Hours) {
            this.value = `${this._getHours()}:${this._getMinutes()}${this._getSeconds()}`;
        }
        else {
            this.value = `${this._getHours()}:${this._getMinutes()}${this._getSeconds()} ${this.selectedAMPM}`;
        }
    }
    _getHours() {
        return this.selectedHour
            ? this.selectedHour.toString().padStart(2, "0")
            : "00";
    }
    _getMinutes() {
        return this.selectedMinute
            ? this.selectedMinute.toString().padStart(2, "0")
            : "00";
    }
    _getSeconds() {
        return this.hideSeconds
            ? ""
            : ":" +
                (this.selectedSecond
                    ? this.selectedSecond.toString().padStart(2, "0")
                    : "00");
    }
    timeConvert12to24(time) {
        const PM = time.match("PM") ? true : false;
        const timeArray = time.split(":");
        const min = timeArray[1];
        let hour;
        let sec;
        if (PM) {
            hour = (12 + parseInt(timeArray[0], 10)).toString();
            sec = timeArray[2].replace("PM", "");
        }
        else {
            hour = timeArray[0];
            sec = timeArray[2].replace("AM", "");
        }
        return `${hour}:${min}:${sec}`;
    }
    timeConvert24to12(time) {
        const values = time.split(":");
        const hour24 = Number(values[0]);
        const hour12 = hour24 % 12 || 12;
        const ampm = hour24 < 12 || hour24 === 24 ? "AM" : "PM";
        return `${hour12
            .toString()
            .padStart(2, "0")}:${values[1]
            .toString()
            .padStart(2, "0")}:${values[2].toString().padStart(2, "0")} ${ampm}`;
    }
    _toggleTimePicker() {
        if (this.isOpen) {
            this._close();
        }
        else {
            this._open();
        }
    }
    _open() {
        if (this.defaultOpen === true || this.isDisabled || this.readOnly) {
            return;
        }
        this.isOpen = true;
        if (!this.overlayRef.hasAttached()) {
            this.overlayRef.attach(this.templatePortal);
        }
    }
    _close() {
        if (this.defaultOpen) {
            return;
        }
        this.isOpen = false;
        this.overlayRef.detach();
        this.inputViewChild.nativeElement.focus();
    }
    _extractValues() {
        if (this.value === undefined ||
            this.value === null ||
            !this.pattern.test(this.value)) {
            this._clearSelectedValue();
            return;
        }
        if (this.is24Hours === true) {
            const result24 = this.timeConvert12to24(this.value);
            const timeArray24 = result24.split(":");
            this.selectedHour = Number(timeArray24[0]);
            this.selectedMinute = Number(timeArray24[1]);
            if (!this.hideSeconds) {
                this.selectedSecond = Number(timeArray24[2]);
            }
        }
        else {
            const result = this.value.split(" ");
            this.selectedAMPM = result[1].toLowerCase() === "am" ? "AM" : "PM";
            const timeArray = result[0].split(":");
            this.selectedHour = Number(timeArray[0]);
            this.selectedMinute = Number(timeArray[1]);
            if (!this.hideSeconds) {
                this.selectedSecond = Number(timeArray[2]);
            }
        }
        let isChanged = false;
        if (this.selectedHour > (this.is24Hours ? 23 : 11)) {
            isChanged = true;
            this.selectedHour = this.is24Hours ? 23 : 11;
        }
        if (this.selectedMinute > 59) {
            isChanged = true;
            this.selectedMinute = 59;
        }
        if (this.selectedSecond > 59) {
            isChanged = true;
            this.selectedSecond = 59;
        }
        if (isChanged) {
            this._setValue();
        }
    }
    _selectNowTime() {
        const today = new Date();
        let nowTime = `${today
            .getHours()
            .toString()
            .padStart(2, "0")}:${today.getMinutes().toString().padStart(2, "0")}${this.hideSeconds
            ? ""
            : ":" + today.getSeconds().toString().padStart(2, "0")}`;
        if (!this.is24Hours) {
            nowTime = this.timeConvert24to12(nowTime);
        }
        this.value = nowTime;
        this._extractValues();
        this._close();
    }
    _clear() {
        if (this.isDisabled || this.readOnly) {
            return;
        }
        this.value = null;
        this._clearSelectedValue();
        this._close();
    }
    _clearSelectedValue() {
        this.selectedHour = null;
        this.selectedMinute = null;
        this.selectedSecond = null;
    }
    _changeAMPM() {
        this.selectedAMPM = this.selectedAMPM === "AM" ? "PM" : "AM";
        this._setValue();
    }
    _onKeydown(event) {
        if (event.key === "Tab" || event.key === "Escape") {
            this._close();
        }
        if (event.key === "ArrowDown") {
            this._open();
            event.preventDefault();
        }
    }
    _onInputChange($event) {
        let time = $event.target.value.trim();
        time = time.toUpperCase();
        const isValid = this.pattern.test(time);
        if (!isValid) {
            $event.target.value = "";
        }
        this.value = isValid ? time : null;
        this._extractValues();
    }
    _onBlur($event) {
        this.focused = false;
        this.onTouchedCallback();
        this.onBlur.emit($event);
    }
    _onFocus($event) {
        this.focused = true;
        this.onFocus.emit($event);
    }
    _getRegEx() {
        if (this.is24Hours) {
            if (this.hideSeconds) {
                return "^(0[0-9]|1[0-9]|2[0-3]):(0[0-9]|[0-5][0-9])$";
            }
            else {
                return "^(0[0-9]|1[0-9]|2[0-3]):(0[0-9]|[0-5][0-9]):(0[0-9]|[0-5][0-9])$";
            }
        }
        else {
            if (this.hideSeconds) {
                return "^(0[0-9]|1[0-1]):(0[0-9]|[0-5][0-9]) ?(AM|PM)$";
            }
            else {
                return "^(0[0-9]|1[0-1]):(0[0-9]|[0-5][0-9]):(0[0-9]|[0-5][0-9]) ?(AM|PM)$";
            }
        }
    }
}
NpTimePickerComponent.controlCount = 1;
NpTimePickerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTimePickerComponent, deps: [{ token: i1.Overlay }, { token: i0.ViewContainerRef }, { token: i1.OverlayPositionBuilder }, { token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component });
NpTimePickerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpTimePickerComponent, selector: "np-time-picker", inputs: { defaultOpen: "defaultOpen", is24Hours: "is24Hours", showNowButton: "showNowButton", hideSeconds: "hideSeconds", placeholder: "placeholder", readOnly: "readOnly", autoFocus: "autoFocus", tabIndex: "tabIndex", styleClass: "styleClass", inputId: "inputId" }, outputs: { onChange: "onChange", onFocus: "onFocus", onBlur: "onBlur" }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => NpTimePickerComponent),
            multi: true,
        },
    ], viewQueries: [{ propertyName: "templatePortalContent", first: true, predicate: ["templatePortalContent"], descendants: true }, { propertyName: "inputViewChild", first: true, predicate: ["control"], descendants: true }], ngImport: i0, template: "<div [ngClass]=\"{\r\n    'np-time-picker': true,\r\n    'np-disabled': isDisabled,\r\n    'np-readonly': readOnly\r\n  }\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-input-group\" *ngIf=\"!defaultOpen; else templatePortalContent\" [ngClass]=\"{ 'np-focused': focused }\">\r\n    <input class=\"np-form-control\" type=\"text\" #control autocomplete=\"off\" [value]=\"value\" [placeholder]=\"placeholder\"\r\n      [npAutofocus]=\"autoFocus\" [attr.tabindex]=\"tabIndex\" [readonly]=\"readOnly\" [disabled]=\"isDisabled\"\r\n      (click)=\"_open()\" (keydown)=\"_onKeydown($event)\" (change)=\"_onInputChange($event)\" (blur)=\"_onBlur($event)\"\r\n      (focus)=\"_onFocus($event)\" />\r\n    <div class=\"np-input-group-append\">\r\n      <button class=\"np-btn-icon np-toggle-overlay\" type=\"button\" tabindex=\"-1\" (click)=\"_toggleTimePicker()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n          <path\r\n            d=\"M11.99 2C6.47 2 2 6.48 2 12s4.47 10 9.99 10C17.52 22 22 17.52 22 12S17.52 2 11.99 2zM12 20c-4.42 0-8-3.58-8-8s3.58-8 8-8 8 3.58 8 8-3.58 8-8 8z\">\r\n          </path>\r\n          <path d=\"M12.5 7H11v6l5.25 3.15.75-1.23-4.5-2.67z\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n  </div>\r\n</div>\r\n<ng-template #templatePortalContent>\r\n  <div class=\"np-time-picker-overlay\" [ngClass]=\"{ 'np-overlay-open': defaultOpen }\">\r\n    <div class=\"np-time-picker-header\">\r\n      <div>{{ is24Hours ? \"HH\" : \"hh\" }}</div>\r\n      <div>mm</div>\r\n      <div *ngIf=\"hideSeconds === false\">ss</div>\r\n      <div *ngIf=\"is24Hours === false\">tt</div>\r\n    </div>\r\n    <div class=\"np-time-picker-controls\">\r\n      <button class=\"np-btn-icon\" type=\"button\" tabindex=\"-1\" (click)=\"_minusHour()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M7.41 15.41L12 10.83l4.59 4.58L18 14l-6-6-6 6z\"></path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n      <button class=\"np-btn-icon\" type=\"button\" tabindex=\"-1\" (click)=\"_minusMinute()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M7.41 15.41L12 10.83l4.59 4.58L18 14l-6-6-6 6z\"></path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n      <button class=\"np-btn-icon\" type=\"button\" *ngIf=\"hideSeconds === false\" tabindex=\"-1\" (click)=\"_minusSecond()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M7.41 15.41L12 10.83l4.59 4.58L18 14l-6-6-6 6z\"></path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n      <button class=\"np-btn-icon\" type=\"button\" *ngIf=\"is24Hours === false\" tabindex=\"-1\" (click)=\"_changeAMPM()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M7.41 15.41L12 10.83l4.59 4.58L18 14l-6-6-6 6z\"></path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n    <div class=\"np-time-picker-controls\">\r\n      <select class=\"np-time-picker-select np-time-picker-hour\" tabindex=\"-1\" (change)=\"_changeTime($event, 'hour')\"\r\n        size=\"4\">\r\n        <option *ngFor=\"let hour of hours\" [value]=\"hour\" [text]=\"hour\" [selected]=\"hour === selectedHour\"></option>\r\n      </select>\r\n      <select class=\"np-time-picker-select np-time-picker-minute\" tabindex=\"-1\" (change)=\"_changeTime($event, 'minute')\"\r\n        size=\"4\">\r\n        <option *ngFor=\"let minute of minutes\" tabindex=\"-1\" [value]=\"minute\" [text]=\"minute\"\r\n          [selected]=\"minute === selectedMinute\"></option>\r\n      </select>\r\n      <select class=\"np-time-picker-select np-time-picker-second\" *ngIf=\"hideSeconds === false\" tabindex=\"-1\"\r\n        (change)=\"_changeTime($event, 'second')\" size=\"4\">\r\n        <option *ngFor=\"let second of seconds\" [value]=\"second\" [text]=\"second\" [selected]=\"second === selectedSecond\">\r\n        </option>\r\n      </select>\r\n      <select class=\"np-time-picker-select np-time-picker-ampm\" *ngIf=\"is24Hours === false\" tabindex=\"-1\"\r\n        (change)=\"_changeTime($event, 'AMPM')\" size=\"2\">\r\n        <option value=\"AM\" [selected]=\"'AM' === selectedAMPM\">AM</option>\r\n        <option value=\"PM\" [selected]=\"'PM' === selectedAMPM\">PM</option>\r\n      </select>\r\n    </div>\r\n    <div class=\"np-time-picker-controls\">\r\n      <button class=\"np-btn-icon\" type=\"button\" tabindex=\"-1\" (click)=\"_addHour()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M7.41 8.59L12 13.17l4.59-4.58L18 10l-6 6-6-6 1.41-1.41z\"></path>\r\n          <path fill=\"none\" d=\"M0 0h24v24H0V0z\"></path>\r\n        </svg>\r\n      </button>\r\n      <button class=\"np-btn-icon\" type=\"button\" tabindex=\"-1\" (click)=\"_addMinute()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M7.41 8.59L12 13.17l4.59-4.58L18 10l-6 6-6-6 1.41-1.41z\"></path>\r\n          <path fill=\"none\" d=\"M0 0h24v24H0V0z\"></path>\r\n        </svg>\r\n      </button>\r\n      <button class=\"np-btn-icon\" type=\"button\" *ngIf=\"hideSeconds === false\" tabindex=\"-1\" (click)=\"_addSecond()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M7.41 8.59L12 13.17l4.59-4.58L18 10l-6 6-6-6 1.41-1.41z\"></path>\r\n          <path fill=\"none\" d=\"M0 0h24v24H0V0z\"></path>\r\n        </svg>\r\n      </button>\r\n      <button class=\"np-btn-icon\" type=\"button\" *ngIf=\"is24Hours === false\" tabindex=\"-1\" (click)=\"_changeAMPM()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M7.41 8.59L12 13.17l4.59-4.58L18 10l-6 6-6-6 1.41-1.41z\"></path>\r\n          <path fill=\"none\" d=\"M0 0h24v24H0V0z\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n    <div class=\"np-time-picker-footer\">\r\n      <button class=\"np-btn np-btn-primary np-ok\" type=\"button\" *ngIf=\"!defaultOpen\" tabindex=\"-1\" (click)=\"_close()\">\r\n        {{ \"Ok\" | npTranslate }}\r\n      </button>\r\n      <button class=\"np-btn np-btn-primary np-now\" type=\"button\" *ngIf=\"showNowButton\" tabindex=\"-1\"\r\n        (click)=\"_selectNowTime()\">\r\n        {{ \"Now\" | npTranslate }}\r\n      </button>\r\n      <button class=\"np-btn np-btn-danger np-clear\" type=\"button\" tabindex=\"-1\" (click)=\"_clear()\">\r\n        {{ \"Clear\" | npTranslate }}\r\n      </button>\r\n    </div>\r\n  </div>\r\n</ng-template>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: NpAutofocusDirective, selector: "[npAutofocus]", inputs: ["npAutofocus"] }, { kind: "pipe", type: NpTranslatePipe, name: "npTranslate" }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTimePickerComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-time-picker", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => NpTimePickerComponent),
                            multi: true,
                        },
                    ], template: "<div [ngClass]=\"{\r\n    'np-time-picker': true,\r\n    'np-disabled': isDisabled,\r\n    'np-readonly': readOnly\r\n  }\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-input-group\" *ngIf=\"!defaultOpen; else templatePortalContent\" [ngClass]=\"{ 'np-focused': focused }\">\r\n    <input class=\"np-form-control\" type=\"text\" #control autocomplete=\"off\" [value]=\"value\" [placeholder]=\"placeholder\"\r\n      [npAutofocus]=\"autoFocus\" [attr.tabindex]=\"tabIndex\" [readonly]=\"readOnly\" [disabled]=\"isDisabled\"\r\n      (click)=\"_open()\" (keydown)=\"_onKeydown($event)\" (change)=\"_onInputChange($event)\" (blur)=\"_onBlur($event)\"\r\n      (focus)=\"_onFocus($event)\" />\r\n    <div class=\"np-input-group-append\">\r\n      <button class=\"np-btn-icon np-toggle-overlay\" type=\"button\" tabindex=\"-1\" (click)=\"_toggleTimePicker()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n          <path\r\n            d=\"M11.99 2C6.47 2 2 6.48 2 12s4.47 10 9.99 10C17.52 22 22 17.52 22 12S17.52 2 11.99 2zM12 20c-4.42 0-8-3.58-8-8s3.58-8 8-8 8 3.58 8 8-3.58 8-8 8z\">\r\n          </path>\r\n          <path d=\"M12.5 7H11v6l5.25 3.15.75-1.23-4.5-2.67z\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n  </div>\r\n</div>\r\n<ng-template #templatePortalContent>\r\n  <div class=\"np-time-picker-overlay\" [ngClass]=\"{ 'np-overlay-open': defaultOpen }\">\r\n    <div class=\"np-time-picker-header\">\r\n      <div>{{ is24Hours ? \"HH\" : \"hh\" }}</div>\r\n      <div>mm</div>\r\n      <div *ngIf=\"hideSeconds === false\">ss</div>\r\n      <div *ngIf=\"is24Hours === false\">tt</div>\r\n    </div>\r\n    <div class=\"np-time-picker-controls\">\r\n      <button class=\"np-btn-icon\" type=\"button\" tabindex=\"-1\" (click)=\"_minusHour()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M7.41 15.41L12 10.83l4.59 4.58L18 14l-6-6-6 6z\"></path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n      <button class=\"np-btn-icon\" type=\"button\" tabindex=\"-1\" (click)=\"_minusMinute()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M7.41 15.41L12 10.83l4.59 4.58L18 14l-6-6-6 6z\"></path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n      <button class=\"np-btn-icon\" type=\"button\" *ngIf=\"hideSeconds === false\" tabindex=\"-1\" (click)=\"_minusSecond()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M7.41 15.41L12 10.83l4.59 4.58L18 14l-6-6-6 6z\"></path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n      <button class=\"np-btn-icon\" type=\"button\" *ngIf=\"is24Hours === false\" tabindex=\"-1\" (click)=\"_changeAMPM()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M7.41 15.41L12 10.83l4.59 4.58L18 14l-6-6-6 6z\"></path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n    <div class=\"np-time-picker-controls\">\r\n      <select class=\"np-time-picker-select np-time-picker-hour\" tabindex=\"-1\" (change)=\"_changeTime($event, 'hour')\"\r\n        size=\"4\">\r\n        <option *ngFor=\"let hour of hours\" [value]=\"hour\" [text]=\"hour\" [selected]=\"hour === selectedHour\"></option>\r\n      </select>\r\n      <select class=\"np-time-picker-select np-time-picker-minute\" tabindex=\"-1\" (change)=\"_changeTime($event, 'minute')\"\r\n        size=\"4\">\r\n        <option *ngFor=\"let minute of minutes\" tabindex=\"-1\" [value]=\"minute\" [text]=\"minute\"\r\n          [selected]=\"minute === selectedMinute\"></option>\r\n      </select>\r\n      <select class=\"np-time-picker-select np-time-picker-second\" *ngIf=\"hideSeconds === false\" tabindex=\"-1\"\r\n        (change)=\"_changeTime($event, 'second')\" size=\"4\">\r\n        <option *ngFor=\"let second of seconds\" [value]=\"second\" [text]=\"second\" [selected]=\"second === selectedSecond\">\r\n        </option>\r\n      </select>\r\n      <select class=\"np-time-picker-select np-time-picker-ampm\" *ngIf=\"is24Hours === false\" tabindex=\"-1\"\r\n        (change)=\"_changeTime($event, 'AMPM')\" size=\"2\">\r\n        <option value=\"AM\" [selected]=\"'AM' === selectedAMPM\">AM</option>\r\n        <option value=\"PM\" [selected]=\"'PM' === selectedAMPM\">PM</option>\r\n      </select>\r\n    </div>\r\n    <div class=\"np-time-picker-controls\">\r\n      <button class=\"np-btn-icon\" type=\"button\" tabindex=\"-1\" (click)=\"_addHour()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M7.41 8.59L12 13.17l4.59-4.58L18 10l-6 6-6-6 1.41-1.41z\"></path>\r\n          <path fill=\"none\" d=\"M0 0h24v24H0V0z\"></path>\r\n        </svg>\r\n      </button>\r\n      <button class=\"np-btn-icon\" type=\"button\" tabindex=\"-1\" (click)=\"_addMinute()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M7.41 8.59L12 13.17l4.59-4.58L18 10l-6 6-6-6 1.41-1.41z\"></path>\r\n          <path fill=\"none\" d=\"M0 0h24v24H0V0z\"></path>\r\n        </svg>\r\n      </button>\r\n      <button class=\"np-btn-icon\" type=\"button\" *ngIf=\"hideSeconds === false\" tabindex=\"-1\" (click)=\"_addSecond()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M7.41 8.59L12 13.17l4.59-4.58L18 10l-6 6-6-6 1.41-1.41z\"></path>\r\n          <path fill=\"none\" d=\"M0 0h24v24H0V0z\"></path>\r\n        </svg>\r\n      </button>\r\n      <button class=\"np-btn-icon\" type=\"button\" *ngIf=\"is24Hours === false\" tabindex=\"-1\" (click)=\"_changeAMPM()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M7.41 8.59L12 13.17l4.59-4.58L18 10l-6 6-6-6 1.41-1.41z\"></path>\r\n          <path fill=\"none\" d=\"M0 0h24v24H0V0z\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n    <div class=\"np-time-picker-footer\">\r\n      <button class=\"np-btn np-btn-primary np-ok\" type=\"button\" *ngIf=\"!defaultOpen\" tabindex=\"-1\" (click)=\"_close()\">\r\n        {{ \"Ok\" | npTranslate }}\r\n      </button>\r\n      <button class=\"np-btn np-btn-primary np-now\" type=\"button\" *ngIf=\"showNowButton\" tabindex=\"-1\"\r\n        (click)=\"_selectNowTime()\">\r\n        {{ \"Now\" | npTranslate }}\r\n      </button>\r\n      <button class=\"np-btn np-btn-danger np-clear\" type=\"button\" tabindex=\"-1\" (click)=\"_clear()\">\r\n        {{ \"Clear\" | npTranslate }}\r\n      </button>\r\n    </div>\r\n  </div>\r\n</ng-template>" }]
        }], ctorParameters: function () { return [{ type: i1.Overlay }, { type: i0.ViewContainerRef }, { type: i1.OverlayPositionBuilder }, { type: i0.ElementRef }]; }, propDecorators: { defaultOpen: [{
                type: Input
            }], is24Hours: [{
                type: Input
            }], showNowButton: [{
                type: Input
            }], hideSeconds: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], readOnly: [{
                type: Input
            }], autoFocus: [{
                type: Input
            }], tabIndex: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], inputId: [{
                type: Input
            }], onChange: [{
                type: Output
            }], onFocus: [{
                type: Output
            }], onBlur: [{
                type: Output
            }], templatePortalContent: [{
                type: ViewChild,
                args: ["templatePortalContent"]
            }], inputViewChild: [{
                type: ViewChild,
                args: ["control"]
            }] } });

class NpTimePickerModule {
}
NpTimePickerModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTimePickerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpTimePickerModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpTimePickerModule, declarations: [NpTimePickerComponent], imports: [CommonModule,
        OverlayModule,
        PortalModule,
        NpAutofocusModule,
        NpTranslationsModule], exports: [NpTimePickerComponent] });
NpTimePickerModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTimePickerModule, imports: [CommonModule,
        OverlayModule,
        PortalModule,
        NpAutofocusModule,
        NpTranslationsModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTimePickerModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpTimePickerComponent],
                    imports: [
                        CommonModule,
                        OverlayModule,
                        PortalModule,
                        NpAutofocusModule,
                        NpTranslationsModule,
                    ],
                    exports: [NpTimePickerComponent],
                }]
        }] });

class NpSwitchComponent {
    constructor() {
        this.inputId = `np-switch_${NpSwitchComponent.controlCount++}`;
        this.onChange = new EventEmitter();
        this.onFocus = new EventEmitter();
        this.onBlur = new EventEmitter();
        this.isDisabled = false;
        this.focused = false;
        this.onChangeCallback = () => { };
        this.onTouchedCallback = () => { };
    }
    get value() {
        return this.innerValue;
    }
    set value(v) {
        if (v !== this.innerValue) {
            this.innerValue = v;
            this.onChangeCallback(v);
            this.onChange.emit(v);
        }
    }
    writeValue(v) {
        if (v !== this.innerValue) {
            this.innerValue = v;
        }
    }
    registerOnChange(fn) {
        this.onChangeCallback = fn;
    }
    registerOnTouched(fn) {
        this.onTouchedCallback = fn;
    }
    setDisabledState(isDisabled) {
        this.isDisabled = isDisabled;
    }
    focus() {
        this.inputViewChild.nativeElement.focus();
    }
    _onClickSwitch($event) {
        if (this.isDisabled || this.readOnly) {
            return;
        }
        this.value = $event.target.checked;
    }
    _onBlur($event) {
        this.focused = false;
        this.onTouchedCallback();
        this.onBlur.emit($event);
    }
    _onFocus($event) {
        this.focused = true;
        this.onFocus.emit($event);
    }
    _getInputId() {
        return this.inputId + "_input";
    }
}
NpSwitchComponent.controlCount = 1;
NpSwitchComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpSwitchComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NpSwitchComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpSwitchComponent, selector: "np-switch", inputs: { trueLabelText: "trueLabelText", falseLabelText: "falseLabelText", readOnly: "readOnly", autoFocus: "autoFocus", tabIndex: "tabIndex", styleClass: "styleClass", inputId: "inputId" }, outputs: { onChange: "onChange", onFocus: "onFocus", onBlur: "onBlur" }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => NpSwitchComponent),
            multi: true,
        },
    ], viewQueries: [{ propertyName: "inputViewChild", first: true, predicate: ["control"], descendants: true }], ngImport: i0, template: "<div [ngClass]=\"{\r\n    'np-switch': true,\r\n    'np-disabled': isDisabled,\r\n    'np-readonly': readOnly,\r\n    'np-focused': focused\r\n  }\" [class]=\"styleClass\" [attr.id]=\"inputId\" role=\"switch\" [attr.aria-checked]=\"innerValue\">\r\n  <label (change)=\"_onClickSwitch($event)\" [attr.for]=\"_getInputId()\">\r\n    <input class=\"np-switch-input\" type=\"checkbox\" #control [attr.id]=\"_getInputId()\" [checked]=\"innerValue\"\r\n      [disabled]=\"isDisabled\" [npAutofocus]=\"autoFocus\" [attr.tabindex]=\"tabIndex\" [readonly]=\"readOnly\"\r\n      (blur)=\"_onBlur($event)\" (focus)=\"_onFocus($event)\" />\r\n    <div class=\"np-switch-label\" [ngClass]=\"{ 'np-switch-danger': value === false }\">\r\n      <span>{{\r\n        falseLabelText ? falseLabelText : (\"False\" | npTranslate)\r\n        }}</span>\r\n    </div>\r\n    <div class=\"np-switch-label\" [ngClass]=\"{ 'np-switch-success': value === true }\">\r\n      <span>{{ trueLabelText ? trueLabelText : (\"True\" | npTranslate) }}</span>\r\n    </div>\r\n  </label>\r\n</div>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NpAutofocusDirective, selector: "[npAutofocus]", inputs: ["npAutofocus"] }, { kind: "pipe", type: NpTranslatePipe, name: "npTranslate" }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpSwitchComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-switch", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => NpSwitchComponent),
                            multi: true,
                        },
                    ], template: "<div [ngClass]=\"{\r\n    'np-switch': true,\r\n    'np-disabled': isDisabled,\r\n    'np-readonly': readOnly,\r\n    'np-focused': focused\r\n  }\" [class]=\"styleClass\" [attr.id]=\"inputId\" role=\"switch\" [attr.aria-checked]=\"innerValue\">\r\n  <label (change)=\"_onClickSwitch($event)\" [attr.for]=\"_getInputId()\">\r\n    <input class=\"np-switch-input\" type=\"checkbox\" #control [attr.id]=\"_getInputId()\" [checked]=\"innerValue\"\r\n      [disabled]=\"isDisabled\" [npAutofocus]=\"autoFocus\" [attr.tabindex]=\"tabIndex\" [readonly]=\"readOnly\"\r\n      (blur)=\"_onBlur($event)\" (focus)=\"_onFocus($event)\" />\r\n    <div class=\"np-switch-label\" [ngClass]=\"{ 'np-switch-danger': value === false }\">\r\n      <span>{{\r\n        falseLabelText ? falseLabelText : (\"False\" | npTranslate)\r\n        }}</span>\r\n    </div>\r\n    <div class=\"np-switch-label\" [ngClass]=\"{ 'np-switch-success': value === true }\">\r\n      <span>{{ trueLabelText ? trueLabelText : (\"True\" | npTranslate) }}</span>\r\n    </div>\r\n  </label>\r\n</div>" }]
        }], propDecorators: { trueLabelText: [{
                type: Input
            }], falseLabelText: [{
                type: Input
            }], readOnly: [{
                type: Input
            }], autoFocus: [{
                type: Input
            }], tabIndex: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], inputId: [{
                type: Input
            }], onChange: [{
                type: Output
            }], onFocus: [{
                type: Output
            }], onBlur: [{
                type: Output
            }], inputViewChild: [{
                type: ViewChild,
                args: ["control"]
            }] } });

class NpSwitchModule {
}
NpSwitchModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpSwitchModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpSwitchModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpSwitchModule, declarations: [NpSwitchComponent], imports: [CommonModule, NpAutofocusModule, NpTranslationsModule], exports: [NpSwitchComponent] });
NpSwitchModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpSwitchModule, imports: [CommonModule, NpAutofocusModule, NpTranslationsModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpSwitchModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpSwitchComponent],
                    imports: [CommonModule, NpAutofocusModule, NpTranslationsModule],
                    exports: [NpSwitchComponent],
                }]
        }] });

class NpNotificationsService {
    constructor() {
        this.messages = [];
    }
    show(msg) {
        this.messages.push(msg);
        setTimeout(() => {
            this.close(msg);
        }, msg.autoCloseTimeout);
    }
    close(msg) {
        const idx = this.messages.indexOf(msg);
        if (idx > -1) {
            this.messages.splice(idx, 1);
        }
    }
    closeAll() {
        this.messages = [];
    }
}
NpNotificationsService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpNotificationsService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
NpNotificationsService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpNotificationsService, providedIn: "root" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpNotificationsService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: "root",
                }]
        }] });

class NpNotificationsComponent {
    constructor(npNotificationsService) {
        this.npNotificationsService = npNotificationsService;
        this.inputId = `np-notifications_${NpNotificationsComponent.controlCount++}`;
    }
    get messageService() {
        return this.npNotificationsService;
    }
    _close(msg) {
        this.npNotificationsService.close(msg);
    }
    _closeAll() {
        this.npNotificationsService.closeAll();
    }
}
NpNotificationsComponent.controlCount = 1;
NpNotificationsComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpNotificationsComponent, deps: [{ token: NpNotificationsService }], target: i0.ɵɵFactoryTarget.Component });
NpNotificationsComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpNotificationsComponent, selector: "np-notifications", inputs: { styleClass: "styleClass", inputId: "inputId" }, ngImport: i0, template: "<div *ngIf=\"messageService\" [ngClass]=\"'np-notifications'\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <ng-container *ngFor=\"let msg of messageService.messages\">\r\n    <div class=\"np-alert\" role=\"alert\" aria-atomic=\"true\" aria-live=\"assertive\" [attr.id]=\"msg._getId()\" [ngClass]=\"{\r\n        'np-alert-success': msg.type === 'success',\r\n        'np-alert-danger': msg.type === 'danger',\r\n        'np-alert-warning': msg.type === 'warning',\r\n        'np-alert-info': msg.type === 'info'\r\n      }\">\r\n      <div class=\"np-alert-icon\">\r\n        <svg class=\"np-icon\" *ngIf=\"msg.type === 'success'\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n          <path\r\n            d=\"M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm-2 15l-5-5 1.41-1.41L10 14.17l7.59-7.59L19 8l-9 9z\">\r\n          </path>\r\n        </svg>\r\n        <svg class=\"np-icon\" *ngIf=\"msg.type === 'danger'\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n          <path d=\"M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm1 15h-2v-2h2v2zm0-4h-2V7h2v6z\">\r\n          </path>\r\n        </svg>\r\n        <svg class=\"np-icon\" *ngIf=\"msg.type === 'warning'\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n          <path d=\"M1 21h22L12 2 1 21zm12-3h-2v-2h2v2zm0-4h-2v-4h2v4z\"></path>\r\n        </svg>\r\n        <svg class=\"np-icon\" *ngIf=\"msg.type === 'info'\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n          <path d=\"M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm1 15h-2v-6h2v6zm0-8h-2V7h2v2z\">\r\n          </path>\r\n        </svg>\r\n      </div>\r\n      <div class=\"np-alert-detail\">\r\n        <div class=\"np-alert-header\" *ngIf=\"msg.header\" [innerHTML]=\"msg.header\"></div>\r\n        <div class=\"np-alert-message\" [innerHTML]=\"msg.message\"></div>\r\n      </div>\r\n      <button class=\"np-btn-icon np-alert-close\" type=\"button\" (click)=\"_close(msg)\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path\r\n            d=\"M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z\">\r\n          </path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n  </ng-container>\r\n  <button class=\"np-btn-icon np-alert-close-all\" type=\"button\"\r\n    *ngIf=\"messageService.messages && messageService.messages.length > 1\" (click)=\"_closeAll()\">\r\n    <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n      <path d=\"M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z\">\r\n      </path>\r\n      <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n    </svg>\r\n  </button>\r\n</div>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpNotificationsComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-notifications", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, template: "<div *ngIf=\"messageService\" [ngClass]=\"'np-notifications'\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <ng-container *ngFor=\"let msg of messageService.messages\">\r\n    <div class=\"np-alert\" role=\"alert\" aria-atomic=\"true\" aria-live=\"assertive\" [attr.id]=\"msg._getId()\" [ngClass]=\"{\r\n        'np-alert-success': msg.type === 'success',\r\n        'np-alert-danger': msg.type === 'danger',\r\n        'np-alert-warning': msg.type === 'warning',\r\n        'np-alert-info': msg.type === 'info'\r\n      }\">\r\n      <div class=\"np-alert-icon\">\r\n        <svg class=\"np-icon\" *ngIf=\"msg.type === 'success'\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n          <path\r\n            d=\"M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm-2 15l-5-5 1.41-1.41L10 14.17l7.59-7.59L19 8l-9 9z\">\r\n          </path>\r\n        </svg>\r\n        <svg class=\"np-icon\" *ngIf=\"msg.type === 'danger'\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n          <path d=\"M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm1 15h-2v-2h2v2zm0-4h-2V7h2v6z\">\r\n          </path>\r\n        </svg>\r\n        <svg class=\"np-icon\" *ngIf=\"msg.type === 'warning'\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n          <path d=\"M1 21h22L12 2 1 21zm12-3h-2v-2h2v2zm0-4h-2v-4h2v4z\"></path>\r\n        </svg>\r\n        <svg class=\"np-icon\" *ngIf=\"msg.type === 'info'\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n          <path d=\"M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm1 15h-2v-6h2v6zm0-8h-2V7h2v2z\">\r\n          </path>\r\n        </svg>\r\n      </div>\r\n      <div class=\"np-alert-detail\">\r\n        <div class=\"np-alert-header\" *ngIf=\"msg.header\" [innerHTML]=\"msg.header\"></div>\r\n        <div class=\"np-alert-message\" [innerHTML]=\"msg.message\"></div>\r\n      </div>\r\n      <button class=\"np-btn-icon np-alert-close\" type=\"button\" (click)=\"_close(msg)\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path\r\n            d=\"M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z\">\r\n          </path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n  </ng-container>\r\n  <button class=\"np-btn-icon np-alert-close-all\" type=\"button\"\r\n    *ngIf=\"messageService.messages && messageService.messages.length > 1\" (click)=\"_closeAll()\">\r\n    <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n      <path d=\"M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z\">\r\n      </path>\r\n      <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n    </svg>\r\n  </button>\r\n</div>" }]
        }], ctorParameters: function () { return [{ type: NpNotificationsService }]; }, propDecorators: { styleClass: [{
                type: Input
            }], inputId: [{
                type: Input
            }] } });

class NpNotificationsModule {
}
NpNotificationsModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpNotificationsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpNotificationsModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpNotificationsModule, declarations: [NpNotificationsComponent], imports: [CommonModule], exports: [NpNotificationsComponent] });
NpNotificationsModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpNotificationsModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpNotificationsModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpNotificationsComponent],
                    imports: [CommonModule],
                    exports: [NpNotificationsComponent],
                }]
        }] });

class NpNotification {
    constructor(value) {
        this.type = value.type;
        this.header = value.header;
        this.message = value.message;
        this.autoCloseTimeout = value.autoCloseTimeout || 10000;
        this.id = Math.floor(Math.random() * 100) + 1;
    }
    _getId() {
        return this.id;
    }
}

class NpOrderByPipe {
    transform(data, orderBy, dir) {
        if (data && orderBy && dir) {
            if (dir.toLowerCase() === "desc") {
                return data
                    .concat()
                    .sort((a, b) => a[orderBy] < b[orderBy] ? 1 : b[orderBy] < a[orderBy] ? -1 : 0);
            }
            else {
                return data
                    .concat()
                    .sort((a, b) => a[orderBy] > b[orderBy] ? 1 : b[orderBy] > a[orderBy] ? -1 : 0);
            }
        }
        else if (data && dir) {
            if (dir.toLowerCase() === "desc") {
                return data.concat().sort((a, b) => (a < b ? 1 : b < a ? -1 : 0));
            }
            else {
                return data.concat().sort((a, b) => (a > b ? 1 : b > a ? -1 : 0));
            }
        }
        else {
            return data;
        }
    }
}
NpOrderByPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpOrderByPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
NpOrderByPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpOrderByPipe, name: "npOrderBy" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpOrderByPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: "npOrderBy",
                }]
        }] });
class NpOrderByModule {
}
NpOrderByModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpOrderByModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpOrderByModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpOrderByModule, declarations: [NpOrderByPipe], exports: [NpOrderByPipe] });
NpOrderByModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpOrderByModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpOrderByModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpOrderByPipe],
                    exports: [NpOrderByPipe],
                }]
        }] });

class NpHighlightPipe {
    transform(text, search) {
        if (search && text) {
            let pattern = search.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&");
            pattern = pattern
                .split(" ")
                .filter((t) => {
                return t.length > 0;
            })
                .join("|");
            const regex = new RegExp(pattern, "gi");
            return text.replace(regex, (match) => `<span class="np-highlight">${match}</span>`);
        }
        else {
            return text;
        }
    }
}
NpHighlightPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpHighlightPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
NpHighlightPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpHighlightPipe, name: "npHighlight" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpHighlightPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: "npHighlight",
                }]
        }] });
class NpHighlightModule {
}
NpHighlightModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpHighlightModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpHighlightModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpHighlightModule, declarations: [NpHighlightPipe], exports: [NpHighlightPipe] });
NpHighlightModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpHighlightModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpHighlightModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpHighlightPipe],
                    exports: [NpHighlightPipe],
                }]
        }] });

class NpAutoCompleteComponent {
    constructor(overlay, viewContainerRef, overlayPositionBuilder, elementRef) {
        this.overlay = overlay;
        this.viewContainerRef = viewContainerRef;
        this.overlayPositionBuilder = overlayPositionBuilder;
        this.elementRef = elementRef;
        this.forceToSelect = false;
        this.searchDelay = 1000;
        this.placeholder = "";
        this.inputId = `np-auto-complete_${NpAutoCompleteComponent.controlCount++}`;
        this.onSearch = new EventEmitter();
        this.onChange = new EventEmitter();
        this.onFocus = new EventEmitter();
        this.onBlur = new EventEmitter();
        this.isDisabled = false;
        this.isLoading = false;
        this.focused = false;
        this.isOpen = false;
        this.onChangeCallback = () => { };
        this.onTouchedCallback = () => { };
    }
    ngAfterContentInit() {
        this.subscription = this.searchResult.subscribe((data) => {
            if (data) {
                this.overlayRef.detach();
            }
            if (this.maxResultLimit &&
                this.maxResultLimit > 0 &&
                data &&
                data.length > this.maxResultLimit) {
                this.options = data.splice(0, this.maxResultLimit);
            }
            else {
                this.options = data;
            }
            this.isLoading = false;
            if (data) {
                if (!this.overlayRef.hasAttached()) {
                    this.overlayRef.attach(this.templatePortal);
                    this.isOpen = true;
                }
            }
        });
    }
    ngAfterViewInit() {
        const positionStrategy = this.overlayPositionBuilder
            .flexibleConnectedTo(this.elementRef)
            .withPositions(TopBottomOverlayPositions);
        this.overlayRef = this.overlay.create({
            positionStrategy,
            hasBackdrop: true,
            backdropClass: "np-auto-complete-backdrop",
            scrollStrategy: this.overlay.scrollStrategies.reposition(),
            panelClass: this.styleClass,
        });
        this.templatePortal = new TemplatePortal(this.templatePortalContent, this.viewContainerRef);
        this.overlayRef.backdropClick().subscribe(() => this._close());
    }
    ngOnDestroy() {
        if (this.subscription) {
            this.subscription.unsubscribe();
        }
    }
    get value() {
        return this.innerValue ? this.innerValue : null;
    }
    set value(v) {
        if (v !== this.innerValue) {
            this.innerValue = v;
            this.onChangeCallback(v);
            this.onChange.emit(v);
        }
    }
    writeValue(v) {
        if (v !== this.innerValue) {
            this.innerValue = v;
        }
    }
    registerOnChange(fn) {
        this.onChangeCallback = fn;
    }
    registerOnTouched(fn) {
        this.onTouchedCallback = fn;
    }
    setDisabledState(isDisabled) {
        this.isDisabled = isDisabled;
    }
    focus() {
        this.inputViewChild.nativeElement.focus();
    }
    _getDisplayValue() {
        return this.innerValue || "";
    }
    _close() {
        this.overlayRef.detach();
        this.inputViewChild.nativeElement.focus();
        this.isOpen = false;
    }
    _onInput($event) {
        if (this.isDisabled || this.readOnly) {
            return;
        }
        const value = $event.target.value.trim();
        if (this.minSearchCharLimit && this.minSearchCharLimit > 0) {
            if (value === undefined ||
                value === null ||
                value.length < this.minSearchCharLimit) {
                return;
            }
        }
        this.isLoading = true;
        if (this.searchTimeout) {
            clearTimeout(this.searchTimeout);
        }
        this.searchTimeout = setTimeout(() => {
            this.searchKeyword = value;
            this.onSearch.emit(value);
        }, this.searchDelay);
    }
    _onInputChange($event) {
        const value = $event.target.value.trim();
        if (!this.forceToSelect) {
            this.value = value;
        }
        if (this.forceToSelect && this.searchResult.value) {
            let valid = false;
            if (this.valueKey) {
                for (const item of this.searchResult.value) {
                    if (item[this.valueKey] === value) {
                        valid = true;
                        break;
                    }
                }
            }
            else {
                for (const item of this.searchResult.value) {
                    if (item === value) {
                        valid = true;
                        break;
                    }
                }
            }
            if (!valid) {
                this.value = null;
                this.inputViewChild.nativeElement.value = "";
            }
            else {
                this.value = value;
            }
        }
    }
    _selectValue(val) {
        this.value = this.valueKey ? val[this.valueKey] : val;
        this._close();
    }
    _onKeydown(event) {
        if (event.key === "Tab" || event.key === "Escape") {
            this._close();
        }
    }
    _trackBy(index) {
        return index;
    }
    _onBlur($event) {
        this.focused = false;
        this.onTouchedCallback();
        this.onBlur.emit($event);
    }
    _onFocus($event) {
        this.focused = true;
        this.onFocus.emit($event);
    }
}
NpAutoCompleteComponent.controlCount = 1;
NpAutoCompleteComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpAutoCompleteComponent, deps: [{ token: i1.Overlay }, { token: i0.ViewContainerRef }, { token: i1.OverlayPositionBuilder }, { token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component });
NpAutoCompleteComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpAutoCompleteComponent, selector: "np-auto-complete", inputs: { searchResult: "searchResult", forceToSelect: "forceToSelect", valueKey: "valueKey", itemTemplate: "itemTemplate", searchDelay: "searchDelay", maxResultLimit: "maxResultLimit", minSearchCharLimit: "minSearchCharLimit", orderBy: "orderBy", orderDir: "orderDir", placeholder: "placeholder", readOnly: "readOnly", autoFocus: "autoFocus", tabIndex: "tabIndex", styleClass: "styleClass", inputId: "inputId" }, outputs: { onSearch: "onSearch", onChange: "onChange", onFocus: "onFocus", onBlur: "onBlur" }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => NpAutoCompleteComponent),
            multi: true,
        },
    ], viewQueries: [{ propertyName: "templatePortalContent", first: true, predicate: ["templatePortalContent"], descendants: true }, { propertyName: "inputViewChild", first: true, predicate: ["control"], descendants: true }], ngImport: i0, template: "<div [ngClass]=\"{\r\n    'np-auto-complete': true,\r\n    'np-disabled': isDisabled,\r\n    'np-readonly': readOnly\r\n  }\" [class]=\"styleClass\" [attr.id]=\"inputId\" role=\"combobox\" aria-haspopup=\"listbox\" [attr.aria-expanded]=\"isOpen\"\r\n  [attr.aria-owns]=\"inputId + '_listbox'\">\r\n  <div class=\"np-input-group\" [ngClass]=\"{ 'np-focused': focused }\">\r\n    <input class=\"np-form-control\" type=\"text\" #control autocomplete=\"off\" [value]=\"_getDisplayValue()\"\r\n      [placeholder]=\"placeholder\" [disabled]=\"isDisabled\" [npAutofocus]=\"autoFocus\" [attr.tabindex]=\"tabIndex\"\r\n      [readonly]=\"readOnly\" (input)=\"_onInput($event)\" (change)=\"_onInputChange($event)\" (keydown)=\"_onKeydown($event)\"\r\n      (blur)=\"_onBlur($event)\" (focus)=\"_onFocus($event)\" />\r\n    <div class=\"np-input-group-append\">\r\n      <div class=\"np-auto-complete-loader\" *ngIf=\"isLoading\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path\r\n            d=\"M12 6v3l4-4-4-4v3c-4.42 0-8 3.58-8 8 0 1.57.46 3.03 1.24 4.26L6.7 14.8c-.45-.83-.7-1.79-.7-2.8 0-3.31 2.69-6 6-6zm6.76 1.74L17.3 9.2c.44.84.7 1.79.7 2.8 0 3.31-2.69 6-6 6v-3l-4 4 4 4v-3c4.42 0 8-3.58 8-8 0-1.57-.46-3.03-1.24-4.26z\">\r\n          </path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</div>\r\n<ng-template #templatePortalContent>\r\n  <ul class=\"np-auto-complete-overlay np-list\" role=\"listbox\" [attr.id]=\"inputId + '_listbox'\">\r\n    <ng-container *ngFor=\"\r\n        let item of options | npOrderBy: orderBy:orderDir;\r\n        let i = index;\r\n        trackBy: _trackBy\r\n      \">\r\n      <li class=\"np-list-item\" role=\"option\" (click)=\"_selectValue(item)\">\r\n        <ng-container *ngIf=\"!itemTemplate; else customTemplate\">\r\n          <span [innerHTML]=\"\r\n              (valueKey ? item[valueKey] : item) | npHighlight: searchKeyword\r\n            \"></span>\r\n        </ng-container>\r\n        <ng-template #customTemplate [ngTemplateOutlet]=\"itemTemplate\"\r\n          [ngTemplateOutletContext]=\"{ item: item, keyword: searchKeyword }\">\r\n        </ng-template>\r\n      </li>\r\n    </ng-container>\r\n    <li *ngIf=\"options && options.length === 0\" class=\"np-list-item np-disabled\" role=\"option\">\r\n      <b>{{ \"No_Result_Found\" | npTranslate }}</b>\r\n    </li>\r\n  </ul>\r\n</ng-template>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: NpAutofocusDirective, selector: "[npAutofocus]", inputs: ["npAutofocus"] }, { kind: "pipe", type: NpOrderByPipe, name: "npOrderBy" }, { kind: "pipe", type: NpHighlightPipe, name: "npHighlight" }, { kind: "pipe", type: NpTranslatePipe, name: "npTranslate" }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpAutoCompleteComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-auto-complete", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => NpAutoCompleteComponent),
                            multi: true,
                        },
                    ], template: "<div [ngClass]=\"{\r\n    'np-auto-complete': true,\r\n    'np-disabled': isDisabled,\r\n    'np-readonly': readOnly\r\n  }\" [class]=\"styleClass\" [attr.id]=\"inputId\" role=\"combobox\" aria-haspopup=\"listbox\" [attr.aria-expanded]=\"isOpen\"\r\n  [attr.aria-owns]=\"inputId + '_listbox'\">\r\n  <div class=\"np-input-group\" [ngClass]=\"{ 'np-focused': focused }\">\r\n    <input class=\"np-form-control\" type=\"text\" #control autocomplete=\"off\" [value]=\"_getDisplayValue()\"\r\n      [placeholder]=\"placeholder\" [disabled]=\"isDisabled\" [npAutofocus]=\"autoFocus\" [attr.tabindex]=\"tabIndex\"\r\n      [readonly]=\"readOnly\" (input)=\"_onInput($event)\" (change)=\"_onInputChange($event)\" (keydown)=\"_onKeydown($event)\"\r\n      (blur)=\"_onBlur($event)\" (focus)=\"_onFocus($event)\" />\r\n    <div class=\"np-input-group-append\">\r\n      <div class=\"np-auto-complete-loader\" *ngIf=\"isLoading\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path\r\n            d=\"M12 6v3l4-4-4-4v3c-4.42 0-8 3.58-8 8 0 1.57.46 3.03 1.24 4.26L6.7 14.8c-.45-.83-.7-1.79-.7-2.8 0-3.31 2.69-6 6-6zm6.76 1.74L17.3 9.2c.44.84.7 1.79.7 2.8 0 3.31-2.69 6-6 6v-3l-4 4 4 4v-3c4.42 0 8-3.58 8-8 0-1.57-.46-3.03-1.24-4.26z\">\r\n          </path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</div>\r\n<ng-template #templatePortalContent>\r\n  <ul class=\"np-auto-complete-overlay np-list\" role=\"listbox\" [attr.id]=\"inputId + '_listbox'\">\r\n    <ng-container *ngFor=\"\r\n        let item of options | npOrderBy: orderBy:orderDir;\r\n        let i = index;\r\n        trackBy: _trackBy\r\n      \">\r\n      <li class=\"np-list-item\" role=\"option\" (click)=\"_selectValue(item)\">\r\n        <ng-container *ngIf=\"!itemTemplate; else customTemplate\">\r\n          <span [innerHTML]=\"\r\n              (valueKey ? item[valueKey] : item) | npHighlight: searchKeyword\r\n            \"></span>\r\n        </ng-container>\r\n        <ng-template #customTemplate [ngTemplateOutlet]=\"itemTemplate\"\r\n          [ngTemplateOutletContext]=\"{ item: item, keyword: searchKeyword }\">\r\n        </ng-template>\r\n      </li>\r\n    </ng-container>\r\n    <li *ngIf=\"options && options.length === 0\" class=\"np-list-item np-disabled\" role=\"option\">\r\n      <b>{{ \"No_Result_Found\" | npTranslate }}</b>\r\n    </li>\r\n  </ul>\r\n</ng-template>" }]
        }], ctorParameters: function () { return [{ type: i1.Overlay }, { type: i0.ViewContainerRef }, { type: i1.OverlayPositionBuilder }, { type: i0.ElementRef }]; }, propDecorators: { searchResult: [{
                type: Input
            }], forceToSelect: [{
                type: Input
            }], valueKey: [{
                type: Input
            }], itemTemplate: [{
                type: Input
            }], searchDelay: [{
                type: Input
            }], maxResultLimit: [{
                type: Input
            }], minSearchCharLimit: [{
                type: Input
            }], orderBy: [{
                type: Input
            }], orderDir: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], readOnly: [{
                type: Input
            }], autoFocus: [{
                type: Input
            }], tabIndex: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], inputId: [{
                type: Input
            }], onSearch: [{
                type: Output
            }], onChange: [{
                type: Output
            }], onFocus: [{
                type: Output
            }], onBlur: [{
                type: Output
            }], templatePortalContent: [{
                type: ViewChild,
                args: ["templatePortalContent"]
            }], inputViewChild: [{
                type: ViewChild,
                args: ["control"]
            }] } });

class NpAutoCompleteModule {
}
NpAutoCompleteModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpAutoCompleteModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpAutoCompleteModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpAutoCompleteModule, declarations: [NpAutoCompleteComponent], imports: [CommonModule,
        OverlayModule,
        PortalModule,
        NpAutofocusModule,
        NpOrderByModule,
        NpHighlightModule,
        NpTranslationsModule], exports: [NpAutoCompleteComponent] });
NpAutoCompleteModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpAutoCompleteModule, imports: [CommonModule,
        OverlayModule,
        PortalModule,
        NpAutofocusModule,
        NpOrderByModule,
        NpHighlightModule,
        NpTranslationsModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpAutoCompleteModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpAutoCompleteComponent],
                    imports: [
                        CommonModule,
                        OverlayModule,
                        PortalModule,
                        NpAutofocusModule,
                        NpOrderByModule,
                        NpHighlightModule,
                        NpTranslationsModule,
                    ],
                    exports: [NpAutoCompleteComponent],
                }]
        }] });

class NpPanelContent {
}
NpPanelContent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpPanelContent, deps: [], target: i0.ɵɵFactoryTarget.Directive });
NpPanelContent.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.0.1", type: NpPanelContent, selector: "[npPanelContent]", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpPanelContent, decorators: [{
            type: Directive,
            args: [{
                    selector: "[npPanelContent]",
                }]
        }] });

class NpPanelComponent {
    constructor(_viewContainerRef, el) {
        this._viewContainerRef = _viewContainerRef;
        this.el = el;
        this.isOpen = true;
        this.inputId = `np-panel_${NpPanelComponent.controlCount++}`;
        this.onExpand = new EventEmitter();
        this.onCollapse = new EventEmitter();
        this.onClose = new EventEmitter();
        this.onZoom = new EventEmitter();
        this.isZoom = false;
        this._contentPortal = null;
    }
    get content() {
        return this._contentPortal;
    }
    ngOnInit() {
        if (this.title instanceof TemplateRef) {
            this.isTitleTemplate = true;
        }
        if (this.isOpen) {
            if (!this._contentPortal && this._explicitContent) {
                this._contentPortal = new TemplatePortal(this._explicitContent, this._viewContainerRef);
            }
        }
    }
    ngOnDestroy() {
        if (this._contentPortal && this._contentPortal.isAttached) {
            this._contentPortal.detach();
        }
    }
    _toggle() {
        if (this.disabled || !this.allowToMinimize || this.isZoom) {
            return;
        }
        if (this.isOpen) {
            this.isOpen = false;
            this.onCollapse.emit(this);
            return;
        }
        this.isOpen = true;
        if (!this._contentPortal && this._explicitContent) {
            this._contentPortal = new TemplatePortal(this._explicitContent, this._viewContainerRef);
        }
        this.onExpand.emit(this);
    }
    _toggleZoom() {
        if (this.disabled) {
            return;
        }
        if (this.isZoom) {
            this.isZoom = false;
            this.onZoom.emit(this);
            return;
        }
        if (!this.isOpen) {
            this._toggle();
        }
        this.isZoom = true;
        this.onZoom.emit(this);
    }
    _close() {
        if (this.disabled) {
            return;
        }
        this.el.nativeElement.remove();
        this.onClose.emit(this);
    }
    _getTitleId() {
        return this.inputId + "_title";
    }
    _getBodyId() {
        return this.inputId + "_body";
    }
}
NpPanelComponent.controlCount = 1;
NpPanelComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpPanelComponent, deps: [{ token: i0.ViewContainerRef }, { token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component });
NpPanelComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpPanelComponent, selector: "np-panel", inputs: { title: "title", allowToMinimize: "allowToMinimize", allowToZoom: "allowToZoom", allowToClose: "allowToClose", isOpen: "isOpen", height: "height", disabled: "disabled", iconCss: "iconCss", styleClass: "styleClass", inputId: "inputId" }, outputs: { onExpand: "onExpand", onCollapse: "onCollapse", onClose: "onClose", onZoom: "onZoom" }, queries: [{ propertyName: "_explicitContent", first: true, predicate: NpPanelContent, descendants: true, read: TemplateRef, static: true }], ngImport: i0, template: "<div [ngClass]=\"{\r\n    'np-panel': true,\r\n    'np-panel-zoom': isZoom,\r\n    'np-disabled': disabled\r\n  }\" [style.max-height.px]=\"height\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-panel-header\">\r\n    <button class=\"np-panel-title\" [attr.tabindex]=\"disabled || !allowToMinimize ? '-1' : '0'\" [attr.id]=\"_getTitleId()\"\r\n      (click)=\"_toggle()\" [attr.aria-controls]=\"_getBodyId()\" [attr.aria-expanded]=\"isOpen\"\r\n      [attr.aria-disabled]=\"disabled\">\r\n      <i *ngIf=\"iconCss\" [class]=\"iconCss\"></i>\r\n      <span *ngIf=\"!isTitleTemplate\" [innerHTML]=\"title\"></span>\r\n      <ng-container *ngIf=\"isTitleTemplate\" [ngTemplateOutlet]=\"title\">\r\n      </ng-container>\r\n    </button>\r\n    <div class=\"np-panel-btns\">\r\n      <button class=\"np-btn-icon\" type=\"button\" [attr.tabindex]=\"disabled ? '-1' : '0'\"\r\n        *ngIf=\"allowToMinimize && !isZoom\" [ngClass]=\"{ 'np-panel-expand': !isOpen, 'np-panel-collapse': isOpen }\"\r\n        (click)=\"_toggle()\">\r\n        <svg class=\"np-icon\" *ngIf=\"isOpen\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M12 8l-6 6 1.41 1.41L12 10.83l4.59 4.58L18 14z\"></path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n        <svg class=\"np-icon\" *ngIf=\"!isOpen\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M16.59 8.59L12 13.17 7.41 8.59 6 10l6 6 6-6z\"></path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n      <button class=\"np-btn-icon\" type=\"button\" [attr.tabindex]=\"disabled ? '-1' : '0'\" *ngIf=\"allowToZoom\"\r\n        [ngClass]=\"{ 'np-panel-zoom-in': !isZoom, 'np-panel-zoom-out': isZoom }\" (click)=\"_toggleZoom()\">\r\n        <svg class=\"np-icon\" *ngIf=\"!isZoom\" viewBox=\"0 0 24 24\">\r\n          <path\r\n            d=\"M15.5 14h-.79l-.28-.27C15.41 12.59 16 11.11 16 9.5 16 5.91 13.09 3 9.5 3S3 5.91 3 9.5 5.91 16 9.5 16c1.61 0 3.09-.59 4.23-1.57l.27.28v.79l5 4.99L20.49 19l-4.99-5zm-6 0C7.01 14 5 11.99 5 9.5S7.01 5 9.5 5 14 7.01 14 9.5 11.99 14 9.5 14z\">\r\n          </path>\r\n          <path d=\"M0 0h24v24H0V0z\" fill=\"none\"></path>\r\n          <path d=\"M12 10h-2v2H9v-2H7V9h2V7h1v2h2v1z\"></path>\r\n        </svg>\r\n        <svg class=\"np-icon\" *ngIf=\"isZoom\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M0 0h24v24H0V0z\" fill=\"none\"></path>\r\n          <path\r\n            d=\"M15.5 14h-.79l-.28-.27C15.41 12.59 16 11.11 16 9.5 16 5.91 13.09 3 9.5 3S3 5.91 3 9.5 5.91 16 9.5 16c1.61 0 3.09-.59 4.23-1.57l.27.28v.79l5 4.99L20.49 19l-4.99-5zm-6 0C7.01 14 5 11.99 5 9.5S7.01 5 9.5 5 14 7.01 14 9.5 11.99 14 9.5 14zM7 9h5v1H7z\">\r\n          </path>\r\n        </svg>\r\n      </button>\r\n      <button class=\"np-btn-icon np-panel-close\" type=\"button\" [attr.tabindex]=\"disabled ? '-1' : '0'\"\r\n        *ngIf=\"allowToClose && !isZoom\" (click)=\"_close()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path\r\n            d=\"M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z\">\r\n          </path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n  </div>\r\n  <div class=\"np-panel-body\" role=\"region\" *ngIf=\"isOpen\" [attr.aria-labelledby]=\"_getTitleId()\"\r\n    [attr.id]=\"_getBodyId()\">\r\n    <ng-content></ng-content>\r\n    <ng-template [cdkPortalOutlet]=\"content\"></ng-template>\r\n  </div>\r\n</div>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i2.CdkPortalOutlet, selector: "[cdkPortalOutlet]", inputs: ["cdkPortalOutlet"], outputs: ["attached"], exportAs: ["cdkPortalOutlet"] }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpPanelComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-panel", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, template: "<div [ngClass]=\"{\r\n    'np-panel': true,\r\n    'np-panel-zoom': isZoom,\r\n    'np-disabled': disabled\r\n  }\" [style.max-height.px]=\"height\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-panel-header\">\r\n    <button class=\"np-panel-title\" [attr.tabindex]=\"disabled || !allowToMinimize ? '-1' : '0'\" [attr.id]=\"_getTitleId()\"\r\n      (click)=\"_toggle()\" [attr.aria-controls]=\"_getBodyId()\" [attr.aria-expanded]=\"isOpen\"\r\n      [attr.aria-disabled]=\"disabled\">\r\n      <i *ngIf=\"iconCss\" [class]=\"iconCss\"></i>\r\n      <span *ngIf=\"!isTitleTemplate\" [innerHTML]=\"title\"></span>\r\n      <ng-container *ngIf=\"isTitleTemplate\" [ngTemplateOutlet]=\"title\">\r\n      </ng-container>\r\n    </button>\r\n    <div class=\"np-panel-btns\">\r\n      <button class=\"np-btn-icon\" type=\"button\" [attr.tabindex]=\"disabled ? '-1' : '0'\"\r\n        *ngIf=\"allowToMinimize && !isZoom\" [ngClass]=\"{ 'np-panel-expand': !isOpen, 'np-panel-collapse': isOpen }\"\r\n        (click)=\"_toggle()\">\r\n        <svg class=\"np-icon\" *ngIf=\"isOpen\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M12 8l-6 6 1.41 1.41L12 10.83l4.59 4.58L18 14z\"></path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n        <svg class=\"np-icon\" *ngIf=\"!isOpen\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M16.59 8.59L12 13.17 7.41 8.59 6 10l6 6 6-6z\"></path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n      <button class=\"np-btn-icon\" type=\"button\" [attr.tabindex]=\"disabled ? '-1' : '0'\" *ngIf=\"allowToZoom\"\r\n        [ngClass]=\"{ 'np-panel-zoom-in': !isZoom, 'np-panel-zoom-out': isZoom }\" (click)=\"_toggleZoom()\">\r\n        <svg class=\"np-icon\" *ngIf=\"!isZoom\" viewBox=\"0 0 24 24\">\r\n          <path\r\n            d=\"M15.5 14h-.79l-.28-.27C15.41 12.59 16 11.11 16 9.5 16 5.91 13.09 3 9.5 3S3 5.91 3 9.5 5.91 16 9.5 16c1.61 0 3.09-.59 4.23-1.57l.27.28v.79l5 4.99L20.49 19l-4.99-5zm-6 0C7.01 14 5 11.99 5 9.5S7.01 5 9.5 5 14 7.01 14 9.5 11.99 14 9.5 14z\">\r\n          </path>\r\n          <path d=\"M0 0h24v24H0V0z\" fill=\"none\"></path>\r\n          <path d=\"M12 10h-2v2H9v-2H7V9h2V7h1v2h2v1z\"></path>\r\n        </svg>\r\n        <svg class=\"np-icon\" *ngIf=\"isZoom\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M0 0h24v24H0V0z\" fill=\"none\"></path>\r\n          <path\r\n            d=\"M15.5 14h-.79l-.28-.27C15.41 12.59 16 11.11 16 9.5 16 5.91 13.09 3 9.5 3S3 5.91 3 9.5 5.91 16 9.5 16c1.61 0 3.09-.59 4.23-1.57l.27.28v.79l5 4.99L20.49 19l-4.99-5zm-6 0C7.01 14 5 11.99 5 9.5S7.01 5 9.5 5 14 7.01 14 9.5 11.99 14 9.5 14zM7 9h5v1H7z\">\r\n          </path>\r\n        </svg>\r\n      </button>\r\n      <button class=\"np-btn-icon np-panel-close\" type=\"button\" [attr.tabindex]=\"disabled ? '-1' : '0'\"\r\n        *ngIf=\"allowToClose && !isZoom\" (click)=\"_close()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path\r\n            d=\"M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z\">\r\n          </path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n  </div>\r\n  <div class=\"np-panel-body\" role=\"region\" *ngIf=\"isOpen\" [attr.aria-labelledby]=\"_getTitleId()\"\r\n    [attr.id]=\"_getBodyId()\">\r\n    <ng-content></ng-content>\r\n    <ng-template [cdkPortalOutlet]=\"content\"></ng-template>\r\n  </div>\r\n</div>" }]
        }], ctorParameters: function () { return [{ type: i0.ViewContainerRef }, { type: i0.ElementRef }]; }, propDecorators: { title: [{
                type: Input
            }], allowToMinimize: [{
                type: Input
            }], allowToZoom: [{
                type: Input
            }], allowToClose: [{
                type: Input
            }], isOpen: [{
                type: Input
            }], height: [{
                type: Input
            }], disabled: [{
                type: Input
            }], iconCss: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], inputId: [{
                type: Input
            }], onExpand: [{
                type: Output
            }], onCollapse: [{
                type: Output
            }], onClose: [{
                type: Output
            }], onZoom: [{
                type: Output
            }], _explicitContent: [{
                type: ContentChild,
                args: [NpPanelContent, { read: TemplateRef, static: true }]
            }] } });

class NpPanelModule {
}
NpPanelModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpPanelModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpPanelModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpPanelModule, declarations: [NpPanelComponent, NpPanelContent], imports: [CommonModule, PortalModule], exports: [NpPanelComponent, NpPanelContent] });
NpPanelModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpPanelModule, imports: [CommonModule, PortalModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpPanelModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpPanelComponent, NpPanelContent],
                    imports: [CommonModule, PortalModule],
                    exports: [NpPanelComponent, NpPanelContent],
                }]
        }] });

class NpMaskService {
    constructor() {
        this.formatToRegExp = {
            0: /[0-9]/,
            a: /[a-z]/,
            A: /[A-Z]/,
            B: /[a-zA-Z]/,
        };
        this.allFormatsStr = "(" +
            Object.keys(this.formatToRegExp)
                .map((key) => this.formatToRegExp[key].toString())
                .map((regexStr) => regexStr.substr(1, regexStr.length - 2))
                .join("|") +
            ")";
        this.allFormatsGlobal = this.getAllFormatRegexp("g");
    }
    valueToFormat(value, format, goingBack = false, prevValue) {
        let maskedValue = "";
        const unmaskedValue = this.unmaskValue(value);
        const isLastCharFormatter = !this.getAllFormatRegexp().test(value[value.length - 1]);
        const isPrevLastCharFormatter = prevValue &&
            !this.getAllFormatRegexp().test(prevValue[prevValue.length - 1]);
        let formatOffset = 0;
        for (let i = 0, maxI = Math.min(unmaskedValue.length, format.length); i < maxI; ++i) {
            const valueChar = unmaskedValue[i];
            let formatChar = format[formatOffset + i];
            let formatRegex = this.getFormatRegexp(formatChar);
            while (formatChar && !formatRegex) {
                maskedValue += formatChar;
                formatChar = format[++formatOffset + i];
                formatRegex = this.getFormatRegexp(formatChar);
            }
            if (valueChar && formatRegex) {
                if (formatRegex.test(valueChar)) {
                    maskedValue += valueChar;
                }
                else {
                    break;
                }
            }
            const nextFormatChar = format[formatOffset + i + 1];
            const nextFormatRegex = this.getFormatRegexp(nextFormatChar);
            const isLastIteration = i === maxI - 1;
            if (isLastIteration && nextFormatChar && !nextFormatRegex) {
                if (!isLastCharFormatter && goingBack) {
                    if (prevValue && !isPrevLastCharFormatter) {
                        continue;
                    }
                    maskedValue = maskedValue.substr(0, formatOffset + i);
                }
                else {
                    maskedValue += nextFormatChar;
                }
            }
        }
        return maskedValue;
    }
    unmaskValue(value) {
        const unmaskedMathes = value.match(this.allFormatsGlobal);
        return unmaskedMathes ? unmaskedMathes.join("") : "";
    }
    getAllFormatRegexp(flags) {
        return new RegExp(this.allFormatsStr, flags);
    }
    getFormatRegexp(formatChar) {
        return formatChar && this.formatToRegExp[formatChar]
            ? this.formatToRegExp[formatChar]
            : null;
    }
}

class NpMaskDirective {
    constructor(injector, maskService) {
        this.injector = injector;
        this.maskService = maskService;
        this.lastMaskedValue = "";
    }
    ngOnInit() {
        setTimeout(() => {
            this.control = this.injector.get(NgControl);
            if (!this.control || !this.control.valueAccessor) {
                return;
            }
            const originalWriteVal = this.control.valueAccessor.writeValue.bind(this.control.valueAccessor);
            this.control.valueAccessor.writeValue = (val) => originalWriteVal(this._maskValue(val));
            const originalChange = this.control.valueAccessor.onChange.bind(this.control.valueAccessor);
            this.control.valueAccessor.registerOnChange((val) => originalChange(this._unmaskValue(val)));
            this._setVal(this._maskValue(this.control.value));
        }, 10);
    }
    _maskValue(val) {
        if (val === null || val === undefined) {
            return '';
        }
        if (!this.mask || val === this.lastMaskedValue) {
            return val;
        }
        const maskedVal = (this.lastMaskedValue = this.maskService.valueToFormat(val, this.mask, this.lastMaskedValue.length > val.length, this.lastMaskedValue));
        return maskedVal;
    }
    _unmaskValue(val) {
        const maskedVal = this._maskValue(val);
        const unmaskedVal = this.maskService.unmaskValue(maskedVal);
        if (maskedVal !== val) {
            this._setVal(maskedVal);
        }
        return maskedVal ? unmaskedVal : "";
    }
    _setVal(val) {
        if (this.control.control) {
            this.control.control.setValue(val, { emitEvent: false });
        }
    }
}
NpMaskDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpMaskDirective, deps: [{ token: i0.Injector }, { token: NpMaskService }], target: i0.ɵɵFactoryTarget.Directive });
NpMaskDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.0.1", type: NpMaskDirective, selector: "[npMask]", inputs: { mask: ["npMask", "mask"] }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpMaskDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: "[npMask]",
                }]
        }], ctorParameters: function () { return [{ type: i0.Injector }, { type: NpMaskService }]; }, propDecorators: { mask: [{
                type: Input,
                args: ["npMask"]
            }] } });
class NpMaskModule {
}
NpMaskModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpMaskModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpMaskModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpMaskModule, declarations: [NpMaskDirective], exports: [NpMaskDirective] });
NpMaskModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpMaskModule, providers: [NpMaskService] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpMaskModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpMaskDirective],
                    exports: [NpMaskDirective],
                    providers: [NpMaskService],
                }]
        }] });

class NpDeferDirective {
    constructor(el, renderer, viewContainer) {
        this.el = el;
        this.renderer = renderer;
        this.viewContainer = viewContainer;
        this.onLoad = new EventEmitter();
        this.isLoaded = false;
    }
    ngAfterViewInit() {
        if (this.shouldLoad()) {
            this.load();
        }
        if (!this.isLoaded) {
            this.documentScrollListener = this.renderer.listen("window", "scroll", () => {
                if (this.shouldLoad()) {
                    this.load();
                }
            });
        }
    }
    shouldLoad() {
        if (this.isLoaded) {
            return false;
        }
        else {
            let rect = this.el.nativeElement.getBoundingClientRect();
            let docElement = document.documentElement;
            let winHeight = docElement.clientHeight;
            return winHeight >= rect.top;
        }
    }
    load() {
        this.viewContainer.createEmbeddedView(this.template);
        this.isLoaded = true;
        this.documentScrollListener = null;
        this.onLoad.emit();
    }
    ngOnDestroy() {
        this.isLoaded = false;
    }
}
NpDeferDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpDeferDirective, deps: [{ token: i0.ElementRef }, { token: i0.Renderer2 }, { token: i0.ViewContainerRef }], target: i0.ɵɵFactoryTarget.Directive });
NpDeferDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.0.1", type: NpDeferDirective, selector: "[npDefer]", outputs: { onLoad: "onLoad" }, queries: [{ propertyName: "template", first: true, predicate: TemplateRef, descendants: true }], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpDeferDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: "[npDefer]",
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.Renderer2 }, { type: i0.ViewContainerRef }]; }, propDecorators: { onLoad: [{
                type: Output
            }], template: [{
                type: ContentChild,
                args: [TemplateRef]
            }] } });
class NpDeferModule {
}
NpDeferModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpDeferModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpDeferModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpDeferModule, declarations: [NpDeferDirective], imports: [CommonModule], exports: [NpDeferDirective] });
NpDeferModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpDeferModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpDeferModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule],
                    exports: [NpDeferDirective],
                    declarations: [NpDeferDirective],
                }]
        }] });

class NpProgressComponent {
    constructor() {
        this.showLabel = true;
        this.inputId = `np-progress_${NpProgressComponent.controlCount++}`;
    }
    getTextValue() {
        return `${this.value}%`;
    }
}
NpProgressComponent.controlCount = 1;
NpProgressComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpProgressComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NpProgressComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpProgressComponent, selector: "np-progress", inputs: { value: "value", styleClass: "styleClass", indeterminate: "indeterminate", striped: "striped", animated: "animated", showLabel: "showLabel", height: "height", inputId: "inputId" }, ngImport: i0, template: "<div role=\"progressbar\" [ngClass]=\"'np-progress'\" [class]=\"styleClass\" [attr.id]=\"inputId\" [attr.aria-valuenow]=\"value\">\r\n  <div class=\"np-progress-container\" [style.height.px]=\"height\">\r\n    <div class=\"np-progress-bar\" *ngIf=\"!indeterminate\" [style.width.%]=\"value\" [ngClass]=\"{\r\n        'np-progress-striped': striped,\r\n        'np-progress-animated': animated\r\n      }\">\r\n      <span *ngIf=\"showLabel\" [innerHTML]=\"getTextValue()\"></span>\r\n    </div>\r\n    <div class=\"np-progress-bar np-progress-indeterminate\" *ngIf=\"indeterminate\"></div>\r\n  </div>\r\n</div>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpProgressComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-progress", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, template: "<div role=\"progressbar\" [ngClass]=\"'np-progress'\" [class]=\"styleClass\" [attr.id]=\"inputId\" [attr.aria-valuenow]=\"value\">\r\n  <div class=\"np-progress-container\" [style.height.px]=\"height\">\r\n    <div class=\"np-progress-bar\" *ngIf=\"!indeterminate\" [style.width.%]=\"value\" [ngClass]=\"{\r\n        'np-progress-striped': striped,\r\n        'np-progress-animated': animated\r\n      }\">\r\n      <span *ngIf=\"showLabel\" [innerHTML]=\"getTextValue()\"></span>\r\n    </div>\r\n    <div class=\"np-progress-bar np-progress-indeterminate\" *ngIf=\"indeterminate\"></div>\r\n  </div>\r\n</div>" }]
        }], propDecorators: { value: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], indeterminate: [{
                type: Input
            }], striped: [{
                type: Input
            }], animated: [{
                type: Input
            }], showLabel: [{
                type: Input
            }], height: [{
                type: Input
            }], inputId: [{
                type: Input
            }] } });

class NpProgressModule {
}
NpProgressModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpProgressModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpProgressModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpProgressModule, declarations: [NpProgressComponent], imports: [CommonModule], exports: [NpProgressComponent] });
NpProgressModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpProgressModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpProgressModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpProgressComponent],
                    imports: [CommonModule],
                    exports: [NpProgressComponent],
                }]
        }] });

class NpCarouselComponent {
    constructor() {
        this.items = [];
        this.autoPlayInterval = 5000;
        this.visibleNum = 1;
        this.scrollNum = 1;
        this.currentPage = 0;
        this.showNavigationArrows = true;
        this.showNavigationIndicators = true;
        this.inputId = `np-carousel_${NpCarouselComponent.controlCount++}`;
        this.isPolite = false;
    }
    _onMouseEnter() {
        if (this.pauseOnHover) {
            this.pause();
        }
    }
    _onMouseLeave() {
        if (this.pauseOnHover) {
            this.start();
        }
    }
    pause() {
        if (this.autoPlay) {
            clearInterval(this.interval);
            this.isPolite = true;
        }
    }
    start() {
        if (this.autoPlay) {
            this._setAutoSlideChange();
        }
    }
    select(page) {
        this._goToPage(page);
    }
    ngOnDestroy() {
        if (this.autoPlay) {
            clearInterval(this.interval);
            this.isPolite = true;
        }
    }
    ngAfterContentInit() {
        this._getSlidesFromPage();
        if (this.autoPlay) {
            this._setAutoSlideChange();
        }
    }
    ngOnChanges(changes) {
        if (changes["scrollNum"] || changes["visibleNum"]) {
            this._getSlidesFromPage();
        }
    }
    _totalPages() {
        if (this.items === undefined || this.items === null) {
            return 0;
        }
        return Math.ceil((this.items.length - this.visibleNum + this.scrollNum) / this.scrollNum);
    }
    getTotalPages() {
        return this._totalPages();
    }
    _getSlidesFromPage() {
        this.startIdx = this.currentPage * this.scrollNum;
        this.endIdx = this.startIdx + this.visibleNum - 1;
    }
    _plusSlides() {
        const idx = this.currentPage + 1;
        this.currentPage = idx >= this._totalPages() ? 0 : idx;
        this._getSlidesFromPage();
    }
    _minusSlides() {
        const idx = this.currentPage - 1;
        this.currentPage = idx < 0 ? this._totalPages() - 1 : idx;
        this._getSlidesFromPage();
    }
    _setAutoSlideChange() {
        this.interval = setInterval(() => {
            this._plusSlides();
        }, this.autoPlayInterval);
        this.isPolite = false;
    }
    _goToPage(page) {
        this.currentPage = page;
        this._getSlidesFromPage();
    }
    _getEmptyArray(i) {
        return new Array(i);
    }
    _isActive(idx) {
        if (this.lazyLoaded || (idx >= this.startIdx && idx <= this.endIdx)) {
            return true;
        }
        return false;
    }
    _getActiveItems() {
        if (!this.items || !this.lazyLoaded) {
            return this.items;
        }
        return this.items.slice(this.startIdx, this.endIdx + 1);
    }
    _getIdxOfItem(i) {
        if (!this.lazyLoaded) {
            return i + 1 + ' of ' + this.items.length;
        }
        return this.startIdx + i + 1 + ' of ' + this.items.length;
    }
    _trackBy(index) {
        return index;
    }
}
NpCarouselComponent.controlCount = 1;
NpCarouselComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpCarouselComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NpCarouselComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpCarouselComponent, selector: "np-carousel", inputs: { items: "items", lazyLoaded: "lazyLoaded", autoPlay: "autoPlay", autoPlayInterval: "autoPlayInterval", itemTemplate: "itemTemplate", visibleNum: "visibleNum", scrollNum: "scrollNum", currentPage: "currentPage", pauseOnHover: "pauseOnHover", showNavigationArrows: "showNavigationArrows", showNavigationIndicators: "showNavigationIndicators", styleClass: "styleClass", inputId: "inputId" }, host: { listeners: { "mouseenter": "_onMouseEnter()", "mouseleave": "_onMouseLeave()" } }, usesOnChanges: true, ngImport: i0, template: "<div [ngClass]=\"'np-carousel'\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-carousel-container\">\r\n    <button class=\"np-btn-icon np-carousel-prev\" type=\"button\" *ngIf=\"showNavigationArrows\" tabindex=\"0\"\r\n      (click)=\"_minusSlides()\">\r\n      <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n        <path d=\"M15.41 16.59L10.83 12l4.58-4.59L14 6l-6 6 6 6 1.41-1.41z\"></path>\r\n        <path fill=\"none\" d=\"M0 0h24v24H0V0z\"></path>\r\n      </svg>\r\n    </button>\r\n    <div class=\"np-carousel-items\" [attr.aria-live]=\"isPolite ? 'polite' : 'off'\">\r\n      <div class=\"np-carousel-item\" role=\"group\" aria-roledescription=\"slide\"\r\n        *ngFor=\"let item of _getActiveItems(); let i = index; trackBy: _trackBy\" [attr.aria-label]=\"_getIdxOfItem(i)\"\r\n        [ngClass]=\"{ 'np-carousel-active': _isActive(i) }\">\r\n        <ng-container [ngTemplateOutlet]=\"itemTemplate\" [ngTemplateOutletContext]=\"{ item: item }\">\r\n        </ng-container>\r\n      </div>\r\n    </div>\r\n    <button class=\"np-btn-icon np-carousel-next\" type=\"button\" *ngIf=\"showNavigationArrows\" tabindex=\"0\"\r\n      (click)=\"_plusSlides()\">\r\n      <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n        <path d=\"M8.59 16.59L13.17 12 8.59 7.41 10 6l6 6-6 6-1.41-1.41z\"></path>\r\n        <path fill=\"none\" d=\"M0 0h24v24H0V0z\"></path>\r\n      </svg>\r\n    </button>\r\n  </div>\r\n  <div class=\"np-carousel-nav\" *ngIf=\"showNavigationIndicators\">\r\n    <ng-container *ngFor=\"let img of _getEmptyArray(_totalPages()); let i = index\">\r\n      <span class=\"np-carousel-dot\" [ngClass]=\"{ 'np-carousel-dot-active': currentPage === i }\"\r\n        (click)=\"_goToPage(i)\"></span>\r\n    </ng-container>\r\n  </div>\r\n</div>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpCarouselComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-carousel", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, template: "<div [ngClass]=\"'np-carousel'\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-carousel-container\">\r\n    <button class=\"np-btn-icon np-carousel-prev\" type=\"button\" *ngIf=\"showNavigationArrows\" tabindex=\"0\"\r\n      (click)=\"_minusSlides()\">\r\n      <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n        <path d=\"M15.41 16.59L10.83 12l4.58-4.59L14 6l-6 6 6 6 1.41-1.41z\"></path>\r\n        <path fill=\"none\" d=\"M0 0h24v24H0V0z\"></path>\r\n      </svg>\r\n    </button>\r\n    <div class=\"np-carousel-items\" [attr.aria-live]=\"isPolite ? 'polite' : 'off'\">\r\n      <div class=\"np-carousel-item\" role=\"group\" aria-roledescription=\"slide\"\r\n        *ngFor=\"let item of _getActiveItems(); let i = index; trackBy: _trackBy\" [attr.aria-label]=\"_getIdxOfItem(i)\"\r\n        [ngClass]=\"{ 'np-carousel-active': _isActive(i) }\">\r\n        <ng-container [ngTemplateOutlet]=\"itemTemplate\" [ngTemplateOutletContext]=\"{ item: item }\">\r\n        </ng-container>\r\n      </div>\r\n    </div>\r\n    <button class=\"np-btn-icon np-carousel-next\" type=\"button\" *ngIf=\"showNavigationArrows\" tabindex=\"0\"\r\n      (click)=\"_plusSlides()\">\r\n      <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n        <path d=\"M8.59 16.59L13.17 12 8.59 7.41 10 6l6 6-6 6-1.41-1.41z\"></path>\r\n        <path fill=\"none\" d=\"M0 0h24v24H0V0z\"></path>\r\n      </svg>\r\n    </button>\r\n  </div>\r\n  <div class=\"np-carousel-nav\" *ngIf=\"showNavigationIndicators\">\r\n    <ng-container *ngFor=\"let img of _getEmptyArray(_totalPages()); let i = index\">\r\n      <span class=\"np-carousel-dot\" [ngClass]=\"{ 'np-carousel-dot-active': currentPage === i }\"\r\n        (click)=\"_goToPage(i)\"></span>\r\n    </ng-container>\r\n  </div>\r\n</div>" }]
        }], propDecorators: { items: [{
                type: Input
            }], lazyLoaded: [{
                type: Input
            }], autoPlay: [{
                type: Input
            }], autoPlayInterval: [{
                type: Input
            }], itemTemplate: [{
                type: Input
            }], visibleNum: [{
                type: Input
            }], scrollNum: [{
                type: Input
            }], currentPage: [{
                type: Input
            }], pauseOnHover: [{
                type: Input
            }], showNavigationArrows: [{
                type: Input
            }], showNavigationIndicators: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], inputId: [{
                type: Input
            }], _onMouseEnter: [{
                type: HostListener,
                args: ["mouseenter"]
            }], _onMouseLeave: [{
                type: HostListener,
                args: ["mouseleave"]
            }] } });

class NpCarouselModule {
}
NpCarouselModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpCarouselModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpCarouselModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpCarouselModule, declarations: [NpCarouselComponent], imports: [CommonModule], exports: [NpCarouselComponent] });
NpCarouselModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpCarouselModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpCarouselModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpCarouselComponent],
                    imports: [CommonModule],
                    exports: [NpCarouselComponent],
                }]
        }] });

class NpTabContent {
}
NpTabContent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTabContent, deps: [], target: i0.ɵɵFactoryTarget.Directive });
NpTabContent.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.0.1", type: NpTabContent, selector: "[npTabContent]", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTabContent, decorators: [{
            type: Directive,
            args: [{
                    selector: "[npTabContent]",
                }]
        }] });

class NpTabComponent {
    constructor(_viewContainerRef) {
        this._viewContainerRef = _viewContainerRef;
        this.active = false;
        this.disabled = false;
        this.inputId = `np-tab_${NpTabComponent.controlCount++}`;
        this.isLoadFirstTime = true;
        this._contentPortal = null;
    }
    get content() {
        return this._contentPortal;
    }
    ngOnInit() {
        if (this.title instanceof TemplateRef) {
            this.titleIsTemplate = true;
        }
        this._contentPortal = new TemplatePortal(this._explicitContent || this._implicitContent, this._viewContainerRef);
    }
    ngOnDestroy() {
        if (this._contentPortal && this._contentPortal.isAttached) {
            this._contentPortal.detach();
        }
    }
    _isActive() {
        return this.active;
    }
}
NpTabComponent.controlCount = 1;
NpTabComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTabComponent, deps: [{ token: i0.ViewContainerRef }], target: i0.ɵɵFactoryTarget.Component });
NpTabComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpTabComponent, selector: "np-tab", inputs: { title: "title", iconCss: "iconCss", active: "active", disabled: "disabled", inputId: "inputId" }, queries: [{ propertyName: "_explicitContent", first: true, predicate: NpTabContent, descendants: true, read: TemplateRef, static: true }], viewQueries: [{ propertyName: "_implicitContent", first: true, predicate: TemplateRef, descendants: true, static: true }], ngImport: i0, template: "<ng-template><ng-content></ng-content></ng-template>", isInline: true, changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTabComponent, decorators: [{
            type: Component,
            args: [{
                    selector: "np-tab",
                    template: "<ng-template><ng-content></ng-content></ng-template>",
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.Default,
                }]
        }], ctorParameters: function () { return [{ type: i0.ViewContainerRef }]; }, propDecorators: { title: [{
                type: Input
            }], iconCss: [{
                type: Input
            }], active: [{
                type: Input
            }], disabled: [{
                type: Input
            }], inputId: [{
                type: Input
            }], _explicitContent: [{
                type: ContentChild,
                args: [NpTabContent, { read: TemplateRef, static: true }]
            }], _implicitContent: [{
                type: ViewChild,
                args: [TemplateRef, { static: true }]
            }] } });

class NpTabsComponent {
    constructor() {
        this.inputId = `np-tabs_${NpTabsComponent.controlCount++}`;
        this.onTabChange = new EventEmitter();
    }
    ngAfterContentInit() {
        // if default active and not disabled tab is present then select it.
        const activeTabs = this.tabs.filter((tab) => tab.active && tab.disabled !== true);
        if (activeTabs.length === 0) {
            // if there is no default active tab, then take the first tab which is not disabled and make it active.
            const tabs = this.tabs.filter((tab) => tab.disabled !== true);
            if (tabs) {
                this.tabs.toArray().forEach((tab) => (tab.active = false));
                tabs[0].active = true;
                this.selected = tabs[0];
                this.onTabChange.emit(tabs[0]);
                tabs[0].isLoadFirstTime = false;
            }
        }
        else {
            this.selected = activeTabs[0];
            this.onTabChange.emit(activeTabs[0]);
            activeTabs[0].isLoadFirstTime = false;
        }
    }
    selectTabById(id) {
        const tab = this.tabs.find((item) => item.inputId === id);
        if (tab && tab.disabled !== true) {
            this._selectTab(tab);
        }
    }
    selectTabByIndex(idx) {
        const tab = this.tabs.toArray()[idx];
        if (tab && tab.disabled !== true) {
            this._selectTab(tab);
        }
    }
    getSelectedTabIndex() {
        return this.tabs.toArray().findIndex((element) => element.active);
    }
    getSelectedTab() {
        return this.selected;
    }
    _getTitleId(tab) {
        return tab.inputId + "_title";
    }
    _getBodyId(tab) {
        return tab.inputId + "_body";
    }
    _selectTab(tab) {
        if (tab.disabled === true || tab.active === true) {
            return;
        }
        this.tabs.toArray().forEach((element) => {
            if (element.inputId !== tab.inputId) {
                element.active = false;
            }
        });
        tab.active = true;
        this.selected = tab;
        this.onTabChange.emit(tab);
        tab.isLoadFirstTime = false;
    }
}
NpTabsComponent.controlCount = 1;
NpTabsComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTabsComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NpTabsComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpTabsComponent, selector: "np-tabs", inputs: { verticalTabs: "verticalTabs", height: "height", stretchLabels: "stretchLabels", styleClass: "styleClass", inputId: "inputId" }, outputs: { onTabChange: "onTabChange" }, queries: [{ propertyName: "tabs", predicate: NpTabComponent }], ngImport: i0, template: "<div role=\"tablist\" [ngClass]=\"{ 'np-tabs': true, 'np-tabs-vertical': verticalTabs }\" [style.max-height.px]=\"height\"\r\n  [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <ul class=\"np-tabs-header\">\r\n    <ng-container *ngFor=\"let tab of tabs\">\r\n      <li class=\"np-tab-title\" role=\"tab\" [attr.id]=\"_getTitleId(tab)\" [ngClass]=\"{\r\n          'np-tab-active': tab.active,\r\n          'np-disabled': tab.disabled,\r\n          'np-tab-stretch-label': stretchLabels\r\n        }\" [attr.tabindex]=\"tab.disabled ? '-1' : '0'\" [attr.aria-selected]=\"tab.active\"\r\n        [attr.aria-controls]=\"_getBodyId(tab)\" (click)=\"_selectTab(tab)\">\r\n        <a class=\"np-tab-title-link\">\r\n          <i *ngIf=\"tab.iconCss\" [class]=\"tab.iconCss\"></i>\r\n          <span *ngIf=\"!tab.titleIsTemplate\" [innerHTML]=\"tab.title\"></span>\r\n          <ng-container *ngIf=\"tab.titleIsTemplate\" [ngTemplateOutlet]=\"tab.title\">\r\n          </ng-container>\r\n        </a>\r\n      </li>\r\n    </ng-container>\r\n  </ul>\r\n  <div class=\"np-tab-body\" role=\"tabpanel\" [attr.id]=\"_getBodyId(selected)\"\r\n    [attr.aria-labelledby]=\"_getTitleId(selected)\">\r\n    <ng-template [cdkPortalOutlet]=\"selected.content\"></ng-template>\r\n  </div>\r\n</div>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i2.CdkPortalOutlet, selector: "[cdkPortalOutlet]", inputs: ["cdkPortalOutlet"], outputs: ["attached"], exportAs: ["cdkPortalOutlet"] }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTabsComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-tabs", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, template: "<div role=\"tablist\" [ngClass]=\"{ 'np-tabs': true, 'np-tabs-vertical': verticalTabs }\" [style.max-height.px]=\"height\"\r\n  [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <ul class=\"np-tabs-header\">\r\n    <ng-container *ngFor=\"let tab of tabs\">\r\n      <li class=\"np-tab-title\" role=\"tab\" [attr.id]=\"_getTitleId(tab)\" [ngClass]=\"{\r\n          'np-tab-active': tab.active,\r\n          'np-disabled': tab.disabled,\r\n          'np-tab-stretch-label': stretchLabels\r\n        }\" [attr.tabindex]=\"tab.disabled ? '-1' : '0'\" [attr.aria-selected]=\"tab.active\"\r\n        [attr.aria-controls]=\"_getBodyId(tab)\" (click)=\"_selectTab(tab)\">\r\n        <a class=\"np-tab-title-link\">\r\n          <i *ngIf=\"tab.iconCss\" [class]=\"tab.iconCss\"></i>\r\n          <span *ngIf=\"!tab.titleIsTemplate\" [innerHTML]=\"tab.title\"></span>\r\n          <ng-container *ngIf=\"tab.titleIsTemplate\" [ngTemplateOutlet]=\"tab.title\">\r\n          </ng-container>\r\n        </a>\r\n      </li>\r\n    </ng-container>\r\n  </ul>\r\n  <div class=\"np-tab-body\" role=\"tabpanel\" [attr.id]=\"_getBodyId(selected)\"\r\n    [attr.aria-labelledby]=\"_getTitleId(selected)\">\r\n    <ng-template [cdkPortalOutlet]=\"selected.content\"></ng-template>\r\n  </div>\r\n</div>" }]
        }], propDecorators: { verticalTabs: [{
                type: Input
            }], height: [{
                type: Input
            }], stretchLabels: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], inputId: [{
                type: Input
            }], onTabChange: [{
                type: Output
            }], tabs: [{
                type: ContentChildren,
                args: [NpTabComponent]
            }] } });

class NpTabsModule {
}
NpTabsModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTabsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpTabsModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpTabsModule, declarations: [NpTabsComponent, NpTabComponent, NpTabContent], imports: [CommonModule, PortalModule], exports: [NpTabsComponent, NpTabComponent, NpTabContent] });
NpTabsModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTabsModule, imports: [CommonModule, PortalModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTabsModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpTabsComponent, NpTabComponent, NpTabContent],
                    imports: [CommonModule, PortalModule],
                    exports: [NpTabsComponent, NpTabComponent, NpTabContent],
                }]
        }] });

class NpAccordionContent {
}
NpAccordionContent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpAccordionContent, deps: [], target: i0.ɵɵFactoryTarget.Directive });
NpAccordionContent.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.0.1", type: NpAccordionContent, selector: "[npAccordionContent]", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpAccordionContent, decorators: [{
            type: Directive,
            args: [{
                    selector: "[npAccordionContent]",
                }]
        }] });

class NpAccordionItemComponent {
    constructor(_viewContainerRef) {
        this._viewContainerRef = _viewContainerRef;
        this.isOpen = false;
        this.inputId = `np-accordion-item_${NpAccordionItemComponent.controlCount++}`;
        this._onExpand = new EventEmitter();
        this._onCollapse = new EventEmitter();
        this._contentPortal = null;
    }
    get content() {
        return this._contentPortal;
    }
    ngOnInit() {
        if (this.title instanceof TemplateRef) {
            this.isTitleTemplate = true;
        }
        if (this.isOpen) {
            if (!this._contentPortal && this._explicitContent) {
                this._contentPortal = new TemplatePortal(this._explicitContent, this._viewContainerRef);
            }
        }
    }
    ngOnDestroy() {
        if (this._contentPortal && this._contentPortal.isAttached) {
            this._contentPortal.detach();
        }
    }
    _getTitleId() {
        return this.inputId + "_title";
    }
    _getBodyId() {
        return this.inputId + "_body";
    }
    _expand() {
        if (this.disabled) {
            return;
        }
        this.isOpen = true;
        if (!this._contentPortal && this._explicitContent) {
            this._contentPortal = new TemplatePortal(this._explicitContent, this._viewContainerRef);
        }
        this._onExpand.emit(this);
    }
    _collapse() {
        if (this.disabled) {
            return;
        }
        this.isOpen = false;
        this._onCollapse.emit(this);
    }
    _toggle() {
        if (this.disabled) {
            return;
        }
        if (this.isOpen) {
            this._collapse();
            return;
        }
        this._expand();
    }
}
NpAccordionItemComponent.controlCount = 1;
NpAccordionItemComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpAccordionItemComponent, deps: [{ token: i0.ViewContainerRef }], target: i0.ɵɵFactoryTarget.Component });
NpAccordionItemComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpAccordionItemComponent, selector: "np-accordion-item", inputs: { title: "title", isOpen: "isOpen", height: "height", disabled: "disabled", iconCss: "iconCss", styleClass: "styleClass", inputId: "inputId" }, outputs: { _onExpand: "_onExpand", _onCollapse: "_onCollapse" }, queries: [{ propertyName: "_explicitContent", first: true, predicate: NpAccordionContent, descendants: true, read: TemplateRef, static: true }], ngImport: i0, template: "<div [ngClass]=\"{ 'np-accordion-item': true, 'np-disabled': disabled }\" [style.max-height.px]=\"height\"\r\n  [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-accordion-header\">\r\n    <button class=\"np-accordion-title\" (click)=\"_toggle()\" [attr.id]=\"_getTitleId()\"\r\n      [attr.tabindex]=\"disabled ? '-1' : '0'\" [attr.aria-expanded]=\"isOpen\" [attr.aria-controls]=\"_getBodyId()\"\r\n      [attr.aria-disabled]=\"disabled\">\r\n      <i *ngIf=\"iconCss\" [class]=\"iconCss\"></i>\r\n      <span *ngIf=\"!isTitleTemplate\" [innerHTML]=\"title\"></span>\r\n      <ng-container *ngIf=\"isTitleTemplate\" [ngTemplateOutlet]=\"title\">\r\n      </ng-container>\r\n    </button>\r\n    <div class=\"np-accordion-btn\">\r\n      <button class=\"np-btn-icon\" type=\"button\" [attr.tabindex]=\"disabled ? '-1' : '0'\" [ngClass]=\"{\r\n          'np-accordion-expand': !isOpen,\r\n          'np-accordion-collapse': isOpen\r\n        }\" (click)=\"_toggle()\">\r\n        <svg class=\"np-icon\" *ngIf=\"isOpen\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M12 8l-6 6 1.41 1.41L12 10.83l4.59 4.58L18 14z\"></path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n        <svg class=\"np-icon\" *ngIf=\"!isOpen\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M16.59 8.59L12 13.17 7.41 8.59 6 10l6 6 6-6z\"></path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n  </div>\r\n  <div class=\"np-accordion-body\" role=\"region\" *ngIf=\"isOpen\" [attr.id]=\"_getBodyId()\"\r\n    [attr.aria-labelledby]=\"_getTitleId()\">\r\n    <ng-content></ng-content>\r\n    <ng-template [cdkPortalOutlet]=\"content\"></ng-template>\r\n  </div>\r\n</div>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i2.CdkPortalOutlet, selector: "[cdkPortalOutlet]", inputs: ["cdkPortalOutlet"], outputs: ["attached"], exportAs: ["cdkPortalOutlet"] }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpAccordionItemComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-accordion-item", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, template: "<div [ngClass]=\"{ 'np-accordion-item': true, 'np-disabled': disabled }\" [style.max-height.px]=\"height\"\r\n  [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-accordion-header\">\r\n    <button class=\"np-accordion-title\" (click)=\"_toggle()\" [attr.id]=\"_getTitleId()\"\r\n      [attr.tabindex]=\"disabled ? '-1' : '0'\" [attr.aria-expanded]=\"isOpen\" [attr.aria-controls]=\"_getBodyId()\"\r\n      [attr.aria-disabled]=\"disabled\">\r\n      <i *ngIf=\"iconCss\" [class]=\"iconCss\"></i>\r\n      <span *ngIf=\"!isTitleTemplate\" [innerHTML]=\"title\"></span>\r\n      <ng-container *ngIf=\"isTitleTemplate\" [ngTemplateOutlet]=\"title\">\r\n      </ng-container>\r\n    </button>\r\n    <div class=\"np-accordion-btn\">\r\n      <button class=\"np-btn-icon\" type=\"button\" [attr.tabindex]=\"disabled ? '-1' : '0'\" [ngClass]=\"{\r\n          'np-accordion-expand': !isOpen,\r\n          'np-accordion-collapse': isOpen\r\n        }\" (click)=\"_toggle()\">\r\n        <svg class=\"np-icon\" *ngIf=\"isOpen\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M12 8l-6 6 1.41 1.41L12 10.83l4.59 4.58L18 14z\"></path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n        <svg class=\"np-icon\" *ngIf=\"!isOpen\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M16.59 8.59L12 13.17 7.41 8.59 6 10l6 6 6-6z\"></path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n  </div>\r\n  <div class=\"np-accordion-body\" role=\"region\" *ngIf=\"isOpen\" [attr.id]=\"_getBodyId()\"\r\n    [attr.aria-labelledby]=\"_getTitleId()\">\r\n    <ng-content></ng-content>\r\n    <ng-template [cdkPortalOutlet]=\"content\"></ng-template>\r\n  </div>\r\n</div>" }]
        }], ctorParameters: function () { return [{ type: i0.ViewContainerRef }]; }, propDecorators: { title: [{
                type: Input
            }], isOpen: [{
                type: Input
            }], height: [{
                type: Input
            }], disabled: [{
                type: Input
            }], iconCss: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], inputId: [{
                type: Input
            }], _onExpand: [{
                type: Output
            }], _onCollapse: [{
                type: Output
            }], _explicitContent: [{
                type: ContentChild,
                args: [NpAccordionContent, { read: TemplateRef, static: true }]
            }] } });

class NpAccordionComponent {
    constructor() {
        this.allowMultipleOpen = true;
        this.inputId = `np-accordion_${NpAccordionComponent.controlCount++}`;
        this.onExpand = new EventEmitter();
        this.onCollapse = new EventEmitter();
        this.subscriptions = [];
    }
    ngAfterContentInit() {
        if (this.defaultOpenIndex >= 0) {
            this.expandByIndex(this.defaultOpenIndex);
        }
        this.items.toArray().forEach((element) => {
            this.subscriptions.push(element._onExpand.subscribe((item) => {
                this._onExpand(item);
            }));
            this.subscriptions.push(element._onCollapse.subscribe((item) => {
                this._onCollapse(item);
            }));
        });
    }
    ngOnDestroy() {
        this.subscriptions.forEach((element) => {
            element.unsubscribe();
        });
    }
    expandByIndex(idx) {
        this.items.toArray()[idx]._expand();
    }
    expandById(id) {
        this.items
            .toArray()
            .find((item) => item.inputId === id)
            ._expand();
    }
    collapseByIndex(idx) {
        this.items.toArray()[idx]._collapse();
    }
    collapseById(id) {
        this.items
            .toArray()
            .find((item) => item.inputId === id)
            ._collapse();
    }
    _onExpand(item) {
        if (!this.allowMultipleOpen) {
            this.items.toArray().find((element) => {
                if (item.inputId !== element.inputId && element.isOpen) {
                    element._collapse();
                }
            });
        }
        this.onExpand.emit(item);
    }
    _onCollapse(item) {
        this.onCollapse.emit(item);
    }
}
NpAccordionComponent.controlCount = 1;
NpAccordionComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpAccordionComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NpAccordionComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpAccordionComponent, selector: "np-accordion", inputs: { defaultOpenIndex: "defaultOpenIndex", allowMultipleOpen: "allowMultipleOpen", styleClass: "styleClass", inputId: "inputId" }, outputs: { onExpand: "onExpand", onCollapse: "onCollapse" }, queries: [{ propertyName: "items", predicate: NpAccordionItemComponent }], ngImport: i0, template: "<div [ngClass]=\"'np-accordion-component'\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <ng-content></ng-content>\r\n</div>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpAccordionComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-accordion", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, template: "<div [ngClass]=\"'np-accordion-component'\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <ng-content></ng-content>\r\n</div>" }]
        }], propDecorators: { defaultOpenIndex: [{
                type: Input
            }], allowMultipleOpen: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], inputId: [{
                type: Input
            }], onExpand: [{
                type: Output
            }], onCollapse: [{
                type: Output
            }], items: [{
                type: ContentChildren,
                args: [NpAccordionItemComponent]
            }] } });

class NpAccordionModule {
}
NpAccordionModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpAccordionModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpAccordionModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpAccordionModule, declarations: [NpAccordionComponent,
        NpAccordionItemComponent,
        NpAccordionContent], imports: [CommonModule, PortalModule], exports: [NpAccordionComponent, NpAccordionItemComponent, NpAccordionContent] });
NpAccordionModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpAccordionModule, imports: [CommonModule, PortalModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpAccordionModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        NpAccordionComponent,
                        NpAccordionItemComponent,
                        NpAccordionContent,
                    ],
                    imports: [CommonModule, PortalModule],
                    exports: [NpAccordionComponent, NpAccordionItemComponent, NpAccordionContent],
                }]
        }] });

class NpAlertComponent {
    constructor(el) {
        this.el = el;
        this.showCloseButton = false;
        this.autoClose = false;
        this.autoCloseTimeout = 10000;
        this.inputId = `np-alert_${NpAlertComponent.controlCount++}`;
    }
    ngOnInit() {
        if (this.autoClose) {
            setTimeout(() => {
                this.close();
            }, this.autoCloseTimeout);
        }
    }
    close() {
        this.el.nativeElement.remove();
    }
}
NpAlertComponent.controlCount = 1;
NpAlertComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpAlertComponent, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component });
NpAlertComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpAlertComponent, selector: "np-alert", inputs: { type: "type", styleClass: "styleClass", showCloseButton: "showCloseButton", autoClose: "autoClose", autoCloseTimeout: "autoCloseTimeout", inputId: "inputId" }, ngImport: i0, template: "<div role=\"alert\" aria-atomic=\"true\" aria-live=\"assertive\" [ngClass]=\"{\r\n    'np-alert': true,\r\n    'np-alert-success': type === 'success',\r\n    'np-alert-danger': type === 'danger',\r\n    'np-alert-warning': type === 'warning',\r\n    'np-alert-info': type === 'info'\r\n  }\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-alert-icon\">\r\n    <svg class=\"np-icon\" *ngIf=\"type === 'success'\" viewBox=\"0 0 24 24\">\r\n      <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n      <path\r\n        d=\"M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm-2 15l-5-5 1.41-1.41L10 14.17l7.59-7.59L19 8l-9 9z\">\r\n      </path>\r\n    </svg>\r\n    <svg class=\"np-icon\" *ngIf=\"type === 'danger'\" viewBox=\"0 0 24 24\">\r\n      <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n      <path d=\"M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm1 15h-2v-2h2v2zm0-4h-2V7h2v6z\"></path>\r\n    </svg>\r\n    <svg class=\"np-icon\" *ngIf=\"type === 'warning'\" viewBox=\"0 0 24 24\">\r\n      <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n      <path d=\"M1 21h22L12 2 1 21zm12-3h-2v-2h2v2zm0-4h-2v-4h2v4z\"></path>\r\n    </svg>\r\n    <svg class=\"np-icon\" *ngIf=\"type === 'info'\" viewBox=\"0 0 24 24\">\r\n      <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n      <path d=\"M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm1 15h-2v-6h2v6zm0-8h-2V7h2v2z\"></path>\r\n    </svg>\r\n  </div>\r\n  <div class=\"np-alert-detail\">\r\n    <ng-content></ng-content>\r\n  </div>\r\n  <button class=\"np-btn-icon np-alert-close\" type=\"button\" *ngIf=\"showCloseButton\" (click)=\"close()\">\r\n    <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n      <path d=\"M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z\">\r\n      </path>\r\n      <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n    </svg>\r\n  </button>\r\n</div>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpAlertComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-alert", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, template: "<div role=\"alert\" aria-atomic=\"true\" aria-live=\"assertive\" [ngClass]=\"{\r\n    'np-alert': true,\r\n    'np-alert-success': type === 'success',\r\n    'np-alert-danger': type === 'danger',\r\n    'np-alert-warning': type === 'warning',\r\n    'np-alert-info': type === 'info'\r\n  }\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-alert-icon\">\r\n    <svg class=\"np-icon\" *ngIf=\"type === 'success'\" viewBox=\"0 0 24 24\">\r\n      <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n      <path\r\n        d=\"M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm-2 15l-5-5 1.41-1.41L10 14.17l7.59-7.59L19 8l-9 9z\">\r\n      </path>\r\n    </svg>\r\n    <svg class=\"np-icon\" *ngIf=\"type === 'danger'\" viewBox=\"0 0 24 24\">\r\n      <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n      <path d=\"M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm1 15h-2v-2h2v2zm0-4h-2V7h2v6z\"></path>\r\n    </svg>\r\n    <svg class=\"np-icon\" *ngIf=\"type === 'warning'\" viewBox=\"0 0 24 24\">\r\n      <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n      <path d=\"M1 21h22L12 2 1 21zm12-3h-2v-2h2v2zm0-4h-2v-4h2v4z\"></path>\r\n    </svg>\r\n    <svg class=\"np-icon\" *ngIf=\"type === 'info'\" viewBox=\"0 0 24 24\">\r\n      <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n      <path d=\"M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm1 15h-2v-6h2v6zm0-8h-2V7h2v2z\"></path>\r\n    </svg>\r\n  </div>\r\n  <div class=\"np-alert-detail\">\r\n    <ng-content></ng-content>\r\n  </div>\r\n  <button class=\"np-btn-icon np-alert-close\" type=\"button\" *ngIf=\"showCloseButton\" (click)=\"close()\">\r\n    <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n      <path d=\"M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z\">\r\n      </path>\r\n      <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n    </svg>\r\n  </button>\r\n</div>" }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { type: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], showCloseButton: [{
                type: Input
            }], autoClose: [{
                type: Input
            }], autoCloseTimeout: [{
                type: Input
            }], inputId: [{
                type: Input
            }] } });

class NpAlertModule {
}
NpAlertModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpAlertModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpAlertModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpAlertModule, declarations: [NpAlertComponent], imports: [CommonModule], exports: [NpAlertComponent] });
NpAlertModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpAlertModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpAlertModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpAlertComponent],
                    imports: [CommonModule],
                    exports: [NpAlertComponent],
                }]
        }] });

class NpModalRef {
    constructor(overlay, content, config, data) {
        this.overlay = overlay;
        this.content = content;
        this.config = config;
        this.data = data;
        this.onClose = new Subject();
        overlay.backdropClick().subscribe(() => {
            if (config.closeOnClickOutside === true) {
                this._close(null);
            }
        });
    }
    close(result) {
        this._close(result);
    }
    _close(result) {
        this.overlay.dispose();
        this.onClose.next(result);
        this.onClose.complete();
    }
}

class NpModalContainerComponent {
    constructor(modalRef) {
        this.modalRef = modalRef;
        this.inputId = `np-modal_${NpModalContainerComponent.controlCount++}`;
    }
    ngOnInit() {
        this.content = this.modalRef.content;
        if (typeof this.content === "string") {
            this.contentType = "string";
        }
        else if (this.content instanceof TemplateRef) {
            this.contentType = "template";
            this.context = {
                close: this.modalRef.close.bind(this.modalRef),
                data: this.modalRef.data,
            };
        }
        else {
            this.contentType = "component";
        }
        this.header = this.modalRef.config.header;
        this.showCloseButton = this.modalRef.config.showCloseButton;
        if (this.modalRef.config.inputId) {
            this.inputId = this.modalRef.config.inputId;
        }
        if (this.modalRef.config.styleClass) {
            this.styleClass = this.modalRef.config.styleClass;
        }
    }
    close() {
        this.modalRef.close(null);
    }
}
NpModalContainerComponent.controlCount = 1;
NpModalContainerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpModalContainerComponent, deps: [{ token: NpModalRef }], target: i0.ɵɵFactoryTarget.Component });
NpModalContainerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpModalContainerComponent, selector: "np-modal", ngImport: i0, template: "<div role=\"dialog\" [ngClass]=\"'np-modal'\" [class]=\"styleClass\" [attr.id]=\"inputId\"\r\n  [attr.aria-labelledby]=\"inputId + '-title'\" [attr.aria-describedby]=\"inputId + '-body'\"\r\n  [attr.aria-modal]=\"modalRef.config.hasBackDrop ? 'true' : null\">\r\n  <div class=\"np-modal-header\">\r\n    <a class=\"np-modal-title\" [innerHTML]=\"header\" [attr.id]=\"inputId + '-title'\"></a>\r\n    <button class=\"np-btn-icon np-modal-close\" type=\"button\" *ngIf=\"showCloseButton\" (click)=\"close()\">\r\n      <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n        <path d=\"M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z\">\r\n        </path>\r\n        <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n      </svg>\r\n    </button>\r\n  </div>\r\n  <div class=\"np-modal-body\" [attr.id]=\"inputId + '-body'\">\r\n    <ng-container [ngSwitch]=\"contentType\">\r\n      <ng-container *ngSwitchCase=\"'string'\">\r\n        <div [innerHTML]=\"content\"></div>\r\n      </ng-container>\r\n      <ng-container *ngSwitchCase=\"'template'\">\r\n        <ng-container *ngTemplateOutlet=\"content; context: context\"></ng-container>\r\n      </ng-container>\r\n      <ng-container *ngSwitchCase=\"'component'\">\r\n        <ng-container *ngComponentOutlet=\"content\"></ng-container>\r\n      </ng-container>\r\n    </ng-container>\r\n  </div>\r\n</div>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgComponentOutlet, selector: "[ngComponentOutlet]", inputs: ["ngComponentOutlet", "ngComponentOutletInjector", "ngComponentOutletContent", "ngComponentOutletNgModule", "ngComponentOutletNgModuleFactory"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i1$1.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { kind: "directive", type: i1$1.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpModalContainerComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-modal", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, template: "<div role=\"dialog\" [ngClass]=\"'np-modal'\" [class]=\"styleClass\" [attr.id]=\"inputId\"\r\n  [attr.aria-labelledby]=\"inputId + '-title'\" [attr.aria-describedby]=\"inputId + '-body'\"\r\n  [attr.aria-modal]=\"modalRef.config.hasBackDrop ? 'true' : null\">\r\n  <div class=\"np-modal-header\">\r\n    <a class=\"np-modal-title\" [innerHTML]=\"header\" [attr.id]=\"inputId + '-title'\"></a>\r\n    <button class=\"np-btn-icon np-modal-close\" type=\"button\" *ngIf=\"showCloseButton\" (click)=\"close()\">\r\n      <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n        <path d=\"M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z\">\r\n        </path>\r\n        <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n      </svg>\r\n    </button>\r\n  </div>\r\n  <div class=\"np-modal-body\" [attr.id]=\"inputId + '-body'\">\r\n    <ng-container [ngSwitch]=\"contentType\">\r\n      <ng-container *ngSwitchCase=\"'string'\">\r\n        <div [innerHTML]=\"content\"></div>\r\n      </ng-container>\r\n      <ng-container *ngSwitchCase=\"'template'\">\r\n        <ng-container *ngTemplateOutlet=\"content; context: context\"></ng-container>\r\n      </ng-container>\r\n      <ng-container *ngSwitchCase=\"'component'\">\r\n        <ng-container *ngComponentOutlet=\"content\"></ng-container>\r\n      </ng-container>\r\n    </ng-container>\r\n  </div>\r\n</div>" }]
        }], ctorParameters: function () { return [{ type: NpModalRef }]; } });

class NpModalConfig {
    constructor(item) {
        this.hasBackDrop = item.hasBackDrop === false ? false : true;
        this.backDropClass = item.backDropClass;
        this.height = item.height;
        this.width = item.width;
        this.showCloseButton = item.showCloseButton === false ? false : true;
        this.header = item.header;
        this.inputId = item.inputId;
        this.styleClass = item.styleClass;
        this.closeOnClickOutside =
            item.closeOnClickOutside === false ? false : true;
    }
}

class NpModalService {
    constructor(overlay, injector, overlayPositionBuilder) {
        this.overlay = overlay;
        this.injector = injector;
        this.overlayPositionBuilder = overlayPositionBuilder;
    }
    open(content, config, data) {
        const positionStrategy = this.overlayPositionBuilder
            .global()
            .centerHorizontally()
            .centerVertically();
        if (!config) {
            config = new NpModalConfig({});
        }
        const overlayConfig = new OverlayConfig({
            positionStrategy,
            hasBackdrop: config.hasBackDrop,
            backdropClass: config.backDropClass || "np-modal-backdrop",
            height: config.height,
            width: config.width,
            scrollStrategy: this.overlay.scrollStrategies.block(),
            panelClass: "np-modal-overlay",
        });
        const overlayRef = this.overlay.create(overlayConfig);
        const myOverlayRef = new NpModalRef(overlayRef, content, config, data);
        const injector = Injector.create({
            parent: this.injector,
            providers: [{ provide: NpModalRef, useValue: myOverlayRef }],
        });
        overlayRef.attach(new ComponentPortal(NpModalContainerComponent, null, injector));
        return myOverlayRef;
    }
}
NpModalService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpModalService, deps: [{ token: i1.Overlay }, { token: i0.Injector }, { token: i1.OverlayPositionBuilder }], target: i0.ɵɵFactoryTarget.Injectable });
NpModalService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpModalService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpModalService, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: i1.Overlay }, { type: i0.Injector }, { type: i1.OverlayPositionBuilder }]; } });

class NpModalModule {
}
NpModalModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpModalModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpModalModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpModalModule, declarations: [NpModalContainerComponent], imports: [CommonModule, OverlayModule, PortalModule], exports: [NpModalContainerComponent] });
NpModalModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpModalModule, providers: [NpModalService], imports: [CommonModule, OverlayModule, PortalModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpModalModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpModalContainerComponent],
                    imports: [CommonModule, OverlayModule, PortalModule],
                    exports: [NpModalContainerComponent],
                    providers: [NpModalService]
                }]
        }] });

class NpTagsComponent {
    constructor(overlay, viewContainerRef, overlayPositionBuilder, elementRef, utility) {
        this.overlay = overlay;
        this.viewContainerRef = viewContainerRef;
        this.overlayPositionBuilder = overlayPositionBuilder;
        this.elementRef = elementRef;
        this.utility = utility;
        this.searchDelay = 1000;
        this.placeholder = "";
        this.inputId = `np-tags_${NpTagsComponent.controlCount++}`;
        this.onChange = new EventEmitter();
        this.onSearch = new EventEmitter();
        this.onCreateNewTag = new EventEmitter();
        this.onFocus = new EventEmitter();
        this.onBlur = new EventEmitter();
        this.isLoading = false;
        this.isDisabled = false;
        this.focused = false;
        this.onChangeCallback = () => { };
        this.onTouchedCallback = () => { };
    }
    ngAfterContentInit() {
        this.subscription = this.searchResult.subscribe((data) => {
            if (this.maxResultLimit &&
                this.maxResultLimit > 0 &&
                data &&
                data.length > this.maxResultLimit) {
                this.options = data.splice(0, this.maxResultLimit);
            }
            else {
                this.options = data;
            }
            if (this.isServerSide) {
                this.isLoading = false;
                if (data) {
                    if (!this.overlayRef.hasAttached()) {
                        this.overlayRef.attach(this.templatePortal);
                    }
                }
            }
        });
    }
    ngAfterViewInit() {
        const positionStrategy = this.overlayPositionBuilder
            .flexibleConnectedTo(this.elementRef)
            .withPositions(TopBottomOverlayPositions);
        this.overlayRef = this.overlay.create({
            positionStrategy,
            hasBackdrop: true,
            backdropClass: "np-tags-backdrop",
            scrollStrategy: this.overlay.scrollStrategies.reposition(),
            panelClass: this.styleClass,
        });
        this.templatePortal = new TemplatePortal(this.templatePortalContent, this.viewContainerRef);
        this.overlayRef.backdropClick().subscribe(() => this._close());
    }
    ngOnDestroy() {
        if (this.subscription) {
            this.subscription.unsubscribe();
        }
    }
    get value() {
        return this.innerValue ? this.innerValue : null;
    }
    set value(v) {
        if (v !== this.innerValue) {
            this.innerValue = v;
            this.onChangeCallback(v);
            this.onChange.emit(v);
        }
    }
    writeValue(v) {
        if (v !== this.innerValue) {
            this.innerValue = v;
            this.selected = Object.assign([], v);
        }
    }
    registerOnChange(fn) {
        this.onChangeCallback = fn;
    }
    registerOnTouched(fn) {
        this.onTouchedCallback = fn;
    }
    setDisabledState(isDisabled) {
        this.isDisabled = isDisabled;
    }
    focus() {
        this.inputViewChild.nativeElement.focus();
    }
    _close() {
        this.displayValue = null;
        this.overlayRef.detach();
        this.inputViewChild.nativeElement.focus();
    }
    _onInput($event) {
        if (!$event.target.value) {
            return;
        }
        this.displayValue = $event.target.value.trim();
        if (this.isDisabled || this.readOnly || !this.isServerSide) {
            return;
        }
        if (this.minSearchCharLimit && this.minSearchCharLimit > 0) {
            if (this.displayValue === undefined ||
                this.displayValue === null ||
                this.displayValue.length < this.minSearchCharLimit) {
                return;
            }
        }
        this.isLoading = true;
        if (this.searchTimeout) {
            clearTimeout(this.searchTimeout);
        }
        const searchKeyword = this.displayValue;
        this.searchTimeout = setTimeout(() => {
            this.onSearch.emit(searchKeyword);
        }, this.searchDelay);
    }
    _selectValue(val) {
        if (this._isSelected(val)) {
            this._removeTag(val);
            return;
        }
        if (this.maxSelectLimit > 0 &&
            this.value &&
            this.value.length === this.maxSelectLimit) {
            return;
        }
        const currentVal = this.valueKey ? val[this.valueKey] : val;
        if (!this.value) {
            this.value = [currentVal];
            this.selected = [val];
        }
        else {
            this.value.push(currentVal);
            this.selected.push(val);
            this.onChangeCallback(this.value);
            this.onChange.emit(this.value);
        }
    }
    _open() {
        if (this.isServerSide || this.isDisabled || this.readOnly) {
            return;
        }
        if (!this.overlayRef.hasAttached()) {
            this.overlayRef.attach(this.templatePortal);
        }
    }
    _createNewTag() {
        if (this.maxSelectLimit > 0 &&
            this.value &&
            this.value.length === this.maxSelectLimit) {
            return;
        }
        if (this.options === undefined || this.options === null) {
            this.options = [];
        }
        let newObj;
        if (this.displayKey) {
            newObj = {};
            newObj[this.displayKey] = this.displayValue;
            if (this.valueKey) {
                newObj[this.valueKey] = this.displayValue;
            }
        }
        else {
            newObj = this.displayValue;
        }
        this.options.push(newObj);
        this._selectValue(newObj);
        this.onCreateNewTag.emit(newObj);
        this.displayValue = null;
    }
    _getValueFromTag(val) {
        return this.displayKey ? val[this.displayKey] : val;
    }
    _removeTag(tag) {
        const idx = this.selected.findIndex((element) => this.utility.isEqual(element, tag));
        if (idx > -1) {
            if (this.value.length === 1) {
                this.value = null;
                this.selected = null;
            }
            else {
                this.value.splice(idx, 1);
                this.selected.splice(idx, 1);
                this.onChangeCallback(this.value);
                this.onChange.emit(this.value);
            }
        }
    }
    _isSelected(tag) {
        return this.selected && (this.selected.findIndex((element) => this.utility.isEqual(element, tag))) > -1;
    }
    _onKeydown(event) {
        if (event.key === "Tab" || event.key === "Escape") {
            this._close();
        }
        if (event.key === "ArrowDown") {
            this._open();
            event.preventDefault();
        }
        if (event.key === "Backspace" &&
            this.value &&
            this.value.length > 0 &&
            (this.displayValue === undefined ||
                this.displayValue === null ||
                this.displayValue.length === 0)) {
            if (this.value.length > 1) {
                this.value.pop();
                this.selected.pop();
                this.onChangeCallback(this.value);
                this.onChange.emit(this.value);
            }
            else {
                this.value = null;
                this.selected = null;
            }
        }
        if (event.key === "Enter" &&
            !this.forceToSelect &&
            this.displayValue &&
            this.displayValue.length > 0) {
            this._createNewTag();
        }
    }
    _trackBy(index) {
        return index;
    }
    _getDisplayValue() {
        return this.displayValue || "";
    }
    _onBlur($event) {
        this.focused = false;
        this.onTouchedCallback();
        this.onBlur.emit($event);
    }
    _onFocus($event) {
        this.focused = true;
        this.onFocus.emit($event);
    }
}
NpTagsComponent.controlCount = 1;
NpTagsComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTagsComponent, deps: [{ token: i1.Overlay }, { token: i0.ViewContainerRef }, { token: i1.OverlayPositionBuilder }, { token: i0.ElementRef }, { token: NpUtilityService }], target: i0.ɵɵFactoryTarget.Component });
NpTagsComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpTagsComponent, selector: "np-tags", inputs: { displayKey: "displayKey", valueKey: "valueKey", searchResult: "searchResult", isServerSide: "isServerSide", forceToSelect: "forceToSelect", itemTemplate: "itemTemplate", searchDelay: "searchDelay", maxResultLimit: "maxResultLimit", minSearchCharLimit: "minSearchCharLimit", maxSelectLimit: "maxSelectLimit", orderBy: "orderBy", orderDir: "orderDir", placeholder: "placeholder", readOnly: "readOnly", autoFocus: "autoFocus", tabIndex: "tabIndex", styleClass: "styleClass", inputId: "inputId" }, outputs: { onChange: "onChange", onSearch: "onSearch", onCreateNewTag: "onCreateNewTag", onFocus: "onFocus", onBlur: "onBlur" }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => NpTagsComponent),
            multi: true,
        },
    ], viewQueries: [{ propertyName: "templatePortalContent", first: true, predicate: ["templatePortalContent"], descendants: true }, { propertyName: "inputViewChild", first: true, predicate: ["control"], descendants: true }], ngImport: i0, template: "<div [ngClass]=\"{\r\n    'np-tags': true,\r\n    'np-disabled': isDisabled,\r\n    'np-readonly': readOnly\r\n  }\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-input-group\" [ngClass]=\"{ 'np-focused': focused }\">\r\n    <div class=\"np-tag\" *ngFor=\"let tag of selected\">\r\n      <div [innerHTML]=\"_getValueFromTag(tag)\"></div>\r\n      <button class=\"np-tag-remove\" tabindex=\"-1\" (click)=\"_removeTag(tag)\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path\r\n            d=\"M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z\">\r\n          </path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n    <input class=\"np-form-control\" type=\"text\" #control autocomplete=\"off\" [placeholder]=\"placeholder\"\r\n      [value]=\"_getDisplayValue()\" [disabled]=\"isDisabled\" [npAutofocus]=\"autoFocus\" [attr.tabindex]=\"tabIndex\"\r\n      [readonly]=\"readOnly\" (click)=\"_open()\" (input)=\"_onInput($event)\" (keydown)=\"_onKeydown($event)\"\r\n      (blur)=\"_onBlur($event)\" (focus)=\"_onFocus($event)\" />\r\n    <div class=\"np-input-group-append\">\r\n      <div class=\"np-tag-loader\" *ngIf=\"isLoading\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path\r\n            d=\"M12 6v3l4-4-4-4v3c-4.42 0-8 3.58-8 8 0 1.57.46 3.03 1.24 4.26L6.7 14.8c-.45-.83-.7-1.79-.7-2.8 0-3.31 2.69-6 6-6zm6.76 1.74L17.3 9.2c.44.84.7 1.79.7 2.8 0 3.31-2.69 6-6 6v-3l-4 4 4 4v-3c4.42 0 8-3.58 8-8 0-1.57-.46-3.03-1.24-4.26z\">\r\n          </path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</div>\r\n<ng-template #templatePortalContent>\r\n  <ul class=\"np-tags-overlay np-list\" role=\"listbox\" [attr.id]=\"inputId + '_listbox'\">\r\n    <ng-container *ngFor=\"\r\n        let item of options | npOrderBy: orderBy:orderDir;\r\n        let i = index;\r\n        trackBy: _trackBy\r\n      \">\r\n      <li class=\"np-list-item\" role=\"option\" (click)=\"_selectValue(item)\"\r\n        [ngClass]=\"{ 'np-tag-selected': _isSelected(item) }\">\r\n        <ng-container *ngIf=\"!itemTemplate; else customTemplate\">\r\n          <span [innerHTML]=\"\r\n              (displayKey ? item[displayKey] : item) | npHighlight: displayValue\r\n            \">\r\n          </span>\r\n        </ng-container>\r\n        <ng-template #customTemplate [ngTemplateOutlet]=\"itemTemplate\"\r\n          [ngTemplateOutletContext]=\"{ item: item, keyword: displayValue }\">\r\n        </ng-template>\r\n      </li>\r\n    </ng-container>\r\n    <li class=\"np-list-item np-disabled\" role=\"option\" *ngIf=\"options && options.length === 0\">\r\n      <b>{{ \"No_Result_Found\" | npTranslate }}</b>\r\n    </li>\r\n  </ul>\r\n</ng-template>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: NpAutofocusDirective, selector: "[npAutofocus]", inputs: ["npAutofocus"] }, { kind: "pipe", type: NpTranslatePipe, name: "npTranslate" }, { kind: "pipe", type: NpOrderByPipe, name: "npOrderBy" }, { kind: "pipe", type: NpHighlightPipe, name: "npHighlight" }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTagsComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-tags", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => NpTagsComponent),
                            multi: true,
                        },
                    ], template: "<div [ngClass]=\"{\r\n    'np-tags': true,\r\n    'np-disabled': isDisabled,\r\n    'np-readonly': readOnly\r\n  }\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-input-group\" [ngClass]=\"{ 'np-focused': focused }\">\r\n    <div class=\"np-tag\" *ngFor=\"let tag of selected\">\r\n      <div [innerHTML]=\"_getValueFromTag(tag)\"></div>\r\n      <button class=\"np-tag-remove\" tabindex=\"-1\" (click)=\"_removeTag(tag)\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path\r\n            d=\"M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z\">\r\n          </path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n    <input class=\"np-form-control\" type=\"text\" #control autocomplete=\"off\" [placeholder]=\"placeholder\"\r\n      [value]=\"_getDisplayValue()\" [disabled]=\"isDisabled\" [npAutofocus]=\"autoFocus\" [attr.tabindex]=\"tabIndex\"\r\n      [readonly]=\"readOnly\" (click)=\"_open()\" (input)=\"_onInput($event)\" (keydown)=\"_onKeydown($event)\"\r\n      (blur)=\"_onBlur($event)\" (focus)=\"_onFocus($event)\" />\r\n    <div class=\"np-input-group-append\">\r\n      <div class=\"np-tag-loader\" *ngIf=\"isLoading\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path\r\n            d=\"M12 6v3l4-4-4-4v3c-4.42 0-8 3.58-8 8 0 1.57.46 3.03 1.24 4.26L6.7 14.8c-.45-.83-.7-1.79-.7-2.8 0-3.31 2.69-6 6-6zm6.76 1.74L17.3 9.2c.44.84.7 1.79.7 2.8 0 3.31-2.69 6-6 6v-3l-4 4 4 4v-3c4.42 0 8-3.58 8-8 0-1.57-.46-3.03-1.24-4.26z\">\r\n          </path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</div>\r\n<ng-template #templatePortalContent>\r\n  <ul class=\"np-tags-overlay np-list\" role=\"listbox\" [attr.id]=\"inputId + '_listbox'\">\r\n    <ng-container *ngFor=\"\r\n        let item of options | npOrderBy: orderBy:orderDir;\r\n        let i = index;\r\n        trackBy: _trackBy\r\n      \">\r\n      <li class=\"np-list-item\" role=\"option\" (click)=\"_selectValue(item)\"\r\n        [ngClass]=\"{ 'np-tag-selected': _isSelected(item) }\">\r\n        <ng-container *ngIf=\"!itemTemplate; else customTemplate\">\r\n          <span [innerHTML]=\"\r\n              (displayKey ? item[displayKey] : item) | npHighlight: displayValue\r\n            \">\r\n          </span>\r\n        </ng-container>\r\n        <ng-template #customTemplate [ngTemplateOutlet]=\"itemTemplate\"\r\n          [ngTemplateOutletContext]=\"{ item: item, keyword: displayValue }\">\r\n        </ng-template>\r\n      </li>\r\n    </ng-container>\r\n    <li class=\"np-list-item np-disabled\" role=\"option\" *ngIf=\"options && options.length === 0\">\r\n      <b>{{ \"No_Result_Found\" | npTranslate }}</b>\r\n    </li>\r\n  </ul>\r\n</ng-template>" }]
        }], ctorParameters: function () { return [{ type: i1.Overlay }, { type: i0.ViewContainerRef }, { type: i1.OverlayPositionBuilder }, { type: i0.ElementRef }, { type: NpUtilityService }]; }, propDecorators: { displayKey: [{
                type: Input
            }], valueKey: [{
                type: Input
            }], searchResult: [{
                type: Input
            }], isServerSide: [{
                type: Input
            }], forceToSelect: [{
                type: Input
            }], itemTemplate: [{
                type: Input
            }], searchDelay: [{
                type: Input
            }], maxResultLimit: [{
                type: Input
            }], minSearchCharLimit: [{
                type: Input
            }], maxSelectLimit: [{
                type: Input
            }], orderBy: [{
                type: Input
            }], orderDir: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], readOnly: [{
                type: Input
            }], autoFocus: [{
                type: Input
            }], tabIndex: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], inputId: [{
                type: Input
            }], onChange: [{
                type: Output
            }], onSearch: [{
                type: Output
            }], onCreateNewTag: [{
                type: Output
            }], onFocus: [{
                type: Output
            }], onBlur: [{
                type: Output
            }], templatePortalContent: [{
                type: ViewChild,
                args: ["templatePortalContent"]
            }], inputViewChild: [{
                type: ViewChild,
                args: ["control"]
            }] } });

class NpTagsModule {
}
NpTagsModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTagsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpTagsModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpTagsModule, declarations: [NpTagsComponent], imports: [CommonModule,
        OverlayModule,
        PortalModule,
        NpAutofocusModule,
        NpTranslationsModule,
        NpOrderByModule,
        NpHighlightModule], exports: [NpTagsComponent] });
NpTagsModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTagsModule, imports: [CommonModule,
        OverlayModule,
        PortalModule,
        NpAutofocusModule,
        NpTranslationsModule,
        NpOrderByModule,
        NpHighlightModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTagsModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpTagsComponent],
                    imports: [
                        CommonModule,
                        OverlayModule,
                        PortalModule,
                        NpAutofocusModule,
                        NpTranslationsModule,
                        NpOrderByModule,
                        NpHighlightModule,
                    ],
                    exports: [NpTagsComponent],
                }]
        }] });

class NpPopoverComponent {
    constructor() {
        this.inputId = `np-popover_${NpPopoverComponent.controlCount++}`;
    }
    ngOnInit() {
        if (this.header instanceof TemplateRef) {
            this.isHeaderTemplate = true;
        }
        if (this.body instanceof TemplateRef) {
            this.isBodyTemplate = true;
        }
    }
}
NpPopoverComponent.controlCount = 1;
NpPopoverComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpPopoverComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NpPopoverComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpPopoverComponent, selector: "np-popover", inputs: { header: "header", body: "body", width: "width", styleClass: "styleClass", context: "context", inputId: "inputId" }, ngImport: i0, template: "<div [ngClass]=\"'np-popover'\" [style.width.px]=\"width\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-popover-header\" *ngIf=\"header\">\r\n    <ng-container *ngIf=\"!isHeaderTemplate\">\r\n      <div [innerHTML]=\"header\"></div>\r\n    </ng-container>\r\n    <ng-template *ngIf=\"isHeaderTemplate\" [ngTemplateOutlet]=\"header\" [ngTemplateOutletContext]=\"context\">\r\n    </ng-template>\r\n  </div>\r\n  <div class=\"np-popover-body\">\r\n    <ng-container *ngIf=\"!isBodyTemplate\">\r\n      <div [innerHTML]=\"body\"></div>\r\n    </ng-container>\r\n    <ng-template *ngIf=\"isBodyTemplate\" [ngTemplateOutlet]=\"body\" [ngTemplateOutletContext]=\"context\">\r\n    </ng-template>\r\n  </div>\r\n</div>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpPopoverComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-popover", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, template: "<div [ngClass]=\"'np-popover'\" [style.width.px]=\"width\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-popover-header\" *ngIf=\"header\">\r\n    <ng-container *ngIf=\"!isHeaderTemplate\">\r\n      <div [innerHTML]=\"header\"></div>\r\n    </ng-container>\r\n    <ng-template *ngIf=\"isHeaderTemplate\" [ngTemplateOutlet]=\"header\" [ngTemplateOutletContext]=\"context\">\r\n    </ng-template>\r\n  </div>\r\n  <div class=\"np-popover-body\">\r\n    <ng-container *ngIf=\"!isBodyTemplate\">\r\n      <div [innerHTML]=\"body\"></div>\r\n    </ng-container>\r\n    <ng-template *ngIf=\"isBodyTemplate\" [ngTemplateOutlet]=\"body\" [ngTemplateOutletContext]=\"context\">\r\n    </ng-template>\r\n  </div>\r\n</div>" }]
        }], propDecorators: { header: [{
                type: Input
            }], body: [{
                type: Input
            }], width: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], context: [{
                type: Input
            }], inputId: [{
                type: Input
            }] } });

class NpPopoverDirective {
    constructor(overlay, overlayPositionBuilder, elementRef, utility) {
        this.overlay = overlay;
        this.overlayPositionBuilder = overlayPositionBuilder;
        this.elementRef = elementRef;
        this.utility = utility;
        this.closeOnClickOutside = true;
        this.backDropClass = "np-popover-backdrop";
        this.hasBackDrop = true;
        this.onOpen = new EventEmitter();
        this.onClose = new EventEmitter();
    }
    ngAfterViewInit() {
        this.elementRef.nativeElement.className = `${this.elementRef.nativeElement.className} np-popover-target`.trim();
        const position = this.utility.getPosition(this.placement);
        const positionStrategy = this.overlayPositionBuilder
            .flexibleConnectedTo(this.elementRef)
            .withPositions(position);
        if (this.openOnClick) {
            this.overlayRef = this.overlay.create({
                positionStrategy,
                hasBackdrop: this.hasBackDrop,
                backdropClass: this.backDropClass,
            });
            this.overlayRef.backdropClick().subscribe(() => {
                if (this.closeOnClickOutside) {
                    this._close();
                }
            });
        }
        else {
            this.overlayRef = this.overlay.create({
                positionStrategy,
            });
        }
    }
    ngOnDestroy() {
        if (this.overlayRef.hasAttached()) {
            this.overlayRef.detach();
        }
    }
    open() {
        this._open();
    }
    close() {
        this._close();
    }
    _showOnMouseEnter() {
        if (this.openOnClick) {
            return;
        }
        this._open();
    }
    _openOnClick() {
        if (!this.openOnClick) {
            return;
        }
        if (this.overlayRef.hasAttached()) {
            this.overlayRef.detach();
            this.onClose.emit();
        }
        else {
            this._open();
        }
    }
    _open() {
        const popoverPortal = new ComponentPortal(NpPopoverComponent);
        const popoverRef = this.overlayRef.attach(popoverPortal);
        popoverRef.instance.header = this.header;
        popoverRef.instance.body = this.body;
        popoverRef.instance.context = this.context;
        popoverRef.instance.width = this.width;
        popoverRef.instance.styleClass = this.styleClass;
        this.onOpen.emit();
    }
    _hideOnMouseLeave() {
        if (this.openOnClick) {
            return;
        }
        this._close();
    }
    _close() {
        if (this.overlayRef.hasAttached()) {
            this.overlayRef.detach();
            this.onClose.emit();
        }
    }
}
NpPopoverDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpPopoverDirective, deps: [{ token: i1.Overlay }, { token: i1.OverlayPositionBuilder }, { token: i0.ElementRef }, { token: NpUtilityService }], target: i0.ɵɵFactoryTarget.Directive });
NpPopoverDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.0.1", type: NpPopoverDirective, selector: "[npPopover]", inputs: { placement: "placement", header: "header", body: "body", context: "context", openOnClick: "openOnClick", width: "width", closeOnClickOutside: "closeOnClickOutside", backDropClass: "backDropClass", hasBackDrop: "hasBackDrop", styleClass: "styleClass" }, outputs: { onOpen: "onOpen", onClose: "onClose" }, host: { listeners: { "mouseover": "_showOnMouseEnter()", "click": "_openOnClick()", "mouseout": "_hideOnMouseLeave()" } }, exportAs: ["NpPopoverDirective"], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpPopoverDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: "[npPopover]",
                    exportAs: "NpPopoverDirective",
                }]
        }], ctorParameters: function () { return [{ type: i1.Overlay }, { type: i1.OverlayPositionBuilder }, { type: i0.ElementRef }, { type: NpUtilityService }]; }, propDecorators: { placement: [{
                type: Input
            }], header: [{
                type: Input
            }], body: [{
                type: Input
            }], context: [{
                type: Input
            }], openOnClick: [{
                type: Input
            }], width: [{
                type: Input
            }], closeOnClickOutside: [{
                type: Input
            }], backDropClass: [{
                type: Input
            }], hasBackDrop: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], onOpen: [{
                type: Output
            }], onClose: [{
                type: Output
            }], _showOnMouseEnter: [{
                type: HostListener,
                args: ["mouseover"]
            }], _openOnClick: [{
                type: HostListener,
                args: ["click"]
            }], _hideOnMouseLeave: [{
                type: HostListener,
                args: ["mouseout"]
            }] } });

class NpPopoverModule {
}
NpPopoverModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpPopoverModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpPopoverModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpPopoverModule, declarations: [NpPopoverComponent, NpPopoverDirective], imports: [CommonModule, OverlayModule], exports: [NpPopoverDirective] });
NpPopoverModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpPopoverModule, imports: [CommonModule, OverlayModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpPopoverModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpPopoverComponent, NpPopoverDirective],
                    imports: [CommonModule, OverlayModule],
                    exports: [NpPopoverDirective]
                }]
        }] });

class NpDropdownComponent {
    constructor(overlay, viewContainerRef, overlayPositionBuilder, elementRef, utility) {
        this.overlay = overlay;
        this.viewContainerRef = viewContainerRef;
        this.overlayPositionBuilder = overlayPositionBuilder;
        this.elementRef = elementRef;
        this.utility = utility;
        this.placeholder = "";
        this.inputId = `np-dropdown_${NpDropdownComponent.controlCount++}`;
        this.onChange = new EventEmitter();
        this.onFocus = new EventEmitter();
        this.onBlur = new EventEmitter();
        this.isDisabled = false;
        this.focused = false;
        this.isOpen = false;
        this.onChangeCallback = () => { };
        this.onTouchedCallback = () => { };
    }
    ngOnChanges(changes) {
        if (changes["items"]) {
            this._setSelectedOption();
        }
    }
    ngAfterViewInit() {
        const positionStrategy = this.overlayPositionBuilder
            .flexibleConnectedTo(this.elementRef)
            .withPositions(TopBottomOverlayPositions);
        this.overlayRef = this.overlay.create({
            positionStrategy,
            hasBackdrop: true,
            backdropClass: "np-dropdown-backdrop",
            scrollStrategy: this.overlay.scrollStrategies.reposition(),
            panelClass: this.styleClass,
        });
        this.templatePortal = new TemplatePortal(this.templatePortalContent, this.viewContainerRef);
        this.overlayRef.backdropClick().subscribe(() => this._close());
    }
    get value() {
        return this.innerValue ? this.innerValue : null;
    }
    set value(v) {
        if (v !== this.innerValue) {
            this.innerValue = v;
            this.onChangeCallback(v);
            this.onChange.emit(v);
        }
    }
    writeValue(v) {
        if (v !== this.innerValue) {
            this.innerValue = v;
            this._setSelectedOption();
        }
    }
    registerOnChange(fn) {
        this.onChangeCallback = fn;
    }
    registerOnTouched(fn) {
        this.onTouchedCallback = fn;
    }
    setDisabledState(isDisabled) {
        this.isDisabled = isDisabled;
    }
    focus() {
        this.inputViewChild.nativeElement.focus();
    }
    _setSelectedOption() {
        let selected;
        if (this.valueKey) {
            for (const item of this.items) {
                if (item[this.valueKey] === this.value) {
                    selected = item;
                    break;
                }
            }
        }
        else {
            for (const item of this.items) {
                if (item === this.value) {
                    selected = item;
                    break;
                }
            }
        }
        this.selected = selected;
    }
    _close() {
        this.overlayRef.detach();
        this.inputViewChild.nativeElement.focus();
        this.isOpen = false;
    }
    _clear() {
        if (this.isDisabled || this.readOnly) {
            return;
        }
        this.value = null;
        this.selected = null;
    }
    _selectValue(val) {
        if (this.isDisabled || this.readOnly) {
            return;
        }
        this.value = this.valueKey ? val[this.valueKey] : val;
        this.selected = val;
        this._close();
    }
    _open() {
        if (this.isDisabled || this.readOnly) {
            return;
        }
        if (!this.overlayRef.hasAttached()) {
            this.overlayRef.attach(this.templatePortal);
            this.isOpen = false;
        }
    }
    _isSelected(item) {
        if (this.displayKey || this.valueKey) {
            return this.utility.isEqual(this.selected, item);
        }
        return this.selected === item;
    }
    _onKeydown(event) {
        if (event.key === "Tab" || event.key === "Escape") {
            this._close();
        }
        if (event.key === "ArrowDown") {
            this._open();
            event.preventDefault();
        }
    }
    _trackBy(index) {
        return index;
    }
    _getDisplayValue() {
        return ((this.displayKey && this.selected
            ? this.selected[this.displayKey]
            : this.selected) || "");
    }
    _onBlur($event) {
        this.focused = false;
        this.onTouchedCallback();
        this.onBlur.emit($event);
    }
    _onFocus($event) {
        this.focused = true;
        this.onFocus.emit($event);
    }
}
NpDropdownComponent.controlCount = 1;
NpDropdownComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpDropdownComponent, deps: [{ token: i1.Overlay }, { token: i0.ViewContainerRef }, { token: i1.OverlayPositionBuilder }, { token: i0.ElementRef }, { token: NpUtilityService }], target: i0.ɵɵFactoryTarget.Component });
NpDropdownComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpDropdownComponent, selector: "np-dropdown", inputs: { items: "items", displayKey: "displayKey", valueKey: "valueKey", itemTemplate: "itemTemplate", orderBy: "orderBy", orderDir: "orderDir", placeholder: "placeholder", readOnly: "readOnly", autoFocus: "autoFocus", tabIndex: "tabIndex", styleClass: "styleClass", inputId: "inputId" }, outputs: { onChange: "onChange", onFocus: "onFocus", onBlur: "onBlur" }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => NpDropdownComponent),
            multi: true,
        },
    ], viewQueries: [{ propertyName: "templatePortalContent", first: true, predicate: ["templatePortalContent"], descendants: true }, { propertyName: "inputViewChild", first: true, predicate: ["control"], descendants: true }], usesOnChanges: true, ngImport: i0, template: "<div [ngClass]=\"{\r\n    'np-dropdown': true,\r\n    'np-disabled': isDisabled,\r\n    'np-readonly': readOnly\r\n  }\" [class]=\"styleClass\" [attr.id]=\"inputId\" role=\"combobox\" aria-haspopup=\"listbox\" [attr.aria-expanded]=\"isOpen\"\r\n  [attr.aria-owns]=\"inputId + '_listbox'\">\r\n  <div class=\"np-input-group\" [ngClass]=\"{ 'np-focused': focused }\">\r\n    <input class=\"np-form-control\" type=\"text\" #control autocomplete=\"off\" readonly [disabled]=\"isDisabled\"\r\n      [npAutofocus]=\"autoFocus\" [attr.tabindex]=\"tabIndex\" [value]=\"_getDisplayValue()\" [placeholder]=\"placeholder\"\r\n      [attr.id]=\"inputId + '_input'\" (click)=\"_open()\" (keydown)=\"_onKeydown($event)\" (blur)=\"_onBlur($event)\"\r\n      (focus)=\"_onFocus($event)\" />\r\n    <div class=\"np-input-group-append\" *ngIf=\"innerValue\">\r\n      <button class=\"np-btn-icon np-btn-clear\" type=\"button\" tabindex=\"-1\" (click)=\"_clear()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path\r\n            d=\"M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z\">\r\n          </path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n  </div>\r\n  <ng-template #templatePortalContent>\r\n    <ul class=\"np-dropdown-overlay np-list\" role=\"listbox\" [attr.id]=\"inputId + '_listbox'\">\r\n      <li class=\"np-list-item\" role=\"option\" *ngFor=\"\r\n          let item of items | npOrderBy: orderBy:orderDir;\r\n          let i = index;\r\n          trackBy: _trackBy\r\n        \" [ngClass]=\"{ 'np-dropdown-selected': _isSelected(item) }\" (click)=\"_selectValue(item)\">\r\n        <ng-container *ngIf=\"!itemTemplate; else customTemplate\">\r\n          <span [innerHTML]=\"displayKey ? item[displayKey] : item\"></span>\r\n        </ng-container>\r\n        <ng-template #customTemplate [ngTemplateOutlet]=\"itemTemplate\" [ngTemplateOutletContext]=\"{ item: item }\">\r\n        </ng-template>\r\n      </li>\r\n    </ul>\r\n  </ng-template>\r\n</div>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: NpAutofocusDirective, selector: "[npAutofocus]", inputs: ["npAutofocus"] }, { kind: "pipe", type: NpOrderByPipe, name: "npOrderBy" }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpDropdownComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-dropdown", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => NpDropdownComponent),
                            multi: true,
                        },
                    ], template: "<div [ngClass]=\"{\r\n    'np-dropdown': true,\r\n    'np-disabled': isDisabled,\r\n    'np-readonly': readOnly\r\n  }\" [class]=\"styleClass\" [attr.id]=\"inputId\" role=\"combobox\" aria-haspopup=\"listbox\" [attr.aria-expanded]=\"isOpen\"\r\n  [attr.aria-owns]=\"inputId + '_listbox'\">\r\n  <div class=\"np-input-group\" [ngClass]=\"{ 'np-focused': focused }\">\r\n    <input class=\"np-form-control\" type=\"text\" #control autocomplete=\"off\" readonly [disabled]=\"isDisabled\"\r\n      [npAutofocus]=\"autoFocus\" [attr.tabindex]=\"tabIndex\" [value]=\"_getDisplayValue()\" [placeholder]=\"placeholder\"\r\n      [attr.id]=\"inputId + '_input'\" (click)=\"_open()\" (keydown)=\"_onKeydown($event)\" (blur)=\"_onBlur($event)\"\r\n      (focus)=\"_onFocus($event)\" />\r\n    <div class=\"np-input-group-append\" *ngIf=\"innerValue\">\r\n      <button class=\"np-btn-icon np-btn-clear\" type=\"button\" tabindex=\"-1\" (click)=\"_clear()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path\r\n            d=\"M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z\">\r\n          </path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n  </div>\r\n  <ng-template #templatePortalContent>\r\n    <ul class=\"np-dropdown-overlay np-list\" role=\"listbox\" [attr.id]=\"inputId + '_listbox'\">\r\n      <li class=\"np-list-item\" role=\"option\" *ngFor=\"\r\n          let item of items | npOrderBy: orderBy:orderDir;\r\n          let i = index;\r\n          trackBy: _trackBy\r\n        \" [ngClass]=\"{ 'np-dropdown-selected': _isSelected(item) }\" (click)=\"_selectValue(item)\">\r\n        <ng-container *ngIf=\"!itemTemplate; else customTemplate\">\r\n          <span [innerHTML]=\"displayKey ? item[displayKey] : item\"></span>\r\n        </ng-container>\r\n        <ng-template #customTemplate [ngTemplateOutlet]=\"itemTemplate\" [ngTemplateOutletContext]=\"{ item: item }\">\r\n        </ng-template>\r\n      </li>\r\n    </ul>\r\n  </ng-template>\r\n</div>" }]
        }], ctorParameters: function () { return [{ type: i1.Overlay }, { type: i0.ViewContainerRef }, { type: i1.OverlayPositionBuilder }, { type: i0.ElementRef }, { type: NpUtilityService }]; }, propDecorators: { items: [{
                type: Input
            }], displayKey: [{
                type: Input
            }], valueKey: [{
                type: Input
            }], itemTemplate: [{
                type: Input
            }], orderBy: [{
                type: Input
            }], orderDir: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], readOnly: [{
                type: Input
            }], autoFocus: [{
                type: Input
            }], tabIndex: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], inputId: [{
                type: Input
            }], onChange: [{
                type: Output
            }], onFocus: [{
                type: Output
            }], onBlur: [{
                type: Output
            }], templatePortalContent: [{
                type: ViewChild,
                args: ["templatePortalContent"]
            }], inputViewChild: [{
                type: ViewChild,
                args: ["control"]
            }] } });

class NpDropdownModule {
}
NpDropdownModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpDropdownModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpDropdownModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpDropdownModule, declarations: [NpDropdownComponent], imports: [CommonModule,
        OverlayModule,
        PortalModule,
        NpAutofocusModule,
        NpOrderByModule], exports: [NpDropdownComponent] });
NpDropdownModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpDropdownModule, imports: [CommonModule,
        OverlayModule,
        PortalModule,
        NpAutofocusModule,
        NpOrderByModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpDropdownModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpDropdownComponent],
                    imports: [
                        CommonModule,
                        OverlayModule,
                        PortalModule,
                        NpAutofocusModule,
                        NpOrderByModule,
                    ],
                    exports: [NpDropdownComponent],
                }]
        }] });

class NpMenuItemComponent {
    constructor(router) {
        this.router = router;
        this.orientation = "vertical";
        this.onClickItem = new EventEmitter();
    }
    _onMouseEnter($event, item) {
        if (this.orientation === "vertical") {
            item.x = $event.target.offsetWidth;
            item.y = 0;
        }
        else {
            item.x = 0;
            item.y = $event.target.offsetHeight;
        }
        item.isChildVisible = true;
    }
    _onMouseLeave(item) {
        item.isChildVisible = false;
    }
    _onClickMenuItem(item) {
        this.onClickItem.emit(item);
    }
    _isActive(item) {
        return this.router.isActive(item.routerLink, { matrixParams: 'ignored', queryParams: 'ignored', paths: 'subset', fragment: 'ignored' });
    }
}
NpMenuItemComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpMenuItemComponent, deps: [{ token: i1$2.Router }], target: i0.ɵɵFactoryTarget.Component });
NpMenuItemComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpMenuItemComponent, selector: "np-menu-item", inputs: { item: "item", orientation: "orientation" }, outputs: { onClickItem: "onClickItem" }, ngImport: i0, template: "<ng-container *ngIf=\"item.visible\">\r\n  <ng-container *ngIf=\"item.isHeader\">\r\n    <li class=\"np-menu-header\" role=\"none\">\r\n      <a [attr.id]=\"item.id\">\r\n        <i *ngIf=\"item.iconCss\" [class]=\"item.iconCss\"></i>\r\n        <span class=\"np-menu-text\" [innerHTML]=\"item.label\"></span>\r\n      </a>\r\n    </li>\r\n  </ng-container>\r\n  <ng-container *ngIf=\"item.items && !item.isHeader\">\r\n    <li class=\"np-menu-item\" role=\"none\" (mouseenter)=\"_onMouseEnter($event, item)\" (mouseleave)=\"_onMouseLeave(item)\">\r\n      <a class=\"np-menu-link\" role=\"menuitem\" aria-haspopup=\"true\" [attr.aria-expanded]=\"item.isChildVisible\"\r\n        tabindex=\"0\" [ngClass]=\"{ 'np-menu-active': item.routerLink && _isActive(item) }\" [attr.id]=\"item.id\">\r\n        <i *ngIf=\"item.iconCss\" [class]=\"item.iconCss\"></i>\r\n        <span class=\"np-menu-text\" [innerHTML]=\"item.label\"></span>\r\n        <span class=\"np-menu-icon\">\r\n          <svg class=\"np-icon\" *ngIf=\"orientation === 'vertical'\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M10 6L8.59 7.41 13.17 12l-4.58 4.59L10 18l6-6z\"></path>\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n          </svg>\r\n          <svg class=\"np-icon\" *ngIf=\"orientation === 'horizontal'\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M16.59 8.59L12 13.17 7.41 8.59 6 10l6 6 6-6z\"></path>\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n          </svg>\r\n        </span>\r\n      </a>\r\n      <ng-container *ngIf=\"item.isChildVisible\">\r\n        <ul class=\"np-submenu\" role=\"menu\" [style.top.px]=\"item.y\" [style.left.px]=\"item.x\">\r\n          <ng-container *ngFor=\"let child of item.items\">\r\n            <np-menu-item [item]=\"child\" [orientation]=\"'vertical'\" (onClickItem)=\"_onClickMenuItem($event)\">\r\n            </np-menu-item>\r\n          </ng-container>\r\n        </ul>\r\n      </ng-container>\r\n    </li>\r\n  </ng-container>\r\n  <ng-container *ngIf=\"!item.items && !item.isHeader\">\r\n    <li class=\"np-menu-item\" role=\"none\">\r\n      <a class=\"np-menu-link\" role=\"menuitem\" tabindex=\"0\" *ngIf=\"item.routerLink\" [attr.id]=\"item.id\"\r\n        [routerLink]=\"item.routerLink\" [queryParams]=\"item.queryParams\" [fragment]=\"item.fragment\"\r\n        [queryParamsHandling]=\"item.queryParamsHandling\" [routerLinkActive]=\"'np-menu-active'\"\r\n        (click)=\"_onClickMenuItem(item)\">\r\n        <i *ngIf=\"item.iconCss\" [class]=\"item.iconCss\"></i>\r\n        <span class=\"np-menu-text\" [innerHTML]=\"item.label\"></span>\r\n      </a>\r\n      <a class=\"np-menu-link\" role=\"menuitem\" tabindex=\"0\" *ngIf=\"item.url\" [attr.id]=\"item.id\" [href]=\"item.url\"\r\n        [target]=\"item.target\" (click)=\"_onClickMenuItem(item)\">\r\n        <i *ngIf=\"item.iconCss\" [class]=\"item.iconCss\"></i>\r\n        <span class=\"np-menu-text\" [innerHTML]=\"item.label\"></span>\r\n        <svg class=\"np-icon ml-1\" *ngIf=\"item.target === '_blank'\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\" />\r\n          <path d=\"M9 5v2h6.59L4 18.59 5.41 20 17 8.41V15h2V5z\" />\r\n        </svg>\r\n      </a>\r\n      <a class=\"np-menu-link\" role=\"menuitem\" tabindex=\"0\" *ngIf=\"!item.routerLink && !item.url\" [attr.id]=\"item.id\"\r\n        (click)=\"_onClickMenuItem(item)\">\r\n        <i *ngIf=\"item.iconCss\" [class]=\"item.iconCss\"></i>\r\n        <span class=\"np-menu-text\" [innerHTML]=\"item.label\"></span>\r\n      </a>\r\n    </li>\r\n  </ng-container>\r\n</ng-container>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$2.RouterLink, selector: "[routerLink]", inputs: ["target", "queryParams", "fragment", "queryParamsHandling", "state", "relativeTo", "preserveFragment", "skipLocationChange", "replaceUrl", "routerLink"] }, { kind: "directive", type: i1$2.RouterLinkActive, selector: "[routerLinkActive]", inputs: ["routerLinkActiveOptions", "ariaCurrentWhenActive", "routerLinkActive"], outputs: ["isActiveChange"], exportAs: ["routerLinkActive"] }, { kind: "component", type: NpMenuItemComponent, selector: "np-menu-item", inputs: ["item", "orientation"], outputs: ["onClickItem"] }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpMenuItemComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-menu-item", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, template: "<ng-container *ngIf=\"item.visible\">\r\n  <ng-container *ngIf=\"item.isHeader\">\r\n    <li class=\"np-menu-header\" role=\"none\">\r\n      <a [attr.id]=\"item.id\">\r\n        <i *ngIf=\"item.iconCss\" [class]=\"item.iconCss\"></i>\r\n        <span class=\"np-menu-text\" [innerHTML]=\"item.label\"></span>\r\n      </a>\r\n    </li>\r\n  </ng-container>\r\n  <ng-container *ngIf=\"item.items && !item.isHeader\">\r\n    <li class=\"np-menu-item\" role=\"none\" (mouseenter)=\"_onMouseEnter($event, item)\" (mouseleave)=\"_onMouseLeave(item)\">\r\n      <a class=\"np-menu-link\" role=\"menuitem\" aria-haspopup=\"true\" [attr.aria-expanded]=\"item.isChildVisible\"\r\n        tabindex=\"0\" [ngClass]=\"{ 'np-menu-active': item.routerLink && _isActive(item) }\" [attr.id]=\"item.id\">\r\n        <i *ngIf=\"item.iconCss\" [class]=\"item.iconCss\"></i>\r\n        <span class=\"np-menu-text\" [innerHTML]=\"item.label\"></span>\r\n        <span class=\"np-menu-icon\">\r\n          <svg class=\"np-icon\" *ngIf=\"orientation === 'vertical'\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M10 6L8.59 7.41 13.17 12l-4.58 4.59L10 18l6-6z\"></path>\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n          </svg>\r\n          <svg class=\"np-icon\" *ngIf=\"orientation === 'horizontal'\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M16.59 8.59L12 13.17 7.41 8.59 6 10l6 6 6-6z\"></path>\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n          </svg>\r\n        </span>\r\n      </a>\r\n      <ng-container *ngIf=\"item.isChildVisible\">\r\n        <ul class=\"np-submenu\" role=\"menu\" [style.top.px]=\"item.y\" [style.left.px]=\"item.x\">\r\n          <ng-container *ngFor=\"let child of item.items\">\r\n            <np-menu-item [item]=\"child\" [orientation]=\"'vertical'\" (onClickItem)=\"_onClickMenuItem($event)\">\r\n            </np-menu-item>\r\n          </ng-container>\r\n        </ul>\r\n      </ng-container>\r\n    </li>\r\n  </ng-container>\r\n  <ng-container *ngIf=\"!item.items && !item.isHeader\">\r\n    <li class=\"np-menu-item\" role=\"none\">\r\n      <a class=\"np-menu-link\" role=\"menuitem\" tabindex=\"0\" *ngIf=\"item.routerLink\" [attr.id]=\"item.id\"\r\n        [routerLink]=\"item.routerLink\" [queryParams]=\"item.queryParams\" [fragment]=\"item.fragment\"\r\n        [queryParamsHandling]=\"item.queryParamsHandling\" [routerLinkActive]=\"'np-menu-active'\"\r\n        (click)=\"_onClickMenuItem(item)\">\r\n        <i *ngIf=\"item.iconCss\" [class]=\"item.iconCss\"></i>\r\n        <span class=\"np-menu-text\" [innerHTML]=\"item.label\"></span>\r\n      </a>\r\n      <a class=\"np-menu-link\" role=\"menuitem\" tabindex=\"0\" *ngIf=\"item.url\" [attr.id]=\"item.id\" [href]=\"item.url\"\r\n        [target]=\"item.target\" (click)=\"_onClickMenuItem(item)\">\r\n        <i *ngIf=\"item.iconCss\" [class]=\"item.iconCss\"></i>\r\n        <span class=\"np-menu-text\" [innerHTML]=\"item.label\"></span>\r\n        <svg class=\"np-icon ml-1\" *ngIf=\"item.target === '_blank'\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\" />\r\n          <path d=\"M9 5v2h6.59L4 18.59 5.41 20 17 8.41V15h2V5z\" />\r\n        </svg>\r\n      </a>\r\n      <a class=\"np-menu-link\" role=\"menuitem\" tabindex=\"0\" *ngIf=\"!item.routerLink && !item.url\" [attr.id]=\"item.id\"\r\n        (click)=\"_onClickMenuItem(item)\">\r\n        <i *ngIf=\"item.iconCss\" [class]=\"item.iconCss\"></i>\r\n        <span class=\"np-menu-text\" [innerHTML]=\"item.label\"></span>\r\n      </a>\r\n    </li>\r\n  </ng-container>\r\n</ng-container>" }]
        }], ctorParameters: function () { return [{ type: i1$2.Router }]; }, propDecorators: { item: [{
                type: Input
            }], orientation: [{
                type: Input
            }], onClickItem: [{
                type: Output
            }] } });

class NpPanelMenuItemComponent {
    constructor(router) {
        this.router = router;
        this.onClickItem = new EventEmitter();
    }
    _onClickMenuItem(menuItem) {
        this.onClickItem.emit(menuItem);
    }
    _isActive(menuItem) {
        if (!menuItem.routerLink) {
            return false;
        }
        return this.router.isActive(menuItem.routerLink, { matrixParams: 'ignored', queryParams: 'ignored', paths: 'subset', fragment: 'ignored' });
    }
    _onClickPanelMenu(menuItem) {
        menuItem.isChildVisible = !menuItem.isChildVisible;
    }
}
NpPanelMenuItemComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpPanelMenuItemComponent, deps: [{ token: i1$2.Router }], target: i0.ɵɵFactoryTarget.Component });
NpPanelMenuItemComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpPanelMenuItemComponent, selector: "np-panel-menu-item", inputs: { item: "item" }, outputs: { onClickItem: "onClickItem" }, ngImport: i0, template: "<ng-container *ngIf=\"item.visible\">\r\n  <ng-container *ngIf=\"item.isHeader\">\r\n    <li class=\"np-menu-header\" role=\"none\">\r\n      <a [attr.id]=\"item.id\">\r\n        <i *ngIf=\"item.iconCss\" [class]=\"item.iconCss\"></i>\r\n        <span class=\"np-menu-text\" [innerHTML]=\"item.label\"></span>\r\n      </a>\r\n    </li>\r\n  </ng-container>\r\n  <ng-container *ngIf=\"item.items && !item.isHeader\">\r\n    <li class=\"np-menu-item\" role=\"none\">\r\n      <a class=\"np-menu-link\" role=\"menuitem\" tabindex=\"0\" [ngClass]=\"{ 'np-menu-active-parent': _isActive(item) }\"\r\n        [attr.id]=\"item.id\" (click)=\"_onClickPanelMenu(item)\">\r\n        <i *ngIf=\"item.iconCss\" [class]=\"item.iconCss\"></i>\r\n        <span class=\"np-menu-text\" [innerHTML]=\"item.label\"></span>\r\n        <span class=\"np-menu-icon\">\r\n          <svg class=\"np-icon\" *ngIf=\"!item.isChildVisible\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M16.59 8.59L12 13.17 7.41 8.59 6 10l6 6 6-6z\"></path>\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n          </svg>\r\n          <svg class=\"np-icon\" *ngIf=\"item.isChildVisible\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M12 8l-6 6 1.41 1.41L12 10.83l4.59 4.58L18 14z\"></path>\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n          </svg>\r\n        </span>\r\n      </a>\r\n      <ng-container *ngIf=\"item.isChildVisible\">\r\n        <ul class=\"np-submenu\" role=\"menu\" [style.top.px]=\"item.y\" [style.left.px]=\"item.x\">\r\n          <ng-container *ngFor=\"let child of item.items\">\r\n            <np-panel-menu-item [item]=\"child\" (onClickItem)=\"_onClickMenuItem($event)\">\r\n            </np-panel-menu-item>\r\n          </ng-container>\r\n        </ul>\r\n      </ng-container>\r\n    </li>\r\n  </ng-container>\r\n  <ng-container *ngIf=\"!item.items && !item.isHeader\">\r\n    <li class=\"np-menu-item\" role=\"none\">\r\n      <a class=\"np-menu-link\" role=\"menuitem\" tabindex=\"0\" *ngIf=\"item.routerLink\" [attr.id]=\"item.id\"\r\n        [routerLink]=\"item.routerLink\" [queryParams]=\"item.queryParams\" [fragment]=\"item.fragment\"\r\n        [queryParamsHandling]=\"item.queryParamsHandling\" [routerLinkActive]=\"'np-menu-active'\"\r\n        (click)=\"_onClickMenuItem(item)\">\r\n        <i *ngIf=\"item.iconCss\" [class]=\"item.iconCss\"></i>\r\n        <span class=\"np-menu-text\" [innerHTML]=\"item.label\"></span>\r\n      </a>\r\n      <a class=\"np-menu-link\" role=\"menuitem\" tabindex=\"0\" *ngIf=\"item.url\" [attr.id]=\"item.id\" [href]=\"item.url\"\r\n        [target]=\"item.target\" (click)=\"_onClickMenuItem(item)\">\r\n        <i *ngIf=\"item.iconCss\" [class]=\"item.iconCss\"></i>\r\n        <span class=\"np-menu-text\" [innerHTML]=\"item.label\"></span>\r\n        <svg class=\"np-icon ml-1\" *ngIf=\"item.target === '_blank'\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\" />\r\n          <path d=\"M9 5v2h6.59L4 18.59 5.41 20 17 8.41V15h2V5z\" />\r\n        </svg>\r\n      </a>\r\n      <a class=\"np-menu-link\" role=\"menuitem\" tabindex=\"0\" *ngIf=\"!item.routerLink && !item.url\" [attr.id]=\"item.id\"\r\n        (click)=\"_onClickMenuItem(item)\">\r\n        <i *ngIf=\"item.iconCss\" [class]=\"item.iconCss\"></i>\r\n        <span class=\"np-menu-text\" [innerHTML]=\"item.label\"></span>\r\n      </a>\r\n    </li>\r\n  </ng-container>\r\n</ng-container>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$2.RouterLink, selector: "[routerLink]", inputs: ["target", "queryParams", "fragment", "queryParamsHandling", "state", "relativeTo", "preserveFragment", "skipLocationChange", "replaceUrl", "routerLink"] }, { kind: "directive", type: i1$2.RouterLinkActive, selector: "[routerLinkActive]", inputs: ["routerLinkActiveOptions", "ariaCurrentWhenActive", "routerLinkActive"], outputs: ["isActiveChange"], exportAs: ["routerLinkActive"] }, { kind: "component", type: NpPanelMenuItemComponent, selector: "np-panel-menu-item", inputs: ["item"], outputs: ["onClickItem"] }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpPanelMenuItemComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-panel-menu-item", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, template: "<ng-container *ngIf=\"item.visible\">\r\n  <ng-container *ngIf=\"item.isHeader\">\r\n    <li class=\"np-menu-header\" role=\"none\">\r\n      <a [attr.id]=\"item.id\">\r\n        <i *ngIf=\"item.iconCss\" [class]=\"item.iconCss\"></i>\r\n        <span class=\"np-menu-text\" [innerHTML]=\"item.label\"></span>\r\n      </a>\r\n    </li>\r\n  </ng-container>\r\n  <ng-container *ngIf=\"item.items && !item.isHeader\">\r\n    <li class=\"np-menu-item\" role=\"none\">\r\n      <a class=\"np-menu-link\" role=\"menuitem\" tabindex=\"0\" [ngClass]=\"{ 'np-menu-active-parent': _isActive(item) }\"\r\n        [attr.id]=\"item.id\" (click)=\"_onClickPanelMenu(item)\">\r\n        <i *ngIf=\"item.iconCss\" [class]=\"item.iconCss\"></i>\r\n        <span class=\"np-menu-text\" [innerHTML]=\"item.label\"></span>\r\n        <span class=\"np-menu-icon\">\r\n          <svg class=\"np-icon\" *ngIf=\"!item.isChildVisible\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M16.59 8.59L12 13.17 7.41 8.59 6 10l6 6 6-6z\"></path>\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n          </svg>\r\n          <svg class=\"np-icon\" *ngIf=\"item.isChildVisible\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M12 8l-6 6 1.41 1.41L12 10.83l4.59 4.58L18 14z\"></path>\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n          </svg>\r\n        </span>\r\n      </a>\r\n      <ng-container *ngIf=\"item.isChildVisible\">\r\n        <ul class=\"np-submenu\" role=\"menu\" [style.top.px]=\"item.y\" [style.left.px]=\"item.x\">\r\n          <ng-container *ngFor=\"let child of item.items\">\r\n            <np-panel-menu-item [item]=\"child\" (onClickItem)=\"_onClickMenuItem($event)\">\r\n            </np-panel-menu-item>\r\n          </ng-container>\r\n        </ul>\r\n      </ng-container>\r\n    </li>\r\n  </ng-container>\r\n  <ng-container *ngIf=\"!item.items && !item.isHeader\">\r\n    <li class=\"np-menu-item\" role=\"none\">\r\n      <a class=\"np-menu-link\" role=\"menuitem\" tabindex=\"0\" *ngIf=\"item.routerLink\" [attr.id]=\"item.id\"\r\n        [routerLink]=\"item.routerLink\" [queryParams]=\"item.queryParams\" [fragment]=\"item.fragment\"\r\n        [queryParamsHandling]=\"item.queryParamsHandling\" [routerLinkActive]=\"'np-menu-active'\"\r\n        (click)=\"_onClickMenuItem(item)\">\r\n        <i *ngIf=\"item.iconCss\" [class]=\"item.iconCss\"></i>\r\n        <span class=\"np-menu-text\" [innerHTML]=\"item.label\"></span>\r\n      </a>\r\n      <a class=\"np-menu-link\" role=\"menuitem\" tabindex=\"0\" *ngIf=\"item.url\" [attr.id]=\"item.id\" [href]=\"item.url\"\r\n        [target]=\"item.target\" (click)=\"_onClickMenuItem(item)\">\r\n        <i *ngIf=\"item.iconCss\" [class]=\"item.iconCss\"></i>\r\n        <span class=\"np-menu-text\" [innerHTML]=\"item.label\"></span>\r\n        <svg class=\"np-icon ml-1\" *ngIf=\"item.target === '_blank'\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\" />\r\n          <path d=\"M9 5v2h6.59L4 18.59 5.41 20 17 8.41V15h2V5z\" />\r\n        </svg>\r\n      </a>\r\n      <a class=\"np-menu-link\" role=\"menuitem\" tabindex=\"0\" *ngIf=\"!item.routerLink && !item.url\" [attr.id]=\"item.id\"\r\n        (click)=\"_onClickMenuItem(item)\">\r\n        <i *ngIf=\"item.iconCss\" [class]=\"item.iconCss\"></i>\r\n        <span class=\"np-menu-text\" [innerHTML]=\"item.label\"></span>\r\n      </a>\r\n    </li>\r\n  </ng-container>\r\n</ng-container>" }]
        }], ctorParameters: function () { return [{ type: i1$2.Router }]; }, propDecorators: { item: [{
                type: Input
            }], onClickItem: [{
                type: Output
            }] } });

class NpMenubarComponent {
    constructor() {
        this.inputId = `np-menubar_${NpMenubarComponent.controlCount++}`;
        this.onClickMenuItem = new EventEmitter();
    }
    ngAfterContentInit() {
        if (!this.isPanelMenu) {
            this.subscription = this.onClickMenuItem.subscribe(() => {
                this.items.forEach((element) => {
                    if (element.items) {
                        this._collapseMenu(element);
                    }
                });
            });
            this.orientation = this.orientation ? this.orientation : "vertical";
        }
        else {
            this.orientation = null;
        }
    }
    ngOnDestroy() {
        if (this.subscription) {
            this.subscription.unsubscribe();
        }
    }
    _collapseMenu(item) {
        item.items.forEach((element) => {
            if (element.items) {
                this._collapseMenu(element);
            }
        });
        item.isChildVisible = false;
    }
    _onClickMenuItem(item) {
        this.onClickMenuItem.emit(item);
    }
}
NpMenubarComponent.controlCount = 1;
NpMenubarComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpMenubarComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NpMenubarComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpMenubarComponent, selector: "np-menubar", inputs: { items: "items", orientation: "orientation", isPanelMenu: "isPanelMenu", styleClass: "styleClass", inputId: "inputId" }, outputs: { onClickMenuItem: "onClickMenuItem" }, ngImport: i0, template: "<ul role=\"menubar\" [ngClass]=\"{\r\n    'np-menubar': true,\r\n    'np-menubar-horizontal': orientation === 'horizontal',\r\n    'np-menubar-vertical': orientation === 'vertical',\r\n    'np-menubar-panel': isPanelMenu\r\n  }\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <ng-container *ngIf=\"!isPanelMenu\">\r\n    <np-menu-item *ngFor=\"let item of items\" [item]=\"item\" [orientation]=\"orientation\"\r\n      (onClickItem)=\"_onClickMenuItem($event)\">\r\n    </np-menu-item>\r\n  </ng-container>\r\n  <ng-container *ngIf=\"isPanelMenu\">\r\n    <np-panel-menu-item *ngFor=\"let item of items\" [item]=\"item\" (onClickItem)=\"_onClickMenuItem($event)\">\r\n    </np-panel-menu-item>\r\n  </ng-container>\r\n</ul>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: NpMenuItemComponent, selector: "np-menu-item", inputs: ["item", "orientation"], outputs: ["onClickItem"] }, { kind: "component", type: NpPanelMenuItemComponent, selector: "np-panel-menu-item", inputs: ["item"], outputs: ["onClickItem"] }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpMenubarComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-menubar", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, template: "<ul role=\"menubar\" [ngClass]=\"{\r\n    'np-menubar': true,\r\n    'np-menubar-horizontal': orientation === 'horizontal',\r\n    'np-menubar-vertical': orientation === 'vertical',\r\n    'np-menubar-panel': isPanelMenu\r\n  }\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <ng-container *ngIf=\"!isPanelMenu\">\r\n    <np-menu-item *ngFor=\"let item of items\" [item]=\"item\" [orientation]=\"orientation\"\r\n      (onClickItem)=\"_onClickMenuItem($event)\">\r\n    </np-menu-item>\r\n  </ng-container>\r\n  <ng-container *ngIf=\"isPanelMenu\">\r\n    <np-panel-menu-item *ngFor=\"let item of items\" [item]=\"item\" (onClickItem)=\"_onClickMenuItem($event)\">\r\n    </np-panel-menu-item>\r\n  </ng-container>\r\n</ul>" }]
        }], propDecorators: { items: [{
                type: Input
            }], orientation: [{
                type: Input
            }], isPanelMenu: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], inputId: [{
                type: Input
            }], onClickMenuItem: [{
                type: Output
            }] } });

class NpPopupMenubarDirective {
    constructor(overlay, overlayPositionBuilder, elementRef) {
        this.overlay = overlay;
        this.overlayPositionBuilder = overlayPositionBuilder;
        this.elementRef = elementRef;
        this.inputId = `np-popup-menubar_${NpPopupMenubarDirective.controlCount++}`;
        this.onClickMenuItem = new EventEmitter();
    }
    ngAfterViewInit() {
        this.elementRef.nativeElement.className = `${this.elementRef.nativeElement.className} np-menubar-target`.trim();
        const positionStrategy = this.overlayPositionBuilder
            .flexibleConnectedTo(this.elementRef)
            .withPositions(TopBottomOverlayPositions);
        this.overlayRef = this.overlay.create({
            positionStrategy,
            hasBackdrop: true,
            backdropClass: "np-menubar-backdrop",
            panelClass: "np-menubar-overlay",
            scrollStrategy: this.overlay.scrollStrategies.reposition(),
        });
        this.overlayRef.backdropClick().subscribe(() => this._close());
        this.subscription = this.onClickMenuItem.subscribe(() => {
            setTimeout(() => {
                this._close();
            }, 100);
        });
    }
    ngOnDestroy() {
        if (this.overlayRef.hasAttached()) {
            this._close();
        }
        if (this.subscription) {
            this.subscription.unsubscribe();
        }
    }
    show() {
        if (this.overlayRef.hasAttached()) {
            this._close();
            return;
        }
        const menubarPortal = new ComponentPortal(NpMenubarComponent);
        const menubarRef = this.overlayRef.attach(menubarPortal);
        menubarRef.instance.items = this.items;
        menubarRef.instance.styleClass = this.styleClass;
        menubarRef.instance.inputId = this.inputId;
        menubarRef.instance.onClickMenuItem = this.onClickMenuItem;
    }
    _close() {
        this.overlayRef.detach();
    }
}
NpPopupMenubarDirective.controlCount = 1;
NpPopupMenubarDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpPopupMenubarDirective, deps: [{ token: i1.Overlay }, { token: i1.OverlayPositionBuilder }, { token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
NpPopupMenubarDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.0.1", type: NpPopupMenubarDirective, selector: "[npPopupMenubar]", inputs: { items: "items", styleClass: "styleClass", inputId: "inputId" }, outputs: { onClickMenuItem: "onClickMenuItem" }, host: { listeners: { "click": "show()" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpPopupMenubarDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: "[npPopupMenubar]",
                }]
        }], ctorParameters: function () { return [{ type: i1.Overlay }, { type: i1.OverlayPositionBuilder }, { type: i0.ElementRef }]; }, propDecorators: { items: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], inputId: [{
                type: Input
            }], onClickMenuItem: [{
                type: Output
            }], show: [{
                type: HostListener,
                args: ["click"]
            }] } });

class NpMenubarModule {
}
NpMenubarModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpMenubarModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpMenubarModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpMenubarModule, declarations: [NpMenubarComponent,
        NpPopupMenubarDirective,
        NpMenuItemComponent,
        NpPanelMenuItemComponent], imports: [CommonModule, RouterModule, OverlayModule], exports: [NpMenubarComponent, NpPopupMenubarDirective] });
NpMenubarModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpMenubarModule, imports: [CommonModule, RouterModule, OverlayModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpMenubarModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        NpMenubarComponent,
                        NpPopupMenubarDirective,
                        NpMenuItemComponent,
                        NpPanelMenuItemComponent,
                    ],
                    imports: [CommonModule, RouterModule, OverlayModule],
                    exports: [NpMenubarComponent, NpPopupMenubarDirective]
                }]
        }] });

class NpMenuItem {
    constructor(item) {
        this.id = item.id;
        this.label = item.label;
        this.items = item.items;
        this.url = item.url;
        this.target = item.target ? item.target : "_self";
        this.routerLink = item.routerLink;
        this.queryParams = item.queryParams;
        this.fragment = item.fragment;
        this.queryParamsHandling = item.queryParamsHandling;
        this.iconCss = item.iconCss;
        this.isChildVisible = false;
        this.visible = item.visible === false ? false : true;
        this.isHeader = item.isHeader === true ? true : false;
    }
}

class NpCardComponent {
    constructor() {
        this.inputId = `np-card_${NpCardComponent.controlCount++}`;
    }
}
NpCardComponent.controlCount = 1;
NpCardComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpCardComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NpCardComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpCardComponent, selector: "np-card", inputs: { width: "width", styleClass: "styleClass", inputId: "inputId" }, ngImport: i0, template: "<div [ngClass]=\"'np-card'\" [style.width.px]=\"width\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <ng-content></ng-content>\r\n</div>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpCardComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-card", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, template: "<div [ngClass]=\"'np-card'\" [style.width.px]=\"width\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <ng-content></ng-content>\r\n</div>" }]
        }], propDecorators: { width: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], inputId: [{
                type: Input
            }] } });

class NpCardHeaderComponent {
}
NpCardHeaderComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpCardHeaderComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NpCardHeaderComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpCardHeaderComponent, selector: "np-card-header", ngImport: i0, template: '<div class="np-card-header"><ng-content></ng-content></div>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpCardHeaderComponent, decorators: [{
            type: Component,
            args: [{
                    selector: "np-card-header",
                    template: '<div class="np-card-header"><ng-content></ng-content></div>',
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.Default,
                }]
        }] });

class NpCardImageComponent {
}
NpCardImageComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpCardImageComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NpCardImageComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpCardImageComponent, selector: "np-card-image", ngImport: i0, template: '<div class="np-card-image"><ng-content></ng-content></div>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpCardImageComponent, decorators: [{
            type: Component,
            args: [{
                    selector: "np-card-image",
                    template: '<div class="np-card-image"><ng-content></ng-content></div>',
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.Default,
                }]
        }] });

class NpCardFooterComponent {
}
NpCardFooterComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpCardFooterComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NpCardFooterComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpCardFooterComponent, selector: "np-card-footer", ngImport: i0, template: '<div class="np-card-footer"><ng-content></ng-content></div>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpCardFooterComponent, decorators: [{
            type: Component,
            args: [{
                    selector: "np-card-footer",
                    template: '<div class="np-card-footer"><ng-content></ng-content></div>',
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.Default,
                }]
        }] });

class NpCardBodyComponent {
}
NpCardBodyComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpCardBodyComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NpCardBodyComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpCardBodyComponent, selector: "np-card-body", ngImport: i0, template: '<div class="np-card-body"><ng-content></ng-content></div>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpCardBodyComponent, decorators: [{
            type: Component,
            args: [{
                    selector: "np-card-body",
                    template: '<div class="np-card-body"><ng-content></ng-content></div>',
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.Default,
                }]
        }] });

class NpCardModule {
}
NpCardModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpCardModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpCardModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpCardModule, declarations: [NpCardComponent,
        NpCardHeaderComponent,
        NpCardImageComponent,
        NpCardBodyComponent,
        NpCardFooterComponent], imports: [CommonModule], exports: [NpCardComponent,
        NpCardHeaderComponent,
        NpCardImageComponent,
        NpCardBodyComponent,
        NpCardFooterComponent] });
NpCardModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpCardModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpCardModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        NpCardComponent,
                        NpCardHeaderComponent,
                        NpCardImageComponent,
                        NpCardBodyComponent,
                        NpCardFooterComponent,
                    ],
                    imports: [CommonModule],
                    exports: [
                        NpCardComponent,
                        NpCardHeaderComponent,
                        NpCardImageComponent,
                        NpCardBodyComponent,
                        NpCardFooterComponent,
                    ],
                }]
        }] });

class NpLoaderDirective {
    constructor(elRef, renderer) {
        this.elRef = elRef;
        this.renderer = renderer;
        this.diameter = 32;
        this.strokeWidth = 4;
        this.isActive = false;
        this.initialized = false;
    }
    ngOnInit() {
        const loader = this.renderer.createElement("div");
        this.renderer.setAttribute(loader, "role", "progressbar");
        this.renderer.setAttribute(loader, "aria-busy", "true");
        this.renderer.addClass(loader, "np-loader");
        this.renderer.setStyle(loader, "width", `${this.diameter}px`);
        this.renderer.setStyle(loader, "height", `${this.diameter}px`);
        this.renderer.setStyle(loader, "border-width", `${this.strokeWidth}px`);
        this.loaderEle = this.renderer.createElement("div");
        this.renderer.addClass(this.loaderEle, "np-loader-backdrop");
        this.renderer.appendChild(this.loaderEle, loader);
        if (this.loadingText) {
            const loaderTextDiv = this.renderer.createElement("div");
            const loaderText = this.renderer.createText(this.loadingText);
            this.renderer.appendChild(loaderTextDiv, loaderText);
            this.renderer.addClass(loaderTextDiv, "np-loader-text");
            this.renderer.appendChild(this.loaderEle, loaderTextDiv);
        }
        this.initialized = true;
    }
    ngOnChanges(changes) {
        setTimeout(() => {
            if (this.initialized) {
                if (changes["show"] && changes["show"].currentValue === true) {
                    this._showLoader();
                }
                else {
                    this._hideLoader();
                }
            }
        }, 10);
    }
    _showLoader() {
        if (!this.initialized || this.isActive) {
            return;
        }
        this.renderer.addClass(this.elRef.nativeElement, "np-loader-target");
        this.renderer.appendChild(this.elRef.nativeElement, this.loaderEle);
        this.isActive = true;
    }
    _hideLoader() {
        if (!this.initialized || !this.isActive) {
            return;
        }
        this.renderer.removeClass(this.elRef.nativeElement, "np-loader-target");
        this.renderer.removeChild(this.elRef.nativeElement, this.loaderEle);
        this.isActive = false;
    }
}
NpLoaderDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpLoaderDirective, deps: [{ token: i0.ElementRef }, { token: i0.Renderer2 }], target: i0.ɵɵFactoryTarget.Directive });
NpLoaderDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.0.1", type: NpLoaderDirective, selector: "[npLoader]", inputs: { show: ["npLoader", "show"], diameter: "diameter", strokeWidth: "strokeWidth", loadingText: "loadingText" }, usesOnChanges: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpLoaderDirective, decorators: [{
            type: Directive,
            args: [{ selector: "[npLoader]" }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.Renderer2 }]; }, propDecorators: { show: [{
                type: Input,
                args: ["npLoader"]
            }], diameter: [{
                type: Input
            }], strokeWidth: [{
                type: Input
            }], loadingText: [{
                type: Input
            }] } });

class NpLoaderModule {
}
NpLoaderModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpLoaderModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpLoaderModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpLoaderModule, declarations: [NpLoaderDirective], imports: [CommonModule], exports: [NpLoaderDirective] });
NpLoaderModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpLoaderModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpLoaderModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpLoaderDirective],
                    imports: [CommonModule],
                    exports: [NpLoaderDirective],
                }]
        }] });

class NpBlockUiDirective {
    constructor(elRef, renderer) {
        this.elRef = elRef;
        this.renderer = renderer;
        this.isActive = false;
        const icon = `<svg class="np-icon" viewBox="0 0 24 24">
            <path d="M0 0h24v24H0z" fill="none"/>
            <path d="M18 8h-1V6c0-2.76-2.24-5-5-5S7 3.24 7 6v2H6c-1.1 0-2 .9-2 2v10c0 1.1.9 2 2 2h12c1.1 0 2-.9 2-2V10c0-1.1-.9-2-2-2zm-6 9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2zm3.1-9H8.9V6c0-1.71 1.39-3.1 3.1-3.1 1.71 0 3.1 1.39 3.1 3.1v2z"/>
        </svg>`;
        const blockUi = this.renderer.createElement("div");
        this.renderer.addClass(blockUi, "np-blockui");
        blockUi.innerHTML = icon;
        this.element = this.renderer.createElement("div");
        this.renderer.addClass(this.element, "np-blockui-backdrop");
        this.renderer.appendChild(this.element, blockUi);
    }
    ngOnChanges(changes) {
        if (changes["visible"].currentValue === true) {
            this._show();
        }
        else {
            this._hide();
        }
    }
    _show() {
        if (this.isActive) {
            return;
        }
        this.isActive = true;
        this.renderer.addClass(this.elRef.nativeElement, "np-blockui-target");
        this.renderer.appendChild(this.elRef.nativeElement, this.element);
    }
    _hide() {
        if (!this.isActive) {
            return;
        }
        this.isActive = false;
        this.renderer.removeClass(this.elRef.nativeElement, "np-blockui-target");
        this.renderer.removeChild(this.elRef.nativeElement, this.element);
    }
}
NpBlockUiDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpBlockUiDirective, deps: [{ token: i0.ElementRef }, { token: i0.Renderer2 }], target: i0.ɵɵFactoryTarget.Directive });
NpBlockUiDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.0.1", type: NpBlockUiDirective, selector: "[npBlockUi]", inputs: { visible: ["npBlockUi", "visible"] }, usesOnChanges: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpBlockUiDirective, decorators: [{
            type: Directive,
            args: [{ selector: "[npBlockUi]" }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.Renderer2 }]; }, propDecorators: { visible: [{
                type: Input,
                args: ["npBlockUi"]
            }] } });

class NpBlockUiModule {
}
NpBlockUiModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpBlockUiModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpBlockUiModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpBlockUiModule, declarations: [NpBlockUiDirective], imports: [CommonModule], exports: [NpBlockUiDirective] });
NpBlockUiModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpBlockUiModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpBlockUiModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpBlockUiDirective],
                    imports: [CommonModule],
                    exports: [NpBlockUiDirective],
                }]
        }] });

class NpSidepanelContent {
}
NpSidepanelContent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpSidepanelContent, deps: [], target: i0.ɵɵFactoryTarget.Directive });
NpSidepanelContent.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.0.1", type: NpSidepanelContent, selector: "[npSidepanelContent]", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpSidepanelContent, decorators: [{
            type: Directive,
            args: [{
                    selector: "[npSidepanelContent]",
                }]
        }] });

class NpSidepanelService {
    constructor() {
        this._observables = {};
    }
    _add(id) {
        this._observables[id] = new Subject();
        return this._observables[id];
    }
    get(id) {
        return this._observables[id];
    }
    _remove(id) {
        delete this._observables[id];
    }
    closeSidepanel(id, data) {
        this._observables[id].next(data);
    }
}
NpSidepanelService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpSidepanelService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
NpSidepanelService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpSidepanelService, providedIn: "root" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpSidepanelService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: "root",
                }]
        }] });

class NpSidepanelComponent {
    constructor(overlay, viewContainerRef, overlayPositionBuilder, sidepanelService) {
        this.overlay = overlay;
        this.viewContainerRef = viewContainerRef;
        this.overlayPositionBuilder = overlayPositionBuilder;
        this.sidepanelService = sidepanelService;
        // left | right | top | bottom
        this.position = "left";
        this.closeOnClickOutside = true;
        this.backDropClass = "np-sidepanel-backdrop";
        this.hasBackDrop = true;
        this.inputId = `np-sidepanel_${NpSidepanelComponent.controlCount++}`;
        this.onOpen = new EventEmitter();
        this.onClose = new EventEmitter();
        this._contentPortal = null;
        this.sidepanelRef = new Subject();
    }
    get content() {
        return this._contentPortal;
    }
    ngOnInit() {
        this.sidepanelRef = this.sidepanelService._add(this.inputId);
        this.sidepanelRef.subscribe((data) => {
            this.close(data);
        });
    }
    ngOnDestroy() {
        this.sidepanelRef.unsubscribe();
        this.sidepanelService._remove(this.inputId);
    }
    open(data) {
        // if overlay is not attached then only attach
        if (this.overlayRef === undefined || !this.overlayRef.hasAttached()) {
            const positionStrategy = this.overlayPositionBuilder.global();
            if (this.position === "left") {
                positionStrategy.left("0");
            }
            if (this.position === "right") {
                positionStrategy.right("0");
            }
            if (this.position === "top") {
                positionStrategy.top("0");
            }
            if (this.position === "bottom") {
                positionStrategy.bottom("0");
            }
            this.overlayRef = this.overlay.create({
                positionStrategy,
                hasBackdrop: this.hasBackDrop,
                backdropClass: this.backDropClass,
                height: this.height,
                width: this.width,
                scrollStrategy: this.overlay.scrollStrategies.block(),
                panelClass: "np-sidepanel-overlay",
            });
            this.templatePortal = new TemplatePortal(this.templatePortalContent, this.viewContainerRef);
            this.overlayRef.backdropClick().subscribe(() => {
                if (this.closeOnClickOutside) {
                    this.close(null);
                }
            });
            if (!this._contentPortal && this._explicitContent) {
                this._contentPortal = new TemplatePortal(this._explicitContent, this.viewContainerRef);
            }
            this.overlayRef.attach(this.templatePortal);
            this.onOpen.emit(data);
            return this.sidepanelRef;
        }
        return null;
    }
    close(data) {
        if (this.overlayRef && this.overlayRef.hasAttached()) {
            if (this._contentPortal && this._contentPortal.isAttached) {
                this._contentPortal.detach();
            }
            this.overlayRef.detach();
            this.onClose.emit(data);
        }
    }
}
NpSidepanelComponent.controlCount = 1;
NpSidepanelComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpSidepanelComponent, deps: [{ token: i1.Overlay }, { token: i0.ViewContainerRef }, { token: i1.OverlayPositionBuilder }, { token: NpSidepanelService }], target: i0.ɵɵFactoryTarget.Component });
NpSidepanelComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpSidepanelComponent, selector: "np-sidepanel", inputs: { position: "position", height: "height", width: "width", header: "header", closeOnClickOutside: "closeOnClickOutside", backDropClass: "backDropClass", hasBackDrop: "hasBackDrop", styleClass: "styleClass", inputId: "inputId" }, outputs: { onOpen: "onOpen", onClose: "onClose" }, queries: [{ propertyName: "_explicitContent", first: true, predicate: NpSidepanelContent, descendants: true, read: TemplateRef, static: true }], viewQueries: [{ propertyName: "templatePortalContent", first: true, predicate: ["templatePortalContent"], descendants: true }], ngImport: i0, template: "<ng-template #templatePortalContent>\r\n  <div role=\"complementary\" [ngClass]=\"'np-sidepanel'\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n    <div class=\"np-sidepanel-header\" *ngIf=\"header\" [innerHTML]=\"header\">\r\n    </div>\r\n    <div class=\"np-sidepanel-content\">\r\n      <ng-content></ng-content>\r\n      <ng-template [cdkPortalOutlet]=\"content\"></ng-template>\r\n    </div>\r\n  </div>\r\n</ng-template>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.CdkPortalOutlet, selector: "[cdkPortalOutlet]", inputs: ["cdkPortalOutlet"], outputs: ["attached"], exportAs: ["cdkPortalOutlet"] }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpSidepanelComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-sidepanel", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, template: "<ng-template #templatePortalContent>\r\n  <div role=\"complementary\" [ngClass]=\"'np-sidepanel'\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n    <div class=\"np-sidepanel-header\" *ngIf=\"header\" [innerHTML]=\"header\">\r\n    </div>\r\n    <div class=\"np-sidepanel-content\">\r\n      <ng-content></ng-content>\r\n      <ng-template [cdkPortalOutlet]=\"content\"></ng-template>\r\n    </div>\r\n  </div>\r\n</ng-template>" }]
        }], ctorParameters: function () { return [{ type: i1.Overlay }, { type: i0.ViewContainerRef }, { type: i1.OverlayPositionBuilder }, { type: NpSidepanelService }]; }, propDecorators: { position: [{
                type: Input
            }], height: [{
                type: Input
            }], width: [{
                type: Input
            }], header: [{
                type: Input
            }], closeOnClickOutside: [{
                type: Input
            }], backDropClass: [{
                type: Input
            }], hasBackDrop: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], inputId: [{
                type: Input
            }], onOpen: [{
                type: Output
            }], onClose: [{
                type: Output
            }], templatePortalContent: [{
                type: ViewChild,
                args: ["templatePortalContent"]
            }], _explicitContent: [{
                type: ContentChild,
                args: [NpSidepanelContent, { read: TemplateRef, static: true }]
            }] } });

class NpSidepanelModule {
}
NpSidepanelModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpSidepanelModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpSidepanelModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpSidepanelModule, declarations: [NpSidepanelComponent, NpSidepanelContent], imports: [CommonModule, PortalModule], exports: [NpSidepanelComponent, NpSidepanelContent] });
NpSidepanelModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpSidepanelModule, imports: [CommonModule, PortalModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpSidepanelModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpSidepanelComponent, NpSidepanelContent],
                    imports: [CommonModule, PortalModule],
                    exports: [NpSidepanelComponent, NpSidepanelContent],
                }]
        }] });

class NpBreadcrumbComponent {
    constructor() {
        this.showIcon = true;
        this.inputId = `np-breadcrumb_${NpBreadcrumbComponent.controlCount++}`;
        this.onClick = new EventEmitter();
    }
    _onClick(item) {
        if (this.onClick && !item.disabled) {
            this.onClick.emit(item);
        }
    }
}
NpBreadcrumbComponent.controlCount = 1;
NpBreadcrumbComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpBreadcrumbComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NpBreadcrumbComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpBreadcrumbComponent, selector: "np-breadcrumb", inputs: { items: "items", showIcon: "showIcon", iconCss: "iconCss", styleClass: "styleClass", inputId: "inputId" }, outputs: { onClick: "onClick" }, ngImport: i0, template: "<div [ngClass]=\"'np-breadcrumb'\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <ul class=\"np-breadcrumb-items\">\r\n    <ng-container *ngIf=\"showIcon\">\r\n      <li class=\"np-breadcrumb-item\">\r\n        <i *ngIf=\"iconCss\" [class]=\"iconCss\"></i>\r\n        <svg class=\"np-icon\" *ngIf=\"!iconCss\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M10 20v-6h4v6h5v-8h3L12 3 2 12h3v8z\"></path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </li>\r\n    </ng-container>\r\n    <ng-container *ngFor=\"let item of items; let i = index\">\r\n      <li class=\"np-breadcrumb-item\" [attr.tabindex]=\"item.disabled ? '-1' : '0'\">\r\n        <a [ngClass]=\"{ 'np-disabled': item.disabled }\" [attr.id]=\"item.id\" [innerHTML]=\"item.label\"\r\n          (click)=\"_onClick(item)\"></a>\r\n      </li>\r\n    </ng-container>\r\n  </ul>\r\n</div>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpBreadcrumbComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-breadcrumb", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, template: "<div [ngClass]=\"'np-breadcrumb'\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <ul class=\"np-breadcrumb-items\">\r\n    <ng-container *ngIf=\"showIcon\">\r\n      <li class=\"np-breadcrumb-item\">\r\n        <i *ngIf=\"iconCss\" [class]=\"iconCss\"></i>\r\n        <svg class=\"np-icon\" *ngIf=\"!iconCss\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M10 20v-6h4v6h5v-8h3L12 3 2 12h3v8z\"></path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </li>\r\n    </ng-container>\r\n    <ng-container *ngFor=\"let item of items; let i = index\">\r\n      <li class=\"np-breadcrumb-item\" [attr.tabindex]=\"item.disabled ? '-1' : '0'\">\r\n        <a [ngClass]=\"{ 'np-disabled': item.disabled }\" [attr.id]=\"item.id\" [innerHTML]=\"item.label\"\r\n          (click)=\"_onClick(item)\"></a>\r\n      </li>\r\n    </ng-container>\r\n  </ul>\r\n</div>" }]
        }], propDecorators: { items: [{
                type: Input
            }], showIcon: [{
                type: Input
            }], iconCss: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], inputId: [{
                type: Input
            }], onClick: [{
                type: Output
            }] } });

class NpBreadcrumbModule {
}
NpBreadcrumbModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpBreadcrumbModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpBreadcrumbModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpBreadcrumbModule, declarations: [NpBreadcrumbComponent], imports: [CommonModule], exports: [NpBreadcrumbComponent] });
NpBreadcrumbModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpBreadcrumbModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpBreadcrumbModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpBreadcrumbComponent],
                    imports: [CommonModule],
                    exports: [NpBreadcrumbComponent],
                }]
        }] });

class NpBreadcrumbItem {
    constructor(item) {
        this.id = item.id;
        this.label = item.label;
        this.data = item.data;
        this.disabled = item.disabled;
    }
}

class NpNumberBoxComponent {
    constructor() {
        this.steps = 1;
        this.showControls = true;
        this.placeholder = "";
        this.inputId = `np-number-box_${NpNumberBoxComponent.controlCount++}`;
        this.onChange = new EventEmitter();
        this.onFocus = new EventEmitter();
        this.onBlur = new EventEmitter();
        this.isDisabled = false;
        this.focused = false;
        this.onChangeCallback = () => { };
        this.onTouchedCallback = () => { };
    }
    get value() {
        return this.innerValue !== undefined ? this.innerValue : null;
    }
    set value(v) {
        if (v !== this.innerValue) {
            this.innerValue = v;
            this.onChangeCallback(v);
            this.onChange.emit(v);
        }
    }
    writeValue(v) {
        if (v !== this.innerValue) {
            this.innerValue = v;
        }
    }
    registerOnChange(fn) {
        this.onChangeCallback = fn;
    }
    registerOnTouched(fn) {
        this.onTouchedCallback = fn;
    }
    setDisabledState(isDisabled) {
        this.isDisabled = isDisabled;
    }
    validate() {
        if (this.min !== undefined && this.value < this.min) {
            return {
                min: {
                    valid: false,
                },
            };
        }
        if (this.max !== undefined && this.value > this.max) {
            return {
                max: {
                    valid: false,
                },
            };
        }
        if (this.pattern) {
            const regex = new RegExp(this.pattern);
            if (this.value && !regex.test(this.value.toString())) {
                return {
                    pattern: {
                        valid: false,
                    },
                };
            }
        }
    }
    focus() {
        this.inputViewChild.nativeElement.focus();
    }
    _add() {
        if (this.isDisabled || this.readOnly) {
            return;
        }
        this.value = this.value + this.steps;
    }
    _minus() {
        if (this.isDisabled || this.readOnly) {
            return;
        }
        this.value = this.value - this.steps;
    }
    _onMouseDownPlus() {
        const that = this;
        this._clearTimeout();
        this.timeout = setTimeout(() => {
            that._onMouseDownPlus();
        }, 200);
        that._add();
    }
    _onMouseUpPlus() {
        this._clearTimeout();
        this.inputViewChild.nativeElement.focus();
    }
    _onMouseDownMinus() {
        const that = this;
        this._clearTimeout();
        this.timeout = setTimeout(() => {
            that._onMouseDownMinus();
        }, 200);
        that._minus();
    }
    _onMouseUpMinus() {
        this._clearTimeout();
        this.inputViewChild.nativeElement.focus();
    }
    _clearTimeout() {
        if (this.timeout) {
            clearTimeout(this.timeout);
        }
    }
    _onInputChange(event) {
        if (isNaN(parseFloat(event.target.value))) {
            this.value = null;
        }
        else {
            this.value = Number(event.target.value);
        }
    }
    _onBlur($event) {
        this.focused = false;
        this.onTouchedCallback();
        this.onBlur.emit($event);
    }
    _onFocus($event) {
        this.focused = true;
        this.onFocus.emit($event);
    }
}
NpNumberBoxComponent.controlCount = 1;
NpNumberBoxComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpNumberBoxComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NpNumberBoxComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpNumberBoxComponent, selector: "np-number-box", inputs: { steps: "steps", min: "min", max: "max", pattern: "pattern", prefixLabel: "prefixLabel", suffixLabel: "suffixLabel", showControls: "showControls", placeholder: "placeholder", readOnly: "readOnly", autoFocus: "autoFocus", tabIndex: "tabIndex", styleClass: "styleClass", inputId: "inputId" }, outputs: { onChange: "onChange", onFocus: "onFocus", onBlur: "onBlur" }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => NpNumberBoxComponent),
            multi: true,
        },
        {
            provide: NG_VALIDATORS,
            useExisting: forwardRef(() => NpNumberBoxComponent),
            multi: true,
        },
    ], viewQueries: [{ propertyName: "inputViewChild", first: true, predicate: ["control"], descendants: true }], ngImport: i0, template: "<div [ngClass]=\"{\r\n    'np-number-box': true,\r\n    'np-disabled': isDisabled,\r\n    'np-readonly': readOnly\r\n  }\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-input-group\" [ngClass]=\"{ 'np-focused': focused }\">\r\n    <label class=\"np-prefix-label\" *ngIf=\"prefixLabel\" [innerHTML]=\"prefixLabel\"></label>\r\n    <input class=\"np-form-control\" type=\"number\" #control autocomplete=\"off\" [npAutofocus]=\"autoFocus\"\r\n      [attr.tabindex]=\"tabIndex\" [readonly]=\"readOnly\" [value]=\"innerValue\" [placeholder]=\"placeholder\"\r\n      [attr.aria-valumin]=\"min\" [attr.aria-valuemax]=\"max\" [attr.aria-valuenow]=\"innerValue\" [disabled]=\"isDisabled\"\r\n      (change)=\"_onInputChange($event)\" (blur)=\"_onBlur($event)\" (focus)=\"_onFocus($event)\" />\r\n    <label class=\"np-suffix-label\" *ngIf=\"suffixLabel\" [innerHTML]=\"suffixLabel\"></label>\r\n    <div class=\"np-input-group-append\" *ngIf=\"showControls\">\r\n      <button class=\"np-btn-icon np-number-minus\" type=\"button\" tabindex=\"-1\" (mousedown)=\"_onMouseDownMinus()\"\r\n        (mouseup)=\"_onMouseUpMinus()\" (mouseleave)=\"_onMouseUpMinus()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M19 13H5v-2h14v2z\"></path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n      <button class=\"np-btn-icon np-number-plus\" type=\"button\" tabindex=\"-1\" (mousedown)=\"_onMouseDownPlus()\"\r\n        (mouseup)=\"_onMouseUpPlus()\" (mouseleave)=\"_onMouseUpPlus()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M19 13h-6v6h-2v-6H5v-2h6V5h2v6h6v2z\"></path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n  </div>\r\n</div>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: NpAutofocusDirective, selector: "[npAutofocus]", inputs: ["npAutofocus"] }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpNumberBoxComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-number-box", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => NpNumberBoxComponent),
                            multi: true,
                        },
                        {
                            provide: NG_VALIDATORS,
                            useExisting: forwardRef(() => NpNumberBoxComponent),
                            multi: true,
                        },
                    ], template: "<div [ngClass]=\"{\r\n    'np-number-box': true,\r\n    'np-disabled': isDisabled,\r\n    'np-readonly': readOnly\r\n  }\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-input-group\" [ngClass]=\"{ 'np-focused': focused }\">\r\n    <label class=\"np-prefix-label\" *ngIf=\"prefixLabel\" [innerHTML]=\"prefixLabel\"></label>\r\n    <input class=\"np-form-control\" type=\"number\" #control autocomplete=\"off\" [npAutofocus]=\"autoFocus\"\r\n      [attr.tabindex]=\"tabIndex\" [readonly]=\"readOnly\" [value]=\"innerValue\" [placeholder]=\"placeholder\"\r\n      [attr.aria-valumin]=\"min\" [attr.aria-valuemax]=\"max\" [attr.aria-valuenow]=\"innerValue\" [disabled]=\"isDisabled\"\r\n      (change)=\"_onInputChange($event)\" (blur)=\"_onBlur($event)\" (focus)=\"_onFocus($event)\" />\r\n    <label class=\"np-suffix-label\" *ngIf=\"suffixLabel\" [innerHTML]=\"suffixLabel\"></label>\r\n    <div class=\"np-input-group-append\" *ngIf=\"showControls\">\r\n      <button class=\"np-btn-icon np-number-minus\" type=\"button\" tabindex=\"-1\" (mousedown)=\"_onMouseDownMinus()\"\r\n        (mouseup)=\"_onMouseUpMinus()\" (mouseleave)=\"_onMouseUpMinus()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M19 13H5v-2h14v2z\"></path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n      <button class=\"np-btn-icon np-number-plus\" type=\"button\" tabindex=\"-1\" (mousedown)=\"_onMouseDownPlus()\"\r\n        (mouseup)=\"_onMouseUpPlus()\" (mouseleave)=\"_onMouseUpPlus()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M19 13h-6v6h-2v-6H5v-2h6V5h2v6h6v2z\"></path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n  </div>\r\n</div>" }]
        }], propDecorators: { steps: [{
                type: Input
            }], min: [{
                type: Input
            }], max: [{
                type: Input
            }], pattern: [{
                type: Input
            }], prefixLabel: [{
                type: Input
            }], suffixLabel: [{
                type: Input
            }], showControls: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], readOnly: [{
                type: Input
            }], autoFocus: [{
                type: Input
            }], tabIndex: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], inputId: [{
                type: Input
            }], onChange: [{
                type: Output
            }], onFocus: [{
                type: Output
            }], onBlur: [{
                type: Output
            }], inputViewChild: [{
                type: ViewChild,
                args: ["control"]
            }] } });

class NpNumberBoxModule {
}
NpNumberBoxModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpNumberBoxModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpNumberBoxModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpNumberBoxModule, declarations: [NpNumberBoxComponent], imports: [CommonModule, NpAutofocusModule], exports: [NpNumberBoxComponent] });
NpNumberBoxModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpNumberBoxModule, imports: [CommonModule, NpAutofocusModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpNumberBoxModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpNumberBoxComponent],
                    imports: [CommonModule, NpAutofocusModule],
                    exports: [NpNumberBoxComponent],
                }]
        }] });

class NpTreeViewComponent {
    constructor() {
        this.cascadeSelection = false;
        this.selectionChange = new EventEmitter();
        this.inputId = `np-treeview_${NpTreeViewComponent.controlCount++}`;
        this.onClick = new EventEmitter();
        this.onExpand = new EventEmitter();
        this.onCollapse = new EventEmitter();
        this.onExpandAll = new EventEmitter();
        this.onCollapseAll = new EventEmitter();
        this.onSelect = new EventEmitter();
        this.onDeselect = new EventEmitter();
    }
    ngOnChanges(changes) {
        if (changes["selection"] && this.cascadeSelection) {
            this._syncSelectionForAll();
        }
        if (changes["cascadeSelection"] && !changes["cascadeSelection"].firstChange) {
            if (changes["cascadeSelection"].currentValue) {
                this._syncSelectionForAll();
            }
            else {
                this._removePartialSelectionAll();
            }
        }
    }
    expandAll() {
        this.items.forEach((element) => {
            this._expandAllInNode(element);
        });
        this.onExpandAll.emit();
    }
    collapseAll() {
        this.items.forEach((element) => {
            this._collapseAllInNode(element);
        });
        this.onCollapseAll.emit();
    }
    selectAll() {
        if (this._isSingleSelectionMode()) {
            return;
        }
        this.selection = [];
        this.items.forEach((element) => {
            this._selectAll(element);
        });
        this.selectionChange.emit(this.selection);
    }
    deselectAll() {
        if (this._isSingleSelectionMode()) {
            return;
        }
        this.selection = [];
        this.selectionChange.emit(this.selection);
    }
    _toggle(item) {
        if (item.isExpanded) {
            item.isExpanded = false;
            this.onCollapse.emit(item);
            return;
        }
        item.isExpanded = true;
        this.onExpand.emit(item);
    }
    _expandAllInNode(item) {
        item.isExpanded = true;
        if (item.childItems) {
            item.childItems.forEach((element) => {
                this._expandAllInNode(element);
            });
        }
    }
    _collapseAllInNode(item) {
        item.isExpanded = false;
        if (item.childItems) {
            item.childItems.forEach((element) => {
                this._collapseAllInNode(element);
            });
        }
    }
    _onClick(item) {
        this.onClick.emit(item);
    }
    _changeSelection(checked, item) {
        if (!item.id) {
            throw new Error("NpTreeViewItem.id must be defined for selection");
        }
        if (checked) {
            this._selectNode(item);
        }
        else {
            this._deselectNode(item);
        }
        if (this.cascadeSelection) {
            this._syncSelectionForAll();
        }
        if (checked) {
            this.onSelect.emit(item);
        }
        else {
            this.onDeselect.emit(item);
        }
    }
    _selectNode(item) {
        if (this._isSingleSelectionMode()) {
            this.selection = [item];
        }
        else {
            if (!this.selection) {
                this.selection = [];
            }
            this.selection.push(item);
            if (this.cascadeSelection) {
                this._selectChildNodes(item);
            }
        }
        this.selectionChange.emit(this.selection);
    }
    _selectChildNodes(item) {
        if (item.childItems) {
            item.childItems.forEach((element) => {
                if (element.childItems) {
                    this._selectChildNodes(element);
                }
                const idx = this._findIndexInSelection(element);
                if (idx === -1) {
                    if (!this.selection) {
                        this.selection = [];
                    }
                    this.selection.push(element);
                }
            });
        }
    }
    _deselectNode(item) {
        if (this._isSingleSelectionMode()) {
            this.selection = [];
        }
        else {
            const idx = this._findIndexInSelection(item);
            if (idx > -1) {
                this.selection.splice(idx, 1);
            }
            if (this.cascadeSelection) {
                this._deselectChildNodes(item);
            }
        }
        this.selectionChange.emit(this.selection);
    }
    _deselectChildNodes(item) {
        if (item.childItems) {
            item.childItems.forEach((element) => {
                if (element.childItems) {
                    this._deselectChildNodes(element);
                }
                const idx = this._findIndexInSelection(element);
                if (idx > -1) {
                    this.selection.splice(idx, 1);
                }
            });
        }
    }
    _isSelected(item) {
        return this._findIndexInSelection(item) > -1;
    }
    _findIndexInSelection(item) {
        let index = -1;
        if (this.selectionMode && this.selection) {
            for (let i = 0; i < this.selection.length; i++) {
                const selectedItem = this.selection[i];
                if (selectedItem.id === item.id) {
                    index = i;
                    break;
                }
            }
        }
        return index;
    }
    _isSingleSelectionMode() {
        return this.selectionMode && this.selectionMode === "single";
    }
    _syncSelectionForAll() {
        this.items.forEach((element) => {
            this._syncSelection(element);
        });
    }
    _syncSelection(item) {
        if (!item.id) {
            throw new Error("NpTreeViewItem.id must be defined for selection");
        }
        if (item.childItems && item.childItems.length) {
            for (const child of item.childItems) {
                this._syncSelection(child);
            }
            let selectedCount = 0;
            let childPartiallySelected = false;
            for (const child of item.childItems) {
                if (this._isSelected(child)) {
                    selectedCount++;
                }
                if (child.partiallySelected) {
                    childPartiallySelected = true;
                }
            }
            if ((childPartiallySelected || selectedCount > 0) &&
                selectedCount !== item.childItems.length) {
                item.partiallySelected = true;
            }
            else {
                item.partiallySelected = false;
            }
            if (!this._isSingleSelectionMode()) {
                const idx = this._findIndexInSelection(item);
                if (selectedCount === item.childItems.length) {
                    if (idx === -1) {
                        if (!this.selection) {
                            this.selection = [];
                        }
                        this.selection.push(item);
                    }
                }
                else {
                    if (idx > -1) {
                        this.selection.splice(idx, 1);
                    }
                }
            }
        }
    }
    _selectAll(item) {
        if (!item.id) {
            throw new Error("NpTreeViewItem.id must be defined for selection");
        }
        this.selection.push(item);
        if (item.childItems) {
            item.childItems.forEach((element) => {
                this._selectAll(element);
            });
        }
    }
    _trackBy(index) {
        return index;
    }
    _removePartialSelectionAll() {
        this.items.forEach((element) => {
            this._removePartialSelection(element);
        });
    }
    _removePartialSelection(element) {
        element.partiallySelected = false;
        if (element.childItems) {
            element.childItems.forEach((item) => {
                this._removePartialSelection(item);
            });
        }
    }
}
NpTreeViewComponent.controlCount = 1;
NpTreeViewComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTreeViewComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NpTreeViewComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpTreeViewComponent, selector: "np-tree-view", inputs: { items: "items", itemTemplate: "itemTemplate", selectionMode: "selectionMode", cascadeSelection: "cascadeSelection", selection: "selection", styleClass: "styleClass", inputId: "inputId" }, outputs: { selectionChange: "selectionChange", onClick: "onClick", onExpand: "onExpand", onCollapse: "onCollapse", onExpandAll: "onExpandAll", onCollapseAll: "onCollapseAll", onSelect: "onSelect", onDeselect: "onDeselect" }, usesOnChanges: true, ngImport: i0, template: "<ul role=\"tree\" [ngClass]=\"'np-treeview'\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <ng-container *ngTemplateOutlet=\"treeViewTemplate; context: { items: items }\">\r\n  </ng-container>\r\n</ul>\r\n<ng-template #treeViewTemplate let-items=\"items\">\r\n  <li class=\"np-treeview-node\" role=\"treeitem\" *ngFor=\"let item of items; trackBy: _trackBy\"\r\n    [attr.aria-expanded]=\"item.isExpanded\">\r\n    <ng-container *ngIf=\"item.childItems\">\r\n      <button class=\"np-btn-icon\" type=\"button\" tabindex=\"0\" (click)=\"_toggle(item)\" [ngClass]=\"{\r\n          'np-treeview-expand': !item.isExpanded,\r\n          'np-treeview-collapse': item.isExpanded\r\n        }\">\r\n        <svg class=\"np-icon\" *ngIf=\"item.isExpanded\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M12 8l-6 6 1.41 1.41L12 10.83l4.59 4.58L18 14z\"></path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n          `\r\n        </svg>\r\n        <svg class=\"np-icon\" *ngIf=\"!item.isExpanded\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M16.59 8.59L12 13.17 7.41 8.59 6 10l6 6 6-6z\"></path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n    </ng-container>\r\n    <div class=\"np-treeview-label\" [ngClass]=\"{ 'np-treeview-selection': selectionMode }\">\r\n      <np-checkbox *ngIf=\"selectionMode\" [ngModel]=\"_isSelected(item)\" [styleClass]=\"'np-treeview-checkbox'\"\r\n        [indeterminate]=\"item.partiallySelected\" (onChange)=\"_changeSelection($event, item)\">\r\n      </np-checkbox>\r\n      <span (click)=\"_onClick(item)\">\r\n        <ng-container *ngIf=\"!itemTemplate; else treeViewLabelTemp\">\r\n          <i *ngIf=\"item.iconCss\" [class]=\"item.iconCss\"></i>{{ item.label }}\r\n        </ng-container>\r\n        <ng-template #treeViewLabelTemp [ngTemplateOutlet]=\"itemTemplate\" [ngTemplateOutletContext]=\"{ item: item }\">\r\n        </ng-template>\r\n      </span>\r\n    </div>\r\n    <ul class=\"np-treeview-sub\" role=\"group\" *ngIf=\"item.childItems && item.isExpanded\">\r\n      <ng-container *ngTemplateOutlet=\"\r\n          treeViewTemplate;\r\n          context: { items: item.childItems }\r\n        \">\r\n      </ng-container>\r\n    </ul>\r\n  </li>\r\n</ng-template>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i3.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: NpCheckboxComponent, selector: "np-checkbox", inputs: ["label", "indeterminate", "readOnly", "autoFocus", "tabIndex", "styleClass", "inputId"], outputs: ["onChange", "onFocus", "onBlur"] }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTreeViewComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-tree-view", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, template: "<ul role=\"tree\" [ngClass]=\"'np-treeview'\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <ng-container *ngTemplateOutlet=\"treeViewTemplate; context: { items: items }\">\r\n  </ng-container>\r\n</ul>\r\n<ng-template #treeViewTemplate let-items=\"items\">\r\n  <li class=\"np-treeview-node\" role=\"treeitem\" *ngFor=\"let item of items; trackBy: _trackBy\"\r\n    [attr.aria-expanded]=\"item.isExpanded\">\r\n    <ng-container *ngIf=\"item.childItems\">\r\n      <button class=\"np-btn-icon\" type=\"button\" tabindex=\"0\" (click)=\"_toggle(item)\" [ngClass]=\"{\r\n          'np-treeview-expand': !item.isExpanded,\r\n          'np-treeview-collapse': item.isExpanded\r\n        }\">\r\n        <svg class=\"np-icon\" *ngIf=\"item.isExpanded\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M12 8l-6 6 1.41 1.41L12 10.83l4.59 4.58L18 14z\"></path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n          `\r\n        </svg>\r\n        <svg class=\"np-icon\" *ngIf=\"!item.isExpanded\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M16.59 8.59L12 13.17 7.41 8.59 6 10l6 6 6-6z\"></path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n    </ng-container>\r\n    <div class=\"np-treeview-label\" [ngClass]=\"{ 'np-treeview-selection': selectionMode }\">\r\n      <np-checkbox *ngIf=\"selectionMode\" [ngModel]=\"_isSelected(item)\" [styleClass]=\"'np-treeview-checkbox'\"\r\n        [indeterminate]=\"item.partiallySelected\" (onChange)=\"_changeSelection($event, item)\">\r\n      </np-checkbox>\r\n      <span (click)=\"_onClick(item)\">\r\n        <ng-container *ngIf=\"!itemTemplate; else treeViewLabelTemp\">\r\n          <i *ngIf=\"item.iconCss\" [class]=\"item.iconCss\"></i>{{ item.label }}\r\n        </ng-container>\r\n        <ng-template #treeViewLabelTemp [ngTemplateOutlet]=\"itemTemplate\" [ngTemplateOutletContext]=\"{ item: item }\">\r\n        </ng-template>\r\n      </span>\r\n    </div>\r\n    <ul class=\"np-treeview-sub\" role=\"group\" *ngIf=\"item.childItems && item.isExpanded\">\r\n      <ng-container *ngTemplateOutlet=\"\r\n          treeViewTemplate;\r\n          context: { items: item.childItems }\r\n        \">\r\n      </ng-container>\r\n    </ul>\r\n  </li>\r\n</ng-template>" }]
        }], propDecorators: { items: [{
                type: Input
            }], itemTemplate: [{
                type: Input
            }], selectionMode: [{
                type: Input
            }], cascadeSelection: [{
                type: Input
            }], selection: [{
                type: Input
            }], selectionChange: [{
                type: Output
            }], styleClass: [{
                type: Input
            }], inputId: [{
                type: Input
            }], onClick: [{
                type: Output
            }], onExpand: [{
                type: Output
            }], onCollapse: [{
                type: Output
            }], onExpandAll: [{
                type: Output
            }], onCollapseAll: [{
                type: Output
            }], onSelect: [{
                type: Output
            }], onDeselect: [{
                type: Output
            }] } });

class NpTreeViewModule {
}
NpTreeViewModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTreeViewModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpTreeViewModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpTreeViewModule, declarations: [NpTreeViewComponent], imports: [CommonModule, FormsModule, NpCheckboxModule], exports: [NpTreeViewComponent] });
NpTreeViewModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTreeViewModule, imports: [CommonModule, FormsModule, NpCheckboxModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTreeViewModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpTreeViewComponent],
                    imports: [CommonModule, FormsModule, NpCheckboxModule],
                    exports: [NpTreeViewComponent],
                }]
        }] });

class NpTreeViewItem {
    constructor(item) {
        this.label = item.label;
        this.id = item.id;
        this.childItems = item.childItems;
        this.isExpanded = item.isExpanded;
        this.data = item.data;
        this.iconCss = item.iconCss;
    }
}

class NpFileUploadComponent {
    constructor() {
        this.showFileSize = true;
        this.inputId = `np-file-upload_${NpFileUploadComponent.controlCount++}`;
        this.onChange = new EventEmitter();
        this.onFocus = new EventEmitter();
        this.onBlur = new EventEmitter();
        this.isDisabled = false;
        this.focused = false;
        this.onChangeCallback = () => { };
        this.onTouchedCallback = () => { };
    }
    get value() {
        return this.innerValue ? this.innerValue : null;
    }
    set value(v) {
        if (v !== this.innerValue) {
            this.innerValue = v;
            this.onChangeCallback(v);
            this.onChange.emit(v);
        }
    }
    writeValue(v) {
        if (v !== this.innerValue) {
            this.innerValue = v;
        }
    }
    registerOnChange(fn) {
        this.onChangeCallback = fn;
    }
    registerOnTouched(fn) {
        this.onTouchedCallback = fn;
    }
    setDisabledState(isDisabled) {
        this.isDisabled = isDisabled;
    }
    validate(control) {
        const value = control.value || [];
        if (this.extensions) {
            let isInValidExtension = false;
            const exts = this.extensions.split(",");
            value.forEach((element) => {
                if (exts.indexOf(element.name.split(".")[1]) === -1) {
                    isInValidExtension = true;
                }
            });
            if (isInValidExtension) {
                return { extensions: { valid: false } };
            }
        }
        if (this.size) {
            let isInValidSize = false;
            value.forEach((element) => {
                if (element.size > this.size) {
                    isInValidSize = true;
                }
            });
            if (isInValidSize) {
                return { size: { valid: false } };
            }
        }
        if (this.multiple && this.totalSize) {
            let totalSize = 0;
            value.forEach((element) => {
                totalSize = totalSize + element.size;
            });
            if (totalSize > this.totalSize) {
                return { totalSize: { valid: false } };
            }
        }
        if (this.maxFiles) {
            if (value.length > this.maxFiles) {
                return { maxFiles: { valid: false } };
            }
        }
    }
    focus() {
        this.inputViewChild.nativeElement.focus();
    }
    _clear() {
        if (this.isDisabled || this.readOnly) {
            return;
        }
        this.value = null;
    }
    _onFileSelected($event) {
        if (this.isDisabled || this.readOnly) {
            return;
        }
        if (this.multiple) {
            const newFiles = Array.from($event.target.files);
            if (newFiles.length > 0) {
                if (this.value && this.value.length > 0) {
                    this.value = this.value.concat(newFiles);
                }
                else {
                    this.value = newFiles;
                }
            }
        }
        else {
            this.value = Array.from($event.target.files);
        }
        this.fileUploadInput.nativeElement.value = "";
    }
    _formatBytes(file, decimals = 2) {
        const bytes = file.size;
        if (bytes === 0) {
            return "0 Bytes";
        }
        const k = 1024;
        const dm = decimals < 0 ? 0 : decimals;
        const sizes = ["Bytes", "KB", "MB", "GB"];
        const i = Math.floor(Math.log(bytes) / Math.log(k));
        return parseFloat((bytes / Math.pow(k, i)).toFixed(dm)) + " " + sizes[i];
    }
    _remove(idx) {
        this.value = this.value.filter((element, index) => index !== idx);
    }
    _onBlur($event) {
        this.focused = false;
        this.onTouchedCallback();
        this.onBlur.emit($event);
    }
    _onFocus($event) {
        this.focused = true;
        this.onFocus.emit($event);
    }
    _getLabel() {
        return this.uploadButtonLabel
            ? this.uploadButtonLabel
            : this.multiple
                ? "Choose_Files"
                : "Choose_File";
    }
    _getInputId() {
        return this.inputId + "_input";
    }
}
NpFileUploadComponent.controlCount = 1;
NpFileUploadComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpFileUploadComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NpFileUploadComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpFileUploadComponent, selector: "np-file-upload", inputs: { multiple: "multiple", extensions: "extensions", accept: "accept", size: "size", totalSize: "totalSize", maxFiles: "maxFiles", uploadButtonLabel: "uploadButtonLabel", showFileSize: "showFileSize", readOnly: "readOnly", autoFocus: "autoFocus", tabIndex: "tabIndex", styleClass: "styleClass", inputId: "inputId" }, outputs: { onChange: "onChange", onFocus: "onFocus", onBlur: "onBlur" }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => NpFileUploadComponent),
            multi: true,
        },
        {
            provide: NG_VALIDATORS,
            useExisting: forwardRef(() => NpFileUploadComponent),
            multi: true,
        },
    ], viewQueries: [{ propertyName: "fileUploadInput", first: true, predicate: ["fileUploadInput"], descendants: true }, { propertyName: "inputViewChild", first: true, predicate: ["control"], descendants: true }], ngImport: i0, template: "<div [ngClass]=\"{\r\n    'np-file-upload': true,\r\n    'np-disabled': isDisabled,\r\n    'np-readonly': readOnly\r\n  }\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-input-group\" [ngClass]=\"{ 'np-focused': focused }\">\r\n    <label class=\"np-file-label\" tabindex=\"auto\" [attr.for]=\"_getInputId()\">\r\n      <input class=\"np-file-input\" type=\"file\" #control [attr.id]=\"_getInputId()\" [attr.accept]=\"accept\"\r\n        [npAutofocus]=\"autoFocus\" [attr.tabindex]=\"tabIndex\" [readonly]=\"readOnly\" [disabled]=\"isDisabled\"\r\n        [multiple]=\"multiple\" #fileUploadInput (change)=\"_onFileSelected($event)\" (blur)=\"_onBlur($event)\"\r\n        (focus)=\"_onFocus($event)\" />\r\n      <span class=\"np-file-btn\">{{ _getLabel() | npTranslate }}</span>\r\n    </label>\r\n    <div class=\"np-input-group-append\" *ngIf=\"value && value.length > 1\">\r\n      <button class=\"np-btn-icon np-btn-clear\" type=\"button\" tabindex=\"-1\" (click)=\"_clear()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path\r\n            d=\"M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z\">\r\n          </path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n  </div>\r\n</div>\r\n<ul class=\"np-list np-file-upload-list\" *ngIf=\"value && value.length > 0\">\r\n  <li class=\"np-list-item\" *ngFor=\"let file of value; let i = index\">\r\n    <span class=\"np-file-name\">\r\n      <svg class=\"np-icon mr-1\" viewBox=\"0 0 24 24\">\r\n        <path d=\"M0 0h24v24H0V0z\" fill=\"none\"></path>\r\n        <path d=\"M14 2H6c-1.1 0-1.99.9-1.99 2L4 20c0 1.1.89 2 1.99 2H18c1.1 0 2-.9 2-2V8l-6-6zM6 20V4h7v5h5v11H6z\">\r\n        </path>\r\n      </svg>\r\n      <a [innerHTML]=\"file.name\"></a>\r\n    </span>\r\n    <span *ngIf=\"showFileSize\" [innerHTML]=\"_formatBytes(file)\"></span>\r\n    <button class=\"np-file-remove-btn\" type=\"button\" tabindex=\"-1\" (click)=\"_remove(i)\">\r\n      <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n        <path d=\"M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z\">\r\n        </path>\r\n        <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n      </svg>\r\n    </button>\r\n  </li>\r\n</ul>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: NpAutofocusDirective, selector: "[npAutofocus]", inputs: ["npAutofocus"] }, { kind: "pipe", type: NpTranslatePipe, name: "npTranslate" }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpFileUploadComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-file-upload", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => NpFileUploadComponent),
                            multi: true,
                        },
                        {
                            provide: NG_VALIDATORS,
                            useExisting: forwardRef(() => NpFileUploadComponent),
                            multi: true,
                        },
                    ], template: "<div [ngClass]=\"{\r\n    'np-file-upload': true,\r\n    'np-disabled': isDisabled,\r\n    'np-readonly': readOnly\r\n  }\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-input-group\" [ngClass]=\"{ 'np-focused': focused }\">\r\n    <label class=\"np-file-label\" tabindex=\"auto\" [attr.for]=\"_getInputId()\">\r\n      <input class=\"np-file-input\" type=\"file\" #control [attr.id]=\"_getInputId()\" [attr.accept]=\"accept\"\r\n        [npAutofocus]=\"autoFocus\" [attr.tabindex]=\"tabIndex\" [readonly]=\"readOnly\" [disabled]=\"isDisabled\"\r\n        [multiple]=\"multiple\" #fileUploadInput (change)=\"_onFileSelected($event)\" (blur)=\"_onBlur($event)\"\r\n        (focus)=\"_onFocus($event)\" />\r\n      <span class=\"np-file-btn\">{{ _getLabel() | npTranslate }}</span>\r\n    </label>\r\n    <div class=\"np-input-group-append\" *ngIf=\"value && value.length > 1\">\r\n      <button class=\"np-btn-icon np-btn-clear\" type=\"button\" tabindex=\"-1\" (click)=\"_clear()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path\r\n            d=\"M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z\">\r\n          </path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n  </div>\r\n</div>\r\n<ul class=\"np-list np-file-upload-list\" *ngIf=\"value && value.length > 0\">\r\n  <li class=\"np-list-item\" *ngFor=\"let file of value; let i = index\">\r\n    <span class=\"np-file-name\">\r\n      <svg class=\"np-icon mr-1\" viewBox=\"0 0 24 24\">\r\n        <path d=\"M0 0h24v24H0V0z\" fill=\"none\"></path>\r\n        <path d=\"M14 2H6c-1.1 0-1.99.9-1.99 2L4 20c0 1.1.89 2 1.99 2H18c1.1 0 2-.9 2-2V8l-6-6zM6 20V4h7v5h5v11H6z\">\r\n        </path>\r\n      </svg>\r\n      <a [innerHTML]=\"file.name\"></a>\r\n    </span>\r\n    <span *ngIf=\"showFileSize\" [innerHTML]=\"_formatBytes(file)\"></span>\r\n    <button class=\"np-file-remove-btn\" type=\"button\" tabindex=\"-1\" (click)=\"_remove(i)\">\r\n      <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n        <path d=\"M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z\">\r\n        </path>\r\n        <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n      </svg>\r\n    </button>\r\n  </li>\r\n</ul>" }]
        }], propDecorators: { multiple: [{
                type: Input
            }], extensions: [{
                type: Input
            }], accept: [{
                type: Input
            }], size: [{
                type: Input
            }], totalSize: [{
                type: Input
            }], maxFiles: [{
                type: Input
            }], uploadButtonLabel: [{
                type: Input
            }], showFileSize: [{
                type: Input
            }], readOnly: [{
                type: Input
            }], autoFocus: [{
                type: Input
            }], tabIndex: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], inputId: [{
                type: Input
            }], onChange: [{
                type: Output
            }], onFocus: [{
                type: Output
            }], onBlur: [{
                type: Output
            }], fileUploadInput: [{
                type: ViewChild,
                args: ["fileUploadInput"]
            }], inputViewChild: [{
                type: ViewChild,
                args: ["control"]
            }] } });

class NpFileUploadModule {
}
NpFileUploadModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpFileUploadModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpFileUploadModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpFileUploadModule, declarations: [NpFileUploadComponent], imports: [CommonModule, NpAutofocusModule, NpTranslationsModule], exports: [NpFileUploadComponent] });
NpFileUploadModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpFileUploadModule, imports: [CommonModule, NpAutofocusModule, NpTranslationsModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpFileUploadModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpFileUploadComponent],
                    imports: [CommonModule, NpAutofocusModule, NpTranslationsModule],
                    exports: [NpFileUploadComponent],
                }]
        }] });

class NpSliderComponent {
    constructor() {
        this.min = 0;
        this.max = 100;
        this.step = 1;
        this.inputId = `np-slider_${NpSliderComponent.controlCount++}`;
        this.onChange = new EventEmitter();
        this.onFocus = new EventEmitter();
        this.onBlur = new EventEmitter();
        this.isDisabled = false;
        this.focused = false;
        this.onChangeCallback = () => { };
        this.onTouchedCallback = () => { };
    }
    get value() {
        return this.innerValue;
    }
    set value(v) {
        if (v !== this.innerValue) {
            this.innerValue = v;
            this.labelText = v;
            this.onChangeCallback(v);
            this.onChange.emit(v);
        }
    }
    writeValue(v) {
        if (v !== this.innerValue) {
            this.innerValue = v;
            this.labelText = v;
            this._setLeftPosition(v);
        }
    }
    registerOnChange(fn) {
        this.onChangeCallback = fn;
    }
    registerOnTouched(fn) {
        this.onTouchedCallback = fn;
    }
    setDisabledState(isDisabled) {
        this.isDisabled = isDisabled;
    }
    focus() {
        this.inputViewChild.nativeElement.focus();
    }
    _onChange($event) {
        if (this.isDisabled || this.readOnly) {
            $event.preventDefault();
            return;
        }
        this.value = $event.target.value;
    }
    _onInput($event) {
        if (this.isDisabled || this.readOnly) {
            $event.preventDefault();
            return;
        }
        this.labelText = $event.target.value;
        this._setLeftPosition(this.labelText);
    }
    _onKeyDown($event) {
        if (this.readOnly) {
            $event.preventDefault();
            return;
        }
    }
    _onBlur($event) {
        this.focused = false;
        this.onTouchedCallback();
        this.onBlur.emit($event);
    }
    _onFocus($event) {
        this.focused = true;
        this.onFocus.emit($event);
    }
    _setLeftPosition(value) {
        const val = ((value - this.min) * 100) / (this.max - this.min);
        this.style = val < 50 ? { left: `${val}%` } : { right: `${100 - val}%` };
    }
}
NpSliderComponent.controlCount = 1;
NpSliderComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpSliderComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NpSliderComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpSliderComponent, selector: "np-slider", inputs: { min: "min", max: "max", step: "step", readOnly: "readOnly", autoFocus: "autoFocus", tabIndex: "tabIndex", styleClass: "styleClass", inputId: "inputId" }, outputs: { onChange: "onChange", onFocus: "onFocus", onBlur: "onBlur" }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => NpSliderComponent),
            multi: true,
        },
    ], viewQueries: [{ propertyName: "inputViewChild", first: true, predicate: ["control"], descendants: true }], ngImport: i0, template: "<div [ngClass]=\"{\r\n    'np-slider': true,\r\n    'np-disabled': isDisabled,\r\n    'np-readonly': readOnly\r\n  }\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <input class=\"np-slider-input\" type=\"range\" #control [ngClass]=\"{ 'np-focused': focused }\" [min]=\"min\" [max]=\"max\"\r\n    [step]=\"step\" [value]=\"innerValue\" [disabled]=\"isDisabled\" [npAutofocus]=\"autoFocus\" [attr.tabindex]=\"tabIndex\"\r\n    [readonly]=\"readOnly\" [attr.aria-valuenow]=\"value\" [attr.aria-valuemin]=\"min\" [attr.aria-valuemax]=\"max\"\r\n    (change)=\"_onChange($event)\" (keydown)=\"_onKeyDown($event)\" (input)=\"_onInput($event)\" (blur)=\"_onBlur($event)\"\r\n    (focus)=\"_onFocus($event)\" />\r\n  <label *ngIf=\"labelText != undefined && labelText != null\" class=\"np-slider-label\" [ngStyle]=\"style\"\r\n    [innerHTML]=\"labelText\"></label>\r\n</div>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$1.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "directive", type: NpAutofocusDirective, selector: "[npAutofocus]", inputs: ["npAutofocus"] }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpSliderComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-slider", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => NpSliderComponent),
                            multi: true,
                        },
                    ], template: "<div [ngClass]=\"{\r\n    'np-slider': true,\r\n    'np-disabled': isDisabled,\r\n    'np-readonly': readOnly\r\n  }\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <input class=\"np-slider-input\" type=\"range\" #control [ngClass]=\"{ 'np-focused': focused }\" [min]=\"min\" [max]=\"max\"\r\n    [step]=\"step\" [value]=\"innerValue\" [disabled]=\"isDisabled\" [npAutofocus]=\"autoFocus\" [attr.tabindex]=\"tabIndex\"\r\n    [readonly]=\"readOnly\" [attr.aria-valuenow]=\"value\" [attr.aria-valuemin]=\"min\" [attr.aria-valuemax]=\"max\"\r\n    (change)=\"_onChange($event)\" (keydown)=\"_onKeyDown($event)\" (input)=\"_onInput($event)\" (blur)=\"_onBlur($event)\"\r\n    (focus)=\"_onFocus($event)\" />\r\n  <label *ngIf=\"labelText != undefined && labelText != null\" class=\"np-slider-label\" [ngStyle]=\"style\"\r\n    [innerHTML]=\"labelText\"></label>\r\n</div>" }]
        }], propDecorators: { min: [{
                type: Input
            }], max: [{
                type: Input
            }], step: [{
                type: Input
            }], readOnly: [{
                type: Input
            }], autoFocus: [{
                type: Input
            }], tabIndex: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], inputId: [{
                type: Input
            }], onChange: [{
                type: Output
            }], onFocus: [{
                type: Output
            }], onBlur: [{
                type: Output
            }], inputViewChild: [{
                type: ViewChild,
                args: ["control"]
            }] } });

class NpSliderModule {
}
NpSliderModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpSliderModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpSliderModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpSliderModule, declarations: [NpSliderComponent], imports: [CommonModule, NpAutofocusModule], exports: [NpSliderComponent] });
NpSliderModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpSliderModule, imports: [CommonModule, NpAutofocusModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpSliderModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpSliderComponent],
                    imports: [CommonModule, NpAutofocusModule],
                    exports: [NpSliderComponent],
                }]
        }] });

class NpListComponent {
    constructor(utility) {
        this.utility = utility;
        this.showTiles = false;
        this.columnSize = 4;
        this.isServerOperations = false;
        this.pageSize = 10;
        this.totalItems = 0;
        this.inputId = `np-list_${NpListComponent.controlCount++}`;
        this.selectionChange = new EventEmitter();
        this.onClick = new EventEmitter();
        this.onSelect = new EventEmitter();
        this.onDeselect = new EventEmitter();
        this.onPageChange = new EventEmitter();
    }
    selectAll() {
        if (this._isSingleSelectionMode()) {
            return;
        }
        const items = [];
        this.items.forEach((element) => {
            if (this.valueKey) {
                items.push(element[this.valueKey]);
            }
            else {
                items.push(element);
            }
        });
        this.selection = items;
        this.selectionChange.emit(this.selection);
    }
    deselectAll() {
        this.selection = [];
        this.selectionChange.emit(this.selection);
    }
    refresh() {
        this.listPaginator.refresh();
    }
    loadPage(page) {
        this.listPaginator.loadPage(page);
    }
    _onSelectItem(checked, item) {
        if (checked) {
            if (this.valueKey) {
                if (this._isSingleSelectionMode()) {
                    this.selection = [item[this.valueKey]];
                }
                else {
                    this.selection.push(item[this.valueKey]);
                }
                this.onSelect.emit(item[this.valueKey]);
            }
            else {
                if (this._isSingleSelectionMode()) {
                    this.selection = [item];
                }
                else {
                    this.selection.push(item);
                }
                this.onSelect.emit(item);
            }
        }
        else {
            const idx = this.selection.indexOf(item);
            this.selection.splice(idx, 1);
            this.onDeselect.emit(item);
        }
        this.selectionChange.emit(this.selection);
    }
    _isSelected(item) {
        return this.selectionMode && this._getSelectedIndexOfItem(item) > -1;
    }
    _getSelectedIndexOfItem(item) {
        const that = this;
        if (this.valueKey) {
            return this.selection.findIndex((element) => element === item[this.valueKey]);
        }
        return this.selection.findIndex((element) => that.utility.isEqual(element, item));
    }
    _trackBy(index) {
        return index;
    }
    _onClick(item) {
        this.onClick.emit(item);
    }
    _onPageChange(options) {
        this.onPageChange.emit(options);
    }
    _isSingleSelectionMode() {
        return this.selectionMode && this.selectionMode === "single";
    }
    _clearSelection() {
        this.deselectAll();
    }
}
NpListComponent.controlCount = 1;
NpListComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpListComponent, deps: [{ token: NpUtilityService }], target: i0.ɵɵFactoryTarget.Component });
NpListComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpListComponent, selector: "np-list", inputs: { header: "header", items: "items", itemTemplate: "itemTemplate", selectionMode: "selectionMode", valueKey: "valueKey", height: "height", orderBy: "orderBy", orderDir: "orderDir", showTiles: "showTiles", columnSize: "columnSize", isServerOperations: "isServerOperations", pageSize: "pageSize", totalItems: "totalItems", styleClass: "styleClass", inputId: "inputId", selection: "selection" }, outputs: { selectionChange: "selectionChange", onClick: "onClick", onSelect: "onSelect", onDeselect: "onDeselect", onPageChange: "onPageChange" }, viewQueries: [{ propertyName: "listPaginator", first: true, predicate: ["listPaginator"], descendants: true }], ngImport: i0, template: "<div [ngClass]=\"'np-list-wrapper'\" [style.max-height.px]=\"height\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-list-header\" *ngIf=\"header\" [innerHTML]=\"header\" [attr.id]=\"inputId + '-title'\"></div>\r\n  <ng-container *ngIf=\"!showTiles\">\r\n    <ul class=\"np-list\" role=\"listbox\" [attr.aria-labelledby]=\"inputId + '-title'\">\r\n      <ng-container *ngFor=\"\r\n          let item of items | npOrderBy: orderBy:orderDir;\r\n          let i = index;\r\n          trackBy: _trackBy\r\n        \">\r\n        <li class=\"np-list-item\" role=\"option\" [attr.aria-selected]=\"_isSelected(item)\" [ngClass]=\"{\r\n            'np-list-selectable': selectionMode,\r\n            'np-list-selected': _isSelected(item)\r\n          }\" [attr.id]=\"'np-list-item_' + (i + 1)\">\r\n          <np-checkbox *ngIf=\"selectionMode\" [ngModel]=\"_isSelected(item)\" [styleClass]=\"'np-list-checkbox'\"\r\n            (onChange)=\"_onSelectItem($event, item)\"></np-checkbox>\r\n          <div class=\"np-list-item-content\" (click)=\"_onClick(item)\">\r\n            <ng-container *ngTemplateOutlet=\"itemTemplate; context: { item: item }\">\r\n            </ng-container>\r\n          </div>\r\n        </li>\r\n      </ng-container>\r\n    </ul>\r\n  </ng-container>\r\n  <ng-container *ngIf=\"showTiles\">\r\n    <div class=\"np-tiles\">\r\n      <div class=\"np-row np-no-gutters\">\r\n        <ng-container *ngFor=\"\r\n            let item of items | npOrderBy: orderBy:orderDir;\r\n            let i = index;\r\n            trackBy: _trackBy\r\n          \">\r\n          <div class=\"np-col np-col-{{ columnSize }}\">\r\n            <div class=\"np-tiles-item\" [ngClass]=\"{\r\n                'np-tiles-selectable': selectionMode,\r\n                'np-tile-selected': _isSelected(item)\r\n              }\" [attr.id]=\"'np-tiles-item_' + (i + 1)\">\r\n              <np-checkbox *ngIf=\"selectionMode\" [ngModel]=\"_isSelected(item)\" [styleClass]=\"'np-tiles-checkbox'\"\r\n                (onChange)=\"_onSelectItem($event, item)\"></np-checkbox>\r\n              <div class=\"np-tiles-item-content\" (click)=\"_onClick(item)\">\r\n                <ng-container *ngTemplateOutlet=\"itemTemplate; context: { item: item }\">\r\n                </ng-container>\r\n              </div>\r\n            </div>\r\n          </div>\r\n        </ng-container>\r\n      </div>\r\n    </div>\r\n  </ng-container>\r\n  <ng-container *ngIf=\"isServerOperations\">\r\n    <np-paginator #listPaginator [pageSize]=\"pageSize\" [totalItems]=\"totalItems\" [styleClass]=\"'np-list-pagination'\"\r\n      (onPageChange)=\"_onPageChange($event)\" (onRefresh)=\"_clearSelection()\" (onPageSizeChange)=\"_clearSelection()\">\r\n    </np-paginator>\r\n  </ng-container>\r\n</div>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i3.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: NpPaginatorComponent, selector: "np-paginator", inputs: ["pageSize", "totalItems", "currentPage", "showPageSize", "showTotal", "styleClass", "inputId"], outputs: ["onPageChange", "onPageSizeChange", "onRefresh"] }, { kind: "component", type: NpCheckboxComponent, selector: "np-checkbox", inputs: ["label", "indeterminate", "readOnly", "autoFocus", "tabIndex", "styleClass", "inputId"], outputs: ["onChange", "onFocus", "onBlur"] }, { kind: "pipe", type: NpOrderByPipe, name: "npOrderBy" }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpListComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-list", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, template: "<div [ngClass]=\"'np-list-wrapper'\" [style.max-height.px]=\"height\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-list-header\" *ngIf=\"header\" [innerHTML]=\"header\" [attr.id]=\"inputId + '-title'\"></div>\r\n  <ng-container *ngIf=\"!showTiles\">\r\n    <ul class=\"np-list\" role=\"listbox\" [attr.aria-labelledby]=\"inputId + '-title'\">\r\n      <ng-container *ngFor=\"\r\n          let item of items | npOrderBy: orderBy:orderDir;\r\n          let i = index;\r\n          trackBy: _trackBy\r\n        \">\r\n        <li class=\"np-list-item\" role=\"option\" [attr.aria-selected]=\"_isSelected(item)\" [ngClass]=\"{\r\n            'np-list-selectable': selectionMode,\r\n            'np-list-selected': _isSelected(item)\r\n          }\" [attr.id]=\"'np-list-item_' + (i + 1)\">\r\n          <np-checkbox *ngIf=\"selectionMode\" [ngModel]=\"_isSelected(item)\" [styleClass]=\"'np-list-checkbox'\"\r\n            (onChange)=\"_onSelectItem($event, item)\"></np-checkbox>\r\n          <div class=\"np-list-item-content\" (click)=\"_onClick(item)\">\r\n            <ng-container *ngTemplateOutlet=\"itemTemplate; context: { item: item }\">\r\n            </ng-container>\r\n          </div>\r\n        </li>\r\n      </ng-container>\r\n    </ul>\r\n  </ng-container>\r\n  <ng-container *ngIf=\"showTiles\">\r\n    <div class=\"np-tiles\">\r\n      <div class=\"np-row np-no-gutters\">\r\n        <ng-container *ngFor=\"\r\n            let item of items | npOrderBy: orderBy:orderDir;\r\n            let i = index;\r\n            trackBy: _trackBy\r\n          \">\r\n          <div class=\"np-col np-col-{{ columnSize }}\">\r\n            <div class=\"np-tiles-item\" [ngClass]=\"{\r\n                'np-tiles-selectable': selectionMode,\r\n                'np-tile-selected': _isSelected(item)\r\n              }\" [attr.id]=\"'np-tiles-item_' + (i + 1)\">\r\n              <np-checkbox *ngIf=\"selectionMode\" [ngModel]=\"_isSelected(item)\" [styleClass]=\"'np-tiles-checkbox'\"\r\n                (onChange)=\"_onSelectItem($event, item)\"></np-checkbox>\r\n              <div class=\"np-tiles-item-content\" (click)=\"_onClick(item)\">\r\n                <ng-container *ngTemplateOutlet=\"itemTemplate; context: { item: item }\">\r\n                </ng-container>\r\n              </div>\r\n            </div>\r\n          </div>\r\n        </ng-container>\r\n      </div>\r\n    </div>\r\n  </ng-container>\r\n  <ng-container *ngIf=\"isServerOperations\">\r\n    <np-paginator #listPaginator [pageSize]=\"pageSize\" [totalItems]=\"totalItems\" [styleClass]=\"'np-list-pagination'\"\r\n      (onPageChange)=\"_onPageChange($event)\" (onRefresh)=\"_clearSelection()\" (onPageSizeChange)=\"_clearSelection()\">\r\n    </np-paginator>\r\n  </ng-container>\r\n</div>" }]
        }], ctorParameters: function () { return [{ type: NpUtilityService }]; }, propDecorators: { header: [{
                type: Input
            }], items: [{
                type: Input
            }], itemTemplate: [{
                type: Input
            }], selectionMode: [{
                type: Input
            }], valueKey: [{
                type: Input
            }], height: [{
                type: Input
            }], orderBy: [{
                type: Input
            }], orderDir: [{
                type: Input
            }], showTiles: [{
                type: Input
            }], columnSize: [{
                type: Input
            }], isServerOperations: [{
                type: Input
            }], pageSize: [{
                type: Input
            }], totalItems: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], inputId: [{
                type: Input
            }], selection: [{
                type: Input
            }], selectionChange: [{
                type: Output
            }], onClick: [{
                type: Output
            }], onSelect: [{
                type: Output
            }], onDeselect: [{
                type: Output
            }], onPageChange: [{
                type: Output
            }], listPaginator: [{
                type: ViewChild,
                args: ["listPaginator"]
            }] } });

class NpListModule {
}
NpListModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpListModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpListModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpListModule, declarations: [NpListComponent], imports: [CommonModule,
        FormsModule,
        NpPaginatorModule,
        NpCheckboxModule,
        NpOrderByModule], exports: [NpListComponent] });
NpListModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpListModule, imports: [CommonModule,
        FormsModule,
        NpPaginatorModule,
        NpCheckboxModule,
        NpOrderByModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpListModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpListComponent],
                    imports: [
                        CommonModule,
                        FormsModule,
                        NpPaginatorModule,
                        NpCheckboxModule,
                        NpOrderByModule,
                    ],
                    exports: [NpListComponent],
                }]
        }] });

class NpVirtualScrollComponent {
    constructor() {
        this.inputId = `np-virtualscroll_${NpVirtualScrollComponent.controlCount++}`;
        this.loadData = new EventEmitter();
        this.loadedPages = [];
    }
    scrollToIndex(idx) {
        this.viewPort.scrollToIndex(idx);
    }
    scrollToOffset(offset) {
        this.viewPort.scrollToOffset(offset);
    }
    _onScrollIndexChange(index) {
        const pageRange = this._createPageRange(Math.floor(index / this.pageSize));
        pageRange.forEach((page) => this._loadPage(page));
    }
    _loadPage(page) {
        if (this.loadedPages.indexOf(page) === -1) {
            this.loadData.emit({ first: this.pageSize * page, rows: this.pageSize });
            this.loadedPages.push(page);
        }
    }
    _createPageRange(page) {
        const range = [];
        if (page !== 0) {
            range.push(page - 1);
        }
        range.push(page);
        if (page !== Math.ceil(this.items.length / this.pageSize) - 1) {
            range.push(page + 1);
        }
        return range;
    }
}
NpVirtualScrollComponent.controlCount = 1;
NpVirtualScrollComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpVirtualScrollComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NpVirtualScrollComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpVirtualScrollComponent, selector: "np-virtual-scroll", inputs: { header: "header", items: "items", pageSize: "pageSize", itemHeight: "itemHeight", template: "template", styleClass: "styleClass", inputId: "inputId" }, outputs: { loadData: "loadData" }, viewQueries: [{ propertyName: "viewPort", first: true, predicate: CdkVirtualScrollViewport, descendants: true }], ngImport: i0, template: "<div\r\n  [ngClass]=\"'np-virtual-scroll-wrapper'\"\r\n  [class]=\"styleClass\"\r\n  [attr.id]=\"inputId\"\r\n>\r\n  <div\r\n    class=\"np-virtual-scroll-header\"\r\n    *ngIf=\"header\"\r\n    [innerHTML]=\"header\"\r\n    [attr.id]=\"inputId + '-title'\"\r\n  ></div>\r\n  <div\r\n    role=\"listbox\"\r\n    [ngClass]=\"'np-virtual-scroll'\"\r\n    [attr.aria-labelledby]=\"inputId + '-title'\"\r\n  >\r\n    <cdk-virtual-scroll-viewport\r\n      [itemSize]=\"itemHeight\"\r\n      (scrolledIndexChange)=\"_onScrollIndexChange($event)\"\r\n      [style.height.px]=\"pageSize * itemHeight\"\r\n    >\r\n      <div\r\n        class=\"np-virtual-scroll-item\"\r\n        role=\"option\"\r\n        *cdkVirtualFor=\"let item of items\"\r\n        [style.height.px]=\"itemHeight\"\r\n      >\r\n        <ng-container *ngIf=\"!item; else customTemplate\">\r\n          Loading...\r\n        </ng-container>\r\n        <ng-template\r\n          #customTemplate\r\n          [ngTemplateOutlet]=\"template\"\r\n          [ngTemplateOutletContext]=\"{ item: item }\"\r\n        >\r\n        </ng-template>\r\n      </div>\r\n    </cdk-virtual-scroll-viewport>\r\n  </div>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i2$1.CdkFixedSizeVirtualScroll, selector: "cdk-virtual-scroll-viewport[itemSize]", inputs: ["itemSize", "minBufferPx", "maxBufferPx"] }, { kind: "directive", type: i2$1.CdkVirtualForOf, selector: "[cdkVirtualFor][cdkVirtualForOf]", inputs: ["cdkVirtualForOf", "cdkVirtualForTrackBy", "cdkVirtualForTemplate", "cdkVirtualForTemplateCacheSize"] }, { kind: "component", type: i2$1.CdkVirtualScrollViewport, selector: "cdk-virtual-scroll-viewport", inputs: ["orientation", "appendOnly"], outputs: ["scrolledIndexChange"] }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpVirtualScrollComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-virtual-scroll", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, template: "<div\r\n  [ngClass]=\"'np-virtual-scroll-wrapper'\"\r\n  [class]=\"styleClass\"\r\n  [attr.id]=\"inputId\"\r\n>\r\n  <div\r\n    class=\"np-virtual-scroll-header\"\r\n    *ngIf=\"header\"\r\n    [innerHTML]=\"header\"\r\n    [attr.id]=\"inputId + '-title'\"\r\n  ></div>\r\n  <div\r\n    role=\"listbox\"\r\n    [ngClass]=\"'np-virtual-scroll'\"\r\n    [attr.aria-labelledby]=\"inputId + '-title'\"\r\n  >\r\n    <cdk-virtual-scroll-viewport\r\n      [itemSize]=\"itemHeight\"\r\n      (scrolledIndexChange)=\"_onScrollIndexChange($event)\"\r\n      [style.height.px]=\"pageSize * itemHeight\"\r\n    >\r\n      <div\r\n        class=\"np-virtual-scroll-item\"\r\n        role=\"option\"\r\n        *cdkVirtualFor=\"let item of items\"\r\n        [style.height.px]=\"itemHeight\"\r\n      >\r\n        <ng-container *ngIf=\"!item; else customTemplate\">\r\n          Loading...\r\n        </ng-container>\r\n        <ng-template\r\n          #customTemplate\r\n          [ngTemplateOutlet]=\"template\"\r\n          [ngTemplateOutletContext]=\"{ item: item }\"\r\n        >\r\n        </ng-template>\r\n      </div>\r\n    </cdk-virtual-scroll-viewport>\r\n  </div>\r\n</div>\r\n" }]
        }], propDecorators: { header: [{
                type: Input
            }], items: [{
                type: Input
            }], pageSize: [{
                type: Input
            }], itemHeight: [{
                type: Input
            }], template: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], inputId: [{
                type: Input
            }], loadData: [{
                type: Output
            }], viewPort: [{
                type: ViewChild,
                args: [CdkVirtualScrollViewport]
            }] } });

class NpVirtualScrollModule {
}
NpVirtualScrollModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpVirtualScrollModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpVirtualScrollModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpVirtualScrollModule, declarations: [NpVirtualScrollComponent], imports: [CommonModule, ScrollingModule], exports: [NpVirtualScrollComponent] });
NpVirtualScrollModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpVirtualScrollModule, imports: [CommonModule, ScrollingModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpVirtualScrollModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpVirtualScrollComponent],
                    imports: [CommonModule, ScrollingModule],
                    exports: [NpVirtualScrollComponent],
                }]
        }] });

class NpStepsComponent extends CdkStepper {
    constructor() {
        super(...arguments);
        this.inputId = `np-steps_${NpStepsComponent.controlCount++}`;
    }
    _onClick(index) {
        this.selectedIndex = index;
    }
    _isTemplate(step) {
        return step.labelTemplate instanceof TemplateRef;
    }
    _getTitleId(step) {
        return step.inputId + "_title";
    }
    _getBodyId(step) {
        return step.inputId + "_body";
    }
}
NpStepsComponent.controlCount = 1;
NpStepsComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpStepsComponent, deps: null, target: i0.ɵɵFactoryTarget.Component });
NpStepsComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpStepsComponent, selector: "np-steps", inputs: { stretchLabels: "stretchLabels", verticalSteps: "verticalSteps", styleClass: "styleClass", inputId: "inputId" }, providers: [{ provide: CdkStepper, useExisting: NpStepsComponent }], usesInheritance: true, ngImport: i0, template: "<div role=\"tablist\" *ngIf=\"!verticalSteps\" [ngClass]=\"{ 'np-steps': true }\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-steps-header\" [ngClass]=\"{ 'np-steps-header-stretch': stretchLabels }\">\r\n    <ng-container *ngFor=\"let step of steps; let i = index\">\r\n      <button class=\"np-step-title\" role=\"tab\" [ngClass]=\"{\r\n          'np-step-done': step.completed,\r\n          'np-step-error': step.hasError,\r\n          'np-step-active': selectedIndex === i\r\n        }\" [attr.tabindex]=\"step.disabled ? '-1' : '0'\" [attr.id]=\"_getTitleId(step)\"\r\n        [attr.aria-selected]=\"step.active\" [attr.aria-controls]=\"_getBodyId(step)\" (click)=\"_onClick(i)\">\r\n        <ng-container *ngIf=\"!_isTemplate(step); else stepLabelTemp\">\r\n          <a class=\"np-step-number\" *ngIf=\"!step.iconCss\">{{ i + 1 }}</a>\r\n          <i *ngIf=\"step.iconCss\" [class]=\"step.iconCss\"></i>\r\n          <span [innerHTML]=\"step.label\"></span>\r\n        </ng-container>\r\n        <ng-template #stepLabelTemp [ngTemplateOutlet]=\"step.labelTemplate\">\r\n        </ng-template>\r\n      </button>\r\n    </ng-container>\r\n  </div>\r\n  <div class=\"np-step-body\" role=\"tabpanel\" [attr.id]=\"_getBodyId(selected)\"\r\n    [attr.aria-labelledby]=\"_getTitleId(selected)\">\r\n    <ng-container [ngTemplateOutlet]=\"selected.content\"></ng-container>\r\n  </div>\r\n</div>\r\n\r\n<div role=\"tablist\" *ngIf=\"verticalSteps\" [ngClass]=\"'np-steps np-steps-vertical'\" [class]=\"styleClass\"\r\n  [attr.id]=\"inputId\">\r\n  <div class=\"np-steps-header\">\r\n    <ng-container *ngFor=\"let step of steps; let i = index\">\r\n      <button class=\"np-step-title\" role=\"tab\" [ngClass]=\"{\r\n          'np-step-done': step.completed,\r\n          'np-step-error': step.hasError,\r\n          'np-step-active': selectedIndex === i\r\n        }\" [attr.tabindex]=\"step.disabled ? '-1' : '0'\" [attr.id]=\"_getTitleId(step)\"\r\n        [attr.aria-selected]=\"step.active\" [attr.aria-controls]=\"_getBodyId(step)\" (click)=\"_onClick(i)\">\r\n        <ng-container *ngIf=\"!_isTemplate(step); else stepLabelTemp\">\r\n          <a class=\"np-step-number\" *ngIf=\"!step.iconCss\">{{ i + 1 }}</a>\r\n          <i *ngIf=\"step.iconCss\" [class]=\"step.iconCss\"></i>\r\n          <span [innerHTML]=\"step.label\"></span>\r\n        </ng-container>\r\n        <ng-template #stepLabelTemp [ngTemplateOutlet]=\"step.labelTemplate\">\r\n        </ng-template>\r\n      </button>\r\n      <div *ngIf=\"selectedIndex === i\" class=\"np-step-body\" role=\"tabpanel\" [attr.id]=\"_getBodyId(selected)\"\r\n        [attr.aria-labelledby]=\"_getTitleId(selected)\">\r\n        <ng-container [ngTemplateOutlet]=\"selected.content\"></ng-container>\r\n      </div>\r\n    </ng-container>\r\n  </div>\r\n</div>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpStepsComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-steps", providers: [{ provide: CdkStepper, useExisting: NpStepsComponent }], encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, template: "<div role=\"tablist\" *ngIf=\"!verticalSteps\" [ngClass]=\"{ 'np-steps': true }\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-steps-header\" [ngClass]=\"{ 'np-steps-header-stretch': stretchLabels }\">\r\n    <ng-container *ngFor=\"let step of steps; let i = index\">\r\n      <button class=\"np-step-title\" role=\"tab\" [ngClass]=\"{\r\n          'np-step-done': step.completed,\r\n          'np-step-error': step.hasError,\r\n          'np-step-active': selectedIndex === i\r\n        }\" [attr.tabindex]=\"step.disabled ? '-1' : '0'\" [attr.id]=\"_getTitleId(step)\"\r\n        [attr.aria-selected]=\"step.active\" [attr.aria-controls]=\"_getBodyId(step)\" (click)=\"_onClick(i)\">\r\n        <ng-container *ngIf=\"!_isTemplate(step); else stepLabelTemp\">\r\n          <a class=\"np-step-number\" *ngIf=\"!step.iconCss\">{{ i + 1 }}</a>\r\n          <i *ngIf=\"step.iconCss\" [class]=\"step.iconCss\"></i>\r\n          <span [innerHTML]=\"step.label\"></span>\r\n        </ng-container>\r\n        <ng-template #stepLabelTemp [ngTemplateOutlet]=\"step.labelTemplate\">\r\n        </ng-template>\r\n      </button>\r\n    </ng-container>\r\n  </div>\r\n  <div class=\"np-step-body\" role=\"tabpanel\" [attr.id]=\"_getBodyId(selected)\"\r\n    [attr.aria-labelledby]=\"_getTitleId(selected)\">\r\n    <ng-container [ngTemplateOutlet]=\"selected.content\"></ng-container>\r\n  </div>\r\n</div>\r\n\r\n<div role=\"tablist\" *ngIf=\"verticalSteps\" [ngClass]=\"'np-steps np-steps-vertical'\" [class]=\"styleClass\"\r\n  [attr.id]=\"inputId\">\r\n  <div class=\"np-steps-header\">\r\n    <ng-container *ngFor=\"let step of steps; let i = index\">\r\n      <button class=\"np-step-title\" role=\"tab\" [ngClass]=\"{\r\n          'np-step-done': step.completed,\r\n          'np-step-error': step.hasError,\r\n          'np-step-active': selectedIndex === i\r\n        }\" [attr.tabindex]=\"step.disabled ? '-1' : '0'\" [attr.id]=\"_getTitleId(step)\"\r\n        [attr.aria-selected]=\"step.active\" [attr.aria-controls]=\"_getBodyId(step)\" (click)=\"_onClick(i)\">\r\n        <ng-container *ngIf=\"!_isTemplate(step); else stepLabelTemp\">\r\n          <a class=\"np-step-number\" *ngIf=\"!step.iconCss\">{{ i + 1 }}</a>\r\n          <i *ngIf=\"step.iconCss\" [class]=\"step.iconCss\"></i>\r\n          <span [innerHTML]=\"step.label\"></span>\r\n        </ng-container>\r\n        <ng-template #stepLabelTemp [ngTemplateOutlet]=\"step.labelTemplate\">\r\n        </ng-template>\r\n      </button>\r\n      <div *ngIf=\"selectedIndex === i\" class=\"np-step-body\" role=\"tabpanel\" [attr.id]=\"_getBodyId(selected)\"\r\n        [attr.aria-labelledby]=\"_getTitleId(selected)\">\r\n        <ng-container [ngTemplateOutlet]=\"selected.content\"></ng-container>\r\n      </div>\r\n    </ng-container>\r\n  </div>\r\n</div>" }]
        }], propDecorators: { stretchLabels: [{
                type: Input
            }], verticalSteps: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], inputId: [{
                type: Input
            }] } });

class NpStepComponent extends CdkStep {
    constructor(stepper, stepperOptions) {
        super(stepper, stepperOptions);
        this.inputId = `np-step_${NpStepComponent.controlCount++}`;
    }
}
NpStepComponent.controlCount = 1;
NpStepComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpStepComponent, deps: [{ token: forwardRef(() => NpStepsComponent) }, { token: STEPPER_GLOBAL_OPTIONS, optional: true }], target: i0.ɵɵFactoryTarget.Component });
NpStepComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpStepComponent, selector: "np-step", inputs: { labelTemplate: "labelTemplate", iconCss: "iconCss", inputId: "inputId" }, providers: [{ provide: CdkStep, useExisting: NpStepComponent }], usesInheritance: true, ngImport: i0, template: '<ng-template><div [attr.id]="inputId"><ng-content></ng-content></div></ng-template>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpStepComponent, decorators: [{
            type: Component,
            args: [{
                    selector: "np-step",
                    template: '<ng-template><div [attr.id]="inputId"><ng-content></ng-content></div></ng-template>',
                    providers: [{ provide: CdkStep, useExisting: NpStepComponent }],
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.Default,
                }]
        }], ctorParameters: function () {
        return [{ type: NpStepsComponent, decorators: [{
                        type: Inject,
                        args: [forwardRef(() => NpStepsComponent)]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [STEPPER_GLOBAL_OPTIONS]
                    }] }];
    }, propDecorators: { labelTemplate: [{
                type: Input
            }], iconCss: [{
                type: Input
            }], inputId: [{
                type: Input
            }] } });

class NpStepNext extends CdkStepperNext {
}
NpStepNext.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpStepNext, deps: null, target: i0.ɵɵFactoryTarget.Directive });
NpStepNext.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.0.1", type: NpStepNext, selector: "button[npStepNext]", inputs: { type: "type" }, host: { properties: { "type": "type" } }, usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpStepNext, decorators: [{
            type: Directive,
            args: [{
                    selector: "button[npStepNext]",
                    host: {
                        "[type]": "type",
                    },
                    inputs: ["type"],
                }]
        }] });
class NpStepPrevious extends CdkStepperPrevious {
}
NpStepPrevious.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpStepPrevious, deps: null, target: i0.ɵɵFactoryTarget.Directive });
NpStepPrevious.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.0.1", type: NpStepPrevious, selector: "button[npStepPrevious]", inputs: { type: "type" }, host: { properties: { "type": "type" } }, usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpStepPrevious, decorators: [{
            type: Directive,
            args: [{
                    selector: "button[npStepPrevious]",
                    host: {
                        "[type]": "type",
                    },
                    inputs: ["type"],
                }]
        }] });

class NpStepsModule {
}
NpStepsModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpStepsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpStepsModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpStepsModule, declarations: [NpStepsComponent, NpStepComponent, NpStepNext, NpStepPrevious], imports: [CommonModule, CdkStepperModule], exports: [NpStepsComponent, NpStepComponent, NpStepNext, NpStepPrevious] });
NpStepsModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpStepsModule, imports: [CommonModule, CdkStepperModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpStepsModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpStepsComponent, NpStepComponent, NpStepNext, NpStepPrevious],
                    imports: [CommonModule, CdkStepperModule],
                    exports: [NpStepsComponent, NpStepComponent, NpStepNext, NpStepPrevious],
                }]
        }] });

class NpCalendarComponent {
    constructor() {
        this.disableWeekDays = [];
        this.disableDates = [];
        this.isStartMonthWithMonday = false;
        this.resetEventsOnLoad = false;
        this.inputId = `np-calendar_${NpCalendarComponent.controlCount++}`;
        this.onLoadMonth = new EventEmitter();
        this.onClickDate = new EventEmitter();
        this.onClickEvent = new EventEmitter();
        this.years = [];
        this.events = [];
        this.originalWeekDays = [
            "Sunday",
            "Monday",
            "Tuesday",
            "Wednesday",
            "Thursday",
            "Friday",
            "Saturday",
        ];
        this.monthsList = [
            { key: 0, value: "January" },
            { key: 1, value: "February" },
            { key: 2, value: "March" },
            { key: 3, value: "April" },
            { key: 4, value: "May" },
            { key: 5, value: "June" },
            { key: 6, value: "July" },
            { key: 7, value: "August" },
            { key: 8, value: "September" },
            { key: 9, value: "October" },
            { key: 10, value: "November" },
            { key: 11, value: "December" },
        ];
        this.today = new Date();
        this.today.setHours(0, 0, 0, 0);
        this.currentMonth = this.today.getMonth();
        this.currentYear = this.today.getFullYear();
    }
    ngAfterContentInit() {
        if (this.isStartMonthWithMonday) {
            this.weekDays = [
                "Monday",
                "Tuesday",
                "Wednesday",
                "Thursday",
                "Friday",
                "Saturday",
                "Sunday",
            ];
        }
        else {
            this.weekDays = [
                "Sunday",
                "Monday",
                "Tuesday",
                "Wednesday",
                "Thursday",
                "Friday",
                "Saturday",
            ];
        }
        this._calculateDays();
        this._onLoad();
    }
    refresh() {
        this._calculateDays();
        this._onLoad();
    }
    addEvents(eve) {
        eve.forEach((element) => {
            this.events.push(element);
        });
        this._calculateDays();
    }
    removeEvents(eve) {
        eve.forEach((element) => {
            const idx = this._findIndexOfEvent(element);
            if (idx > -1) {
                this.events.splice(idx, 1);
            }
        });
        this._calculateDays();
    }
    _calculateDays() {
        const weeks = [];
        weeks[0] = [];
        const daysInMonth = this._getCurrentMonthData();
        const firstWeekDayOfMonth = new Date(this.currentYear, this.currentMonth, 1).getDay();
        // push extra values up to week days match to start date if month
        for (let index = 0; index < firstWeekDayOfMonth; index++) {
            weeks[0].push({ disabled: true });
        }
        if (this.isStartMonthWithMonday) {
            // if start with monday then
            if (firstWeekDayOfMonth === 0) {
                weeks[0].push({ disabled: true }, { disabled: true }, { disabled: true }, { disabled: true }, { disabled: true }, { disabled: true });
            }
            else {
                weeks[0].pop();
            }
        }
        let j = 0;
        // push all dates in month
        daysInMonth.forEach((element) => {
            if (weeks[j].length === 7) {
                j++;
                weeks[j] = [];
            }
            weeks[j].push(element);
        });
        if (weeks[j].length !== 7) {
            while (weeks[j].length !== 7) {
                weeks[j].push({ disabled: true });
            }
        }
        this.currentMonthWeeks = weeks;
    }
    _getCurrentMonthData() {
        const data = [];
        const totalDaysInMonth = this._daysInCurrentMonth();
        for (let i = 1; i <= totalDaysInMonth; i++) {
            const date = new Date(this.currentYear, this.currentMonth, i);
            data.push({
                date,
                day: i,
                disabled: this._checkIsFullDateDisabled(date),
                today: this._compareDate(this.today, date),
                events: this._getEventsForDate(date),
            });
        }
        return data;
    }
    _getEventsForDate(date) {
        if (this.events === undefined || this.events === null) {
            return null;
        }
        return this.events
            .filter((element) => this._compareDate(element.startDate, date))
            .sort((a, b) => a.startDate > b.startDate ? 1 : b.startDate > a.startDate ? -1 : 0);
    }
    _daysInCurrentMonth() {
        let days = 0;
        switch (this.currentMonth) {
            case 0: // Jan
            case 2: // Mar
            case 4: // May
            case 6: // Jul
            case 7: // Aug
            case 9: // Oct
            case 11: // Dec
                days = 31;
                break;
            case 3: // Apr
            case 5: // Jun
            case 8: // Sept
            case 10: // Nov
                days = 30;
                break;
            case 1: // Feb
                days = this.currentYear % 4 === 0 ? 29 : 28;
                break;
        }
        return days;
    }
    _checkIsFullDateDisabled(date) {
        if (date === undefined || date === null) {
            return false;
        }
        if (this._checkIsWeekDayDisabled(date.getDay())) {
            return true;
        }
        return (this.disableDates.findIndex((item) => this._compareDate(item, date))) > -1;
    }
    _checkIsWeekDayDisabled(index) {
        const day = this.originalWeekDays[index];
        return this.disableWeekDays.indexOf(day) > -1;
    }
    _prevMonth() {
        if (this.currentMonth === 0) {
            this.currentMonth = 11;
            this.currentYear = this.currentYear - 1;
        }
        else {
            this.currentMonth = this.currentMonth - 1;
        }
        this._calculateDays();
        this._onLoad();
    }
    _nextMonth() {
        if (this.currentMonth === 11) {
            this.currentMonth = 0;
            this.currentYear = this.currentYear + 1;
        }
        else {
            this.currentMonth = this.currentMonth + 1;
        }
        this._calculateDays();
        this._onLoad();
    }
    _changeYear($event) {
        this.currentYear = Number($event.target.value.trim());
        this._calculateDays();
        this._onLoad();
    }
    _selectMonth($event) {
        this.currentMonth = Number($event.target.value);
        this._calculateDays();
        this._onLoad();
    }
    _loadCurrentMonth() {
        this.currentMonth = this.today.getMonth();
        this.currentYear = this.today.getFullYear();
        this._calculateDays();
        this._onLoad();
    }
    _compareDate(dateA, dateB) {
        if (!dateA || !dateB) {
            return false;
        }
        if (dateA.getFullYear() === dateB.getFullYear() &&
            dateA.getMonth() === dateB.getMonth() &&
            dateA.getDate() === dateB.getDate()) {
            return true;
        }
        return false;
    }
    _onClickDate(date) {
        if (this._checkIsFullDateDisabled(date)) {
            return;
        }
        if (this.onClickDate) {
            this.onClickDate.emit(date);
        }
    }
    _onClickEvent($domEvent, event) {
        $domEvent.stopPropagation();
        if (this._checkIsFullDateDisabled(event.startDate)) {
            return;
        }
        if (this.onClickEvent) {
            this.onClickEvent.emit(event);
        }
    }
    _findIndexOfEvent(event) {
        let index = -1;
        if (this.events) {
            for (let i = 0; i < this.events.length; i++) {
                const element = this.events[i];
                if (element.startDate === event.startDate &&
                    element.endDate === event.endDate &&
                    element.title === event.title) {
                    index = i;
                    break;
                }
            }
        }
        return index;
    }
    _onLoad() {
        if (this.resetEventsOnLoad) {
            this.events = [];
        }
        if (this.onLoadMonth) {
            this.onLoadMonth.emit({
                month: this.currentMonth,
                year: this.currentYear,
            });
        }
    }
    _getDateClass(item) {
        if (this.dateClass) {
            return (`np-calendar-day np-day-${item.day} ` + this.dateClass(item.date)).trim();
        }
        return `np-calendar-day np-day-${item.day}`;
    }
}
NpCalendarComponent.controlCount = 1;
NpCalendarComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpCalendarComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NpCalendarComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpCalendarComponent, selector: "np-calendar", inputs: { disableWeekDays: "disableWeekDays", disableDates: "disableDates", dateClass: "dateClass", isStartMonthWithMonday: "isStartMonthWithMonday", eventTemplate: "eventTemplate", styleClass: "styleClass", resetEventsOnLoad: "resetEventsOnLoad", inputId: "inputId" }, outputs: { onLoadMonth: "onLoadMonth", onClickDate: "onClickDate", onClickEvent: "onClickEvent" }, ngImport: i0, template: "<div [ngClass]=\"'np-calendar'\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-toolbar np-calendar-toolbar\">\r\n    <div class=\"np-toolbar-item\">\r\n      <button class=\"np-btn-icon np-calendar-refresh-btn\" type=\"button\" tabindex=\"-1\" (click)=\"refresh()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path\r\n            d=\"M17.65 6.35C16.2 4.9 14.21 4 12 4c-4.42 0-7.99 3.58-7.99 8s3.57 8 7.99 8c3.73 0 6.84-2.55 7.73-6h-2.08c-.82 2.33-3.04 4-5.65 4-3.31 0-6-2.69-6-6s2.69-6 6-6c1.66 0 3.14.69 4.22 1.78L13 11h7V4l-2.35 2.35z\">\r\n          </path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n    <div class=\"np-toolbar-item\">\r\n      <button class=\"np-btn np-calendar-today-btn\" type=\"button\" tabindex=\"-1\" (click)=\"_loadCurrentMonth()\">\r\n        {{ \"Today\" | npTranslate }}\r\n      </button>\r\n    </div>\r\n    <div class=\"np-toolbar-spacer\"></div>\r\n    <div class=\"np-toolbar-item\">\r\n      <button class=\"np-btn-icon np-calendar-prev-btn\" type=\"button\" tabindex=\"-1\" (click)=\"_prevMonth()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M15.41 16.59L10.83 12l4.58-4.59L14 6l-6 6 6 6 1.41-1.41z\"></path>\r\n          <path fill=\"none\" d=\"M0 0h24v24H0V0z\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n    <div class=\"np-toolbar-item\">\r\n      <input class=\"np-form-control np-calendar-years-input\" type=\"number\" tabindex=\"-1\" [value]=\"currentYear\"\r\n        (change)=\"_changeYear($event)\" required />\r\n    </div>\r\n    <div class=\"np-toolbar-item\">\r\n      <select class=\"np-form-control np-calendar-months-select\" tabindex=\"-1\" (change)=\"_selectMonth($event)\">\r\n        <option *ngFor=\"let month of monthsList\" [value]=\"month.key\" [text]=\"month.value | npTranslate\"\r\n          [selected]=\"month.key === currentMonth\"></option>\r\n      </select>\r\n    </div>\r\n    <div class=\"np-toolbar-item\">\r\n      <button class=\"np-btn-icon np-calendar-next-btn\" type=\"button\" tabindex=\"-1\" (click)=\"_nextMonth()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M8.59 16.59L13.17 12 8.59 7.41 10 6l6 6-6 6-1.41-1.41z\"></path>\r\n          <path fill=\"none\" d=\"M0 0h24v24H0V0z\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n  </div>\r\n  <table class=\"np-calendar-table\">\r\n    <thead>\r\n      <tr>\r\n        <th *ngFor=\"let weekDay of weekDays\">{{ weekDay | npTranslate }}</th>\r\n      </tr>\r\n    </thead>\r\n    <tbody>\r\n      <tr *ngFor=\"let week of currentMonthWeeks\">\r\n        <td *ngFor=\"let item of week\">\r\n          <div *ngIf=\"!item.day\" class=\"np-calendar-day\"></div>\r\n          <div *ngIf=\"item.day\" [class]=\"_getDateClass(item)\" [ngClass]=\"{\r\n              'np-calendar-today': item.today,\r\n              'np-disabled': item.disabled\r\n            }\" (click)=\"_onClickDate(item.date)\">\r\n            <div class=\"np-calendar-day-label\" [innerHTML]=\"item.day\"></div>\r\n            <div class=\"np-calendar-events\">\r\n              <ng-container *ngFor=\"let eve of item.events\">\r\n                <div class=\"np-calendar-event\" [style.background-color]=\"eve.backgroundColor\"\r\n                  [style.color]=\"eve.fontColor\" (click)=\"_onClickEvent($event, eve)\">\r\n                  <div class=\"np-calendar-event-details\">\r\n                    <div *ngIf=\"!eventTemplate; else customTemplate\" [innerHTML]=\"eve.title\" [title]=\"eve.title\"></div>\r\n                    <ng-template #customTemplate [ngTemplateOutlet]=\"eventTemplate\"\r\n                      [ngTemplateOutletContext]=\"{ event: eve }\">\r\n                    </ng-template>\r\n                  </div>\r\n                </div>\r\n              </ng-container>\r\n            </div>\r\n          </div>\r\n        </td>\r\n      </tr>\r\n    </tbody>\r\n  </table>\r\n</div>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "pipe", type: NpTranslatePipe, name: "npTranslate" }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpCalendarComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-calendar", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, template: "<div [ngClass]=\"'np-calendar'\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-toolbar np-calendar-toolbar\">\r\n    <div class=\"np-toolbar-item\">\r\n      <button class=\"np-btn-icon np-calendar-refresh-btn\" type=\"button\" tabindex=\"-1\" (click)=\"refresh()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path\r\n            d=\"M17.65 6.35C16.2 4.9 14.21 4 12 4c-4.42 0-7.99 3.58-7.99 8s3.57 8 7.99 8c3.73 0 6.84-2.55 7.73-6h-2.08c-.82 2.33-3.04 4-5.65 4-3.31 0-6-2.69-6-6s2.69-6 6-6c1.66 0 3.14.69 4.22 1.78L13 11h7V4l-2.35 2.35z\">\r\n          </path>\r\n          <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n    <div class=\"np-toolbar-item\">\r\n      <button class=\"np-btn np-calendar-today-btn\" type=\"button\" tabindex=\"-1\" (click)=\"_loadCurrentMonth()\">\r\n        {{ \"Today\" | npTranslate }}\r\n      </button>\r\n    </div>\r\n    <div class=\"np-toolbar-spacer\"></div>\r\n    <div class=\"np-toolbar-item\">\r\n      <button class=\"np-btn-icon np-calendar-prev-btn\" type=\"button\" tabindex=\"-1\" (click)=\"_prevMonth()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M15.41 16.59L10.83 12l4.58-4.59L14 6l-6 6 6 6 1.41-1.41z\"></path>\r\n          <path fill=\"none\" d=\"M0 0h24v24H0V0z\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n    <div class=\"np-toolbar-item\">\r\n      <input class=\"np-form-control np-calendar-years-input\" type=\"number\" tabindex=\"-1\" [value]=\"currentYear\"\r\n        (change)=\"_changeYear($event)\" required />\r\n    </div>\r\n    <div class=\"np-toolbar-item\">\r\n      <select class=\"np-form-control np-calendar-months-select\" tabindex=\"-1\" (change)=\"_selectMonth($event)\">\r\n        <option *ngFor=\"let month of monthsList\" [value]=\"month.key\" [text]=\"month.value | npTranslate\"\r\n          [selected]=\"month.key === currentMonth\"></option>\r\n      </select>\r\n    </div>\r\n    <div class=\"np-toolbar-item\">\r\n      <button class=\"np-btn-icon np-calendar-next-btn\" type=\"button\" tabindex=\"-1\" (click)=\"_nextMonth()\">\r\n        <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n          <path d=\"M8.59 16.59L13.17 12 8.59 7.41 10 6l6 6-6 6-1.41-1.41z\"></path>\r\n          <path fill=\"none\" d=\"M0 0h24v24H0V0z\"></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n  </div>\r\n  <table class=\"np-calendar-table\">\r\n    <thead>\r\n      <tr>\r\n        <th *ngFor=\"let weekDay of weekDays\">{{ weekDay | npTranslate }}</th>\r\n      </tr>\r\n    </thead>\r\n    <tbody>\r\n      <tr *ngFor=\"let week of currentMonthWeeks\">\r\n        <td *ngFor=\"let item of week\">\r\n          <div *ngIf=\"!item.day\" class=\"np-calendar-day\"></div>\r\n          <div *ngIf=\"item.day\" [class]=\"_getDateClass(item)\" [ngClass]=\"{\r\n              'np-calendar-today': item.today,\r\n              'np-disabled': item.disabled\r\n            }\" (click)=\"_onClickDate(item.date)\">\r\n            <div class=\"np-calendar-day-label\" [innerHTML]=\"item.day\"></div>\r\n            <div class=\"np-calendar-events\">\r\n              <ng-container *ngFor=\"let eve of item.events\">\r\n                <div class=\"np-calendar-event\" [style.background-color]=\"eve.backgroundColor\"\r\n                  [style.color]=\"eve.fontColor\" (click)=\"_onClickEvent($event, eve)\">\r\n                  <div class=\"np-calendar-event-details\">\r\n                    <div *ngIf=\"!eventTemplate; else customTemplate\" [innerHTML]=\"eve.title\" [title]=\"eve.title\"></div>\r\n                    <ng-template #customTemplate [ngTemplateOutlet]=\"eventTemplate\"\r\n                      [ngTemplateOutletContext]=\"{ event: eve }\">\r\n                    </ng-template>\r\n                  </div>\r\n                </div>\r\n              </ng-container>\r\n            </div>\r\n          </div>\r\n        </td>\r\n      </tr>\r\n    </tbody>\r\n  </table>\r\n</div>" }]
        }], ctorParameters: function () { return []; }, propDecorators: { disableWeekDays: [{
                type: Input
            }], disableDates: [{
                type: Input
            }], dateClass: [{
                type: Input
            }], isStartMonthWithMonday: [{
                type: Input
            }], eventTemplate: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], resetEventsOnLoad: [{
                type: Input
            }], inputId: [{
                type: Input
            }], onLoadMonth: [{
                type: Output
            }], onClickDate: [{
                type: Output
            }], onClickEvent: [{
                type: Output
            }] } });

class NpCalendarModule {
}
NpCalendarModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpCalendarModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpCalendarModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpCalendarModule, declarations: [NpCalendarComponent], imports: [CommonModule, NpTranslationsModule], exports: [NpCalendarComponent] });
NpCalendarModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpCalendarModule, imports: [CommonModule, NpTranslationsModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpCalendarModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpCalendarComponent],
                    imports: [CommonModule, NpTranslationsModule],
                    exports: [NpCalendarComponent],
                }]
        }] });

class NpCalendarEvent {
    constructor(item) {
        this.startDate = item.startDate;
        this.endDate = item.endDate;
        this.title = item.description;
        this.data = item.data;
        this.backgroundColor = item.backgroundColor;
        this.fontColor = item.fontColor;
    }
}

class NpRadioButtonComponent {
    constructor() {
        this.inputId = `np-radio-button_${NpRadioButtonComponent.controlCount++}`;
        this.focused = false;
    }
    ngAfterViewInit() {
        if (!this.value) {
            throw new EvalError("The [value] property is required!");
        }
        if (!this.label) {
            throw new EvalError("The [label] property is required!");
        }
    }
}
NpRadioButtonComponent.controlCount = 1;
NpRadioButtonComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpRadioButtonComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NpRadioButtonComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpRadioButtonComponent, selector: "np-radio-button", inputs: { label: "label", value: "value", inputId: "inputId" }, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpRadioButtonComponent, decorators: [{
            type: Component,
            args: [{
                    selector: "np-radio-button",
                    template: "",
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.Default,
                }]
        }], propDecorators: { label: [{
                type: Input
            }], value: [{
                type: Input
            }], inputId: [{
                type: Input
            }] } });

class NpRadioGroupComponent {
    constructor(el) {
        this.el = el;
        // Orientation can be 'horizontal' or 'vertical'
        this.orientation = 'horizontal';
        this.inputId = `np-radio-group_${NpRadioGroupComponent.controlCount++}`;
        this.onChange = new EventEmitter();
        this.onFocus = new EventEmitter();
        this.onBlur = new EventEmitter();
        this.isDisabled = false;
        this.onChangeCallback = () => { };
        this.onTouchedCallback = () => { };
    }
    set autoFocus(value) {
        if (value) {
            this.focus();
        }
    }
    get value() {
        return this.innerValue ? this.innerValue : null;
    }
    set value(v) {
        if (v !== this.innerValue) {
            this.innerValue = v;
            this.onChangeCallback(v);
            this.onChange.emit(v);
        }
    }
    writeValue(v) {
        if (v !== this.innerValue) {
            this.innerValue = v;
        }
    }
    registerOnChange(fn) {
        this.onChangeCallback = fn;
    }
    registerOnTouched(fn) {
        this.onTouchedCallback = fn;
    }
    setDisabledState(isDisabled) {
        this.isDisabled = isDisabled;
    }
    focus() {
        setTimeout(() => {
            if (!this.value) {
                const radio = this.el.nativeElement.querySelector("#" + this.radioButtons.first.inputId);
                if (radio) {
                    radio.querySelector(".np-radio-button-input").focus();
                }
            }
            this.radioButtons.forEach((item) => {
                if (item.value === this.value) {
                    const radio = this.el.nativeElement.querySelector("#" + item.inputId);
                    if (radio) {
                        radio.querySelector(".np-radio-button-input").focus();
                    }
                }
            });
        }, 100);
    }
    _onKeyDown(event) {
        if ((event.key === "ArrowRight" ||
            event.key === "ArrowLeft" ||
            event.key === "ArrowUp" ||
            event.key === "ArrowDown") &&
            (this.readOnly || this.isDisabled)) {
            event.preventDefault();
        }
    }
    _onChange(item) {
        this.value = item.value;
    }
    _isSelected(item) {
        return this.value === item.value;
    }
    _getTabIndex(item, i) {
        if (!this.value) {
            if (i === 0) {
                return this.tabIndex || 0;
            }
            return -1;
        }
        return this._isSelected(item) ? this.tabIndex || 0 : -1;
    }
    _onBlur($event, item) {
        item.focused = false;
        this.onTouchedCallback();
        this.onBlur.emit($event);
    }
    _onFocus($event, item) {
        item.focused = true;
        this.onFocus.emit($event);
    }
    _getInputId(id) {
        return id + "_input";
    }
}
NpRadioGroupComponent.controlCount = 1;
NpRadioGroupComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpRadioGroupComponent, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component });
NpRadioGroupComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpRadioGroupComponent, selector: "np-radio-group", inputs: { name: "name", orientation: "orientation", readOnly: "readOnly", tabIndex: "tabIndex", styleClass: "styleClass", inputId: "inputId", autoFocus: "autoFocus" }, outputs: { onChange: "onChange", onFocus: "onFocus", onBlur: "onBlur" }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => NpRadioGroupComponent),
            multi: true,
        },
    ], queries: [{ propertyName: "radioButtons", predicate: NpRadioButtonComponent }], ngImport: i0, template: "<div class=\"np-radio-group\" role=\"radiogroup\" [ngClass]=\"{ 'np-radio-group-vertical': orientation === 'vertical' }\"\r\n  [attr.id]=\"inputId\">\r\n  <ng-container *ngFor=\"let item of radioButtons; let i = index\">\r\n    <div [ngClass]=\"{\r\n        'np-radio-button': true,\r\n        'np-disabled': isDisabled,\r\n        'np-readonly': readOnly\r\n      }\" role=\"radio\" [attr.aria-checked]=\"_isSelected(item)\" [class]=\"styleClass\" [attr.id]=\"item.inputId\">\r\n      <label class=\"np-radio-button-label\" [attr.for]=\"_getInputId(item.inputId)\">\r\n        <input class=\"np-radio-button-input\" type=\"radio\" [value]=\"value\" [checked]=\"_isSelected(item)\"\r\n          [attr.id]=\"_getInputId(item.inputId)\" [attr.name]=\"name\" [disabled]=\"isDisabled\" [readonly]=\"readOnly\"\r\n          [attr.tabindex]=\"_getTabIndex(item, i)\" (change)=\"_onChange(item)\" (keydown)=\"_onKeyDown($event)\"\r\n          (blur)=\"_onBlur($event, item)\" (focus)=\"_onFocus($event, item)\" />\r\n        <span class=\"np-radio-container\" [ngClass]=\"{\r\n            'np-radio-selected': _isSelected(item),\r\n            'np-focused-rounded': item.focused\r\n          }\">\r\n          <span class=\"np-radio-outer-circle\"></span>\r\n          <span class=\"np-radio-inner-circle\"></span>\r\n        </span>\r\n        <span class=\"np-radio-button-text\" [innerHTML]=\"item.label\"></span>\r\n      </label>\r\n    </div>\r\n  </ng-container>\r\n</div>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpRadioGroupComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-radio-group", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => NpRadioGroupComponent),
                            multi: true,
                        },
                    ], template: "<div class=\"np-radio-group\" role=\"radiogroup\" [ngClass]=\"{ 'np-radio-group-vertical': orientation === 'vertical' }\"\r\n  [attr.id]=\"inputId\">\r\n  <ng-container *ngFor=\"let item of radioButtons; let i = index\">\r\n    <div [ngClass]=\"{\r\n        'np-radio-button': true,\r\n        'np-disabled': isDisabled,\r\n        'np-readonly': readOnly\r\n      }\" role=\"radio\" [attr.aria-checked]=\"_isSelected(item)\" [class]=\"styleClass\" [attr.id]=\"item.inputId\">\r\n      <label class=\"np-radio-button-label\" [attr.for]=\"_getInputId(item.inputId)\">\r\n        <input class=\"np-radio-button-input\" type=\"radio\" [value]=\"value\" [checked]=\"_isSelected(item)\"\r\n          [attr.id]=\"_getInputId(item.inputId)\" [attr.name]=\"name\" [disabled]=\"isDisabled\" [readonly]=\"readOnly\"\r\n          [attr.tabindex]=\"_getTabIndex(item, i)\" (change)=\"_onChange(item)\" (keydown)=\"_onKeyDown($event)\"\r\n          (blur)=\"_onBlur($event, item)\" (focus)=\"_onFocus($event, item)\" />\r\n        <span class=\"np-radio-container\" [ngClass]=\"{\r\n            'np-radio-selected': _isSelected(item),\r\n            'np-focused-rounded': item.focused\r\n          }\">\r\n          <span class=\"np-radio-outer-circle\"></span>\r\n          <span class=\"np-radio-inner-circle\"></span>\r\n        </span>\r\n        <span class=\"np-radio-button-text\" [innerHTML]=\"item.label\"></span>\r\n      </label>\r\n    </div>\r\n  </ng-container>\r\n</div>" }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { name: [{
                type: Input
            }], orientation: [{
                type: Input
            }], readOnly: [{
                type: Input
            }], tabIndex: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], inputId: [{
                type: Input
            }], autoFocus: [{
                type: Input
            }], onChange: [{
                type: Output
            }], onFocus: [{
                type: Output
            }], onBlur: [{
                type: Output
            }], radioButtons: [{
                type: ContentChildren,
                args: [NpRadioButtonComponent]
            }] } });

class NpRadioButtonModule {
}
NpRadioButtonModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpRadioButtonModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpRadioButtonModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpRadioButtonModule, declarations: [NpRadioButtonComponent, NpRadioGroupComponent], imports: [CommonModule], exports: [NpRadioButtonComponent, NpRadioGroupComponent] });
NpRadioButtonModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpRadioButtonModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpRadioButtonModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpRadioButtonComponent, NpRadioGroupComponent],
                    imports: [CommonModule],
                    exports: [NpRadioButtonComponent, NpRadioGroupComponent],
                }]
        }] });

class NpInputTextComponent {
    constructor() {
        this.type = "text";
        this.placeholder = "";
        this.inputId = `np-input-text_${NpInputTextComponent.controlCount++}`;
        this.onChange = new EventEmitter();
        this.onFocus = new EventEmitter();
        this.onBlur = new EventEmitter();
        this.isDisabled = false;
        this.focused = false;
        this.onChangeCallback = () => { };
        this.onTouchedCallback = () => { };
    }
    get value() {
        return this.innerValue ? this.innerValue : null;
    }
    set value(v) {
        if (v !== this.innerValue) {
            this.innerValue = v;
            this.onChangeCallback(v);
            this.onChange.emit(v);
        }
    }
    writeValue(v) {
        if (v !== this.innerValue) {
            this.innerValue = v;
        }
    }
    registerOnChange(fn) {
        this.onChangeCallback = fn;
    }
    registerOnTouched(fn) {
        this.onTouchedCallback = fn;
    }
    setDisabledState(isDisabled) {
        this.isDisabled = isDisabled;
    }
    validate() {
        if (this.minLength !== undefined &&
            this.value &&
            this.value.length < this.minLength) {
            return {
                minLength: {
                    valid: false,
                },
            };
        }
        if (this.maxLength !== undefined &&
            this.value &&
            this.value.length > this.maxLength) {
            return {
                maxLength: {
                    valid: false,
                },
            };
        }
        if (this.pattern) {
            const regex = new RegExp(this.pattern);
            if (this.value && !regex.test(this.value.toString())) {
                return {
                    pattern: {
                        valid: false,
                    },
                };
            }
        }
    }
    focus() {
        this.inputViewChild.nativeElement.focus();
    }
    _onInputChange(event) {
        this.value = event.target.value;
    }
    _onBlur($event) {
        this.focused = false;
        this.onTouchedCallback();
        this.onBlur.emit($event);
    }
    _onFocus($event) {
        this.focused = true;
        this.onFocus.emit($event);
    }
}
NpInputTextComponent.controlCount = 1;
NpInputTextComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpInputTextComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NpInputTextComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpInputTextComponent, selector: "np-input-text", inputs: { type: "type", minLength: "minLength", maxLength: "maxLength", pattern: "pattern", prefixLabel: "prefixLabel", suffixLabel: "suffixLabel", mask: "mask", placeholder: "placeholder", readOnly: "readOnly", autoFocus: "autoFocus", tabIndex: "tabIndex", styleClass: "styleClass", inputId: "inputId" }, outputs: { onChange: "onChange", onFocus: "onFocus", onBlur: "onBlur" }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => NpInputTextComponent),
            multi: true,
        },
        {
            provide: NG_VALIDATORS,
            useExisting: forwardRef(() => NpInputTextComponent),
            multi: true,
        },
    ], viewQueries: [{ propertyName: "inputViewChild", first: true, predicate: ["control"], descendants: true }], ngImport: i0, template: "<div [ngClass]=\"{\r\n    'np-input-text': true,\r\n    'np-disabled': isDisabled,\r\n    'np-readonly': readOnly\r\n  }\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-input-group\" [ngClass]=\"{ 'np-focused': focused }\">\r\n    <label class=\"np-prefix-label\" *ngIf=\"prefixLabel\" [innerHTML]=\"prefixLabel\"></label>\r\n    <input class=\"np-form-control\" [type]=\"type\" #control autocomplete=\"off\" [npAutofocus]=\"autoFocus\"\r\n      [attr.tabindex]=\"tabIndex\" [readonly]=\"readOnly\" [value]=\"innerValue || ''\" [placeholder]=\"placeholder\"\r\n      [attr.minlength]=\"minLength\" [attr.maxlength]=\"maxLength\" [disabled]=\"isDisabled\" (blur)=\"_onBlur($event)\"\r\n      (focus)=\"_onFocus($event)\" (change)=\"_onInputChange($event)\" />\r\n    <label class=\"np-suffix-label\" *ngIf=\"suffixLabel\" [innerHTML]=\"suffixLabel\"></label>\r\n  </div>\r\n</div>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: NpAutofocusDirective, selector: "[npAutofocus]", inputs: ["npAutofocus"] }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpInputTextComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-input-text", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => NpInputTextComponent),
                            multi: true,
                        },
                        {
                            provide: NG_VALIDATORS,
                            useExisting: forwardRef(() => NpInputTextComponent),
                            multi: true,
                        },
                    ], template: "<div [ngClass]=\"{\r\n    'np-input-text': true,\r\n    'np-disabled': isDisabled,\r\n    'np-readonly': readOnly\r\n  }\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-input-group\" [ngClass]=\"{ 'np-focused': focused }\">\r\n    <label class=\"np-prefix-label\" *ngIf=\"prefixLabel\" [innerHTML]=\"prefixLabel\"></label>\r\n    <input class=\"np-form-control\" [type]=\"type\" #control autocomplete=\"off\" [npAutofocus]=\"autoFocus\"\r\n      [attr.tabindex]=\"tabIndex\" [readonly]=\"readOnly\" [value]=\"innerValue || ''\" [placeholder]=\"placeholder\"\r\n      [attr.minlength]=\"minLength\" [attr.maxlength]=\"maxLength\" [disabled]=\"isDisabled\" (blur)=\"_onBlur($event)\"\r\n      (focus)=\"_onFocus($event)\" (change)=\"_onInputChange($event)\" />\r\n    <label class=\"np-suffix-label\" *ngIf=\"suffixLabel\" [innerHTML]=\"suffixLabel\"></label>\r\n  </div>\r\n</div>" }]
        }], propDecorators: { type: [{
                type: Input
            }], minLength: [{
                type: Input
            }], maxLength: [{
                type: Input
            }], pattern: [{
                type: Input
            }], prefixLabel: [{
                type: Input
            }], suffixLabel: [{
                type: Input
            }], mask: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], readOnly: [{
                type: Input
            }], autoFocus: [{
                type: Input
            }], tabIndex: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], inputId: [{
                type: Input
            }], onChange: [{
                type: Output
            }], onFocus: [{
                type: Output
            }], onBlur: [{
                type: Output
            }], inputViewChild: [{
                type: ViewChild,
                args: ["control"]
            }] } });

class NpInputTextModule {
}
NpInputTextModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpInputTextModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpInputTextModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpInputTextModule, declarations: [NpInputTextComponent], imports: [CommonModule, NpAutofocusModule], exports: [NpInputTextComponent] });
NpInputTextModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpInputTextModule, imports: [CommonModule, NpAutofocusModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpInputTextModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpInputTextComponent],
                    imports: [CommonModule, NpAutofocusModule],
                    exports: [NpInputTextComponent],
                }]
        }] });

class NpTextareaComponent {
    constructor() {
        this.resize = true;
        this.placeholder = "";
        this.inputId = `np-textarea_${NpTextareaComponent.controlCount++}`;
        this.onChange = new EventEmitter();
        this.onFocus = new EventEmitter();
        this.onBlur = new EventEmitter();
        this.isDisabled = false;
        this.focused = false;
        this.onChangeCallback = () => { };
        this.onTouchedCallback = () => { };
    }
    get value() {
        return this.innerValue ? this.innerValue : null;
    }
    set value(v) {
        if (v !== this.innerValue) {
            this.innerValue = v;
            this.onChangeCallback(v);
            this.onChange.emit(v);
        }
    }
    writeValue(v) {
        if (v !== this.innerValue) {
            this.innerValue = v;
        }
    }
    registerOnChange(fn) {
        this.onChangeCallback = fn;
    }
    registerOnTouched(fn) {
        this.onTouchedCallback = fn;
    }
    setDisabledState(isDisabled) {
        this.isDisabled = isDisabled;
    }
    validate() {
        if (this.minLength !== undefined &&
            this.value &&
            this.value.length < this.minLength) {
            return {
                minLength: {
                    valid: false,
                },
            };
        }
        if (this.maxLength !== undefined &&
            this.value &&
            this.value.length > this.maxLength) {
            return {
                maxLength: {
                    valid: false,
                },
            };
        }
    }
    focus() {
        this.inputViewChild.nativeElement.focus();
    }
    _onInputChange(event) {
        this.value = event.target.value;
    }
    _onBlur($event) {
        this.focused = false;
        this.onTouchedCallback();
        this.onBlur.emit($event);
    }
    _onFocus($event) {
        this.focused = true;
        this.onFocus.emit($event);
    }
}
NpTextareaComponent.controlCount = 1;
NpTextareaComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTextareaComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NpTextareaComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpTextareaComponent, selector: "np-textarea", inputs: { rows: "rows", cols: "cols", resize: "resize", minLength: "minLength", maxLength: "maxLength", placeholder: "placeholder", readOnly: "readOnly", autoFocus: "autoFocus", tabIndex: "tabIndex", styleClass: "styleClass", inputId: "inputId" }, outputs: { onChange: "onChange", onFocus: "onFocus", onBlur: "onBlur" }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => NpTextareaComponent),
            multi: true,
        },
        {
            provide: NG_VALIDATORS,
            useExisting: forwardRef(() => NpTextareaComponent),
            multi: true,
        },
    ], viewQueries: [{ propertyName: "inputViewChild", first: true, predicate: ["control"], descendants: true }], ngImport: i0, template: "<div [ngClass]=\"{\r\n    'np-textarea': true,\r\n    'np-disabled': isDisabled,\r\n    'np-readonly': readOnly,\r\n    'np-focused': focused\r\n  }\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <textarea class=\"np-textarea-control\" #control [npAutofocus]=\"autoFocus\" [attr.tabindex]=\"tabIndex\"\r\n    [readonly]=\"readOnly\" [value]=\"innerValue || ''\" [placeholder]=\"placeholder\" [attr.minlength]=\"minLength\"\r\n    [attr.rows]=\"rows\" [attr.cols]=\"cols\" [style.resize]=\"resize ? 'both' : 'none'\" [attr.maxlength]=\"maxLength\"\r\n    [disabled]=\"isDisabled\" (blur)=\"_onBlur($event)\" (focus)=\"_onFocus($event)\"\r\n    (change)=\"_onInputChange($event)\"></textarea>\r\n</div>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NpAutofocusDirective, selector: "[npAutofocus]", inputs: ["npAutofocus"] }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTextareaComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-textarea", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => NpTextareaComponent),
                            multi: true,
                        },
                        {
                            provide: NG_VALIDATORS,
                            useExisting: forwardRef(() => NpTextareaComponent),
                            multi: true,
                        },
                    ], template: "<div [ngClass]=\"{\r\n    'np-textarea': true,\r\n    'np-disabled': isDisabled,\r\n    'np-readonly': readOnly,\r\n    'np-focused': focused\r\n  }\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <textarea class=\"np-textarea-control\" #control [npAutofocus]=\"autoFocus\" [attr.tabindex]=\"tabIndex\"\r\n    [readonly]=\"readOnly\" [value]=\"innerValue || ''\" [placeholder]=\"placeholder\" [attr.minlength]=\"minLength\"\r\n    [attr.rows]=\"rows\" [attr.cols]=\"cols\" [style.resize]=\"resize ? 'both' : 'none'\" [attr.maxlength]=\"maxLength\"\r\n    [disabled]=\"isDisabled\" (blur)=\"_onBlur($event)\" (focus)=\"_onFocus($event)\"\r\n    (change)=\"_onInputChange($event)\"></textarea>\r\n</div>" }]
        }], propDecorators: { rows: [{
                type: Input
            }], cols: [{
                type: Input
            }], resize: [{
                type: Input
            }], minLength: [{
                type: Input
            }], maxLength: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], readOnly: [{
                type: Input
            }], autoFocus: [{
                type: Input
            }], tabIndex: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], inputId: [{
                type: Input
            }], onChange: [{
                type: Output
            }], onFocus: [{
                type: Output
            }], onBlur: [{
                type: Output
            }], inputViewChild: [{
                type: ViewChild,
                args: ["control"]
            }] } });

class NpTextareaModule {
}
NpTextareaModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTextareaModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpTextareaModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpTextareaModule, declarations: [NpTextareaComponent], imports: [CommonModule, NpAutofocusModule], exports: [NpTextareaComponent] });
NpTextareaModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTextareaModule, imports: [CommonModule, NpAutofocusModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTextareaModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpTextareaComponent],
                    imports: [CommonModule, NpAutofocusModule],
                    exports: [NpTextareaComponent],
                }]
        }] });

class NpRichTextComponent {
    constructor(el) {
        this.el = el;
        this.inputId = `np-rich-text_${NpRichTextComponent.controlCount++}`;
        this.onChange = new EventEmitter();
        this.onFocus = new EventEmitter();
        this.onBlur = new EventEmitter();
        this.isDisabled = false;
        this.focused = false;
        this.isBold = false;
        this.isItalic = false;
        this.isUnderline = false;
        this.isBlockquote = false;
        this.isStrikethrough = false;
        this.currentFormat = "no value";
        this.currentFont = "no value";
        this.currentfontsize = "no value";
        this.onChangeCallback = () => { };
        this.onTouchedCallback = () => { };
        this.config = [
            "bold",
            "italic",
            "underline",
            "strikethrough",
            "removeformat",
            "formatblock",
            "blockquote",
            "fontname",
            "fontsize",
            "forecolor",
            "backcolor",
            "subscript",
            "superscript",
            "justifyleft",
            "justifycenter",
            "justifyright",
            "indent",
            "outdent",
            "insertunorderedlist",
            "insertorderedlist",
            "createlink",
            "undo",
            "redo",
        ];
        this.fonts = ["Arial", "Arial Black", "Courier New", "Times New Roman"];
    }
    get value() {
        return this.innerValue ? this.innerValue : null;
    }
    set value(v) {
        if (v !== this.innerValue) {
            this.innerValue = v;
            this.onChangeCallback(v);
            this.onChange.emit(v);
        }
    }
    writeValue(v) {
        if (v !== this.innerValue) {
            this.innerValue = v;
            if (this.inputViewChild && v) {
                this.inputViewChild.nativeElement.innerHTML = v;
            }
        }
    }
    registerOnChange(fn) {
        this.onChangeCallback = fn;
    }
    registerOnTouched(fn) {
        this.onTouchedCallback = fn;
    }
    setDisabledState(isDisabled) {
        this.isDisabled = isDisabled;
    }
    validate() {
        var text = this.el.nativeElement.querySelector(".np-rich-text-input")
            .textContent;
        if (this.minLength !== undefined && text && text.length < this.minLength) {
            return {
                minLength: {
                    valid: false,
                },
            };
        }
        if (this.maxLength !== undefined && text && text.length > this.maxLength) {
            return {
                maxLength: {
                    valid: false,
                },
            };
        }
    }
    focus() {
        this.inputViewChild.nativeElement.focus();
    }
    _onInputChange(event) {
        this.value = event.target.innerHTML;
    }
    _onBlur($event) {
        this.focused = false;
        this.onTouchedCallback();
        this.onBlur.emit($event);
    }
    _onFocus($event) {
        this.focused = true;
        this.onFocus.emit($event);
    }
    _formatDoc(sCmd, sValue) {
        document.execCommand(sCmd, false, sValue);
        this.focus();
    }
    _formatBlock(sCmd, sValue) {
        if (sValue === "no value") {
            return;
        }
        this._formatDoc(sCmd, sValue);
        setTimeout(() => {
            this.currentFormat = "no value";
            this.currentFont = "no value";
            this.currentfontsize = "no value";
        }, 100);
    }
    _showForeColorOverlay() {
        if (!this.focused) {
            this.focus();
        }
        if (document.getSelection() && document.getSelection().getRangeAt) {
            this.currentSelectionRange = document.getSelection().getRangeAt(0);
        }
        let colour = document.queryCommandValue("foreColor");
        if (colour.indexOf("rgb") > -1) {
            colour = this._changeRGBToHex(colour);
        }
        if (colour.indexOf("transparent") > -1) {
            colour = null;
        }
        this.foreColor = colour;
    }
    _changeForeColor(color) {
        if (this.currentSelectionRange) {
            document.getSelection().removeAllRanges();
            document.getSelection().addRange(this.currentSelectionRange);
            this.foreColor = color;
            if (color) {
                this._formatDoc("foreColor", color);
            }
            else {
                document.execCommand("removeformat", false, "foreColor");
            }
            this.currentSelectionRange = null;
        }
        this.foreColorPopover.close();
    }
    _showBackColorOverlay() {
        if (!this.focused) {
            this.focus();
        }
        if (document.getSelection() && document.getSelection().getRangeAt) {
            this.currentSelectionRange = document.getSelection().getRangeAt(0);
        }
        let colour = document.queryCommandValue("backColor");
        if (colour.indexOf("rgb") > -1) {
            colour = this._changeRGBToHex(colour);
        }
        if (colour.indexOf("transparent") > -1) {
            colour = null;
        }
        this.backColor = colour;
    }
    _changeBackColor(color) {
        if (this.currentSelectionRange) {
            document.getSelection().removeAllRanges();
            document.getSelection().addRange(this.currentSelectionRange);
            this.backColor = color;
            if (color) {
                this._formatDoc("backColor", color);
            }
            else {
                document.execCommand("removeformat", false, "backColor");
            }
            this.currentSelectionRange = null;
        }
        this.backColorPopover.close();
    }
    _onCloseOverlays() {
        if (this.currentSelectionRange) {
            document.getSelection().removeAllRanges();
            document.getSelection().addRange(this.currentSelectionRange);
            this.currentSelectionRange = null;
        }
        this.focus();
    }
    _showCreateLink() {
        if (!this.focused) {
            this.focus();
        }
        if (document.getSelection() && document.getSelection().getRangeAt) {
            this.currentSelectionRange = document.getSelection().getRangeAt(0);
        }
        this.linkUrl = "https://";
    }
    _createLink() {
        if (this.currentSelectionRange) {
            document.getSelection().removeAllRanges();
            document.getSelection().addRange(this.currentSelectionRange);
            if (this.linkUrl) {
                this._formatDoc("createlink", this.linkUrl);
            }
            this.currentSelectionRange = null;
        }
        this.createLinkPopover.close();
    }
    _closeCreateLinkOverlay() {
        this.createLinkPopover.close();
    }
    _changeRGBToHex(val) {
        const rgb = val
            .replace("rgb", "")
            .replace("rgba", "")
            .replace("(", "")
            .replace(")", "")
            .replace(" ", "");
        const rgbAray = rgb.split(",");
        return this._rgbToHex(Number(rgbAray[0]), Number(rgbAray[1]), Number(rgbAray[2]));
    }
    _rgbToHex(r, g, b) {
        const red = this._convertNumberToHex(r);
        const green = this._convertNumberToHex(g);
        const blue = this._convertNumberToHex(b);
        return `#${red}${green}${blue}`;
    }
    _convertNumberToHex(num) {
        let hex = Number(num).toString(16);
        if (hex.length < 2) {
            hex = `0${hex}`;
        }
        return hex;
    }
    _isAllowed(permission) {
        return this.config.indexOf(permission) > -1;
    }
}
NpRichTextComponent.controlCount = 1;
NpRichTextComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpRichTextComponent, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component });
NpRichTextComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpRichTextComponent, selector: "np-rich-text", inputs: { minLength: "minLength", maxLength: "maxLength", config: "config", fonts: "fonts", height: "height", readOnly: "readOnly", autoFocus: "autoFocus", tabIndex: "tabIndex", styleClass: "styleClass", inputId: "inputId" }, outputs: { onChange: "onChange", onFocus: "onFocus", onBlur: "onBlur" }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => NpRichTextComponent),
            multi: true,
        },
        {
            provide: NG_VALIDATORS,
            useExisting: forwardRef(() => NpRichTextComponent),
            multi: true,
        },
    ], viewQueries: [{ propertyName: "inputViewChild", first: true, predicate: ["control"], descendants: true }, { propertyName: "createLinkPopover", first: true, predicate: ["createLinkPopover"], descendants: true }, { propertyName: "foreColorPopover", first: true, predicate: ["foreColorPopover"], descendants: true }, { propertyName: "backColorPopover", first: true, predicate: ["backColorPopover"], descendants: true }], ngImport: i0, template: "<div [ngClass]=\"{\r\n    'np-rich-text': true,\r\n    'np-disabled': isDisabled,\r\n    'np-focused': focused\r\n  }\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-rich-text-container\">\r\n    <div [ngClass]=\"{ 'np-toolbar': true, 'np-readonly': readOnly }\">\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('bold')\">\r\n        <button class=\"np-btn-icon np-btn-bold\" [ngClass]=\"{ 'np-btn-active': isBold }\"\r\n          (click)=\"_formatDoc('bold', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n            <path\r\n              d=\"M15.6 10.79c.97-.67 1.65-1.77 1.65-2.79 0-2.26-1.75-4-4-4H7v14h7.04c2.09 0 3.71-1.7 3.71-3.79 0-1.52-.86-2.82-2.15-3.42zM10 6.5h3c.83 0 1.5.67 1.5 1.5s-.67 1.5-1.5 1.5h-3v-3zm3.5 9H10v-3h3.5c.83 0 1.5.67 1.5 1.5s-.67 1.5-1.5 1.5z\">\r\n            </path>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('italic')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-italic\" [ngClass]=\"{ 'np-btn-active': isItalic }\"\r\n          (click)=\"_formatDoc('italic', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n            <path d=\"M10 4v3h2.21l-3.42 8H6v3h8v-3h-2.21l3.42-8H18V4z\"></path>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('underline')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-underline\" [ngClass]=\"{ 'np-btn-active': isUnderline }\"\r\n          (click)=\"_formatDoc('underline', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n            <path\r\n              d=\"M12 17c3.31 0 6-2.69 6-6V3h-2.5v8c0 1.93-1.57 3.5-3.5 3.5S8.5 12.93 8.5 11V3H6v8c0 3.31 2.69 6 6 6zm-7 2v2h14v-2H5z\">\r\n            </path>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('strikethrough')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-strikethrough\" [ngClass]=\"{ 'np-btn-active': isStrikethrough }\"\r\n          (click)=\"_formatDoc('strikethrough', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n            <path d=\"M10 19h4v-3h-4v3zM5 4v3h5v3h4V7h5V4H5zM3 14h18v-2H3v2z\"></path>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('removeformat')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-remove-format\" (click)=\"_formatDoc('removeformat', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\" />\r\n            <path\r\n              d=\"M3.27 5L2 6.27l6.97 6.97L6.5 19h3l1.57-3.66L16.73 21 18 19.73 3.55 5.27 3.27 5zM6 5v.18L8.82 8h2.4l-.72 1.68 2.1 2.1L14.21 8H20V5H6z\" />\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-separator\" *ngIf=\"_isAllowed('formatblock') || _isAllowed('blockquote')\"></div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('formatblock')\">\r\n        <select class=\"np-form-control np-select-format\" [(ngModel)]=\"currentFormat\"\r\n          (change)=\"_formatBlock('formatblock', currentFormat)\">\r\n          <option [value]=\"'no value'\">\r\n            {{ \"Formatting\" | npTranslate }}\r\n          </option>\r\n          <option [value]=\"'h1'\">Header 1</option>\r\n          <option [value]=\"'h2'\">Header 2</option>\r\n          <option [value]=\"'h3'\">Header 3</option>\r\n          <option [value]=\"'h4'\">Header 4</option>\r\n          <option [value]=\"'h5'\">Header 5</option>\r\n          <option [value]=\"'h6'\">Header 6</option>\r\n          <option [value]=\"'p'\">Paragraph</option>\r\n          <option [value]=\"'pre'\">Pre formatted</option>\r\n        </select>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('blockquote')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-blockquote\" [ngClass]=\"{ 'np-btn-active': isBlockquote }\"\r\n          (click)=\"_formatDoc('formatblock', 'blockquote')\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n            <path d=\"M6 17h3l2-4V7H5v6h3zm8 0h3l2-4V7h-6v6h3z\"></path>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-separator\" *ngIf=\"\r\n          _isAllowed('fontname') ||\r\n          _isAllowed('fontsize') ||\r\n          _isAllowed('foreColor') ||\r\n          _isAllowed('backcolor')\r\n        \"></div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('fontname')\">\r\n        <select class=\"np-form-control np-select-font\" [(ngModel)]=\"currentFont\"\r\n          (change)=\"_formatBlock('fontname', currentFont)\">\r\n          <option [value]=\"'no value'\">\r\n            {{ \"Font\" | npTranslate }}\r\n          </option>\r\n          <option *ngFor=\"let font of fonts\" [value]=\"font\">{{ font }}</option>\r\n        </select>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('fontsize')\">\r\n        <select class=\"np-form-control np-select-fontsize\" [(ngModel)]=\"currentfontsize\"\r\n          (change)=\"_formatBlock('fontsize', currentfontsize)\">\r\n          <option [value]=\"'no value'\">\r\n            {{ \"Font_Size\" | npTranslate }}\r\n          </option>\r\n          <option [value]=\"1\">Smaller</option>\r\n          <option [value]=\"2\">Small</option>\r\n          <option [value]=\"3\">Medium</option>\r\n          <option [value]=\"4\">Large</option>\r\n          <option [value]=\"5\">Larger</option>\r\n          <option [value]=\"6\">X-large</option>\r\n          <option [value]=\"7\">X-larger</option>\r\n        </select>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('forecolor')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-fore-color\" npPopover #foreColorPopover=\"NpPopoverDirective\"\r\n          [body]=\"foreColorTemplate\" [openOnClick]=\"true\" (onOpen)=\"_showForeColorOverlay()\"\r\n          (onClose)=\"_onCloseOverlays()\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\" />\r\n            <path\r\n              d=\"M5 17v2h14v-2H5zm4.5-4.2h5l.9 2.2h2.1L12.75 4h-1.5L6.5 15h2.1l.9-2.2zM12 5.98L13.87 11h-3.74L12 5.98z\" />\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('backcolor')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-back-color\" npPopover #backColorPopover=\"NpPopoverDirective\"\r\n          [body]=\"backColorTemplate\" [openOnClick]=\"true\" (onOpen)=\"_showBackColorOverlay()\"\r\n          (onClose)=\"_onCloseOverlays()\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0V0z\" fill=\"none\" />\r\n            <path\r\n              d=\"M9.93 13.5h4.14L12 7.98zM20 2H4c-1.1 0-2 .9-2 2v16c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4.05 16.5l-1.14-3H9.17l-1.12 3H5.96l5.11-13h1.86l5.11 13h-2.09z\" />\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-separator\" *ngIf=\"_isAllowed('subscript') || _isAllowed('superscript')\"></div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('subscript')\">\r\n        <button class=\"np-btn-icon np-btn-subscript\" [ngClass]=\"{ 'np-btn-active': isBold }\"\r\n          (click)=\"_formatDoc('subscript', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <g>\r\n              <rect fill=\"none\" height=\"24\" width=\"24\" />\r\n              <path\r\n                d=\"M22,18h-2v1h3v1h-4v-2c0-0.55,0.45-1,1-1h2v-1h-3v-1h3c0.55,0,1,0.45,1,1v1C23,17.55,22.55,18,22,18z M5.88,18h2.66 l3.4-5.42h0.12l3.4,5.42h2.66l-4.65-7.27L17.81,4h-2.68l-3.07,4.99h-0.12L8.85,4H6.19l4.32,6.73L5.88,18z\" />\r\n            </g>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('superscript')\">\r\n        <button class=\"np-btn-icon np-btn-superscript\" [ngClass]=\"{ 'np-btn-active': isBold }\"\r\n          (click)=\"_formatDoc('superscript', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <g>\r\n              <rect fill=\"none\" height=\"24\" width=\"24\" x=\"0\" y=\"0\" />\r\n              <path\r\n                d=\"M22,7h-2v1h3v1h-4V7c0-0.55,0.45-1,1-1h2V5h-3V4h3c0.55,0,1,0.45,1,1v1C23,6.55,22.55,7,22,7z M5.88,20h2.66l3.4-5.42h0.12 l3.4,5.42h2.66l-4.65-7.27L17.81,6h-2.68l-3.07,4.99h-0.12L8.85,6H6.19l4.32,6.73L5.88,20z\" />\r\n            </g>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-separator\" *ngIf=\"\r\n          _isAllowed('justifyleft') ||\r\n          _isAllowed('justifycenter') ||\r\n          _isAllowed('justifyright')\r\n        \"></div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('justifyleft')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-align-left\" (click)=\"_formatDoc('justifyleft', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n            <path d=\"M15 15H3v2h12v-2zm0-8H3v2h12V7zM3 13h18v-2H3v2zm0 8h18v-2H3v2zM3 3v2h18V3H3z\"></path>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('justifycenter')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-align-center\" (click)=\"_formatDoc('justifycenter', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n            <path d=\"M7 15v2h10v-2H7zm-4 6h18v-2H3v2zm0-8h18v-2H3v2zm4-6v2h10V7H7zM3 3v2h18V3H3z\"></path>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('justifyright')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-align-right\" (click)=\"_formatDoc('justifyright', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n            <path d=\"M3 21h18v-2H3v2zm6-4h12v-2H9v2zm-6-4h18v-2H3v2zm6-4h12V7H9v2zM3 3v2h18V3H3z\"></path>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-separator\" *ngIf=\"_isAllowed('indent') || _isAllowed('outdent')\"></div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('indent')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-add-indent\" (click)=\"_formatDoc('indent', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\" />\r\n            <path d=\"M3 21h18v-2H3v2zM3 8v8l4-4-4-4zm8 9h10v-2H11v2zM3 3v2h18V3H3zm8 6h10V7H11v2zm0 4h10v-2H11v2z\" />\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('outdent')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-remove-indent\" (click)=\"_formatDoc('outdent', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\" />\r\n            <path d=\"M11 17h10v-2H11v2zm-8-5l4 4V8l-4 4zm0 9h18v-2H3v2zM3 3v2h18V3H3zm8 6h10V7H11v2zm0 4h10v-2H11v2z\" />\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-separator\" *ngIf=\"\r\n          _isAllowed('insertunorderedlist') || _isAllowed('insertorderedlist')\r\n        \"></div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('insertunorderedlist')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-unorder-list\" (click)=\"_formatDoc('insertunorderedlist', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0V0z\" fill=\"none\"></path>\r\n            <path\r\n              d=\"M4 10.5c-.83 0-1.5.67-1.5 1.5s.67 1.5 1.5 1.5 1.5-.67 1.5-1.5-.67-1.5-1.5-1.5zm0-6c-.83 0-1.5.67-1.5 1.5S3.17 7.5 4 7.5 5.5 6.83 5.5 6 4.83 4.5 4 4.5zm0 12c-.83 0-1.5.68-1.5 1.5s.68 1.5 1.5 1.5 1.5-.68 1.5-1.5-.67-1.5-1.5-1.5zM7 19h14v-2H7v2zm0-6h14v-2H7v2zm0-8v2h14V5H7z\">\r\n            </path>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('insertorderedlist')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-order-list\" (click)=\"_formatDoc('insertorderedlist', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n            <path\r\n              d=\"M2 17h2v.5H3v1h1v.5H2v1h3v-4H2v1zm1-9h1V4H2v1h1v3zm-1 3h1.8L2 13.1v.9h3v-1H3.2L5 10.9V10H2v1zm5-6v2h14V5H7zm0 14h14v-2H7v2zm0-6h14v-2H7v2z\">\r\n            </path>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-separator\" *ngIf=\"_isAllowed('createlink')\"></div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('createlink')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-create-link\" npPopover #createLinkPopover=\"NpPopoverDirective\"\r\n          [header]=\"'Enter_The_URL_For_Link' | npTranslate\" [body]=\"createLinkTemp\" [openOnClick]=\"true\"\r\n          (onOpen)=\"_showCreateLink()\" (onClose)=\"_onCloseOverlays()\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\" />\r\n            <path\r\n              d=\"M3.9 12c0-1.71 1.39-3.1 3.1-3.1h4V7H7c-2.76 0-5 2.24-5 5s2.24 5 5 5h4v-1.9H7c-1.71 0-3.1-1.39-3.1-3.1zM8 13h8v-2H8v2zm9-6h-4v1.9h4c1.71 0 3.1 1.39 3.1 3.1s-1.39 3.1-3.1 3.1h-4V17h4c2.76 0 5-2.24 5-5s-2.24-5-5-5z\" />\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('createlink')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-unlink\" (click)=\"_formatDoc('unlink', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0V0z\" fill=\"none\" />\r\n            <path\r\n              d=\"M17 7h-4v1.9h4c1.71 0 3.1 1.39 3.1 3.1 0 1.43-.98 2.63-2.31 2.98l1.46 1.46C20.88 15.61 22 13.95 22 12c0-2.76-2.24-5-5-5zm-1 4h-2.19l2 2H16zM2 4.27l3.11 3.11C3.29 8.12 2 9.91 2 12c0 2.76 2.24 5 5 5h4v-1.9H7c-1.71 0-3.1-1.39-3.1-3.1 0-1.59 1.21-2.9 2.76-3.07L8.73 11H8v2h2.73L13 15.27V17h1.73l4.01 4L20 19.74 3.27 3 2 4.27z\" />\r\n            <path d=\"M0 24V0\" fill=\"none\" />\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-separator\" *ngIf=\"_isAllowed('undo') || _isAllowed('redo')\"></div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('undo')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-undo\" (click)=\"_formatDoc('undo', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n            <path\r\n              d=\"M12.5 8c-2.65 0-5.05.99-6.9 2.6L2 7v9h9l-3.62-3.62c1.39-1.16 3.16-1.88 5.12-1.88 3.54 0 6.55 2.31 7.6 5.5l2.37-.78C21.08 11.03 17.15 8 12.5 8z\">\r\n            </path>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('redo')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-redo\" (click)=\"_formatDoc('redo', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n            <path\r\n              d=\"M18.4 10.6C16.55 8.99 14.15 8 11.5 8c-4.65 0-8.58 3.03-9.96 7.22L3.9 16c1.05-3.19 4.05-5.5 7.6-5.5 1.95 0 3.73.72 5.12 1.88L13 16h9V7l-3.6 3.6z\">\r\n            </path>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n    </div>\r\n    <div class=\"np-rich-text-input\" role=\"textbox\" [attr.contenteditable]=\"!isDisabled && !readOnly\" #control\r\n      [attr.tabindex]=\"tabIndex\" [style.height.px]=\"height\" [npAutofocus]=\"autoFocus\" (blur)=\"_onBlur($event)\"\r\n      (focus)=\"_onFocus($event)\" (input)=\"_onInputChange($event)\"></div>\r\n  </div>\r\n</div>\r\n\r\n<ng-template #backColorTemplate>\r\n  <np-color-picker [(ngModel)]=\"backColor\" [colors]=\"[]\" [defaultOpen]=\"true\" (onChange)=\"_changeBackColor($event)\">\r\n  </np-color-picker>\r\n</ng-template>\r\n\r\n<ng-template #foreColorTemplate>\r\n  <np-color-picker [(ngModel)]=\"foreColor\" [colors]=\"[]\" [defaultOpen]=\"true\" (onChange)=\"_changeForeColor($event)\">\r\n  </np-color-picker>\r\n</ng-template>\r\n\r\n<ng-template #createLinkTemp>\r\n  <div class=\"np-create-link-form\">\r\n    <div class=\"np-form-group\">\r\n      <input type=\"url\" class=\"np-form-control\" [npAutofocus]=\"true\" [(ngModel)]=\"linkUrl\" />\r\n    </div>\r\n    <div class=\"np-btn-group\">\r\n      <button type=\"button\" class=\"np-btn\" (click)=\"_createLink()\">\r\n        {{ \"Ok\" | npTranslate }}\r\n      </button>\r\n      <button type=\"button\" class=\"np-btn\" (click)=\"_closeCreateLinkOverlay()\">\r\n        {{ \"Cancel\" | npTranslate }}\r\n      </button>\r\n    </div>\r\n  </div>\r\n</ng-template>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: NpAutofocusDirective, selector: "[npAutofocus]", inputs: ["npAutofocus"] }, { kind: "directive", type: i3.NgSelectOption, selector: "option", inputs: ["ngValue", "value"] }, { kind: "directive", type: i3.ɵNgSelectMultipleOption, selector: "option", inputs: ["ngValue", "value"] }, { kind: "directive", type: i3.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i3.SelectControlValueAccessor, selector: "select:not([multiple])[formControlName],select:not([multiple])[formControl],select:not([multiple])[ngModel]", inputs: ["compareWith"] }, { kind: "directive", type: i3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i3.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: NpColorPickerComponent, selector: "np-color-picker", inputs: ["format", "colors", "defaultOpen", "readOnly", "autoFocus", "tabIndex", "styleClass", "inputId"], outputs: ["onChange", "onFocus", "onBlur"] }, { kind: "directive", type: NpPopoverDirective, selector: "[npPopover]", inputs: ["placement", "header", "body", "context", "openOnClick", "width", "closeOnClickOutside", "backDropClass", "hasBackDrop", "styleClass"], outputs: ["onOpen", "onClose"], exportAs: ["NpPopoverDirective"] }, { kind: "pipe", type: NpTranslatePipe, name: "npTranslate" }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpRichTextComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-rich-text", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => NpRichTextComponent),
                            multi: true,
                        },
                        {
                            provide: NG_VALIDATORS,
                            useExisting: forwardRef(() => NpRichTextComponent),
                            multi: true,
                        },
                    ], template: "<div [ngClass]=\"{\r\n    'np-rich-text': true,\r\n    'np-disabled': isDisabled,\r\n    'np-focused': focused\r\n  }\" [class]=\"styleClass\" [attr.id]=\"inputId\">\r\n  <div class=\"np-rich-text-container\">\r\n    <div [ngClass]=\"{ 'np-toolbar': true, 'np-readonly': readOnly }\">\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('bold')\">\r\n        <button class=\"np-btn-icon np-btn-bold\" [ngClass]=\"{ 'np-btn-active': isBold }\"\r\n          (click)=\"_formatDoc('bold', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n            <path\r\n              d=\"M15.6 10.79c.97-.67 1.65-1.77 1.65-2.79 0-2.26-1.75-4-4-4H7v14h7.04c2.09 0 3.71-1.7 3.71-3.79 0-1.52-.86-2.82-2.15-3.42zM10 6.5h3c.83 0 1.5.67 1.5 1.5s-.67 1.5-1.5 1.5h-3v-3zm3.5 9H10v-3h3.5c.83 0 1.5.67 1.5 1.5s-.67 1.5-1.5 1.5z\">\r\n            </path>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('italic')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-italic\" [ngClass]=\"{ 'np-btn-active': isItalic }\"\r\n          (click)=\"_formatDoc('italic', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n            <path d=\"M10 4v3h2.21l-3.42 8H6v3h8v-3h-2.21l3.42-8H18V4z\"></path>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('underline')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-underline\" [ngClass]=\"{ 'np-btn-active': isUnderline }\"\r\n          (click)=\"_formatDoc('underline', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n            <path\r\n              d=\"M12 17c3.31 0 6-2.69 6-6V3h-2.5v8c0 1.93-1.57 3.5-3.5 3.5S8.5 12.93 8.5 11V3H6v8c0 3.31 2.69 6 6 6zm-7 2v2h14v-2H5z\">\r\n            </path>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('strikethrough')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-strikethrough\" [ngClass]=\"{ 'np-btn-active': isStrikethrough }\"\r\n          (click)=\"_formatDoc('strikethrough', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n            <path d=\"M10 19h4v-3h-4v3zM5 4v3h5v3h4V7h5V4H5zM3 14h18v-2H3v2z\"></path>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('removeformat')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-remove-format\" (click)=\"_formatDoc('removeformat', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\" />\r\n            <path\r\n              d=\"M3.27 5L2 6.27l6.97 6.97L6.5 19h3l1.57-3.66L16.73 21 18 19.73 3.55 5.27 3.27 5zM6 5v.18L8.82 8h2.4l-.72 1.68 2.1 2.1L14.21 8H20V5H6z\" />\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-separator\" *ngIf=\"_isAllowed('formatblock') || _isAllowed('blockquote')\"></div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('formatblock')\">\r\n        <select class=\"np-form-control np-select-format\" [(ngModel)]=\"currentFormat\"\r\n          (change)=\"_formatBlock('formatblock', currentFormat)\">\r\n          <option [value]=\"'no value'\">\r\n            {{ \"Formatting\" | npTranslate }}\r\n          </option>\r\n          <option [value]=\"'h1'\">Header 1</option>\r\n          <option [value]=\"'h2'\">Header 2</option>\r\n          <option [value]=\"'h3'\">Header 3</option>\r\n          <option [value]=\"'h4'\">Header 4</option>\r\n          <option [value]=\"'h5'\">Header 5</option>\r\n          <option [value]=\"'h6'\">Header 6</option>\r\n          <option [value]=\"'p'\">Paragraph</option>\r\n          <option [value]=\"'pre'\">Pre formatted</option>\r\n        </select>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('blockquote')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-blockquote\" [ngClass]=\"{ 'np-btn-active': isBlockquote }\"\r\n          (click)=\"_formatDoc('formatblock', 'blockquote')\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n            <path d=\"M6 17h3l2-4V7H5v6h3zm8 0h3l2-4V7h-6v6h3z\"></path>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-separator\" *ngIf=\"\r\n          _isAllowed('fontname') ||\r\n          _isAllowed('fontsize') ||\r\n          _isAllowed('foreColor') ||\r\n          _isAllowed('backcolor')\r\n        \"></div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('fontname')\">\r\n        <select class=\"np-form-control np-select-font\" [(ngModel)]=\"currentFont\"\r\n          (change)=\"_formatBlock('fontname', currentFont)\">\r\n          <option [value]=\"'no value'\">\r\n            {{ \"Font\" | npTranslate }}\r\n          </option>\r\n          <option *ngFor=\"let font of fonts\" [value]=\"font\">{{ font }}</option>\r\n        </select>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('fontsize')\">\r\n        <select class=\"np-form-control np-select-fontsize\" [(ngModel)]=\"currentfontsize\"\r\n          (change)=\"_formatBlock('fontsize', currentfontsize)\">\r\n          <option [value]=\"'no value'\">\r\n            {{ \"Font_Size\" | npTranslate }}\r\n          </option>\r\n          <option [value]=\"1\">Smaller</option>\r\n          <option [value]=\"2\">Small</option>\r\n          <option [value]=\"3\">Medium</option>\r\n          <option [value]=\"4\">Large</option>\r\n          <option [value]=\"5\">Larger</option>\r\n          <option [value]=\"6\">X-large</option>\r\n          <option [value]=\"7\">X-larger</option>\r\n        </select>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('forecolor')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-fore-color\" npPopover #foreColorPopover=\"NpPopoverDirective\"\r\n          [body]=\"foreColorTemplate\" [openOnClick]=\"true\" (onOpen)=\"_showForeColorOverlay()\"\r\n          (onClose)=\"_onCloseOverlays()\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\" />\r\n            <path\r\n              d=\"M5 17v2h14v-2H5zm4.5-4.2h5l.9 2.2h2.1L12.75 4h-1.5L6.5 15h2.1l.9-2.2zM12 5.98L13.87 11h-3.74L12 5.98z\" />\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('backcolor')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-back-color\" npPopover #backColorPopover=\"NpPopoverDirective\"\r\n          [body]=\"backColorTemplate\" [openOnClick]=\"true\" (onOpen)=\"_showBackColorOverlay()\"\r\n          (onClose)=\"_onCloseOverlays()\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0V0z\" fill=\"none\" />\r\n            <path\r\n              d=\"M9.93 13.5h4.14L12 7.98zM20 2H4c-1.1 0-2 .9-2 2v16c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4.05 16.5l-1.14-3H9.17l-1.12 3H5.96l5.11-13h1.86l5.11 13h-2.09z\" />\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-separator\" *ngIf=\"_isAllowed('subscript') || _isAllowed('superscript')\"></div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('subscript')\">\r\n        <button class=\"np-btn-icon np-btn-subscript\" [ngClass]=\"{ 'np-btn-active': isBold }\"\r\n          (click)=\"_formatDoc('subscript', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <g>\r\n              <rect fill=\"none\" height=\"24\" width=\"24\" />\r\n              <path\r\n                d=\"M22,18h-2v1h3v1h-4v-2c0-0.55,0.45-1,1-1h2v-1h-3v-1h3c0.55,0,1,0.45,1,1v1C23,17.55,22.55,18,22,18z M5.88,18h2.66 l3.4-5.42h0.12l3.4,5.42h2.66l-4.65-7.27L17.81,4h-2.68l-3.07,4.99h-0.12L8.85,4H6.19l4.32,6.73L5.88,18z\" />\r\n            </g>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('superscript')\">\r\n        <button class=\"np-btn-icon np-btn-superscript\" [ngClass]=\"{ 'np-btn-active': isBold }\"\r\n          (click)=\"_formatDoc('superscript', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <g>\r\n              <rect fill=\"none\" height=\"24\" width=\"24\" x=\"0\" y=\"0\" />\r\n              <path\r\n                d=\"M22,7h-2v1h3v1h-4V7c0-0.55,0.45-1,1-1h2V5h-3V4h3c0.55,0,1,0.45,1,1v1C23,6.55,22.55,7,22,7z M5.88,20h2.66l3.4-5.42h0.12 l3.4,5.42h2.66l-4.65-7.27L17.81,6h-2.68l-3.07,4.99h-0.12L8.85,6H6.19l4.32,6.73L5.88,20z\" />\r\n            </g>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-separator\" *ngIf=\"\r\n          _isAllowed('justifyleft') ||\r\n          _isAllowed('justifycenter') ||\r\n          _isAllowed('justifyright')\r\n        \"></div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('justifyleft')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-align-left\" (click)=\"_formatDoc('justifyleft', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n            <path d=\"M15 15H3v2h12v-2zm0-8H3v2h12V7zM3 13h18v-2H3v2zm0 8h18v-2H3v2zM3 3v2h18V3H3z\"></path>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('justifycenter')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-align-center\" (click)=\"_formatDoc('justifycenter', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n            <path d=\"M7 15v2h10v-2H7zm-4 6h18v-2H3v2zm0-8h18v-2H3v2zm4-6v2h10V7H7zM3 3v2h18V3H3z\"></path>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('justifyright')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-align-right\" (click)=\"_formatDoc('justifyright', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n            <path d=\"M3 21h18v-2H3v2zm6-4h12v-2H9v2zm-6-4h18v-2H3v2zm6-4h12V7H9v2zM3 3v2h18V3H3z\"></path>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-separator\" *ngIf=\"_isAllowed('indent') || _isAllowed('outdent')\"></div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('indent')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-add-indent\" (click)=\"_formatDoc('indent', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\" />\r\n            <path d=\"M3 21h18v-2H3v2zM3 8v8l4-4-4-4zm8 9h10v-2H11v2zM3 3v2h18V3H3zm8 6h10V7H11v2zm0 4h10v-2H11v2z\" />\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('outdent')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-remove-indent\" (click)=\"_formatDoc('outdent', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\" />\r\n            <path d=\"M11 17h10v-2H11v2zm-8-5l4 4V8l-4 4zm0 9h18v-2H3v2zM3 3v2h18V3H3zm8 6h10V7H11v2zm0 4h10v-2H11v2z\" />\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-separator\" *ngIf=\"\r\n          _isAllowed('insertunorderedlist') || _isAllowed('insertorderedlist')\r\n        \"></div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('insertunorderedlist')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-unorder-list\" (click)=\"_formatDoc('insertunorderedlist', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0V0z\" fill=\"none\"></path>\r\n            <path\r\n              d=\"M4 10.5c-.83 0-1.5.67-1.5 1.5s.67 1.5 1.5 1.5 1.5-.67 1.5-1.5-.67-1.5-1.5-1.5zm0-6c-.83 0-1.5.67-1.5 1.5S3.17 7.5 4 7.5 5.5 6.83 5.5 6 4.83 4.5 4 4.5zm0 12c-.83 0-1.5.68-1.5 1.5s.68 1.5 1.5 1.5 1.5-.68 1.5-1.5-.67-1.5-1.5-1.5zM7 19h14v-2H7v2zm0-6h14v-2H7v2zm0-8v2h14V5H7z\">\r\n            </path>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('insertorderedlist')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-order-list\" (click)=\"_formatDoc('insertorderedlist', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n            <path\r\n              d=\"M2 17h2v.5H3v1h1v.5H2v1h3v-4H2v1zm1-9h1V4H2v1h1v3zm-1 3h1.8L2 13.1v.9h3v-1H3.2L5 10.9V10H2v1zm5-6v2h14V5H7zm0 14h14v-2H7v2zm0-6h14v-2H7v2z\">\r\n            </path>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-separator\" *ngIf=\"_isAllowed('createlink')\"></div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('createlink')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-create-link\" npPopover #createLinkPopover=\"NpPopoverDirective\"\r\n          [header]=\"'Enter_The_URL_For_Link' | npTranslate\" [body]=\"createLinkTemp\" [openOnClick]=\"true\"\r\n          (onOpen)=\"_showCreateLink()\" (onClose)=\"_onCloseOverlays()\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\" />\r\n            <path\r\n              d=\"M3.9 12c0-1.71 1.39-3.1 3.1-3.1h4V7H7c-2.76 0-5 2.24-5 5s2.24 5 5 5h4v-1.9H7c-1.71 0-3.1-1.39-3.1-3.1zM8 13h8v-2H8v2zm9-6h-4v1.9h4c1.71 0 3.1 1.39 3.1 3.1s-1.39 3.1-3.1 3.1h-4V17h4c2.76 0 5-2.24 5-5s-2.24-5-5-5z\" />\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('createlink')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-unlink\" (click)=\"_formatDoc('unlink', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0V0z\" fill=\"none\" />\r\n            <path\r\n              d=\"M17 7h-4v1.9h4c1.71 0 3.1 1.39 3.1 3.1 0 1.43-.98 2.63-2.31 2.98l1.46 1.46C20.88 15.61 22 13.95 22 12c0-2.76-2.24-5-5-5zm-1 4h-2.19l2 2H16zM2 4.27l3.11 3.11C3.29 8.12 2 9.91 2 12c0 2.76 2.24 5 5 5h4v-1.9H7c-1.71 0-3.1-1.39-3.1-3.1 0-1.59 1.21-2.9 2.76-3.07L8.73 11H8v2h2.73L13 15.27V17h1.73l4.01 4L20 19.74 3.27 3 2 4.27z\" />\r\n            <path d=\"M0 24V0\" fill=\"none\" />\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-separator\" *ngIf=\"_isAllowed('undo') || _isAllowed('redo')\"></div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('undo')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-undo\" (click)=\"_formatDoc('undo', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n            <path\r\n              d=\"M12.5 8c-2.65 0-5.05.99-6.9 2.6L2 7v9h9l-3.62-3.62c1.39-1.16 3.16-1.88 5.12-1.88 3.54 0 6.55 2.31 7.6 5.5l2.37-.78C21.08 11.03 17.15 8 12.5 8z\">\r\n            </path>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <div class=\"np-toolbar-item\" *ngIf=\"_isAllowed('redo')\">\r\n        <button type=\"button\" class=\"np-btn-icon np-btn-redo\" (click)=\"_formatDoc('redo', null)\">\r\n          <svg class=\"np-icon\" viewBox=\"0 0 24 24\">\r\n            <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\r\n            <path\r\n              d=\"M18.4 10.6C16.55 8.99 14.15 8 11.5 8c-4.65 0-8.58 3.03-9.96 7.22L3.9 16c1.05-3.19 4.05-5.5 7.6-5.5 1.95 0 3.73.72 5.12 1.88L13 16h9V7l-3.6 3.6z\">\r\n            </path>\r\n          </svg>\r\n        </button>\r\n      </div>\r\n    </div>\r\n    <div class=\"np-rich-text-input\" role=\"textbox\" [attr.contenteditable]=\"!isDisabled && !readOnly\" #control\r\n      [attr.tabindex]=\"tabIndex\" [style.height.px]=\"height\" [npAutofocus]=\"autoFocus\" (blur)=\"_onBlur($event)\"\r\n      (focus)=\"_onFocus($event)\" (input)=\"_onInputChange($event)\"></div>\r\n  </div>\r\n</div>\r\n\r\n<ng-template #backColorTemplate>\r\n  <np-color-picker [(ngModel)]=\"backColor\" [colors]=\"[]\" [defaultOpen]=\"true\" (onChange)=\"_changeBackColor($event)\">\r\n  </np-color-picker>\r\n</ng-template>\r\n\r\n<ng-template #foreColorTemplate>\r\n  <np-color-picker [(ngModel)]=\"foreColor\" [colors]=\"[]\" [defaultOpen]=\"true\" (onChange)=\"_changeForeColor($event)\">\r\n  </np-color-picker>\r\n</ng-template>\r\n\r\n<ng-template #createLinkTemp>\r\n  <div class=\"np-create-link-form\">\r\n    <div class=\"np-form-group\">\r\n      <input type=\"url\" class=\"np-form-control\" [npAutofocus]=\"true\" [(ngModel)]=\"linkUrl\" />\r\n    </div>\r\n    <div class=\"np-btn-group\">\r\n      <button type=\"button\" class=\"np-btn\" (click)=\"_createLink()\">\r\n        {{ \"Ok\" | npTranslate }}\r\n      </button>\r\n      <button type=\"button\" class=\"np-btn\" (click)=\"_closeCreateLinkOverlay()\">\r\n        {{ \"Cancel\" | npTranslate }}\r\n      </button>\r\n    </div>\r\n  </div>\r\n</ng-template>" }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { minLength: [{
                type: Input
            }], maxLength: [{
                type: Input
            }], config: [{
                type: Input
            }], fonts: [{
                type: Input
            }], height: [{
                type: Input
            }], readOnly: [{
                type: Input
            }], autoFocus: [{
                type: Input
            }], tabIndex: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], inputId: [{
                type: Input
            }], onChange: [{
                type: Output
            }], onFocus: [{
                type: Output
            }], onBlur: [{
                type: Output
            }], inputViewChild: [{
                type: ViewChild,
                args: ["control"]
            }], createLinkPopover: [{
                type: ViewChild,
                args: ["createLinkPopover"]
            }], foreColorPopover: [{
                type: ViewChild,
                args: ["foreColorPopover"]
            }], backColorPopover: [{
                type: ViewChild,
                args: ["backColorPopover"]
            }] } });

class NpRichTextModule {
}
NpRichTextModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpRichTextModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpRichTextModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpRichTextModule, declarations: [NpRichTextComponent], imports: [CommonModule,
        NpAutofocusModule,
        FormsModule,
        NpColorPickerModule,
        NpPopoverModule,
        NpTranslationsModule], exports: [NpRichTextComponent] });
NpRichTextModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpRichTextModule, imports: [CommonModule,
        NpAutofocusModule,
        FormsModule,
        NpColorPickerModule,
        NpPopoverModule,
        NpTranslationsModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpRichTextModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpRichTextComponent],
                    imports: [
                        CommonModule,
                        NpAutofocusModule,
                        FormsModule,
                        NpColorPickerModule,
                        NpPopoverModule,
                        NpTranslationsModule,
                    ],
                    exports: [NpRichTextComponent],
                }]
        }] });

class NpTimelineComponent {
    constructor() {
        this.inputId = `np-timeline_${NpTimelineComponent.controlCount++}`;
    }
    ngOnInit() { }
    _trackBy(index) {
        return index;
    }
}
NpTimelineComponent.controlCount = 1;
NpTimelineComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTimelineComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NpTimelineComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: NpTimelineComponent, selector: "np-timeline", inputs: { items: "items", itemTemplate: "itemTemplate", height: "height", styleClass: "styleClass", inputId: "inputId" }, ngImport: i0, template: "<div [ngClass]=\"'np-timeline'\" [class]=\"styleClass\" [style.max-height.px]=\"height\" [attr.id]=\"inputId\">\r\n  <div class=\"np-timeline-container\">\r\n    <ng-container *ngFor=\"let item of items; let i = index; trackBy: _trackBy\">\r\n      <div class=\"np-timeline-item\" [attr.id]=\"'np-timeline-item_' + (i + 1)\" [class]=\"item.styleClass\">\r\n        <div class=\"np-timeline-separator\">\r\n          <span *ngIf=\"item.iconCss\" class=\"np-timeline-marker\">\r\n            <i [class]=\"item.iconCss\"></i>\r\n          </span>\r\n          <span *ngIf=\"!item.iconCss\" class=\"np-timeline-default-marker\"></span>\r\n          <div class=\"np-timeline-connector\"></div>\r\n        </div>\r\n        <div class=\"np-timeline-item-content\">\r\n          <ng-container *ngTemplateOutlet=\"itemTemplate; context: { item: item }\">\r\n          </ng-container>\r\n        </div>\r\n      </div>\r\n    </ng-container>\r\n  </div>\r\n</div>", dependencies: [{ kind: "directive", type: i1$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTimelineComponent, decorators: [{
            type: Component,
            args: [{ selector: "np-timeline", encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, template: "<div [ngClass]=\"'np-timeline'\" [class]=\"styleClass\" [style.max-height.px]=\"height\" [attr.id]=\"inputId\">\r\n  <div class=\"np-timeline-container\">\r\n    <ng-container *ngFor=\"let item of items; let i = index; trackBy: _trackBy\">\r\n      <div class=\"np-timeline-item\" [attr.id]=\"'np-timeline-item_' + (i + 1)\" [class]=\"item.styleClass\">\r\n        <div class=\"np-timeline-separator\">\r\n          <span *ngIf=\"item.iconCss\" class=\"np-timeline-marker\">\r\n            <i [class]=\"item.iconCss\"></i>\r\n          </span>\r\n          <span *ngIf=\"!item.iconCss\" class=\"np-timeline-default-marker\"></span>\r\n          <div class=\"np-timeline-connector\"></div>\r\n        </div>\r\n        <div class=\"np-timeline-item-content\">\r\n          <ng-container *ngTemplateOutlet=\"itemTemplate; context: { item: item }\">\r\n          </ng-container>\r\n        </div>\r\n      </div>\r\n    </ng-container>\r\n  </div>\r\n</div>" }]
        }], ctorParameters: function () { return []; }, propDecorators: { items: [{
                type: Input
            }], itemTemplate: [{
                type: Input
            }], height: [{
                type: Input
            }], styleClass: [{
                type: Input
            }], inputId: [{
                type: Input
            }] } });

class NpTimelineModule {
}
NpTimelineModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTimelineModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NpTimelineModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: NpTimelineModule, declarations: [NpTimelineComponent], imports: [CommonModule], exports: [NpTimelineComponent] });
NpTimelineModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTimelineModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: NpTimelineModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NpTimelineComponent],
                    imports: [CommonModule],
                    exports: [NpTimelineComponent],
                }]
        }] });

/*Color Picker */

/**
 * Generated bundle index. Do not edit.
 */

export { Column, DataSource, DataTypes, FilterTypes, Filters, LoadOptions, NpAccordionComponent, NpAccordionContent, NpAccordionItemComponent, NpAccordionModule, NpAlertComponent, NpAlertModule, NpAutoCompleteComponent, NpAutoCompleteModule, NpAutofocusDirective, NpAutofocusModule, NpBlockUiDirective, NpBlockUiModule, NpBreadcrumbComponent, NpBreadcrumbItem, NpBreadcrumbModule, NpCalendarComponent, NpCalendarEvent, NpCalendarModule, NpCardBodyComponent, NpCardComponent, NpCardFooterComponent, NpCardHeaderComponent, NpCardImageComponent, NpCardModule, NpCarouselComponent, NpCarouselModule, NpCheckboxComponent, NpCheckboxGroupComponent, NpCheckboxModule, NpColorPickerComponent, NpColorPickerModule, NpDataGridComponent, NpDataGridModule, NpDatePickerComponent, NpDatePickerModule, NpDeferDirective, NpDeferModule, NpDialogConfig, NpDialogContainerComponent, NpDialogModule, NpDialogRef, NpDialogService, NpDropdownComponent, NpDropdownModule, NpFileUploadComponent, NpFileUploadModule, NpHighlightModule, NpHighlightPipe, NpInputTextComponent, NpInputTextModule, NpListComponent, NpListModule, NpLoaderDirective, NpLoaderModule, NpMaskDirective, NpMaskModule, NpMenuItem, NpMenubarComponent, NpMenubarModule, NpModalConfig, NpModalContainerComponent, NpModalModule, NpModalRef, NpModalService, NpNotification, NpNotificationsComponent, NpNotificationsModule, NpNotificationsService, NpNumberBoxComponent, NpNumberBoxModule, NpOrderByModule, NpOrderByPipe, NpPaginatorComponent, NpPaginatorModule, NpPanelComponent, NpPanelContent, NpPanelModule, NpPopoverComponent, NpPopoverDirective, NpPopoverModule, NpPopupMenubarDirective, NpProgressComponent, NpProgressModule, NpRadioButtonComponent, NpRadioButtonModule, NpRadioGroupComponent, NpRichTextComponent, NpRichTextModule, NpSidepanelComponent, NpSidepanelContent, NpSidepanelModule, NpSidepanelService, NpSliderComponent, NpSliderModule, NpStepComponent, NpStepNext, NpStepPrevious, NpStepsComponent, NpStepsModule, NpSwitchComponent, NpSwitchModule, NpTabComponent, NpTabContent, NpTabsComponent, NpTabsModule, NpTagsComponent, NpTagsModule, NpTextareaComponent, NpTextareaModule, NpTimePickerComponent, NpTimePickerModule, NpTimelineComponent, NpTimelineModule, NpTooltipDirective, NpTooltipModule, NpTranslatePipe, NpTranslationsModule, NpTranslationsService, NpTreeViewComponent, NpTreeViewItem, NpTreeViewModule, NpVirtualScrollComponent, NpVirtualScrollModule, SortDirections, State };
//# sourceMappingURL=np-ui-lib.mjs.map
